SystemOrganization addCategory: #'Cog-Benchmarks-DeltaBlue'!
SystemOrganization addCategory: #'Cog-Benchmarks-Richards'!
SystemOrganization addCategory: #'Cog-Benchmarks-SMark'!
SystemOrganization addCategory: #'Cog-Benchmarks-Shootout'!
SystemOrganization addCategory: #'Cog-Bootstrapping'!
SystemOrganization addCategory: #'Cog-Morphing Bytecode Set'!
SystemOrganization addCategory: #'Cog-ProcessorPlugins'!
SystemOrganization addCategory: #'Cog-Processors'!
SystemOrganization addCategory: #'Cog-Processors-Tests'!
SystemOrganization addCategory: #'Cog-Scripting'!
SystemOrganization addCategory: #'Cog-Scripts'!
SystemOrganization addCategory: #'Cog-Tests'!
SystemOrganization addCategory: #'Cog-Benchmarks'!

!DummyStream methodsFor: '*Cog-Benchmarks-Shootout-Shootout-Shootout-platform' stamp: 'eem 10/21/2008 13:18'!
nl
	"do nothing"! !

!DummyStream methodsFor: '*Cog-Benchmarks-Shootout-Shootout-Shootout-platform' stamp: 'eem 10/21/2008 13:20'!
print: number digits: decimalPlaces
	"do nothing"! !

!DummyStream methodsFor: '*Cog-Benchmarks-Shootout-Shootout-Shootout-platform' stamp: 'eem 10/21/2008 13:20'!
print: number paddedTo: width
	"do nothing"! !

TestCase subclass: #BochsIA32AlienTests
	instanceVariableNames: 'processor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Processors-Tests'!

!BochsIA32AlienTests methodsFor: 'tests' stamp: 'eem 5/7/2010 10:43'!
callTrapPerformance: n
	"Call a function that is out-of-range.  Ensure the call is trapped."
	"self new testCallTrap"
	| memory |
	 "The address is out of range of memory every which way (whether relative or absolute and whether big-endian or little."
	memory := ByteArray new: 1024.
	memory replaceFrom: 1 to: 5 with: { self processor callOpcode. 0. 16r80. 16r80. 0. } asByteArray.
	self processor
			eip: 0;
			esp: (memory size - 4). "Room for return address"
	1 to: n do:
		[:ign|
		[self processor singleStepIn: memory]
			on: ProcessorSimulationTrap
			do: [:ex|]].

	"QSystemProfiler spyOn: [BochsIA32AlienTests new callTrapPerformance: 1024*128]"
	"Time millisecondsToRun: [BochsIA32AlienTests new callTrapPerformance: 1024*128] 2463"
	"Time millisecondsToRun: [1 to: 1024*1024*64 do: [:ign| nil yourself]] 636"
	"Time millisecondsToRun: [1 to: 1024*1024*64 do: [:ign| nil perform: #ifNotNilDo: with: nil]] 3639"
	"Time millisecondsToRun: [1 to: 1024*1024*64 do: [:ign| nil perform: #ifNotNilDo:ifNil: with: nil with: nil]] 12401"! !

!BochsIA32AlienTests methodsFor: 'accessing' stamp: 'eem 3/18/2014 10:44'!
integerRegisterGetters
	^#(eax ecx edx ebx esp ebp esi edi eip)! !

!BochsIA32AlienTests methodsFor: 'accessing' stamp: 'eem 3/18/2014 10:45'!
integerRegisterSetters
	^#(eax: ecx: edx: ebx: esp: ebp: esi: edi: eip:)! !

!BochsIA32AlienTests methodsFor: 'accessing' stamp: 'eem 12/12/2008 16:23'!
nfib
	"long fib(long n) { return n <= 1 ? 1 : fib(n-1) + fib(n-2) + 1; }
	 as compiled by Microsoft Visual C++ V6 (12.00.8804) cl /O2 /Fc"
	"| bat nfib ip |
	bat := BochsIA32AlienTests new.
	nfib := bat nfib asByteArray.
	ip := 0.
	20 timesRepeat:
		[bat processor disassembleInstructionAt: ip In: nfib into:
			[:da :len|
			Transcript nextPutAll: da; cr; flush.
			ip := ip + len]]"
	^#("00000" 16r56							"push    esi"
		"00001" 16r8B 16r74 16r24 16r08		"mov     esi, DWORD PTR _n$[esp]"
		"00005" 16r83 16rFE 16r01				"cmp     esi, 1"
		"00008" 16r7F 16r07						"jg      SHORT $L528"
		"0000a" 16rB8 16r01 16r00 16r00 16r00	"mov     eax, 1"
		"0000f" 16r5E							"pop     esi"
		"00010" 16rC3							"ret     0"
"
$L528:"
		"00011" 16r8D 16r46 16rFE				"lea     eax, DWORD PTR [esi-2]"
		"00014" 16r57							"push    edi"
		"00015" 16r50							"push    eax"
		"00016" 16rE8 16rE5 16rFF 16rFF 16rFF   "call    _fib"
		"0001b" 16r4E							"dec     esi"
		"0001c" 16r8B 16rF8						"mov     edi, eax"
		"0001e" 16r56							"push    esi"
		"0001f" 16rE8 16rDC 16rFF 16rFF 16rFF   "call    _fib"
		"00024" 16r83 16rC4 16r08				"add     esp, 8"
		"00027" 16r8D 16r44 16r07 16r01		"lea     eax, DWORD PTR [edi+eax+1]"
		"0002b" 16r5F							"pop     edi"
		"0002c" 16r5E							"pop     esi"
		"0002d" 16rC3							"ret     0")! !

!BochsIA32AlienTests methodsFor: 'accessing' stamp: 'eem 12/11/2008 13:53'!
processor
	processor ifNil:
		[processor := BochsIA32Alien new].
	^processor! !

!BochsIA32AlienTests methodsFor: 'execution' stamp: 'eem 10/21/2010 11:02'!
runNFib: n disassemble: disassemble printRegisters: printRegisters
	"Run nfib wth the argument. Answer the result."
	"self new runNFib: 5 disassemble: true printRegisters: true"
	| memory |
	memory := ByteArray new: 4096 * 2 withAll: self processor nopOpcode.
	memory
		replaceFrom: 1 to: self nfib size with: self nfib asByteArray startingAt: 1;
		longAt: memory size - 3 put: n bigEndian: false; "argument n"
		longAt: memory size - 7 put: self nfib size bigEndian: false.  "return address"
	self processor
		eip: 0;
		esp: (memory size - 8). "Room for return address and argument n"
	printRegisters ifTrue:
		[self processor printRegistersOn: Transcript.
		 Transcript cr; flush].
	"run until something goes wrong."
	self processor runInMemory: memory readExecuteOnlyBelow: memory size / 2.
	printRegisters ifTrue:
		[self processor printRegistersOn: Transcript.
		 Transcript cr; flush].
	^self processor eax! !

!BochsIA32AlienTests methodsFor: 'execution' stamp: 'eem 10/21/2010 11:06'!
singleStepNFib: n disassemble: disassemble printRegisters: printRegisters
	"Run nfib wth the argument. Answer the result."
	"self new runNFib: 5 disassemble: true printRegisters: true"
	| memory finalSP |
	memory := ByteArray new: 4096 * 2 withAll: self processor nopOpcode.
	finalSP := memory size - 4. "Stop when we return to the nop following nfib"
	memory
		replaceFrom: 1 to: self nfib size with: self nfib asByteArray startingAt: 1;
		longAt: memory size - 3 put: n bigEndian: false; "argument n"
		longAt: memory size - 7 put: self nfib size bigEndian: false.  "return address"
	self processor
			eip: 0;
			esp: (memory size - 8). "Room for return address and argument n"
	printRegisters ifTrue:
		[self processor printRegistersOn: Transcript.
		 Transcript cr; flush].
	[disassemble ifTrue:
		[Transcript nextPutAll: (self processor disassembleNextInstructionIn: memory); cr; flush].
	 self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
	 printRegisters ifTrue:
		[self processor printRegistersOn: Transcript.
		 Transcript cr; flush].
	 self processor esp ~= finalSP] whileTrue.
	^self processor eax! !

!BochsIA32AlienTests methodsFor: 'tests' stamp: 'eem 4/15/2009 17:13'!
testCPUHasSSE2
	"Use the CPUID instruction to check if SSE2 is supported.  Cog
	 uses SSE2 instructions for machine-code floating-point primitives."
	self processor eax: 0. "get vendor identfication string"
	self processor eip: 0; singleStepIn: (ByteArray with: 16r0F with: 16rA2 with: 16r90) "cpuid;nop".
	self assert: self processor eip = 2.
	self assert: self processor eax >= 1.
	self processor eax: 1.
	self processor eip: 0; singleStepIn: (ByteArray with: 16r0F with: 16rA2 with: 16r90) "cpuid;nop".
	self assert: self processor eip = 2.
	self assert: (self processor edx bitAnd: 1 << 26) ~= 0

	"self new testCPUHasSSE2"! !

!BochsIA32AlienTests methodsFor: 'tests' stamp: 'eem 12/11/2008 18:09'!
testCPUID
	| vendorString |
	self processor
			eip: 0;
			eax: 0. "get vendor identfication string"
	self processor singleStepIn: (ByteArray with: 16r0F with: 16rA2 with: 16r90) "cpuid;nop".
	self assert: self processor eip = 2.
	self assert: self processor eax ~= 0.
	vendorString := (ByteArray new: 12)
						longAt: 1 put: self processor ebx bigEndian: false;
						longAt: 5 put: self processor edx bigEndian: false;
						longAt: 9 put: self processor ecx bigEndian: false;
						asString.
	self assert: (vendorString = 'GenuineIntel'
				or: [vendorString = 'AuthenticAMD'])! !

!BochsIA32AlienTests methodsFor: 'tests' stamp: 'eem 5/7/2010 11:05'!
testCallTrap
	"Call a function that is out-of-range.  Ensure the call is trapped."
	"self new testCallTrap"
	| memory |
	 "The address is out of range of memory every which way (whether relative or absolute and whether big-endian or little."
	memory := ByteArray new: 1024.
	memory replaceFrom: 1 to: 5 with: { self processor callOpcode. 0. 16r80. 16r80. 0. } asByteArray.
	self processor
			eip: 0;
			esp: (memory size - 4). "Room for return address"
	self should: [self processor singleStepIn: memory]
		raise: ProcessorSimulationTrap
		withExceptionDo:
			[:pst|
			self assert: pst address = ((memory longAt: 2 bigEndian: false) + 5 "length of call instr").
			self assert: pst pc = 0.
			self assert: pst type = #call].

	"| memory |
	memory := ByteArray new: 1024.
	memory replaceFrom: 1 to: 5 with: { BochsIA32Alien new callOpcode. 0. 16r80. 16r80. 0. } asByteArray.
	BochsIA32AlienTests new processor
		eip: 0;
		esp: (memory size - 4);
		singleStepIn: memory;
		printRegistersOn: Transcript.
	Transcript flush"! !

!BochsIA32AlienTests methodsFor: 'tests' stamp: 'eem 10/20/2010 15:58'!
testExecutionTrap
	"Execute a run of nops.  test executing beyond the executable limit is trapped."
	"self new testExecutionTrap"
	| memory |
	 "The address is out of range of memory every which way (whether relative or absolute and whether big-endian or little."
	memory := ByteArray new: 4096 * 2 withAll: self processor nopOpcode.
	self processor
			eip: 0;
			esp: (memory size - 4). "Room for return address"
	self should: [self processor runInMemory: memory minimumAddress: 0 readOnlyBelow: memory size / 2]
		raise: Error
		withExceptionDo:
			[:err|
			self assert: self processor pc = (memory size / 2).
			self assert: ('*EIP*> CS.limit*' match: err messageText)].
	self processor eip: 0.
	self should: [[self processor singleStepIn: memory minimumAddress: 0 readOnlyBelow: memory size / 2] repeat]
		raise: Error
		withExceptionDo:
			[:err|
			self assert: self processor pc = (memory size / 2).
			self assert: ('*EIP*> CS.limit*' match: err messageText)]! !

!BochsIA32AlienTests methodsFor: 'tests' stamp: 'eem 4/16/2009 17:57'!
testMOVSD
	"Test MOVSD indirecting through edx."
	"self new testMOVSD"
	self processor
		edx: 0;
		eip: 0;
		singleStepIn: {16rF2. 16r0F. 16r10. 16r42. 16r04. 16r90. 16r01. 16r02. 16r03. 16r04. 16r05. 16r06} asByteArray "movsd %ds:0x4(%edx), %xmm0;nop;garbage".
	self assert: self processor eip = 5.
	self assert: self processor xmm0low = 16r0605040302019004! !

!BochsIA32AlienTests methodsFor: 'tests' stamp: 'eem 1/14/2009 15:50'!
testNfib1
	"self new testNfib1"
	self should: [self runNFib: 1 disassemble: false printRegisters: false]
		raise: Error.
	self deny: (self processor eip between: 1 and: self nfib size).
	self assert: self processor eax = 1 benchFib! !

!BochsIA32AlienTests methodsFor: 'tests' stamp: 'eem 1/14/2009 15:51'!
testNfib16
	"self new testNfib16"
	self should: [self runNFib: 16 disassemble: false printRegisters: false]
		raise: Error.
	self deny: (self processor eip between: 1 and: self nfib size).
	self assert: self processor eax = 16 benchFib! !

!BochsIA32AlienTests methodsFor: 'tests' stamp: 'eem 1/14/2009 15:50'!
testNfib2
	"self new testNfib2"
	self should: [self runNFib: 2 disassemble: false printRegisters: false]
		raise: Error.
	self deny: (self processor eip between: 1 and: self nfib size).
	self assert: self processor eax = 2 benchFib! !

!BochsIA32AlienTests methodsFor: 'tests' stamp: 'eem 1/14/2009 15:49'!
testNfib4
	"self new testNfib4"
	self should: [self runNFib: 4 disassemble: false printRegisters: false]
		raise: Error.
	self deny: (self processor eip between: 1 and: self nfib size).
	self assert: self processor eax = 4 benchFib! !

!BochsIA32AlienTests methodsFor: 'tests' stamp: 'eem 3/18/2014 10:44'!
testResetCPU
	"self new testResetCPU"
	self integerRegisterSetters do:
		[:setter|
		self processor perform: setter with: 16r55555555].
	self integerRegisterGetters do:
		[:getter|
		self assert: 16r55555555 = (self processor perform: getter)].
	self processor reset.
	self integerRegisterGetters do:
		[:getter|
		self assert: 0 = (self processor perform: getter)]! !

!BochsIA32AlienTests methodsFor: 'tests' stamp: 'eem 1/14/2009 15:10'!
testStepNfib1
	"self new testNfib1"
	self singleStepNFib: 1 disassemble: false printRegisters: false.
	self assert: self processor eip = self nfib size.
	self assert: self processor eax = 1 benchFib! !

!BochsIA32AlienTests methodsFor: 'tests' stamp: 'eem 1/14/2009 15:10'!
testStepNfib2
	"self new testNfib2"
	self singleStepNFib: 2 disassemble: false printRegisters: false.
	self assert: self processor eip = self nfib size.
	self assert: self processor eax = 2 benchFib! !

!BochsIA32AlienTests methodsFor: 'tests' stamp: 'eem 1/14/2009 15:11'!
testStepNfib4
	"self new testNfib4"
	self singleStepNFib: 4 disassemble: false printRegisters: false.
	self assert: self processor eip = self nfib size.
	self assert: self processor eax = 4 benchFib! !

TestCase subclass: #CogVMTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Tests'!

!CogVMTests methodsFor: 'support' stamp: 'eem 6/17/2009 23:18'!
recurse
	self recurse! !

!CogVMTests methodsFor: 'support' stamp: 'eem 6/17/2009 08:45'!
runningOnCogit
	"CogVMTests new runningOnCogit"
	^(1 to: 3) anySatisfy: [:each| thisContext xrayIsExecutingMachineCode]! !

!CogVMTests methodsFor: 'tests' stamp: 'eem 9/14/2009 06:18'!
testMultiplicativeOperators
	"CogVMTests new setUp testMultiplicativeOperators"
	self runningOnCogit ifTrue:
		[thisContext xrayIsExecutingMachineCode ifFalse:
			[^self testMultiplicativeOperators]].
	1 to: 3 do: "Running 3 times should ensure all operators are compiled to machine code"
		[:ignored| | values |
		self assert: (1 / 2 literalEqual: (Fraction numerator: 1 denominator: 2)).
		self assert: 1 // 2 == 0.
		self assert: (1 quo: 2) == 0.
		self assert: 3 * 4 == 12.

		self assert: 65536 / 2 == 32768.
		self assert: 65536 // 2 == 32768.
		self assert: (65536 quo: 2) == 32768.
		self assert: 65536 * 2 == 131072.
		#(1 2 4 8 16 32 64 128 256 512 1024 2048 4096 8192 16384 32768 65536
		   131072 262144 524288 1048576 2097152 4194304 8388608 16777216 33554432
		   67108864 134217728 268435456 536870912 1073741824 2147483648 4294967296) withIndexDo:
			[:value :index| | power | "test that integer overflow is detected in multiplication"
			power := index - 1.
			self assert: value * value = (2 raisedTo: power + power)].

		self assert: SmallInteger minVal / -1 = (SmallInteger maxVal + 1).
		self assert: SmallInteger minVal // -1 = (SmallInteger maxVal + 1).
		self assert: (SmallInteger minVal quo: -1) = (SmallInteger maxVal + 1).
		self assert: (SmallInteger minVal \\ -1) = 0.

		values := Integer primesUpTo: 1000.
		values := (values reverse collect: [:ea| ea negated]), values.
		values do:
			[:dividend|
			values do:
				[:divisor|
				self assert: (dividend quo: divisor) * divisor + (dividend rem: divisor) = dividend.
				self assert: (dividend // divisor) * divisor + (dividend \\ divisor) = dividend]]]! !

!CogVMTests methodsFor: 'tests' stamp: 'eem 6/17/2009 23:18'!
testPCAccessForActivation
	"self new testPCAccessForActivation"
	| runningOnCogit theProcess block run pc executingMachineCode scanner blockCount |
	runningOnCogit := self runningOnCogit.
	run := true.
	theProcess := Processor activeProcess.
	"Fork a process that will sample the pc of the following recursive block."
	[(Delay forMilliseconds: 1) wait.
	 pc := theProcess suspendedContext pc.
	 executingMachineCode := theProcess suspendedContext xrayIsExecutingMachineCode.
	 run := false] forkAt: Processor userInterruptPriority.
	"The only suspension point in this block is on activation (assuming
	 ifTrue: is inlined) so its pc must be the first bytecode in the block."
	block := [run ifTrue: [block value]].
	block value.
	"Find the first bytecode of the second block in this method."
	blockCount := 0.
	(scanner := InstructionStream on: thisContext method)
		scanFor:
			[:b| blockCount = 2 or: [b == 143 and: [blockCount := blockCount + 1. false]]].
	self assert: pc = scanner pc.
	self assert: executingMachineCode = runningOnCogit.
	"Fork a process that will use recurse: to infinitely recurse.
	 The only suspension point in this call is on activation (assuming
	 ifTrue: is inlined) so its pc must be the first bytecode in the method."
	theProcess := [self recurse] forkAt: Processor activePriority - 1.
	(Delay forMilliseconds: 1) wait.
	pc := theProcess suspendedContext pc.
	executingMachineCode := theProcess suspendedContext xrayIsExecutingMachineCode.
	theProcess terminate.
	self assert: pc = (self class compiledMethodAt: #recurse) initialPC.
	self assert: executingMachineCode = runningOnCogit! !

!CogVMTests methodsFor: 'tests' stamp: 'eem 6/17/2009 22:31'!
testPCAccessForSends
	"self new testPCAccessForSends"
	| runningOnCogit |
	runningOnCogit := self runningOnCogit.
	#("Method-level pc maping"
		( '{ thisContext pc.
			thisContext xrayIsExecutingMachineCode.
			thisContext method }'
			pc)
		( '{ thisContext perform: #perform:withArguments: with: #pc with: Array new.
			thisContext xrayIsExecutingMachineCode.
			thisContext method }'
			perform:with:with: )
		( '{ [:ctxt :msg :ign1| ctxt perform: msg] value: thisContext value: #pc value: nil.
			thisContext xrayIsExecutingMachineCode.
			thisContext method }'
			value:value:value: )
	   "Block-level pc maping"
		( '[:method|
			{ thisContext pc.
			  thisContext xrayIsExecutingMachineCode.
			  method } ] value: thisContext method'
			pc)
		( '[:method|
			{ (thisContext perform: #perform:withArguments: with: #pc with: Array new).
			  thisContext xrayIsExecutingMachineCode.
			  method } ] value: thisContext method'
			perform:with:with:)
		( '[:method|
			{ [:ctxt :msg :ign1| ctxt perform: msg] value: thisContext value: #pc value: nil.
			  thisContext xrayIsExecutingMachineCode.
			  method } ] value: thisContext method'
			value:value:value: ) ) do:
		[:case|
		 [:actualPc :executingMachineCode :method| | flag scanner expectedPc |
		  flag := false.
		  (scanner := InstructionStream on: method)
			scanFor:
				[:b| flag or: [flag := scanner selectorToSendOrSelf == case second. false]].
		  expectedPc := scanner pc.
		  self assert: actualPc = expectedPc.
		  self assert: executingMachineCode = runningOnCogit]
			valueWithArguments: (Compiler evaluate: case first logged: false)]! !

TestCase subclass: #GdbARMAlienTests
	instanceVariableNames: 'processor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Processors-Tests'!

!GdbARMAlienTests methodsFor: 'accessing' stamp: 'eem 3/18/2014 10:44'!
integerRegisterGetters
	^#(r0 r1 r2 r3 r4 r5 r6 r7 r8 r9 r10 r11 r12 lr sp pc)! !

!GdbARMAlienTests methodsFor: 'accessing' stamp: 'eem 3/18/2014 10:45'!
integerRegisterSetters
	^#(r0: r1: r2: r3: r4: r5: r6: r7: r8: r9: r10: r11: r12: lr: sp: pc:)! !

!GdbARMAlienTests methodsFor: 'accessing' stamp: 'tpr 5/5/2014 18:06'!
memory 
"build a memory for this test; a ByteArray of 1024 bytes, filled with NOPs"
	| mem |
	mem := ByteArray new: 1024.
	1 to: 1024  by: 4do:[:i|
		mem unsignedLongAt: i put: 16rE1A00000 bigEndian: false].
	^mem! !

!GdbARMAlienTests methodsFor: 'accessing' stamp: 'lw 7/11/2012 14:16'!
nfib
	"long fib(long n) { return n <= 1 ? 1 : fib(n-1) + fib(n-2) + 1; }
	 as compiled by arm-elf-gnuabi-gcc fib.c -c -marm
	also, the jumps are changed by hand."
	"| bat nfib ip |
	bat := GdbARMAlienTests new.
	nfib := bat nfib asWordArray.
	ip := 0.
	23 timesRepeat:
		[bat processor disassembleInstructionAt: ip In: nfib into:
			[:da :len|
			Transcript nextPutAll: da; cr; flush.
			ip := ip + len]]"
	^#("00000000 <fib>:
	   0:"		16re92d4810 		"push	{r4, fp, lr}	fp = r11, sp is changed in this command
	   4:"		16re28db008 		"add	fp, sp, #8	now, the frame pointer is changed
	   8:"		16re24dd00c 		"sub	sp, sp, #12
	   c:"		16re50b0010 		"str	r0, [fp, #-16]
	  10:"		16re51b3010 		"ldr	r3, [fp, #-16]	r3 <- [fp-16] <- r0
	  14:"		16re3530001 		"cmp	r3, #1
	  18:"		16rda00000c 		"ble	50 <fib+0x50>
	  1c:"		16re51b3010 		"ldr	r3, [fp, #-16]
	  20:"		16re2433001 		"sub	r3, r3, #1
	  24:"		16re1a00003 		"mov	r0, r3
	  28:"		16rebfffff4 		"bl	0 <fib>
	  2c:"		16re1a04000 		"mov	r4, r0
	  30:"		16re51b3010 		"ldr	r3, [fp, #-16]
	  34:"		16re2433002	 	"sub	r3, r3, #2
	  38:"		16re1a00003 		"mov	r0, r3
	  3c:"		16rebffffef 		"bl	0 <fib>
	  40:"		16re1a03000 		"mov	r3, r0
	  44:"		16re0843003 		"add	r3, r4, r3
	  48:"		16re2833001 		"add	r3, r3, #1
	  4c:"		16rea000000 		"b	54 <fib+0x54>
	  50:"		16re3a03001 		"mov	r3, #1
	  54:"		16re1a00003 		"mov	r0, r3
	  58:"		16re24bd008 		"sub	sp, fp, #8
	  5c:"		16re8bd8810 		"pop	{r4, fp, pc}")! !

!GdbARMAlienTests methodsFor: 'accessing' stamp: 'eem 12/11/2008 13:53'!
processor
	processor ifNil:
		[processor := GdbARMAlien new].
	^processor! !

!GdbARMAlienTests methodsFor: 'execution' stamp: 'lw 8/9/2012 20:57'!
runNFib: n disassemble: disassemble printRegisters: printRegisters
	"Run nfib wth the argument. Answer the result."
	"self new runNFib: 5 disassemble: true printRegisters: true"
	| memory |
	memory := Bitmap new: 1024 * 2 withAll: self processor nopOpcode.
	memory replaceFrom: 1 to: self nfib size with: self nfib asWordArray startingAt: 1.
	self processor
		r0: n;"argument n"
		lr: memory size * 2; "return address"
		pc: 0;
		sp: (memory size * 4) - 16.
	printRegisters ifTrue:
		[self processor printRegistersOn: Transcript.
		 Transcript cr; flush].
	"run until something goes wrong."
	self processor runInMemory: memory readExecuteOnlyBelow: memory size / 2.
	printRegisters ifTrue:
		[self processor printRegistersOn: Transcript.
		 Transcript cr; flush].
	^self processor r0! !

!GdbARMAlienTests methodsFor: 'execution' stamp: 'lw 7/11/2012 13:45'!
singleStepNFib: n disassemble: disassemble printRegisters: printRegisters
	"Run nfib wth the argument. Answer the result."
	"self new runNFib: 5 disassemble: true printRegisters: true"
	| memory |
	memory := WordArray new: 1024 * 2 withAll: self processor nopOpcode.
	memory replaceFrom: 1 to: self nfib size with: self nfib asWordArray startingAt: 1.
	self processor
		r0: n; "argument n"
		lr: self nfib size * 4;  "return address"
		pc: 0;
		sp: (memory size * 4 - 12). "Room for return address, frame pointer and r4"
	printRegisters ifTrue:
		[self processor printRegistersOn: Transcript.
		 Transcript cr; flush].
	[disassemble ifTrue:
		[Transcript nextPutAll: (self processor disassembleNextInstructionIn: memory); cr; flush].
	 self processor singleStepIn: memory readExecuteOnlyBelow: memory size * 4 / 2.
	 printRegisters ifTrue:
		[self processor printRegistersOn: Transcript.
		 Transcript cr; flush].
	"stop, once we leave the nfib code and step through the nops after that."
	 self processor pc < (self nfib size * 4)] whileTrue.
	^self processor r0! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 5/8/2014 08:38'!
testCall
	"Call a function that is in-range."
	
	"self new testCall"
	| memory |
	memory := self memory.
	self processor reset.

	memory unsignedLongAt: 5 put: (CogARMCompiler new mov: 10 imm: 0 ror: 0)  bigEndian: false. 
	memory unsignedLongAt: 9 put: (CogARMCompiler new orr: 10 imm: 0 ror: 0) bigEndian: false.
	memory unsignedLongAt: 13 put: (CogARMCompiler new orr: 10 imm: 0 ror: 0) bigEndian: false. 
	memory unsignedLongAt: 17 put: (CogARMCompiler new orr: 10 imm: 40 ror: 0) bigEndian: false. 

	memory unsignedLongAt: 21 put: (CogARMCompiler new bl: 12) bigEndian: false.

	memory unsignedLongAt: 25 put: (CogARMCompiler new mov:5imm: 99 ror:0 ) bigEndian: false.
	memory unsignedLongAt: 41 put: (CogARMCompiler new mov: 4 imm: 42 ror: 0) bigEndian: false.
	memory unsignedLongAt: 45 put: (CogARMCompiler new bx: 14) bigEndian: false.
	
	"processor disassembleFrom: 0 to: 60 in: memory on: Transcript cr"
	self processor
			pc: 4;
			sp: (memory size - 4); "Room for return address"
			singleStepIn: memory.
			"We have to step several times, because the first step only changes the pc, but does not fetch anything from the address it points to."
	self processor singleStepIn: memory.
	self processor singleStepIn: memory.
	self processor singleStepIn: memory.
	self assert: processor pc = 16r14.
	self processor singleStepIn: memory.
	self assert: processor pc = 16r28 "check the call".
	self processor singleStepIn: memory.
	self assert: processor r4 = 42.
	self processor singleStepIn: memory.
	self processor singleStepIn: memory.

	self assert: self processor pc = 16r1C.
	self assert: self processor lr = 16r18.
	self assert: self processor r5 = 99
! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 5/12/2014 17:25'!
testCallTrap
	"Call a function that is out-of-range.  Ensure the call is trapped."
	"self new testCallTrap"
	| memory |
	memory := self memory.
	memory unsignedLongAt: 5 put: (CogARMCompiler new bl: 1020) bigEndian: false.
	"Can't do this diassemble until after the #asByteArray - "
	"processor disassembleFrom: 0 to:16 in: memory on: Transcript cr"
	self processor
			pc: 4;
			sp: (memory size - 4); "Room for return address"
			singleStepIn: memory.
			"We have to step twice, because the first step only changes the pc, but does not fetch anything from the address it points to."
	self should: [self processor singleStepIn: memory]
		raise: ProcessorSimulationTrap
		withExceptionDo:
			[:pst|
			self assert: self processor pc = 4.
			self assert: self processor lr = 8.
			self assert: pst pc = 4.
			self assert: pst nextpc = 8.
			self assert: pst address = 1032.
			self assert: pst type = #call].! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 5/12/2014 17:26'!
testCallTrap2
	"Call a function that is out-of-range.  Ensure the call is trapped
	This version calls well outside the memory array."
	"self new testCallTrap2"
	| memory |
	memory := self memory.
	memory unsignedLongAt: 5 put: (CogARMCompiler new bl: 16rFF00) bigEndian: false.
	"Can't do this diassemble until after the #asByteArray - "
	"processor disassembleFrom: 0 to:16 in: memory on: Transcript cr"
	self processor
			pc: 4;
			sp: (memory size - 4); "Room for return address"
			singleStepIn: memory.
			"We have to step twice, because the first step only changes the pc, but does not fetch anything from the address it points to."
	self should: [self processor singleStepIn: memory]
		raise: ProcessorSimulationTrap
		withExceptionDo:
			[:pst|
			self assert: self processor pc = 16r4.
			self assert: self processor lr = 8.
			self assert: pst pc = 4.
			self assert: pst nextpc = 8.
			self assert: pst address  = 16rFF0C.
			self assert: pst type = #call].! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 5/12/2014 17:26'!
testCallTrap3
	"Call a function that is out-of-range.  Ensure the call is trapped
	This version calls well outside the memory array negatively"
	"self new testCallTrap3"
	| memory |
	memory := self memory.
	memory unsignedLongAt: 5 put: (CogARMCompiler new bl: -16rFF00) bigEndian: false.
	"Can't do this diassemble until after the #asByteArray - "
	"processor disassembleFrom: 0 to:16 in: memory on: Transcript cr"
	self processor
			pc: 4;
			sp: (memory size - 4); "Room for return address"
			singleStepIn: memory.
			"We have to step twice, because the first step only changes the pc, but does not fetch anything from the address it points to."
	self should: [self processor singleStepIn: memory]
		raise: ProcessorSimulationTrap
		withExceptionDo:
			[:pst|
			self assert: self processor pc = 16r4.
			self assert: self processor lr = 8.
			self assert: pst pc = 4.
			self assert: pst nextpc = 8.
			self assert: pst address  = 16rFFFF010C.
			self assert: pst type = #call].! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 5/6/2014 15:28'!
testDisassembling
	"self new testDisassembling"

	| memory result |
	memory := WordArray new: 2.
	memory at: 1 put: 3800756324.
	result := self processor
		disassembleInstructionAt: 0 
		In: memory 
		into: [:str :len | 
			self 
				assert: len = 4;
				assert: str = '00000000: add	pc, sl, #100	; 0x64'].! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 5/12/2014 17:20'!
testExecutionTrap
	"Execute a run of nops.  test executing beyond the executable limit is trapped."
	"self new testExecutionTrap"
	| memory |
	 "Run through NOPs until we hit the limit set by readOnlyBelow: "
	memory := (Bitmap new: 1024 * 2 withAll: self processor nopOpcode) asByteArray.
	self processor
			pc: 0;
			sp: (memory size - 4). "Room for return address"
	self should: [self processor runInMemory: memory minimumAddress: 0 readOnlyBelow: memory size / 2]
		raise: Error
		withExceptionDo:
			[:err|
			self assert: self processor pc = (memory size / 2-4).
			self assert: ('Error 0: Illegal Instruction fetch address (0x1000).' match: err messageText)].
	self processor reset;  pc: 0.
	self should: [[self processor singleStepIn: memory minimumAddress: 0 readOnlyBelow: memory size / 2] repeat]
		raise: Error
		withExceptionDo:
			[:err|
			self assert: self processor pc = (memory size / 2- 4).
			self assert: ('Error 0: Illegal Instruction fetch address (0x1000).' match: err messageText)]! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 5/6/2014 15:31'!
testFlags
"test the processor flag state reading and setting"
	"self new testFlags"
	| memory |
	memory := Bitmap new: 5.
	self processor reset.
	memory longAt: 1 put: 16rE3A03001 bigEndian: false. "MOV r3, #1"
	memory longAt: 5 put: 16rE3530001 bigEndian: false. "CMP r3, #1"
	memory longAt: 9 put: 16r13A00003 bigEndian: false. "MOVNE r0, #3"
	memory longAt: 13 put: 16r03A00005 bigEndian: false. "MOVEQ r0, #5"
	memory := memory asByteArray.
	self processor
		disassembleInstructionAt: 0 
		In: memory 
		into: [:str :len | 
			self 
				assert: len = 4;
				assert: str equals: '00000000: mov	r3, #1'].
	self processor
		disassembleInstructionAt: 4 
		In: memory 
		into: [:str :len | 
			self 
				assert: len = 4;
				assert: str equals: '00000004: cmp	r3, #1'].
	self processor
		disassembleInstructionAt: 8 
		In: memory 
		into: [:str :len | 
			self 
				assert: len = 4;
				assert: str equals: '00000008: movne	r0, #3'].
	self processor
		disassembleInstructionAt: 12 
		In: memory 
		into: [:str :len | 
			self 
				assert: len = 4;
				assert: str equals: '0000000c: moveq	r0, #5'].
	self processor
		pc: 0;
		singleStepIn: memory;
		singleStepIn: memory;
		singleStepIn: memory;
		assert: self processor r0 = 0;
		singleStepIn: memory.
	self 
		assert: self processor pc = 16;
		assert: self processor r3 = 1;
		assert: self processor r0 = 5;
		assert: self processor zflag = 1;
		assert: self processor cflag = 1;
		assert: self processor vflag = 0;
		assert: self processor nflag = 0.
	self processor reset.
	self assert: self processor eflags = 3. "IFFlags are both set."! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 5/8/2014 08:42'!
testJump
	"Jump in-range."
	
	"self new testJump"
	| memory |
	memory := self memory.
	self processor reset.

	memory unsignedLongAt: 5 put: (CogARMCompiler new mov: 10 imm: 0 ror: 0)  bigEndian: false. 
	memory unsignedLongAt: 9 put: (CogARMCompiler new orr: 10 imm: 0 ror: 0) bigEndian: false.
	memory unsignedLongAt: 13 put: (CogARMCompiler new orr: 10 imm: 0 ror: 0) bigEndian: false. 
	memory unsignedLongAt: 17 put: (CogARMCompiler new orr: 10 imm: 40 ror: 0) bigEndian: false. 

	memory unsignedLongAt: 21 put: (CogARMCompiler new b: 12) bigEndian: false.

	memory unsignedLongAt: 25 put: (CogARMCompiler new mov:5imm: 99 ror:0 ) bigEndian: false.
	memory unsignedLongAt: 41 put: (CogARMCompiler new mov: 4 imm: 42 ror: 0) bigEndian: false.
	memory unsignedLongAt: 45 put: (CogARMCompiler new bx: 14) bigEndian: false.
	
	"processor disassembleFrom: 0 to: 60 in: memory on: Transcript cr"
	self processor
			pc: 4;
			sp: (memory size - 4); "Room for return address"
			singleStepIn: memory.
			"We have to step several times, because the first step only changes the pc, but does not fetch anything from the address it points to."
	self processor singleStepIn: memory.
	self processor singleStepIn: memory.
	self processor singleStepIn: memory.
	self assert: processor pc = 16r14.
	self processor singleStepIn: memory.
	self assert: processor pc = 16r28 "check the call".
	self processor singleStepIn: memory.
	self assert: processor r4= 42.
! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 5/11/2014 03:19'!
testJumpTrap
	"Jump a function that is out-of-range.  Ensure the call is trapped."
	"self new testJumpTrap"
	| memory |
	memory := self memory.
	memory unsignedLongAt: 5 put: (CogARMCompiler new b: 1020) bigEndian: false.
	"Can't do this diassemble until after the #asByteArray - "
	"processor disassembleFrom: 0 to:16 in: memory on: Transcript cr"
	self processor
			pc: 4;
			sp: (memory size - 4); "Room for return address"
			singleStepIn: memory.
			"We have to step twice, because the first step only changes the pc, but does not fetch anything from the address it points to."
	self should: [self processor singleStepIn: memory]
		raise: ProcessorSimulationTrap
		withExceptionDo:
			[:pst|
			self assert: self processor pc = 4.
			self assert: self processor lr = 0.
			self assert: pst pc = 4.
			self assert: pst nextpc = 8.
			self assert: pst address = 1032.
			self assert: pst type = #jump].! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 5/7/2014 18:44'!
testLongCall
	"Long-Call a function that is in-range."
	
	"self new testLongCall"
	| memory |
	memory := self memory.
	self processor reset.

	memory unsignedLongAt: 5 put: (CogARMCompiler new mov: 10 imm: 0 ror: 0)  bigEndian: false. 
	memory unsignedLongAt: 9 put: (CogARMCompiler new orr: 10 imm: 0 ror: 0) bigEndian: false.
	memory unsignedLongAt: 13 put: (CogARMCompiler new orr: 10 imm: 0 ror: 0) bigEndian: false. 
	memory unsignedLongAt: 17 put: (CogARMCompiler new orr: 10 imm: 40 ror: 0) bigEndian: false. 

	memory unsignedLongAt: 21 put: (CogARMCompiler new blx: 10) bigEndian: false.

	memory unsignedLongAt: 25 put: (CogARMCompiler new mov:5imm: 99 ror:0 ) bigEndian: false.
	memory unsignedLongAt: 41 put: (CogARMCompiler new mov: 4 imm: 42 ror: 0) bigEndian: false.
	memory unsignedLongAt: 45 put: (CogARMCompiler new bx: 14) bigEndian: false.
	
	"processor disassembleFrom: 0 to: 60 in: memory on: Transcript cr"
	self processor
			pc: 4;
			sp: (memory size - 4); "Room for return address"
			singleStepIn: memory.
			"We have to step several times, because the first step only changes the pc, but does not fetch anything from the address it points to."
	self processor singleStepIn: memory.
	self processor singleStepIn: memory.
	self processor singleStepIn: memory.
	self assert: processor pc = 16r14.
	self processor singleStepIn: memory.
	self assert: processor pc = 16r28 "check the call".
	self processor singleStepIn: memory.
	self assert: processor r4 = 42.
	self processor singleStepIn: memory.
	self processor singleStepIn: memory.

	self assert: self processor pc = 16r1C.
	self assert: self processor lr = 16r18.
	self assert: self processor r5 = 99
! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 5/12/2014 17:28'!
testLongCallTrap
	"Long-Call a function that is above-range."
	
	"self new testLongCallTrap"
	| memory |
	memory := self memory.
	self processor reset.

	memory unsignedLongAt: 5 put: (CogARMCompiler new mov: 10 imm: 0 ror: 0)  bigEndian: false. 
	memory unsignedLongAt: 9 put: (CogARMCompiler new orr: 10 imm: 0 ror: 0) bigEndian: false.
	memory unsignedLongAt: 13 put: (CogARMCompiler new orr: 10 imm: 4 ror: 24) bigEndian: false. 
	memory unsignedLongAt: 17 put: (CogARMCompiler new orr: 10 imm: 0 ror: 0) bigEndian: false. 

	memory unsignedLongAt: 21 put: (CogARMCompiler new blx: 10) bigEndian: false.

	memory unsignedLongAt: 25 put: (CogARMCompiler new mov:5imm: 99 ror:0 ) bigEndian: false.
	memory unsignedLongAt: 41 put: (CogARMCompiler new mov: 4 imm: 42 ror: 0) bigEndian: false.
	memory unsignedLongAt: 45 put: (CogARMCompiler new bx: 14) bigEndian: false.
	
	"processor disassembleFrom: 0 to: 60 in: memory on: Transcript cr"
	self processor
			pc: 4;
			sp: (memory size - 4); "Room for return address"
			singleStepIn: memory.
			"We have to step several times, because the first step only changes the pc, but does not fetch anything from the address it points to."
	self should: [self processor singleStepIn: memory.
				self processor singleStepIn: memory.
				self processor singleStepIn: memory.
				self processor singleStepIn: memory.
				self processor singleStepIn: memory.
				self processor singleStepIn: memory.
				self processor singleStepIn: memory]
		raise: ProcessorSimulationTrap
		withExceptionDo:
			[:pst|
			self assert: self processor pc = 16r14.
			self assert: self processor lr = 16r18.
			self assert: pst pc = 16r14.
			self assert: pst nextpc = 16r18.
			self assert: pst address = 1024.
			self assert: pst type = #call].! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 5/12/2014 17:28'!
testLongCallTrap2
	"Long-Call a function that is way outside range."
	
	"self new testLongCallTrap2"
	| memory |
	memory := self memory.
	self processor reset.

	memory unsignedLongAt: 5 put: (CogARMCompiler new mov: 10 imm: 16rFF ror: 8)  bigEndian: false. 
	memory unsignedLongAt: 9 put: (CogARMCompiler new orr: 10 imm: 0 ror: 0) bigEndian: false.
	memory unsignedLongAt: 13 put: (CogARMCompiler new orr: 10 imm: 4 ror: 24) bigEndian: false. 
	memory unsignedLongAt: 17 put: (CogARMCompiler new orr: 10 imm: 0 ror: 0) bigEndian: false. 

	memory unsignedLongAt: 21 put: (CogARMCompiler new blx: 10) bigEndian: false.

	memory unsignedLongAt: 25 put: (CogARMCompiler new mov:5imm: 99 ror:0 ) bigEndian: false.
	memory unsignedLongAt: 41 put: (CogARMCompiler new mov: 4 imm: 42 ror: 0) bigEndian: false.
	memory unsignedLongAt: 45 put: (CogARMCompiler new bx: 14) bigEndian: false.
	
	"processor disassembleFrom: 0 to: 60 in: memory on: Transcript cr"
	self processor
			pc: 4;
			sp: (memory size - 4); "Room for return address"
			singleStepIn: memory.
			"We have to step several times, because the first step only changes the pc, but does not fetch anything from the address it points to."
	self should: [self processor singleStepIn: memory.
				self processor singleStepIn: memory.
				self processor singleStepIn: memory.
				self processor singleStepIn: memory.
				self processor singleStepIn: memory.
				self processor singleStepIn: memory.
				self processor singleStepIn: memory]
		raise: ProcessorSimulationTrap
		withExceptionDo:
			[:pst|
			self assert: self processor pc = 16r14.
			self assert: self processor lr = 16r18.
			self assert: pst pc = 16r14.
			self assert: pst nextpc = 16r18.
			self assert: pst address = 16rFF000400.
			self assert: pst type = #call].! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 5/8/2014 08:47'!
testLongJump
	"Jump in-range."
	
	"self new testLongJump"
	| memory |
	memory := self memory.
	self processor reset.

	memory unsignedLongAt: 5 put: (CogARMCompiler new mov: 10 imm: 0 ror: 0)  bigEndian: false. 
	memory unsignedLongAt: 9 put: (CogARMCompiler new orr: 10 imm: 0 ror: 0) bigEndian: false.
	memory unsignedLongAt: 13 put: (CogARMCompiler new orr: 10 imm: 0 ror: 0) bigEndian: false. 
	memory unsignedLongAt: 17 put: (CogARMCompiler new orr: 10 imm: 40 ror: 0) bigEndian: false. 

	memory unsignedLongAt: 21 put: (CogARMCompiler new bx: 10) bigEndian: false.

	memory unsignedLongAt: 25 put: (CogARMCompiler new mov:5imm: 99 ror:0 ) bigEndian: false.
	memory unsignedLongAt: 41 put: (CogARMCompiler new mov: 4 imm: 42 ror: 0) bigEndian: false.
	memory unsignedLongAt: 45 put: (CogARMCompiler new bx: 14) bigEndian: false.
	
	"processor disassembleFrom: 0 to: 60 in: memory on: Transcript cr"
	self processor
			pc: 4;
			sp: (memory size - 4); "Room for return address"
			singleStepIn: memory.
			"We have to step several times, because the first step only changes the pc, but does not fetch anything from the address it points to."
	self processor singleStepIn: memory.
	self processor singleStepIn: memory.
	self processor singleStepIn: memory.
	self assert: processor pc = 16r14.
	self processor singleStepIn: memory.
	self assert: processor pc = 16r28 "check the call".
	self processor singleStepIn: memory.
	self assert: processor r4= 42.
! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 5/8/2014 07:50'!
testLongJumpAddressForming
	"self new testLongJumpAddressForming"
	"test of the somewhat loopy code used in CogARMCompiler>concretizeConditionalJumpLong: to generate the oading of a long address for jumps"
	| memory |
	memory := self memory.
	self processor reset.
	memory unsignedLongAt: 1 put: (CogARMCompiler new mov: 10 imm: 16r7F ror: 8)  bigEndian: false. 
	memory unsignedLongAt: 5 put: (CogARMCompiler new orr: 10 imm: 16rFF ror: 16) bigEndian: false.
	memory unsignedLongAt: 9 put: (CogARMCompiler new orr: 10 imm: 16rFE ror: 24) bigEndian: false. 
	memory unsignedLongAt: 13 put: (CogARMCompiler new orr: 10 imm: 16r68 ror: 0) bigEndian: false. 

	self processor
		disassembleInstructionAt: 0 
		In: memory 
		into: [:str :len | 
			self 
				assert: len = 4;
				assert: str equals: '00000000: mov	sl, #2130706432	; 0x7f000000'].
	self processor
		disassembleInstructionAt: 4 
		In: memory 
		into: [:str :len | 
			self 
				assert: len = 4;
				assert: str equals: '00000004: orr	sl, sl, #16711680	; 0xff0000'].
	self processor
		disassembleInstructionAt: 8 
		In: memory 
		into: [:str :len | 
			self 
				assert: len = 4;
				assert: str equals: '00000008: orr	sl, sl, #65024	; 0xfe00'].
	self processor
		disassembleInstructionAt: 12 
		In: memory 
		into: [:str :len | 
			self 
				assert: len = 4;
				assert: str equals: '0000000c: orr	sl, sl, #104	; 0x68'].
	self processor
		pc: 0;
		singleStepIn: memory;
		singleStepIn: memory;
		singleStepIn: memory;
		singleStepIn: memory.
	self 
		assert: self processor pc = 16;
		assert: self processor r10 = 16r7FFFFE68;
		assert: self processor zflag = 0;
		assert: self processor cflag = 0;
		assert: self processor vflag = 0;
		assert: self processor nflag = 0.
! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 5/12/2014 17:29'!
testLongJumpTrap
	"Long-Jump a function that is above-range."
	
	"self new testLongJumpTrap"
	| memory |
	memory := self memory.
	self processor reset.

	memory unsignedLongAt: 5 put: (CogARMCompiler new mov: 10 imm: 0 ror: 0)  bigEndian: false. 
	memory unsignedLongAt: 9 put: (CogARMCompiler new orr: 10 imm: 0 ror: 0) bigEndian: false.
	memory unsignedLongAt: 13 put: (CogARMCompiler new orr: 10 imm: 4 ror: 24) bigEndian: false. 
	memory unsignedLongAt: 17 put: (CogARMCompiler new orr: 10 imm: 0 ror: 0) bigEndian: false. 

	memory unsignedLongAt: 21 put: (CogARMCompiler new bx: 10) bigEndian: false.

	memory unsignedLongAt: 25 put: (CogARMCompiler new mov:5imm: 99 ror:0 ) bigEndian: false.
	memory unsignedLongAt: 41 put: (CogARMCompiler new mov: 4 imm: 42 ror: 0) bigEndian: false.
	memory unsignedLongAt: 45 put: (CogARMCompiler new bx: 14) bigEndian: false.
	
	"processor disassembleFrom: 0 to: 60 in: memory on: Transcript cr"
	self processor
			pc: 4;
			sp: (memory size - 4); "Room for return address"
			singleStepIn: memory.
			"We have to step several times, because the first step only changes the pc, but does not fetch anything from the address it points to."
	self should: [self processor singleStepIn: memory.
				self processor singleStepIn: memory.
				self processor singleStepIn: memory.
				self processor singleStepIn: memory.
				self processor singleStepIn: memory.
				self processor singleStepIn: memory.
				self processor singleStepIn: memory]
		raise: ProcessorSimulationTrap
		withExceptionDo:
			[:pst|
			self assert: self processor pc = 16r14.
			self assert: pst pc = 16r14.
			self assert: pst nextpc = 16r18.
			self assert: pst address = 1024.
			self assert: pst type =  #jump].! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 5/12/2014 15:54'!
testMoveAwR
	"Read a register from a constant address that is in-range."
	
	"self new testMoveAwR"
	| memory |
	memory := self memory.
	self processor reset.

	"LEA sl, #16r228"
	memory unsignedLongAt: 5 put: (CogARMCompiler new mov: 10 imm: 0 ror: 0)  bigEndian: false. 
	memory unsignedLongAt: 9 put: (CogARMCompiler new orr: 10 imm: 0 ror: 0) bigEndian: false.
	memory unsignedLongAt: 13 put: (CogARMCompiler new orr: 10 imm: 2 ror: 24) bigEndian: false. 
	memory unsignedLongAt: 17 put: (CogARMCompiler new orr: 10 imm: 40 ror: 0) bigEndian: false. 
	"LDR R5, [sl]"
	memory unsignedLongAt: 21 put: (CogARMCompiler new ldr: 5 rn: 10 plusImm: 0) bigEndian: false.

	
	"processor disassembleFrom: 0 to: 60 in: memory on: Transcript cr"
	memory unsignedLongAt: 16r228 + 1 put: 99.
	self processor
			pc: 4;
			sp: (memory size - 4); "Room for return address"
			singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
			"We have to step several times, because the first step only changes the pc, but does not fetch anything from the address it points to."
	self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
	self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
	self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
	self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
	self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
	self assert:[processor r5 = 99]
! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 5/12/2014 16:12'!
testMoveAwRTrap1
	"Read from a register at a constant address that is out-of--range."
	
	"self new testMoveAwRTrap1"
	| memory |
	memory := self memory.
	self processor reset.

	"LEA sl, #16rFF00001FC"
	memory unsignedLongAt: 5 put: (CogARMCompiler new mov: 10 imm: 16rFF ror: 8)  bigEndian: false. 
	memory unsignedLongAt: 9 put: (CogARMCompiler new orr: 10 imm: 0 ror: 0) bigEndian: false.
	memory unsignedLongAt: 13 put: (CogARMCompiler new orr: 10 imm: 1 ror: 24) bigEndian: false. 
	memory unsignedLongAt: 17 put: (CogARMCompiler new orr: 10 imm: 16rFC ror: 0) bigEndian: false. 
	"STR R5, [sl]"
	memory unsignedLongAt: 21 put: (CogARMCompiler new ldr: 5 rn: 10 plusImm: 0) bigEndian: false.

	
	"processor disassembleFrom: 0 to: 60 in: memory on: Transcript cr"
	self processor
			pc: 4;
			sp: (memory size - 4); "Room for return address"
			singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
			"We have to step several times, because the first step only changes the pc, but does not fetch anything from the address it points to."
	
	self should: [self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2]
		raise: ProcessorSimulationTrap
		withExceptionDo:
			[:pst|
			self assert: self processor pc = 16r14.
			self assert: pst pc = 16r14.
			self assert: pst nextpc = 16r18.
			self assert: pst address = 16rFF0001FC.
			self assert: pst type = #read]! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 5/12/2014 15:30'!
testMoveRAw
	"Write a register to a constant address that is in-range."
	
	"self new testMoveRAw"
	| memory |
	memory := self memory.
	self processor reset.

	"LEA sl, #16r3FC"
	memory unsignedLongAt: 5 put: (CogARMCompiler new mov: 10 imm: 0 ror: 0)  bigEndian: false. 
	memory unsignedLongAt: 9 put: (CogARMCompiler new orr: 10 imm: 0 ror: 0) bigEndian: false.
	memory unsignedLongAt: 13 put: (CogARMCompiler new orr: 10 imm: 2 ror: 24) bigEndian: false. 
	memory unsignedLongAt: 17 put: (CogARMCompiler new orr: 10 imm: 40 ror: 0) bigEndian: false. 
	"STR R5, [sl]"
	memory unsignedLongAt: 21 put: (CogARMCompiler new str: 5 rn: 10 plusImm: 0) bigEndian: false.

	
	"processor disassembleFrom: 0 to: 60 in: memory on: Transcript cr"
	self processor
			pc: 4;
			sp: (memory size - 4); "Room for return address"
			r5: 99;
			singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
			"We have to step several times, because the first step only changes the pc, but does not fetch anything from the address it points to."
	self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
	self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
	self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
	self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
	self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
	self assert:[(memory unsignedLongAt: (processor r10) + 1) = processor r5]
! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 5/12/2014 15:36'!
testMoveRAwTrap1
	"Write a register to a constant address that is below-range."
	
	"self new testMoveRAwTrap1"
	| memory |
	memory := self memory.
	self processor reset.

	"LEA sl, #16r1FC"
	memory unsignedLongAt: 5 put: (CogARMCompiler new mov: 10 imm: 0 ror: 0)  bigEndian: false. 
	memory unsignedLongAt: 9 put: (CogARMCompiler new orr: 10 imm: 0 ror: 0) bigEndian: false.
	memory unsignedLongAt: 13 put: (CogARMCompiler new orr: 10 imm: 1 ror: 24) bigEndian: false. 
	memory unsignedLongAt: 17 put: (CogARMCompiler new orr: 10 imm: 16rFC ror: 0) bigEndian: false. 
	"STR R5, [sl]"
	memory unsignedLongAt: 21 put: (CogARMCompiler new str: 5 rn: 10 plusImm: 0) bigEndian: false.

	
	"processor disassembleFrom: 0 to: 60 in: memory on: Transcript cr"
	self processor
			pc: 4;
			sp: (memory size - 4); "Room for return address"
			r5: 99;
			singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
			"We have to step several times, because the first step only changes the pc, but does not fetch anything from the address it points to."
	
	self should: [self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2]
		raise: ProcessorSimulationTrap
		withExceptionDo:
			[:pst|
			self assert: self processor pc = 16r14.
			self assert: pst pc = 16r14.
			self assert: pst nextpc = 16r18.
			self assert: pst address = 16r1FC.
			self assert: pst type = #write]! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 5/12/2014 15:46'!
testMoveRAwTrap2
	"Write a register to a constant address that is below-range."
	
	"self new testMoveRAwTrap2"
	| memory |
	memory := self memory.
	self processor reset.

	"LEA sl, #16r1FC"
	memory unsignedLongAt: 5 put: (CogARMCompiler new mov: 10 imm: 0 ror: 0)  bigEndian: false. 
	memory unsignedLongAt: 9 put: (CogARMCompiler new orr: 10 imm: 0 ror: 0) bigEndian: false.
	memory unsignedLongAt: 13 put: (CogARMCompiler new orr: 10 imm: 16rFF ror: 24) bigEndian: false. 
	memory unsignedLongAt: 17 put: (CogARMCompiler new orr: 10 imm: 16rFC ror: 0) bigEndian: false. 
	"STR R5, [sl]"
	memory unsignedLongAt: 21 put: (CogARMCompiler new str: 5 rn: 10 plusImm: 0) bigEndian: false.

	
	"processor disassembleFrom: 0 to: 60 in: memory on: Transcript cr"
	self processor
			pc: 4;
			sp: (memory size - 4); "Room for return address"
			r5: 99;
			singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
			"We have to step several times, because the first step only changes the pc, but does not fetch anything from the address it points to."
	
	self should: [self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size / 2]
		raise: ProcessorSimulationTrap
		withExceptionDo:
			[:pst|
			self assert: self processor pc = 16r14.
			self assert: pst pc = 16r14.
			self assert: pst nextpc = 16r18.
			self assert: pst address = 16rFFFC.
			self assert: pst type = #write]! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'lw 8/18/2012 14:24'!
testNfib1
	"self new testNfib1"
	self should: [self runNFib: 1 disassemble: false printRegisters: false]
		raise: Error
		withExceptionDo: 
			[:err| self assert: err messageText = 'Error 0: Illegal Instruction fetch address (0x1000).'].
	self deny: (self processor pc between: 0 and: self nfib size).
	self assert: self processor r0 = 1 benchFib! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'lw 7/11/2012 14:21'!
testNfib16
	"self new testNfib16"
	self should: [self runNFib: 16 disassemble: false printRegisters: false]
		raise: Error.
	self deny: (self processor pc between: 0 and: self nfib size).
	self assert: self processor r0 = 16 benchFib! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'lw 7/10/2012 14:29'!
testNfib2
	"self new testNfib2"
	self should: [self runNFib: 2 disassemble: false printRegisters: false]
		raise: Error.
	self deny: (self processor pc between: 0 and: self nfib size).
	self assert: self processor r0 = 2 benchFib! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'lw 7/11/2012 14:20'!
testNfib4
	"self new testNfib4"
	self should: [self runNFib: 4 disassemble: false printRegisters: false]
		raise: Error.
	self deny: (self processor pc between: 0 and: self nfib size).
	self assert: self processor r0 = 4 benchFib! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 4/30/2014 11:15'!
testQuickDisassemby
	"self new testQuickDisassemby"

	| memory result |
	memory := WordArray new: 2.
	memory at: 1 put: 3858758348.
	result := self processor
		disassembleInstructionAt: 0 
		In: memory 
		into: [:str :len | 
			^str].! !

!GdbARMAlienTests methodsFor: 'execution' stamp: 'tpr 4/30/2014 11:43'!
testQuickDisassembyOf: word
	"self new testQuickDisassembyOf: 3858758348"

	| memory result |
	memory := WordArray new: 2.
	memory at: 1 put: word.
	result := self processor
		disassembleInstructionAt: 0 
		In: memory 
		into: [:str :len | 
			^str].! !

!GdbARMAlienTests methodsFor: 'execution' stamp: 'eem 3/18/2014 10:44'!
testResetCPU
	"self new testResetCPU"
	self integerRegisterSetters do:
		[:setter|
		self processor perform: setter with: 16r55555555].
	self integerRegisterGetters do:
		[:getter|
		self assert: 16r55555555 = (self processor perform: getter)].
	self processor reset.
	self integerRegisterGetters do:
		[:getter|
		self assert: 0 = (self processor perform: getter)]! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 5/27/2014 18:17'!
testReturnTrap
	"return above-range."
	
	"self new testReturnTrap"
	| memory |
	memory := self memory.
	self processor reset.

	"assemble a nasty number in r10"
	memory unsignedLongAt: 5 put: (CogARMCompiler new mov: 10 imm: 16r1E ror: 8)  bigEndian: false. 
	memory unsignedLongAt: 9 put: (CogARMCompiler new orr: 10 imm: 0 ror: 0) bigEndian: false.
	memory unsignedLongAt: 13 put: (CogARMCompiler new orr: 10 imm: 0 ror: 0) bigEndian: false. 
	memory unsignedLongAt: 17 put: (CogARMCompiler new orr: 10 imm: 1 ror: 0) bigEndian: false. 
	"push this on the stack"
	memory unsignedLongAt: 21 put: (CogARMCompiler new pushR: 10) bigEndian: false.
	"pop the stack into pc to emulate a return via stack as generated in  various trampoline code"	
	memory unsignedLongAt: 25 put: (CogARMCompiler new popR: 15) bigEndian: false.

	
	"processor disassembleFrom: 0 to: 60 in: memory on: Transcript cr"
	self processor
			pc: 4;
			sp: (memory size - 4); "Room for return address"
			singleStepIn: memory readExecuteOnlyBelow: memory size /2 .
			"We have to step several times, because the first step only changes the pc, but does not fetch anything from the address it points to."
	self should: [self processor singleStepIn: memory readExecuteOnlyBelow: memory size /2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size /2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size /2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size /2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size /2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size /2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size /2]
		raise: ProcessorSimulationTrap
		withExceptionDo:
			[:pst|
			self assert: self processor pc = 16r18.
			self assert: pst pc = 16r18.
			self assert: pst nextpc = 16r1C.
			self assert: pst address = 16r1E000000.
			self assert: pst type = #return].! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 5/27/2014 14:52'!
testReturnTrap2
	"return above-range."
	
	"self new testReturnTrap2"
	| memory |
	memory := self memory.
	self processor reset.

	"assemble a nasty number in r10"
	memory unsignedLongAt: 5 put: (CogARMCompiler new mov: 10 imm: 16r1E ror: 8)  bigEndian: false. 
	memory unsignedLongAt: 9 put: (CogARMCompiler new orr: 10 imm: 0 ror: 0) bigEndian: false.
	memory unsignedLongAt: 13 put: (CogARMCompiler new orr: 10 imm: 0 ror: 0) bigEndian: false. 
	memory unsignedLongAt: 17 put: (CogARMCompiler new orr: 10 imm: 0 ror: 0) bigEndian: false. 
	"push this on the stack"
	memory unsignedLongAt: 21 put: (CogARMCompiler new pushR: 10) bigEndian: false.
	"pop the stack into pc to emulate a return via stack as generated in  various trampoline code"	
	memory unsignedLongAt: 25 put: (CogARMCompiler new popR: 15) bigEndian: false.

	
	"processor disassembleFrom: 0 to: 60 in: memory on: Transcript cr"
	self processor
			pc: 4;
			sp: (memory size - 4); "Room for return address"
			singleStepIn: memory readExecuteOnlyBelow: memory size /2 .
			"We have to step several times, because the first step only changes the pc, but does not fetch anything from the address it points to."
	self should: [self processor runInMemory: memory readExecuteOnlyBelow: memory size /2.]
		raise: ProcessorSimulationTrap
		withExceptionDo:
			[:pst|
			self assert: self processor pc = 16r18.
			self assert: pst pc = 16r18.
			self assert: pst nextpc = 16r1C.
			self assert: pst address = 16r1E000000.
			self assert: pst type = #return].! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'tpr 5/28/2014 07:20'!
testReturnTrapWithThumbBug
	"return above-range with a bad address that ends in 1 - which triggers an ARM sim bug"
	
	"self new testReturnTrapWithThumbBug"
	| memory |
	memory := self memory.
	self processor reset.

	"pop the stack into pc to emulate a return via stack as generated in  various trampoline code"	
	memory unsignedLongAt: 1 put: (CogARMCompiler new mov: 15 rn: 14) bigEndian: false.

	
	"processor disassembleFrom: 0 to: 60 in: memory on: Transcript cr"
	self processor
			pc: 0;
			sp: (memory size - 4); "Room for return address"
			pushWord:16r1E000001 in: memory;
			singleStepIn: memory readExecuteOnlyBelow: memory size /2 .
			"We have to step several times, because the first step only changes the pc, but does not fetch anything from the address it points to."
	self should: [self processor singleStepIn: memory readExecuteOnlyBelow: memory size /2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size /2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size /2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size /2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size /2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size /2.
				self processor singleStepIn: memory readExecuteOnlyBelow: memory size /2]
		raise: ProcessorSimulationTrap
		withExceptionDo:
			[:pst|
			self assert: self processor pc = 16r18.
			self assert: pst pc = 16r18.
			self assert: pst nextpc = 16r1C.
			self assert: pst address = 16r1E000000.
			self assert: pst type = #return].! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'lw 7/11/2012 13:27'!
testStepNfib1
	"self new testStepNfib1"
	self singleStepNFib: 1 disassemble: false printRegisters: false.
	self assert: self processor pc = (self nfib asWordArray size * 4).
	self assert: self processor r0 = 1 benchFib! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'lw 7/11/2012 14:19'!
testStepNfib2
	"self new testStepNfib2"
	self singleStepNFib: 2 disassemble: false printRegisters: false.
	self assert: self processor pc = (self nfib size * 4).
	self assert: self processor r0 = 2 benchFib! !

!GdbARMAlienTests methodsFor: 'tests' stamp: 'lw 7/11/2012 14:20'!
testStepNfib4
	"self new testStepNfib4"
	self singleStepNFib: 4 disassemble: false printRegisters: false.
	self assert: self processor pc = (self nfib size * 4).
	self assert: self processor r0 = 4 benchFib! !

Object subclass: #BytecodeEncoderPutschEditor
	instanceVariableNames: 'xlator xlation kwdxlation ranges index output codeIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Morphing Bytecode Set'!

!BytecodeEncoderPutschEditor commentStamp: '<historical>' prior: 0!
I am a MethodNode that uses the size and emit methods that use the BytecodeEncoder hierarchy's bytecode generation facilities.  This means my nodes no longer need encode specifics about the bytecode set.

To compile edited versions of the size* and emit* methods use
	BytecodeEncoderPutschEditor new edit

In 3.8:
To get the source of the new version of MethodNode>>generate: for BytecodeAgnosticMethodNode use
BytecodeEncoderPutschEditor new
	editCode: (MethodNode sourceCodeAt: #generate:) asString
	inClass: BytecodeAgnosticMethodNode
	withSelector: #generate:

In 3.9:
To get the source of the new version of MethodNode>>generateWith:using: for BytecodeAgnosticMethodNode use
BytecodeEncoderPutschEditor new
	editCode: (BytecodeAgnosticMethodNode sourceCodeAt: #generateWith:using:) asString
	inClass: BytecodeAgnosticMethodNode
	withSelector: #generateWith:using:!

!BytecodeEncoderPutschEditor methodsFor: 'code editing' stamp: 'eem 5/5/2008 19:24'!
edit
	| sn |
	sn := SystemNavigation default.
	xlation keysAndValuesDo:
		[:s :t|
		(sn allImplementorsOf: s localTo: ParseNode) do:
			[:md|
			md actualClass
				compile: (self editCode: md sourceString inClass: md actualClass withSelector: md methodSymbol)
				classified: 'code generation (new scheme)']]! !

!BytecodeEncoderPutschEditor methodsFor: 'code editing' stamp: 'eem 5/6/2008 10:55'!
editCode: code inClass: class withSelector: selector
	| codeString |
	ranges := SHParserST80 new rangesIn: code classOrMetaClass: class workspace: nil  environment: nil.
	index := 1.
	codeIndex := 1.
	output := String new writeStream.
	codeString := code asString.
	self process: codeString while: [:ign| true].
	"(StringHolder new textContents:
		(TextDiffBuilder buildDisplayPatchFrom: code to: output contents))
			openLabel: class name , '>>', selector."
	^output contents! !

!BytecodeEncoderPutschEditor methodsFor: 'initialize-release' stamp: 'eem 5/6/2008 10:53'!
initialize
	xlator := [:s|
			((((s allButFirst: 4) beginsWith: 'For') or: [((s allButFirst: 4) beginsWith: 'Except') or: [s fifth = $:]])
				ifTrue: [(s first: 4), 'Code', (s allButFirst: 4)]
				ifFalse: [(s first: 4), 'CodeFor', (s allButFirst: 4)]) copyReplaceAll: ':on:' with: ':encoder:'].
	xlation := Dictionary new.
	(((ParseNode withAllSubclasses removeAll: Encoder withAllSubclasses; yourself)
		inject: Set new
		into: [:s :c| s addAll: c selectors. s])
			select:
				[:s| ((s beginsWith: 'emit') or: [s beginsWith: 'size'])
					and: [(s includesSubstring: 'Code' caseSensitive: true) not]]) do:
					[:s|xlation at: s put: (xlator value: s) asSymbol].
	kwdxlation := Dictionary new.
	xlation keysAndValuesDo: [:k :v| kwdxlation at: k keywords first put: v keywords first]! !

!BytecodeEncoderPutschEditor methodsFor: 'code editing' stamp: 'eem 5/6/2008 11:25'!
process: code while: aBlock
	| range mapOnToEncoder kwd |
	mapOnToEncoder := false.
	[index <= ranges size] whileTrue:
		[range := ranges at: index.
		  (aBlock value: range) ifFalse:
			[^self].
		 index := index + 1.
		 [codeIndex < range start] whileTrue:
			[output nextPut: (code at: codeIndex).
			 codeIndex := codeIndex + 1].
		range type == #assignment
			ifTrue: [output nextPutAll: ':='.
					codeIndex := range end + 1]
			ifFalse:
				[(#(keyword patternKeyword) includes: range type) ifTrue:
					[kwd := code copyFrom: range start to: range end.
					(mapOnToEncoder and: [kwd = 'on:'])
						ifTrue:
							[output nextPutAll: 'encoder: encoder'.
							 mapOnToEncoder := false.
							 codeIndex := (ranges at: index) end + 1.
							 index := index + 1]
						ifFalse:
							[(kwdxlation includesKey: kwd) ifTrue:
								[(kwd beginsWith: 'emit') ifTrue:
									[mapOnToEncoder := true].
								 output nextPutAll: (kwdxlation at: kwd).
								 codeIndex := range end + 1]]]
					ifFalse:
						[[codeIndex <= range end] whileTrue:
							[output nextPut: (code at: codeIndex).
							 codeIndex := codeIndex + 1].
						"kill whitespace after up-arrow in ^ expr"
						(range type == #return and: [index <= ranges size]) ifTrue:
							[codeIndex := (ranges at: index) start]]]]! !

Object subclass: #ClassHierarchyDuplicator
	instanceVariableNames: 'xlator classes prefix'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Morphing Bytecode Set'!

!ClassHierarchyDuplicator methodsFor: 'code editing' stamp: 'eem 5/16/2008 15:50'!
edit
	(ChangeSet superclassOrder: classes asArray) do:
		[:class| | newClass |
		newClass := class subclassDefinerClass evaluate: (self editClassDefinitionOf: class).
		{ class. class class }
			with: { newClass. newClass class }
			do: [:b :nb|
				b selectors do:
					[:s|
					nb
						compile: (self editCode: (b sourceCodeAt: s) inClass: b withSelector: s)
						classified: (class organization categoryOfElement: s)]]]

	"self new edit"! !

!ClassHierarchyDuplicator methodsFor: 'code editing' stamp: 'eem 5/16/2008 15:43'!
editClassDefinitionOf: aClass
	| classDef categoryString |
	categoryString := 'category: '''.
	classDef := self editCode: aClass definition inClass: nil withSelector: nil.
	classDef := classDef
					copyReplaceAll: categoryString
					with: categoryString, prefix.
	^classDef
		copyReplaceAll: aClass classVariablesString
		with: (String streamContents: [:s| aClass classVariablesString subStrings do: [:ea| s nextPutAll: prefix; nextPutAll: ea; space]])

	"self new editClassDefinitionOf: MessageNode"! !

!ClassHierarchyDuplicator methodsFor: 'code editing' stamp: 'eem 5/16/2008 15:59'!
editCode: sourceText inClass: class withSelector: selector
	| ranges index codeIndex output codeString range |
	ranges := SHParserST80 new
				rangesIn: (codeString := sourceText asString)
				classOrMetaClass: class
				workspace: nil
				environment: nil.
	index := codeIndex := 1.
	output := (String new: codeString size) writeStream.
	[index <= ranges size] whileTrue:
		[range := ranges at: index.
		 index := index + 1.
		 [codeIndex < range start] whileTrue:
			[output nextPut: (codeString at: codeIndex).
			 codeIndex := codeIndex + 1].
		range type == #assignment
			ifTrue: [output nextPutAll: ':='.
					codeIndex := range end + 1]
			ifFalse:
				[(#(globalVar classVar) includes: range type)
					ifTrue:
						[output nextPutAll: (xlator value: (codeString copyFrom: range start to: range end)).
						 codeIndex := range end + 1]
					ifFalse:
						[#symbol == range type
							ifTrue:
								[output
									nextPut: (codeString at: range start); "#"
									nextPutAll: (xlator value: (codeString copyFrom: range start + 1 to: range end)).
								 codeIndex := range end + 1]
							ifFalse:
								[[codeIndex <= range end] whileTrue:
									[output nextPut: (codeString at: codeIndex).
									 codeIndex := codeIndex + 1].
								"kill whitespace after up-arrow in ^ expr"
								(range type == #return and: [index <= ranges size]) ifTrue:
									[codeIndex := (ranges at: index) start]]]]].
	^output contents

	"SHParserST80 new
		rangesIn: (ClassHierarchyDuplicator sourceCodeAt: #editCode:inClass:withSelector:) asString
		classOrMetaClass: ClassHierarchyDuplicator
		workspace: nil
		environment: nil"

	"SHParserST80 new
		rangesIn: ClassHierarchyDuplicator definition asString
		classOrMetaClass: nil
		workspace: nil
		environment: nil"

	"ClassHierarchyDuplicator new editCode: LeafNode definition inClass: nil withSelector: nil"
	"ClassHierarchyDuplicator new editCode: (MessageNode sourceCodeAt: #emitToDo:on:value:) inClass: MethodNode withSelector: #emitToDo:on:value:"
	"ClassHierarchyDuplicator new editCode: (MessageNode class sourceCodeAt: #initialize) inClass: MessageNode class withSelector: #initialize"! !

!ClassHierarchyDuplicator methodsFor: 'initialize-release' stamp: 'eem 5/16/2008 15:53'!
initialize
	| globalNames |
	prefix := 'XXX'.
	classes := Set new.
	((SystemOrganization categories reject: [:c| c beginsWith: prefix]) select:
		[:c| ('*Compiler*' match: c) and: [#'Compiler-Morphing Bytecode Set' ~= c]]) do:
			[:cat|
			(SystemOrganization listAtCategoryNamed: cat) do:
				[:cn|
				classes add: (Smalltalk at: cn)]].
	globalNames := classes collect: [:ea| ea name asString].
	classes do: [:c| c classPool keys do: [:sym| globalNames add: sym asString]].
	xlator := [:s| (globalNames includes: s) ifTrue: [prefix, s] ifFalse: [s]]

	"self new edit"! !

Object subclass: #ClosureLabelsPrintEditor
	instanceVariableNames: 'xlator xlation kwdxlation ranges index output codeIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Morphing Bytecode Set'!

!ClosureLabelsPrintEditor methodsFor: 'code editing' stamp: 'eem 6/2/2008 11:47'!
edit: generateViewBar
	"self new edit: true"
	| sn |
	sn := SystemNavigation default.
	xlation keysAndValuesDo:
		[:s :t|
		(sn allImplementorsOf: s localTo: ParseNode) do:
			[:md| | newCode |
			newCode := self editCode: md sourceString inClass: md actualClass withSelector: md methodSymbol.
			generateViewBar
				ifTrue: [md actualClass compile: newCode classified: 'printing']
				ifFalse:
					[(StringHolder new textContents:
						(CodeDiffBuilder buildDisplayPatchFrom: md sourceString to: newCode))
							openLabel: md printString]]]! !

!ClosureLabelsPrintEditor methodsFor: 'code editing' stamp: 'eem 6/2/2008 11:39'!
editCode: code inClass: class withSelector: selector
	| codeString |
	ranges := SHParserST80 new rangesIn: code classOrMetaClass: class workspace: nil  environment: nil.
	index := 1.
	codeIndex := 1.
	output := String new writeStream.
	codeString := code asString.
	self process: codeString.
	^output contents! !

!ClosureLabelsPrintEditor methodsFor: 'initialize-release' stamp: 'eem 6/2/2008 11:38'!
initialize
	xlator := [:s| s copyReplaceAll: 'print' with: 'printWithClosureAnalysis'].
	xlation := Dictionary new.
	(((ParseNode withAllSubclasses removeAll: Encoder withAllSubclasses; yourself)
		inject: Set new
		into: [:s :c| s addAll: c selectors. s]) select:
			[:s| s beginsWith: 'print']) do:
				[:s|xlation at: s put: (xlator value: s) asSymbol].
	kwdxlation := Dictionary new.
	xlation keysAndValuesDo: [:k :v| kwdxlation at: k keywords first put: v keywords first]! !

!ClosureLabelsPrintEditor methodsFor: 'code editing' stamp: 'eem 6/2/2008 11:43'!
process: code
	| range kwd |
	[index <= ranges size] whileTrue:
		[range := ranges at: index.
		 index := index + 1.
		 [codeIndex < range start] whileTrue:
			[output nextPut: (code at: codeIndex).
			 codeIndex := codeIndex + 1].
		range type == #assignment
			ifTrue: [output nextPutAll: ':='.
					codeIndex := range end + 1]
			ifFalse:
				[(#(keyword patternKeyword) includes: range type) ifTrue:
					[kwd := code copyFrom: range start to: range end.
					(kwdxlation includesKey: kwd) ifTrue:
						[output nextPutAll: (kwdxlation at: kwd).
						 codeIndex := range end + 1]]
					ifFalse:
						[[codeIndex <= range end] whileTrue:
							[output nextPut: (code at: codeIndex).
							 codeIndex := codeIndex + 1].
						"kill whitespace after up-arrow in ^ expr"
						(range type == #return and: [index <= ranges size]) ifTrue:
							[codeIndex := (ranges at: index) start]]]]! !

Object subclass: #CogScripts
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Scripts'!

!CogScripts class methodsFor: 'closure scripts' stamp: 'eem 7/17/2008 18:56'!
bootstrapClosures
	"CogScripts bootstrapClosures"
	| rep |
	Transcript clear.
	rep := false
			ifTrue: [MCCacheRepository default]
			ifFalse:
				[MCHttpRepository
					location: 'http://dev.qwaq.com/ss/Oinq'
					user: 'qwaq'
					password: ''].
	"This changes load order in Monticello such that additions come in before modifications."
	(rep loadVersionFromFileNamed: 'Monticello-eem.302.mcz') load.
	"This adds some prereqs the compiler uses that are loaded in later packages:
	 Fix the ClassBuilder so redefining CompiledMethod can add and remove class variables.
	 Add Object/Array>>isArray.
	 Add new interface for accessing inst vars & fields on initializing the compiler (Encoder)."
	self bootstrapClosuresCompilerPreloadCode readStream fileIn.
	"This temporarily stops Monticello from unloading code on load and warning about overwriting changes.
	 Since changes span multiple packages need all additions in before any deletions occur.
	 Can't warn about anything until the new debugger api is installed."
	ChangeSet
		newChangesFromStream: self bootstrapClosuresNeuterMonticelloCode readStream
		named: 'neuterMonticello'.
	Smalltalk at: #DoNotUnload put: true.
	1 to: 2 do:
		 [:i|
		  #(	'Compiler-eem.30.mcz'
			'Files-eem.21.mcz'
			'Exceptions-eem.14.mcz'
			'Collections-eem.55.mcz'
			'Tools-eem.45.mcz'
			'Kernel-eem.82.mcz'
			'System-eem.53.mcz'
			'Brad-eem.51.mcz'
			'Morphic-eem.38.mcz'
			'Tweak-Compiler-eem.36.mcz'
			'Tweak-Hacks-eem.30.mcz'
			'Tweak-Basic-eem.151.mcz'
			'Tweak-Core-Proto-eem.56.mcz') do:
				[:pn|
				Transcript clear; nextPutAll: pn; space; nextPut: $(; print: i; nextPut: $); endEntry.
				(rep loadVersionFromFileNamed: pn) load].
		 Smalltalk at: #DoNotUnload put: false].
	"Now remove the temporary hacks to Monticello"
	(ChangeSet named: 'neuterMonticello') changedMessageList do:
		[:mr| | changeRecords |
		changeRecords := mr actualClass changeRecordsAt: mr methodSymbol.
		changeRecords second fileIn].
	"Install BlockClosure in the specialObjectsArray"
	Smalltalk recreateSpecialObjectsArray.
	"Throw the switch to compile to closures"
	self bootstrapClosuresClosureCompilerSwitchCode readStream fileIn.
	"Recompile the system except the one method we can't yet deal with in GeniePlugin (1 too many literals)"
	(Smalltalk forgetDoIts allClasses reject: [:c| c name == #GeniePlugin]) do:
		[:c|
		{ c. c class } do:
			[:b|
			Transcript cr; print: b; endEntry.
			b selectors asSortedCollection do:
				[:s|
				b recompile: s from: b]]].
	UsefulScripts postRecompileCleanup.
	self inform: 'Save and quit and then run UsefulScripts postRecompileCleanup.\Rinse and repeat' withCRs! !

!CogScripts class methodsFor: 'closure scripts' stamp: 'eem 6/16/2008 17:29'!
bootstrapClosuresClosureCompilerSwitchCode
	^'
!!Parser methodsFor: ''public access'' stamp: ''eem 5/15/2008 15:44''!!
encoder
	encoder isNil ifTrue:
		[encoder := EncoderForV3PlusClosures new].
	^encoder!! !!'! !

!CogScripts class methodsFor: 'closure scripts' stamp: 'eem 6/13/2008 14:52'!
bootstrapClosuresCompilerPreloadCode
	^'
!!ClassBuilder methodsFor: ''class format'' stamp: ''eem 6/13/2008 10:03''!!
computeFormat: type instSize: newInstSize forSuper: newSuper ccIndex: ccIndex
	"Compute the new format for making oldClass a subclass of newSuper.
	Return the format or nil if there is any problem."
	| instSize isVar isWords isPointers isWeak |
	type == #compiledMethod
		ifTrue:[^CompiledMethod format].
	instSize := newInstSize + (newSuper ifNil:[0] ifNotNil:[newSuper instSize]).
	instSize > 254 ifTrue:[
		self error: ''Class has too many instance variables ('', instSize printString,'')''.
		^nil].
	type == #normal ifTrue:[isVar := isWeak := false. isWords := isPointers := true].
	type == #bytes ifTrue:[isVar := true. isWords := isPointers := isWeak := false].
	type == #words ifTrue:[isVar := isWords := true. isPointers := isWeak := false].
	type == #variable ifTrue:[isVar := isPointers := isWords := true. isWeak := false].
	type == #weak ifTrue:[isVar := isWeak := isWords := isPointers := true].
	(isPointers not and:[instSize > 0]) ifTrue:[
		self error:''A non-pointer class cannot have instance variables''.
		^nil].
	^(self format: instSize 
		variable: isVar 
		words: isWords 
		pointers: isPointers 
		weak: isWeak) + (ccIndex bitShift: 11).!! !!

!!ClassBuilder methodsFor: ''public'' stamp: ''eem 6/13/2008 10:00''!!
superclass: aClass
	variableByteSubclass: t instanceVariableNames: f 
	classVariableNames: d poolDictionaries: s category: cat
	"This is the standard initialization message for creating a new class as a 
	subclass of an existing class in which the subclass is to 
	have indexable byte-sized nonpointer variables."
	| oldClassOrNil actualType |
	(aClass instSize > 0)
		ifTrue: [^self error: ''cannot make a byte subclass of a class with named fields''].
	(aClass isVariable and: [aClass isWords])
		ifTrue: [^self error: ''cannot make a byte subclass of a class with word fields''].
	(aClass isVariable and: [aClass isPointers])
		ifTrue: [^self error: ''cannot make a byte subclass of a class with pointer fields''].
	oldClassOrNil := aClass environment at: t ifAbsent:[nil].
	actualType := (oldClassOrNil notNil
				   and: [oldClassOrNil typeOfClass == #compiledMethod])
					ifTrue: [#compiledMethod]
					ifFalse: [#bytes].
	^self 
		name: t
		inEnvironment: aClass environment
		subclassOf: aClass
		type: actualType
		instanceVariableNames: f
		classVariableNames: d
		poolDictionaries: s
		category: cat!! !!

!!Array methodsFor: ''testing'' stamp: ''eem 5/8/2008 11:13''!!
isArray
	^true!! !!

!!Object methodsFor: ''testing'' stamp: ''eem 5/8/2008 11:13''!!
isArray
	^false!! !!

!!Behavior methodsFor: ''compiling'' stamp: ''eem 5/13/2008 09:50''!!
instVarNamesAndOffsetsDo: aBinaryBlock
	"This is part of the interface between the compiler and a class''s instance or field names.
	 The class should enumerate aBinaryBlock with the instance variable name strings and
	 their integer offsets.  The order is important. Names evaluated later will override the
	 same names occurring earlier."

	"Nothing to do here; ClassDescription introduces named instance variables"
	^self!! !!

!!ClassDescription methodsFor: ''compiling'' stamp: ''eem 5/13/2008 09:48''!!
instVarNamesAndOffsetsDo: aBinaryBlock
	"This is part of the interface between the compiler and a class''s instance or field names.
	 The class should enumerate aBinaryBlock with the instance variable name strings and
	 their integer offsets.  The order is important. Names evaluated later will override the
	 same names occurring earlier."

	| superInstSize |
	(superInstSize := superclass notNil ifTrue: [superclass instSize] ifFalse: [0]) > 0 ifTrue:
		[superclass instVarNamesAndOffsetsDo: aBinaryBlock].
	1 to: self instSize - superInstSize do:
		[:i| aBinaryBlock value: (instanceVariables at: i) value: i + superInstSize]!! !!


!!Behavior methodsFor: ''compiling'' stamp: ''eem 5/13/2008 09:50''!!
variablesAndOffsetsDo: aBinaryBlock
	"This is the interface between the compiler and a class''s instance or field names.  The
	 class should enumerate aBinaryBlock with the field definitions (with nil offsets) followed
	 by the instance variable name strings and their integer offsets.  The order is important.
	 Names evaluated later will override the same names occurring earlier."

	"Only need to do instance variables here.  CProtoObject introduces field definitions."
	self instVarNamesAndOffsetsDo: aBinaryBlock!! !!

!!CProtoObject class methodsFor: ''compiling'' stamp: ''eem 5/13/2008 09:53''!!
variablesAndOffsetsDo: aBinaryBlock
	"This is the interface between the compiler and a class''s instance or field names.  The
	 class should enumerate aBinaryBlock with the field definitions (with nil offsets) followed
	 by the instance variable name strings and their integer offsets.  The order is important.
	 Names evaluated later will override the same names occurring earlier."

	self allFieldsReverseDo: [:field| aBinaryBlock value: field value: nil].
	self instVarNamesAndOffsetsDo: aBinaryBlock!! !!'! !

!CogScripts class methodsFor: 'closure scripts' stamp: 'eem 6/13/2008 14:56'!
bootstrapClosuresNeuterMonticelloCode
	^'
!!MCVersionLoader methodsFor: ''checking'' stamp: ''eem 6/12/2008 17:30''!!
checkForModifications
	| modifications |
	modifications := versions select: [:ea | ea package workingCopy modified].
	true ifTrue: [^true].
	modifications isEmpty ifFalse: [self warnAboutLosingChangesTo: modifications].!! !!

!!MCClassDefinition methodsFor: ''installing'' stamp: ''eem 6/12/2008 17:53''!!
unload
	(Smalltalk at: #DoNotUnload ifAbsent: [false]) ifTrue: [^self].
	Smalltalk removeClassNamed: name!! !!

!!MCMethodDefinition methodsFor: ''installing'' stamp: ''eem 6/12/2008 17:53''!!
unload
	| previousVersion |
	(Smalltalk at: #DoNotUnload ifAbsent: [false]) ifTrue: [^self].
	self isOverrideMethod ifTrue: [previousVersion := self scanForPreviousVersion].
	previousVersion
		ifNil: [self actualClass ifNotNilDo: [:class | class removeSelector: selector]]
		ifNotNil: [previousVersion fileIn] !! !!

!!MCOrganizationDefinition methodsFor: ''as yet unclassified'' stamp: ''eem 6/12/2008 18:06''!!
postloadOver: oldDefinition
	[SystemOrganization categories:
		(self
			reorderCategories: SystemOrganization categories
			original: (oldDefinition ifNil: [#()] ifNotNil: [oldDefinition categories]))]
		on: Error
		do: [:ex| Transcript cr; print: ex messageText; endEntry]!! !!

!!MCPackageLoader methodsFor: ''private'' stamp: ''eem 6/12/2008 21:32''!!
tryToLoad: aDefinition
	[aDefinition loadOver: (self obsoletionFor: aDefinition)]
		on: Error
		do: [:ex| self halt. errorDefinitions add: aDefinition]!! !!'! !

!CogScripts class methodsFor: 'separate vm scripts' stamp: 'eem 6/11/2010 13:21'!
browseExclusiveMethodImportsForPrimitiveClass: primClass
	"Browse methods used by the class holding VM primitives and unused elsewhere."
	"self browseExclusiveMethodImportsForPrimitiveClass: StackInterpreterSPrimitives"
	Cursor execute showWhile:
		["The algorithm computes a fixed point of the methods used
		   by the parcel which are unused outside it.  The algorithm is
				compute messages sent within parcel
				repeat until at a fixed point:
					compute intersection of this with methods implemented outside parcel
					compute messages sent outside parcel not within the intersection
					remove these from intersection"

		| parcelMessages "<IdentitySet of: Symbol>
								messages sent within this parcel"
		  externalMethods "<Set of: MethodDescription>
								methods implemented outside this parcel"
		  danglingMethods "<Set of: MethodDescription>
								methods importeded only by this parcel"
		  previousDangling "<Set of: MethodDescription>
								intermediate value of danglingMethods (for determining if fixed point is reached)"
		  danglingMessages "<Set of: Symbol> selectors of methods in danglingMethods"
		  noLongerDangling "<Set of: Symbol> selectors to be moved from dangling" |

		parcelMessages := IdentitySet new.
		primClass methodsDo:
			[:meth| parcelMessages addAll: meth messages].
		"compute starting points for danglingMethods and externalMethods"
		danglingMethods := Set new: 50.
		externalMethods := Set new: 20000.
		(PackageInfo named: 'VMMaker') classes do:
			[:aBehavior| | extends |
			(aBehavior = primClass or: [aBehavior inheritsFrom: primClass]) ifFalse:
				[aBehavior selectorsAndMethodsDo:
					[:sel :meth|
					(primClass includesSelector: sel) ifFalse:
						[((parcelMessages includes: sel)
							ifTrue: [danglingMethods]
							ifFalse: [externalMethods])
								add: (MethodReference class: aBehavior selector: sel)]]]].
		["Now iterate to the fixed-point.  Any method in dangling with a selector sent
		  in external must be moved into external until dangling reaches its fixed point."
		previousDangling := danglingMethods copy.
		danglingMessages := danglingMethods collect: [:md| md selector].
		noLongerDangling := Set new: danglingMethods size.
		externalMethods do:
			[:md|
			md compiledMethod messages do:
				[:l|
				(danglingMessages includes: l) ifTrue:
					[noLongerDangling add: l]]].
		externalMethods := danglingMethods select: [:md| noLongerDangling includes: md selector].
		danglingMethods removeAll: externalMethods.
		danglingMethods size ~= previousDangling size] whileTrue.
		SystemNavigation default
			browseMessageList: danglingMethods asSortedCollection
			name: 'Methods Used Only by ', primClass name, ' but not in ', primClass name]! !

!CogScripts class methodsFor: 'separate vm scripts' stamp: 'eem 2/5/2014 10:31'!
changedMethodsForObjectMemorySends
	"Answer the methods in StackInterpreter and subclasses that change if sends to self for methods implemented
	 in ObjectMemory, NewObjectMemory (& NewObjectMemorySE ?) become sends to objectMemory."
	"CogScripts changedMethodsForObjectMemorySends"
	| selectors rules model environment sortedChanges |
	selectors := { ObjectMemory. NewObjectMemory. "NewObjectMemorySE" }
					inject: Set new
					into: [:sels :class| sels addAll: class selectors; yourself].
	rules := RBParseTreeRewriter new.
	rules
		replace: 'self `@method: ``@args'
		with: 'objectMemory `@method: ``@args'
		when: [:node| selectors includes: node selector].
	#(	'nilObj' 'trueObj' 'falseObj')
		do: [:instVar|
			rules
				replace: instVar, ' := ``@args' with: 'objectMemory ', instVar, 'ect: ``@args';
				replace: instVar with: 'objectMemory ', instVar, 'ect'].
	self readWriteVars do: [:instVar|
			rules
				replace: instVar, ' := ``@args' with: 'objectMemory ', instVar, ': ``@args';
				replace: instVar with: 'objectMemory ', instVar].
	self readOnlyVars do: [:instVar|
			rules replace: instVar with: 'objectMemory ', instVar].
	model := RBNamespace new.
	environment := RBBrowserEnvironment new forClasses:
						{ StackInterpreter. CoInterpreter. CoInterpreterMT.
						   StackInterpreterSimulator. CogVMSimulator }.
	environment classesAndSelectorsDo:
		[ :class :selector | | tree |
		"(class == StackInterpreter and: [selector == #isContextHeader:]) ifTrue: [self halt]."
		"(class == StackInterpreter and: [selector == #isIndexable:]) ifTrue: [self halt]."
		"(class == StackInterpreter and: [selector == #printContextCallStackOf:]) ifTrue: [self halt]."
		tree := class parseTreeFor: selector.
		(rules executeTree: tree) ifTrue:
			[model compile: rules tree newSource in: class classified: (class whichCategoryIncludesSelector: selector)]].
	false ifTrue: [model changes inspect].
	false ifTrue: "shortest change:"
		[(model changes changes inject: model changes changes first into: [:c1 :c2| c1 printString size < c2 printString size ifTrue: [c1] ifFalse: [c2]]) inspect].

	sortedChanges := model changes changes asSortedCollection:
						[:c1 :c2|
						c1 changeClass == c2 changeClass
							ifTrue: [c1 selector <= c2 selector]
							ifFalse: [c2 changeClass inheritsFrom: c1 changeClass]].
	true ifTrue:
		[MessageSetTextDifferencer
			openMessageList: (sortedChanges collect: [:mr| { MethodReference class: mr changeClass selector: mr selector. TextReference new text: mr source class: mr class selector: mr selector }])
			name: 'self foo <-> objectMemory foo et al' 
			autoSelect: nil].

	^sortedChanges! !

!CogScripts class methodsFor: 'separate vm scripts' stamp: 'eem 9/30/2010 13:20'!
createObjMemSims
	"self createObjMemSims"
	{ NewObjectMemory. NewCoObjectMemory } do:
		[:c| | sc oc nc |
		sc := Compiler evaluate: ((Class templateForSubclassOf: c category: c category, 'Simulation') copyReplaceAll: 'NameOfSubclass' with: c name, 'Simulator').
		false ifTrue:
			[oc := NewObjectMemorySimulator.
			oc selectors do:
				[:s| [sc compile: (oc sourceCodeAt: s) asString
						classified: (oc whichCategoryIncludesSelector: s)
						withStamp: (oc >> s) timeStamp
						notifying: nil] on: Error do: [:ex|]]].
		nc := Compiler evaluate: ((Class templateForSubclassOf: sc category: sc category) copyReplaceAll: 'NameOfSubclass' with: sc name, 'LSB').
		oc := nc selectors size > 0 ifTrue: [nc] ifFalse: [NewObjectMemorySimulatorLSB].
		oc selectors do:
			[:s| | aoc |
			aoc := (CogVMSimulatorLSB includesSelector: s) ifTrue: [CogVMSimulatorLSB] ifFalse: [NewObjectMemorySimulatorLSB].
			nc compile: (aoc sourceCodeAt: s) asString
					classified: (aoc whichCategoryIncludesSelector: s)
					withStamp: (aoc >> s) timeStamp
					notifying: nil].
		nc := Compiler evaluate: ((Class templateForSubclassOf: sc category: sc category) copyReplaceAll: 'NameOfSubclass' with: sc name, 'MSB').
		oc := NewObjectMemorySimulatorMSB.
		oc selectors do:
			[:s| nc compile: (oc sourceCodeAt: s) asString
					classified: (oc whichCategoryIncludesSelector: s)
					withStamp: (oc >> s) timeStamp
					notifying: nil]]! !

!CogScripts class methodsFor: 'separate vm scripts' stamp: 'eem 6/8/2010 16:54'!
createSVMTree
	"Create the parallel StackInterpreterS, CoInterpreterS tree in which
	 objectMemory is an inst var rather than ObjectMemory et al being a superclass"
	"CogScripts createSVMTree"

	| changes map |
	changes := Cursor execute showWhile: [self changedMethodsForObjectMemorySends].

	map := Cursor execute showWhile: [self createStackInterpreterSHierarchy].

	(ChangeSet superclassOrder: (StackInterpreter withAllSubclasses select: [:c| map includesKey: c]) asArray) do:
		[:sourceClass|
		sourceClass selectors do:
			[:sel| | destClass source stamp |
			destClass := map
							at: (((sel beginsWith: 'primitive')
								and: [sel last ~~ $:
								and: [sel ~~ #primitiveFail]])
									ifTrue: [{sourceClass. #primitives}]
									ifFalse: [sourceClass])
							ifAbsent: [map at: sourceClass].
			(changes detect: [:c| c changeClass == sourceClass and: [c selector = sel]] ifNone: [])
				ifNotNil:
					[:change|
					source := change source.
					stamp := Utilities changeStamp copyReplaceAll: Utilities authorInitials with: Utilities authorInitials, ' (objmem refactor)']
				ifNil:
					[source := sourceClass sourceCodeAt: sel.
					stamp := (sourceClass >> sel) timeStamp].
			[destClass
					compile: source
					classified: (sourceClass whichCategoryIncludesSelector: sel)
					withStamp: stamp
					notifying: nil]
				on: SyntaxErrorNotification
				do: [:ex| | newBrowser |
					newBrowser := Browser new setClass: destClass selector: nil.
					newBrowser selectMessageCategoryNamed: (sourceClass whichCategoryIncludesSelector: sel).
					Browser
						openBrowserView: (newBrowser openMessageCatEditString: source)
						label: 'category "', (sourceClass whichCategoryIncludesSelector: sel), '" in ', destClass name]]].

	self readWriteVars, self readOnlyVars do:
		[:sym|
		(NewObjectMemory whichClassIncludesSelector: sym) ifNil:
			[(NewObjectMemory whichClassDefinesInstVar: sym asString)
				compile: sym, (String with: Character cr with: Character tab with: $^), sym
				classified: #accessing]].
	self readWriteVars do:
		[:sym| | setter | setter := (sym, ':') asSymbol.
		(NewObjectMemory whichClassIncludesSelector: setter) ifNil:
			[(NewObjectMemory whichClassDefinesInstVar: sym asString)
				compile: setter, ' aValue', (String with: Character cr with: Character tab with: $^), sym, ' := aValue'
				classified: #accessing]].! !

!CogScripts class methodsFor: 'separate vm scripts' stamp: 'eem 6/2/2010 18:15'!
createStackInterpreterSHierarchy
	"Create the parallel StackInterpreterS, CoInterpreterS tree (without methods).
	 Answer a Dictionary maping source class to dest class with {source. #primitives} -> dest
	 for the added primitives classes."

	| map |
	(Smalltalk classNamed: #StackInterpreterS) ifNotNil:
		[:sis|
		(Object confirm: 'StackInterpreterS exists, nuke?') ifTrue:
			[(ChangeSet superclassOrder: sis withAllSubclasses asArray) reverseDo:
				[:sissc| sissc removeFromSystemUnlogged]]].

	map := Dictionary new.
	(ChangeSet superclassOrder: (StackInterpreter withAllSubclasses
									remove: SchizophrenicClosureFormatStackInterpreter;
									yourself) asArray) do:
		[:sisc| | def |
		def := sisc definition.
		def := sisc == StackInterpreter
				ifTrue: [((def copyReplaceAll: sisc superclass name, ' ' with: ObjectMemory superclass name, ' ')
							copyReplaceAll: 'instanceVariableNames: ''' with: 'instanceVariableNames: ''objectMemory ')
							copyReplaceAll: 'poolDictionaries: ''' with: 'poolDictionaries: ''', (ObjectMemory poolDictionaryNames fold: [:a :b| a, ' ', b]), ' ']
				ifFalse: [def copyReplaceAll: sisc superclass name, ' ' with: sisc superclass name, 'S '].
		def := def copyReplaceAll: sisc name printString with: sisc name printString, 'S'.
		map at: sisc put: (Compiler evaluate: def)].

	map at: {StackInterpreter. #primitives}
		put: (Compiler
				evaluate: 'StackInterpreterS subclass: #StackInterpreterSPrimitives
							instanceVariableNames: ''''
							classVariableNames: ''''
							poolDictionaries: ''''
							category: ''VMMaker-Interpreter''');
		at: {CoInterpreter. #primitives}
		put: (Compiler
				evaluate: 'CoInterpreterS subclass: #CoInterpreterSPrimitives
						instanceVariableNames: ''''
						classVariableNames: ''''
						poolDictionaries: ''''
						category: ''VMMaker-Interpreter''');
		at: {StackInterpreter. #objmem}
		put: (Compiler
				evaluate: 'NewObjectMemory subclass: #NewObjectMemoryS
						instanceVariableNames: ''coInterpreter''
							classVariableNames: ''''
							poolDictionaries: ''''
							category: ''VMMaker-Interpreter''');
		at: {CoInterpreter. #objmem}
		put: (Compiler
				evaluate: 'NewObjectMemoryS subclass: #NewCoObjectMemoryS
						instanceVariableNames: ''''
						classVariableNames: ''''
						poolDictionaries: ''''
						category: ''VMMaker-Interpreter''').

	"reparent subclasses underneath StackInterpreterSPrimitives & CoInterpreterSPrimitives"
	#(StackInterpreterS CoInterpreterS) do:
		[:cn|
		((Smalltalk classNamed: cn) subclasses reject: [:c| c name endsWith: 'Primitives']) do:
			[:sisc| | def |
			def := sisc definition.
			def := def copyReplaceAll: cn, ' ' with: cn, 'Primitives '.
			Compiler evaluate: def]].
	^map! !

!CogScripts class methodsFor: 'separate vm scripts' stamp: 'eem 2/5/2014 10:32'!
doClassSide
	"self doClassSide"
	| classes rules model env sortedChanges |
	classes := (PackageInfo named: 'VMMaker') classes.
	classes := classes select: [:c| classes anySatisfy: [:d| d name last = $S and: [d name allButLast = c name]]].

	rules := RBParseTreeRewriter new.
	model := RBNamespace new.
	env := RBBrowserEnvironment new forClasses: classes.
	classes do: [:c| rules replace: c name with: c name, 'S'].
	env classesAndSelectorsDo:
		[:class :selector| | tree |
		class isMeta ifTrue:
			[tree := class parseTreeFor: selector.
			rules executeTree: tree.
			model compile: rules tree newSource in: class classified: (class whichCategoryIncludesSelector: selector)]].
	false ifTrue: [model changes inspect].
	false ifTrue: "shortest change:"
		[(model changes changes inject: model changes changes first into: [:c1 :c2| c1 printString size < c2 printString size ifTrue: [c1] ifFalse: [c2]]) inspect].

	sortedChanges := model changes changes asSortedCollection:
						[:c1 :c2|
						c1 changeClass == c2 changeClass
							ifTrue: [c1 selector <= c2 selector]
							ifFalse: [c2 changeClass inheritsFrom: c1 changeClass]].
	true ifTrue:
		[MessageSetTextDifferencer
			openMessageList: (sortedChanges collect: [:mr| { MethodReference class: mr changeClass selector: mr selector. TextReference new text: mr source class: mr class selector: mr selector }])
			name: 'class side' 
			autoSelect: nil].

	sortedChanges do:
		[:mr|
		(Smalltalk classNamed: (mr changeClass theNonMetaClass name, 'S') asSymbol) class
			compile: mr source
			classified: (mr changeClass whichCategoryIncludesSelector: mr selector)
			withStamp: (mr source asString = (mr changeClass sourceCodeAt: mr selector) asString
							ifTrue: [(mr changeClass >> mr selector) timeStamp]
							ifFalse: [Utilities changeStamp copyReplaceAll: Utilities authorInitials with: Utilities authorInitials, ' (objmem refactor)'])
			notifying: nil]! !

!CogScripts class methodsFor: 'separate vm scripts' stamp: 'eem 6/8/2010 17:01'!
readOnlyVars
	^#(#checkForLeaks #fullGCLock #gcStartUsecs #memoryLimit #scavengeThreshold #youngStart
		#statCompMoveCount #statFullGCUsecs #statFullGCs #statGCEndUsecs #statGrowMemory #statIGCDeltaUsecs
		#statIncrGCUsecs #statIncrGCs #statMarkCount #statMkFwdCount #statRootTableCount #statRootTableOverflows
		#statShrinkMemory #statSpecialMarkCount #statSurvivorCount #statSweepCount #statTenures)! !

!CogScripts class methodsFor: 'separate vm scripts' stamp: 'eem 6/8/2010 17:06'!
readWriteVars
	^#(#specialObjectsOop
		#edenBytes #endOfMemory #forceTenureFlag #freeStart #needGCFlag
		#gcBiasToGrow #gcBiasToGrowGCLimit #gcBiasToGrowThreshold
		#growHeadroom #lastHash #lowSpaceThreshold #memory
		#remapBuffer #remapBufferCount #rootTable #rootTableCount
		#signalLowSpace #shrinkThreshold tenuringThreshold)! !

!CogScripts class methodsFor: 'documentation' stamp: 'eem 2/5/2014 10:17'!
refactoringPackages
	"to use the source editing facilities in the refactoring browser that this class uses load
		AST-Core
		AST-Semantic
		Refactoring-Core
		Refactoring-Environment
		Refactoring-Changes
	in that order from http://www.squeaksource.com/rb.  Relevant tests are
		AST-Tests-Core
		AST-Tests-Semantic
		Refactoring-Tests-Core
		Refactoring-Tests-Environment
		Refactoring-Tests-Changes"! !

!CogScripts methodsFor: 'look on class side' stamp: 'eem 6/13/2008 14:32'!
seeClassSide
	"All the code is on the class side"! !

Object subclass: #DBAbstractConstraint
	instanceVariableNames: 'strength'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Benchmarks-DeltaBlue'!

!DBAbstractConstraint commentStamp: '<historical>' prior: 0!
I am an abstract class representing a system-maintainable relationship (or "constraint") between a set of variables. I supply a strength instance variable; concrete subclasses provide a means of storing the constrained variables and other information required to represent a constraint.

Instance variables:
	strength			the strength of this constraint <Strength>!

!DBAbstractConstraint methodsFor: 'adding' stamp: 'ClementBera 9/23/2013 10:54'!
addConstraint
	"Activate this constraint and attempt to satisfy it."

	self addToGraph.
	DBPlanner current incrementalAdd: self.! !

!DBAbstractConstraint methodsFor: 'adding' stamp: 'ClementBera 9/23/2013 10:54'!
addToGraph
	"Add myself to the constraint graph."

	self subclassResponsibility! !

!DBAbstractConstraint methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:55'!
chooseMethod: mark
	"Decide if I can be satisfied and record that decision. The output of
	 the choosen method must not have the given mark and must have a
	 walkabout strength less than that of this constraint."

	self subclassResponsibility! !

!DBAbstractConstraint methodsFor: 'adding' stamp: 'ClementBera 9/23/2013 10:54'!
destroyConstraint
	"Deactivate this constraint, remove it from the constraint graph,
	 possibly causing other constraints to be satisfied, and destroy it."

	(self isSatisfied) ifTrue: [DBPlanner current incrementalRemove: self].
	self removeFromGraph.
	self release.! !

!DBAbstractConstraint methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:55'!
execute
	"Enforce this constraint. Assume that it is satisfied."

	self subclassResponsibility! !

!DBAbstractConstraint methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:55'!
inputsDo: aBlock
	"Assume that I am satisfied. Evaluate the given block on all my current
	 input variables."

	self subclassResponsibility! !

!DBAbstractConstraint methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:55'!
inputsKnown: mark
	"Assume that I am satisfied. Answer true if all my current inputs are
	 known. A variable is known if either a) it is 'stay' (i.e. it is a
	 constant at plan execution time), b) it has the given mark (indicating
	 that it has been computed by a constraint appearing earlier in the
	 plan), or c) it is not determined by any constraint."

	self inputsDo:
		[ :v |
		 (v mark = mark or: [v stay or: [v determinedBy isNil]]) ifFalse:
			[^false]].
	^true! !

!DBAbstractConstraint methodsFor: 'testing' stamp: 'ClementBera 9/23/2013 10:53'!
isInput
	"Normal constraints are not input constraints. An input constraint is
	 one that depends on external state, such as the mouse, the keyboard,
	 a clock, or some arbitrary piece of imperative code."

	^false! !

!DBAbstractConstraint methodsFor: 'testing' stamp: 'ClementBera 9/23/2013 10:54'!
isSatisfied
	"Answer true if this constraint is satisfied in the current solution."

	self subclassResponsibility! !

!DBAbstractConstraint methodsFor: 'printing' stamp: 'ClementBera 9/23/2013 11:02'!
longPrintOn: aStream

	aStream nextPut: $(.
	self shortPrintOn: aStream.
	aStream space; nextPutAll: self strength printString.
	(self isSatisfied)
		ifTrue:
			[aStream cr; space; space; space.
			 self inputsDo:
				[ :in | aStream nextPutAll: 'v', in printString, ' '].
			aStream nextPutAll: '-> '.
			aStream nextPutAll: 'v', self output printString]
		ifFalse:
			[aStream space; nextPutAll: 'UNSATISFIED'].
	aStream nextPut: $); cr.! !

!DBAbstractConstraint methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:55'!
markUnsatisfied
	"Record the fact that I am unsatisfied."

	self subclassResponsibility! !

!DBAbstractConstraint methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:55'!
output
	"Answer my current output variable. Raise an error if I am not
	 currently satisfied."

	self subclassResponsibility! !

!DBAbstractConstraint methodsFor: 'printing' stamp: 'ClementBera 9/23/2013 10:57'!
printOn: aStream

	self shortPrintOn: aStream! !

!DBAbstractConstraint methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:56'!
recalculate
	"Calculate the walkabout strength, the stay flag, and, if it is 'stay',
	 the value for the current output of this constraint. Assume this
	 constraint is satisfied."

	self subclassResponsibility! !

!DBAbstractConstraint methodsFor: 'adding' stamp: 'ClementBera 9/23/2013 10:54'!
removeFromGraph
	"Remove myself from the constraint graph."

	self subclassResponsibility! !

!DBAbstractConstraint methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:56'!
satisfy: mark
	"Attempt to find a way to enforce this (still unsatisfied) constraint.
	 If successful, record the solution, perhaps modifying the current
	 dataflow graph.  Answer the constraint that this constraint overrides,
	 if there is one, or nil, if there isn't."

	| overridden out |
	self chooseMethod: mark.
	self isSatisfied
		ifTrue:			"constraint can be satisfied"
			["mark inputs to allow cycle detection in addPropagate"
			 self inputsDo: [ :in | in mark: mark].
			 out := self output.
			 overridden := out determinedBy.
			 overridden ifNotNil: [overridden markUnsatisfied].
			 out determinedBy: self.
			 (DBPlanner current addPropagate: self mark: mark) ifFalse:
				[self notify:
					('Cycle encountered adding:\   ',
					 self printString,
					 '\Constraint removed.') withCRs.
				 ^nil].
			 out mark: mark]
		ifFalse:			"constraint cannot be satisfied"
			[overridden := nil.
			 (strength sameAs: (DBStrength required)) ifTrue:
				[self notify: 'Failed to satisfy a required constraint']].
	^ overridden! !

!DBAbstractConstraint methodsFor: 'printing' stamp: 'ClementBera 9/23/2013 11:02'!
shortPrintOn: aStream

	aStream nextPutAll: self class name, '(', self printString, ')'.! !

!DBAbstractConstraint methodsFor: 'accessing' stamp: 'ClementBera 9/23/2013 10:53'!
strength
	^ strength! !

!DBAbstractConstraint methodsFor: 'accessing' stamp: 'ClementBera 9/23/2013 10:53'!
strength: anObject
	strength := anObject! !

DBAbstractConstraint subclass: #DBBinaryConstraint
	instanceVariableNames: 'direction v1 v2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Benchmarks-DeltaBlue'!

!DBBinaryConstraint commentStamp: '<historical>' prior: 0!
I am an abstract superclass for constraints having two possible output variables.

Instance variables:
	v1, v2		possible output variables <Variable>
	direction		one of:
					#forward (v2 is output)
					#backward (	v1 is output)
					nil (not satisfied)!

!DBBinaryConstraint class methodsFor: 'instance creation' stamp: 'ClementBera 9/23/2013 10:33'!
var: variable1 var: variable2 strength: strengthSymbol
	"Install a constraint with the given strength equating the given
	 variables."

	^(self new) var: variable1 var: variable2 strength: strengthSymbol! !

!DBBinaryConstraint methodsFor: 'adding' stamp: 'ClementBera 9/23/2013 10:21'!
addToGraph
	"Add myself to the constraint graph."

	v1 addConstraint: self.
	v2 addConstraint: self.
	direction := nil.! !

!DBBinaryConstraint methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:24'!
chooseMethod: mark
	"Decide if I can be satisfied and which way I should flow based on the relative strength of the variables I relate, and record that decision."

	v1 mark == mark ifTrue:		"forward or nothing"
		[ ^ direction := ((v2 mark ~= mark) and: [strength stronger: v2 walkStrength])
			ifTrue: [ #forward ]
			ifFalse: [ nil ] ].

	v2 mark == mark ifTrue:		"backward or nothing"
		[ ^ direction := ((v1 mark ~= mark) and: [strength stronger: v1 walkStrength])
			ifTrue: [ #backward ]
			ifFalse: [ nil ] ].

	"if we get here, neither variable is marked, so we have choice"
	(v1 walkStrength weaker: v2 walkStrength)
		ifTrue:
			[ ^ direction := (strength stronger: v1 walkStrength)
				ifTrue: [ #backward ]
				ifFalse: [ nil ]]
		ifFalse:
			[ ^ direction := (strength stronger: v2 walkStrength)
				ifTrue: [ #forward ]
				ifFalse: [ nil ]]. ! !

!DBBinaryConstraint methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:25'!
execute
	"Enforce this constraint. Assume that it is satisfied."

	self subclassResponsibility! !

!DBBinaryConstraint methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:25'!
inputsDo: aBlock
	"Evaluate the given block on my current input variable."

	direction == #forward
		ifTrue: [ aBlock value: v1 ]
		ifFalse: [ aBlock value: v2 ].! !

!DBBinaryConstraint methodsFor: 'testing' stamp: 'ClementBera 9/23/2013 10:21'!
isSatisfied
	"Answer true if this constraint is satisfied in the current solution."

	^ direction notNil! !

!DBBinaryConstraint methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:25'!
markUnsatisfied
	"Record the fact that I am unsatisfied."

	direction := nil.! !

!DBBinaryConstraint methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:26'!
output
	"Answer my current output variable."

	^ direction == #forward
		ifTrue: [ v2 ]
		ifFalse: [ v1 ]! !

!DBBinaryConstraint methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:27'!
recalculate
	"Calculate the walkabout strength, the stay flag, and, if it is 'stay',
         the value for the current output of this constraint. Assume this
	 constraint is satisfied."

	| in out |
	direction == #forward
		ifTrue: [in := v1. out := v2]
		ifFalse: [in := v2. out := v1].
	out walkStrength: (strength weakest: in walkStrength).
	out stay: in stay.
	out stay ifTrue: [ self execute ].		"stay optimization"! !

!DBBinaryConstraint methodsFor: 'adding' stamp: 'ClementBera 9/23/2013 10:29'!
removeFromGraph
	"Remove myself from the constraint graph."

	v1 ifNotNil: [v1 removeConstraint: self].
	v2 ifNotNil: [v2 removeConstraint: self].
	direction := nil.! !

!DBBinaryConstraint methodsFor: 'initialize' stamp: 'ClementBera 9/23/2013 10:21'!
var: variable1 var: variable2 strength: strengthSymbol
	"Initialize myself with the given variables and strength."

	strength := DBStrength of: strengthSymbol.
	v1 := variable1.
	v2 := variable2.
	direction := nil.
	self addConstraint.! !

DBBinaryConstraint subclass: #DBEqualityConstraint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Benchmarks-DeltaBlue'!

!DBEqualityConstraint commentStamp: '<historical>' prior: 0!
I constrain two variables to have the same value: "v1 = v2".!

!DBEqualityConstraint methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 11:24'!
execute
	"Enforce this constraint. Assume that it is satisfied."
 
	direction == #forward
		ifTrue: [v2 value: v1 value]
		ifFalse: [v1 value: v2 value].! !

DBBinaryConstraint subclass: #DBScaleConstraint
	instanceVariableNames: 'offset scale'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Benchmarks-DeltaBlue'!

!DBScaleConstraint commentStamp: '<historical>' prior: 0!
I relate two variables by the linear scaling relationship:
"v2 = (v1 * scale) + offset". Either v1 or v2 may be changed to maintain this
relationship but the scale factor and offset are considered read-only.

Instance variables:
	scale		scale factor input variable <Variable>
	offset		offset input variable <Variable>!

!DBScaleConstraint class methodsFor: 'instance creation' stamp: 'ClementBera 9/23/2013 10:32'!
var: src var: scale var: offset var: dst strength: strengthSymbol
	"Install a scale constraint with the given strength on the given variables."

	^(self new) src: src scale: scale offset: offset dst: dst strength: strengthSymbol! !

!DBScaleConstraint methodsFor: 'adding' stamp: 'ClementBera 9/23/2013 10:28'!
addToGraph
	"Add myself to the constraint graph."

	super addToGraph.
	scale addConstraint: self.
	offset addConstraint: self.
! !

!DBScaleConstraint methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:31'!
execute
	"Enforce this constraint. Assume that it is satisfied."

	direction == #forward
		ifTrue: [v2 value: v1 value * scale value + offset value]
		ifFalse: [v1 value: v2 value - offset value // scale value].! !

!DBScaleConstraint methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:31'!
inputsDo: aBlock
	"Evaluate the given block on my current input variable."

	direction == #forward
		ifTrue: [ aBlock 
				value: v1; 
				value: scale; 
				value: offset]
		ifFalse: [ aBlock 
				value: v2; 
				value: scale; 
				value: offset].! !

!DBScaleConstraint methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:32'!
recalculate
	"Calculate the walkabout strength, the stay flag, and, if it is 'stay', the value for the current output of this constraint. Assume this constraint is satisfied."

	| in out |
	direction == #forward
		ifTrue: [in := v1. out := v2]
		ifFalse: [out := v1. in := v2].
	out walkStrength: (strength weakest: in walkStrength).
	out stay: (in stay and: [scale stay and: [offset stay]]).
	out stay ifTrue: [self execute].		"stay optimization"! !

!DBScaleConstraint methodsFor: 'adding' stamp: 'ClementBera 9/23/2013 10:29'!
removeFromGraph
	"Remove myself from the constraint graph."

	super removeFromGraph.
	scale ifNotNil: [scale removeConstraint: self].
	offset ifNotNil: [offset removeConstraint: self].
! !

!DBScaleConstraint methodsFor: 'initialize' stamp: 'ClementBera 9/23/2013 10:27'!
src: srcVar scale: scaleVar offset: offsetVar dst: dstVar strength: strengthSymbol
	"Initialize myself with the given variables and strength."

	strength := DBStrength of: strengthSymbol.
	v1 := srcVar.
	v2 := dstVar.
	scale := scaleVar.
	offset := offsetVar.
	direction := nil.
	self addConstraint.! !

DBAbstractConstraint subclass: #DBUnaryConstraint
	instanceVariableNames: 'output satisfied'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Benchmarks-DeltaBlue'!

!DBUnaryConstraint commentStamp: '<historical>' prior: 0!
I am an abstract superclass for constraints having a single possible output variable.

Instance variables:
	output		possible output variable <Variable>
	satisfied		true if I am currently satisfied <Boolean>!

DBUnaryConstraint subclass: #DBEditConstraint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Benchmarks-DeltaBlue'!

!DBEditConstraint commentStamp: '<historical>' prior: 0!
I mark variables that should, with some level of preference, stay the same. I have one method with zero inputs and one output, which does nothing. Planners may exploit the fact that, if I am satisfied, my output will not change during plan execution. This is called "stay optimization."!

!DBEditConstraint methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:19'!
execute
	"Edit constraints do nothing."! !

!DBEditConstraint methodsFor: 'testing' stamp: 'ClementBera 9/23/2013 10:18'!
isInput
	"I indicate that a variable is to be changed by imperative code."

	^true! !

DBUnaryConstraint subclass: #DBStayConstraint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Benchmarks-DeltaBlue'!

!DBStayConstraint commentStamp: '<historical>' prior: 0!
I mark variables that should, with some level of preference, stay the same.
I have one method with zero inputs and one output, which does nothing. Planners
may exploit the fact that, if I am satisfied, my output will not change during
plan execution. This is called "stay optimization."!

!DBStayConstraint methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:20'!
execute
	"Stay constraints do nothing."! !

!DBUnaryConstraint class methodsFor: 'instance creation' stamp: 'ClementBera 9/23/2013 10:20'!
var: aVariable strength: strengthSymbol
	"Install an edit constraint with the given strength on the given
	 variable."

	^(self new) var: aVariable strength: strengthSymbol! !

!DBUnaryConstraint methodsFor: 'adding' stamp: 'ClementBera 9/23/2013 10:16'!
addToGraph
	"Add myself to the constraint graph."

	output addConstraint: self.
	satisfied := false.! !

!DBUnaryConstraint methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:19'!
chooseMethod: mark
	"Decide if I can be satisfied and record that decision."

	satisfied :=
		output mark ~= mark and:
		[strength stronger: output walkStrength].! !

!DBUnaryConstraint methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:17'!
execute
	"Enforce this constraint. Assume that it is satisfied."

	self subclassResponsibility! !

!DBUnaryConstraint methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:17'!
inputsDo: aBlock
	"I have no input variables."! !

!DBUnaryConstraint methodsFor: 'testing' stamp: 'ClementBera 9/23/2013 10:15'!
isSatisfied
	"Answer true if this constraint is satisfied in the current solution."

	^satisfied! !

!DBUnaryConstraint methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:17'!
markUnsatisfied
	"Record the fact that I am unsatisfied."

	satisfied := false.! !

!DBUnaryConstraint methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:18'!
output
	"Answer my current output variable."

	^ output! !

!DBUnaryConstraint methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:18'!
recalculate
	"Calculate the walkabout strength, the stay flag, and, if it is 'stay',
	 the value for the current output of this constraint. Assume this
	 constraint is satisfied."

	output walkStrength: strength.
	output stay: self isInput not.
	output stay ifTrue: [self execute].	"stay optimization"! !

!DBUnaryConstraint methodsFor: 'adding' stamp: 'ClementBera 9/23/2013 10:16'!
removeFromGraph
	"Remove myself from the constraint graph."

	output ifNotNil: [ :out | out removeConstraint: self].
	satisfied := false.! !

!DBUnaryConstraint methodsFor: 'initialize' stamp: 'ClementBera 9/23/2013 10:15'!
var: aVariable strength: strengthSymbol
	"Initialize myself with the given variable and strength."

	strength := DBStrength of: strengthSymbol.
	output := aVariable.
	satisfied := false.
	self addConstraint.! !

Object subclass: #DBPlanner
	instanceVariableNames: 'currentMark'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Benchmarks-DeltaBlue'!

DBPlanner class
	instanceVariableNames: 'currentPlanner'!

!DBPlanner commentStamp: '<historical>' prior: 0!
This benchmark is an implementation of the DeltaBlue Constraint Solver described in `The DeltaBlue Algorithm: An Incremental Constraint Hierarchy Solver'', by Bjorn N. Freeman-Benson and John Maloney, Communications of the ACM, January 1990 (also as University of Washington TR 89-08-06).
!

DBPlanner class
	instanceVariableNames: 'currentPlanner'!

!DBPlanner class methodsFor: 'accessing' stamp: 'ClementBera 9/23/2013 11:16'!
current
	^ currentPlanner! !

!DBPlanner class methodsFor: 'instance creation' stamp: 'ClementBera 9/23/2013 10:39'!
new
	^ currentPlanner := super new! !

!DBPlanner methodsFor: 'private' stamp: 'ClementBera 9/23/2013 10:36'!
addConstraintsConsuming: v to: aCollection

	| determiningC |
	determiningC := v determinedBy.
	v constraints do:
		[ :c |
		 (c == determiningC or: [c isSatisfied not]) ifFalse:
			[aCollection add: c]].! !

!DBPlanner methodsFor: 'private' stamp: 'ClementBera 9/23/2013 10:36'!
addPropagate: c mark: mark
	"Recompute the walkabout strengths and stay flags of all variables
	 downstream of the given constraint and recompute the actual values
	 of all variables whose stay flag is true. If a cycle is detected,
	 remove the given constraint and answer false. Otherwise, answer true.

	 Details: Cycles are detected when a marked variable is encountered
	 downstream of the given constraint. The sender is assumed to have
	 marked the inputs of the given constraint with the given mark. Thus,
	 encountering a marked node downstream of the output constraint means
	 that there is a path from the constraint's output to one of its
	 inputs."

	| todo d |
	todo := OrderedCollection with: c.
	[todo isEmpty] whileFalse:
		[d := todo removeFirst.
		 (d output mark = mark) ifTrue:
			[self incrementalRemove: c.
			 ^ false].
		 d recalculate.
		 self addConstraintsConsuming: d output to: todo].
	^ true! !

!DBPlanner methodsFor: 'private' stamp: 'ClementBera 9/23/2013 10:37'!
changeVar: aVariable newValue: newValue

	| editConstraint plan |
	editConstraint := DBEditConstraint var: aVariable strength: #preferred.
	plan := self extractPlanFromConstraints: (Array with: editConstraint).
	10 timesRepeat: [
		aVariable value: newValue.
		plan execute].
	editConstraint destroyConstraint.! !

!DBPlanner methodsFor: 'private' stamp: 'ClementBera 9/23/2013 10:37'!
constraintsConsuming: v do: aBlock

	| determiningC |
	determiningC := v determinedBy.
	v constraints do:
		[ :c |
		 (c == determiningC or: [c isSatisfied not]) ifFalse:
			[aBlock value: c]].! !

!DBPlanner methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:34'!
extractPlanFromConstraints: constraints
	"Extract a plan for resatisfaction starting from the outputs of the
	 given constraints, usually a set of input constraints."

	| sources |
	sources := OrderedCollection new.
	constraints do:
		[: c | (c isInput and: [c isSatisfied]) ifTrue: [sources add: c]].
	^self makePlan: sources! !

!DBPlanner methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:35'!
extractPlanFromVariables: variables
	"Extract a plan from the dataflow graph having the given variables. It
	 is assumed that the given set of variables is complete, or at least
	 that it contains all the input variables."

	| sources |
	sources := OrderedCollection new.
	variables do:
		[: v |
		 (v constraints) do:
			[: c | (c isInput and: [c isSatisfied]) ifTrue: [sources add: c]]].
	^self makePlan: sources! !

!DBPlanner methodsFor: 'adding' stamp: 'ClementBera 9/23/2013 10:34'!
incrementalAdd: c
	"Attempt to satisfy the given constraint and, if successful,
	 incrementally update the dataflow graph.

	 Details: If satifying the constraint is successful, it may override a
	 weaker constraint on its output. The algorithm attempts to resatisfy
	 that constraint using some other method. This process is repeated
	 until either a) it reaches a variable that was not previously
	 determined by any constraint or b) it reaches a constraint that
	 is too weak to be satisfied using any of its methods. The variables
	 of constraints that have been processed are marked with a unique mark
	 value so that we know where we've been. This allows the algorithm to
	 avoid getting into an infinite loop even if the constraint graph has
	 an inadvertent cycle."

	| mark overridden |
	mark := self newMark.
	overridden := c satisfy: mark.
	[overridden isNil] whileFalse:
		[overridden := overridden satisfy: mark].! !

!DBPlanner methodsFor: 'adding' stamp: 'ClementBera 9/23/2013 10:34'!
incrementalRemove: c
	"Entry point for retracting a constraint. Remove the given constraint,
	 which should be satisfied, and incrementally update the dataflow
	 graph.

	 Details: Retracting the given constraint may allow some currently
	 unsatisfiable downstream constraint be satisfied. We thus collect a
	 list of unsatisfied downstream constraints and attempt to satisfy
	 each one in turn. This list is sorted by constraint strength,
	 strongest first, as a heuristic for avoiding unnecessarily adding
	 and then overriding weak constraints."

	| out unsatisfied |
	out := c output.
	c markUnsatisfied.
	c removeFromGraph.
	unsatisfied := self removePropagateFrom: out.
	unsatisfied do: [: u | self incrementalAdd: u].! !

!DBPlanner methodsFor: 'initialize' stamp: 'ClementBera 9/23/2013 10:33'!
initialize

	super initialize.

	currentMark := 1.! !

!DBPlanner methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:35'!
makePlan: sources
	"Extract a plan for resatisfaction starting from the given satisfied
	 source constraints, usually a set of input constraints. This method
	 assumes that stay optimization is desired; the plan will contain only
	 constraints whose output variables are not stay. Constraints that do
	 no computation, such as stay and edit constraints, are not included
	 in the plan.

	 Details: The outputs of a constraint are marked when it is added to
	 the plan under construction. A constraint may be appended to the plan
	 when all its input variables are known. A variable is known if either
	 a) the variable is marked (indicating that has been computed by a
	 constraint appearing earlier in the plan), b) the variable is 'stay'
	 (i.e. it is a constant at plan execution time), or c) the variable
	 is not determined by any constraint. The last provision is for past
	 states of history variables, which are not stay but which are also
	 not computed by any constraint."

	| mark plan todo c |
	mark := self newMark.
	plan := DBPlan new.
	todo := sources.
	[todo isEmpty] whileFalse:
		[c := todo removeFirst.
		 ((c output mark ~= mark) and:		"not in plan already and..."
		  [c inputsKnown: mark]) ifTrue:	"eligible for inclusion"
			[plan addLast: c.
			 c output mark: mark.
			 self addConstraintsConsuming: c output to: todo]].
	^ plan! !

!DBPlanner methodsFor: 'private' stamp: 'ClementBera 9/23/2013 10:37'!
newMark
	"Select a previously unused mark value.

	 Details: We just keep incrementing. If necessary, the counter will
	 turn into a LargePositiveInteger. In that case, it will be a bit
	 slower to compute the next mark but the algorithms will all behave
	 correctly. We reserve the value '0' to mean 'unmarked'. Thus, this
	 generator starts at '1' and will never produce '0' as a mark value."

	^currentMark := currentMark + 1! !

!DBPlanner methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:36'!
propagateFrom: v
	"The given variable has changed. Propagate new values downstream."

	| todo c |
	todo := OrderedCollection new.
	self addConstraintsConsuming: v to: todo.
	[todo isEmpty] whileFalse:
		[c := todo removeFirst.
		 c execute.
		 self addConstraintsConsuming: c output to: todo].! !

!DBPlanner methodsFor: 'private' stamp: 'ClementBera 9/23/2013 10:39'!
removePropagateFrom: out
	"Update the walkabout strengths and stay flags of all variables
	 downstream of the given constraint. Answer a collection of unsatisfied
	 constraints sorted in order of decreasing strength."

	| unsatisfied todo v |
	unsatisfied := SortedCollection sortBlock:
		[ :c1 :c2 | c1 strength stronger: c2 strength].
	out determinedBy: nil.
	out walkStrength: DBStrength absoluteWeakest.
	out stay: true.
	todo := OrderedCollection with: out.
	[todo isEmpty] whileFalse:
		[v := todo removeFirst.
		 v constraints do:
		 	[ :c | c isSatisfied ifFalse: [unsatisfied add: c]].
		 self constraintsConsuming: v do:
			[ :c |
			 c recalculate.
			 todo add: c output]].
	^ unsatisfied! !

Object subclass: #DBStrength
	instanceVariableNames: 'symbolicValue arithmeticValue'
	classVariableNames: 'AbsoluteStrongest AbsoluteWeakest Required StrengthConstants StrengthTable'
	poolDictionaries: ''
	category: 'Cog-Benchmarks-DeltaBlue'!

!DBStrength commentStamp: '<historical>' prior: 0!
Strengths are used to measure the relative importance of constraints. The hierarchy of available strengths is determined by the class variable StrengthTable (see my class initialization method). Because Strengths are invariant, references to Strength instances are shared (i.e. all references to
"Strength of: #required" point to a single, shared instance). New strengths may be inserted in the strength hierarchy without disrupting current constraints.

Instance variables:
	symbolicValue		symbolic strength name (e.g. #required) <Symbol>
	arithmeticValue		index of the constraint in the hierarchy, used for comparisons <Number>!

!DBStrength class methodsFor: 'constants' stamp: 'ClementBera 9/23/2013 10:53'!
absoluteStrongest

	^AbsoluteStrongest! !

!DBStrength class methodsFor: 'constants' stamp: 'ClementBera 9/23/2013 10:53'!
absoluteWeakest

	^AbsoluteWeakest! !

!DBStrength class methodsFor: 'initialize' stamp: 'ClementBera 9/23/2013 10:52'!
initialize
	"Initialize the symbolic strength table. Fix the internally caches
	 values of all existing instances."
	"Strength initialize"

	StrengthTable := Dictionary new.
	StrengthTable at: #absoluteStrongest put: -10000.
	StrengthTable at: #required put: -800.
	StrengthTable at: #strongPreferred put: -600.
	StrengthTable at: #preferred put: -400.
	StrengthTable at: #strongDefault put: -200.
	StrengthTable at: #default put: 0.
	StrengthTable at: #weakDefault put: 500.
	StrengthTable at: #absoluteWeakest put: 10000.

	StrengthConstants := Dictionary new.
	StrengthTable keys do:
		[: strengthSymbol |
			StrengthConstants
				at: strengthSymbol
				put: ((super new) initializeWith: strengthSymbol)].

	AbsoluteStrongest := DBStrength of: #absoluteStrongest.
	AbsoluteWeakest := DBStrength of: #absoluteWeakest.
	Required := DBStrength of: #required.! !

!DBStrength class methodsFor: 'instance creation' stamp: 'ClementBera 9/23/2013 10:52'!
of: aSymbol
	"Answer an instance with the specified strength."

	^ StrengthConstants at: aSymbol! !

!DBStrength class methodsFor: 'constants' stamp: 'ClementBera 9/23/2013 10:53'!
required

	^Required! !

!DBStrength methodsFor: 'private' stamp: 'ClementBera 9/23/2013 10:50'!
arithmeticValue
	"Answer my arithmetic value. Used for comparisons. Note that
	 STRONGER constraints have SMALLER arithmetic values."

	^arithmeticValue! !

!DBStrength methodsFor: 'private' stamp: 'ClementBera 9/23/2013 10:51'!
initializeWith: symVal
	"Record my symbolic value and reset my arithmetic value."

	symbolicValue := symVal.
	arithmeticValue := StrengthTable at: symbolicValue.! !

!DBStrength methodsFor: 'printing' stamp: 'ClementBera 9/23/2013 10:50'!
printOn: aStream
	"Append a string which represents my strength onto aStream."

	aStream nextPutAll: '%', symbolicValue, '%'.! !

!DBStrength methodsFor: 'comparing' stamp: 'ClementBera 9/23/2013 10:49'!
sameAs: aStrength
	"Answer true if I am the same strength as the given Strength."

	^ arithmeticValue = aStrength arithmeticValue! !

!DBStrength methodsFor: 'comparing' stamp: 'ClementBera 9/23/2013 10:49'!
stronger: aStrength
	"Answer true if I am stronger than the given Strength."

	^ arithmeticValue < aStrength arithmeticValue! !

!DBStrength methodsFor: 'max / min' stamp: 'ClementBera 9/23/2013 10:50'!
strongest: aStrength
	"Answer the stronger of myself and aStrength."

	^ (aStrength stronger: self)
		ifTrue: [aStrength]
		ifFalse: [self]! !

!DBStrength methodsFor: 'comparing' stamp: 'ClementBera 9/23/2013 10:49'!
weaker: aStrength
	"Answer true if I am weaker than the given Strength."

	^ arithmeticValue > aStrength arithmeticValue! !

!DBStrength methodsFor: 'max / min' stamp: 'ClementBera 9/23/2013 10:50'!
weakest: aStrength
	"Answer the weaker of myself and aStrength."

	^ (aStrength weaker: self)
		ifTrue: [aStrength]
		ifFalse: [self].! !

Object subclass: #DBVariable
	instanceVariableNames: 'constraints determinedBy mark stay value walkStrength'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Benchmarks-DeltaBlue'!

!DBVariable commentStamp: '<historical>' prior: 0!
I represent a constrained variable. In addition to my value, I maintain the structure of the constraint graph, the current dataflow graph, and various parameters of interest to the DeltaBlue incremental constraint solver.

Instance variables:
	value			my value; changed by constraints, read by client <Object>
	constraints		normal constraints that reference me <Array of Constraint>
	determinedBy	the constraint that currently determines
					my value (or nil if there isn''t one) <Constraint>
	walkStrength		my walkabout strength <Strength>
	stay			true if I am a planning-time constant <Boolean>
	mark			used by the planner to mark constraints <Number>!

!DBVariable class methodsFor: 'instance creation' stamp: 'ClementBera 9/23/2013 11:01'!
value: aValue

	^self new value: aValue! !

!DBVariable methodsFor: 'accessing' stamp: 'ClementBera 9/23/2013 10:58'!
addConstraint: aConstraint
	"Add the given constraint to the set of all constraints that refer
	 to me."

	constraints add: aConstraint.! !

!DBVariable methodsFor: 'accessing' stamp: 'ClementBera 9/23/2013 10:58'!
constraints
	^ constraints! !

!DBVariable methodsFor: 'accessing' stamp: 'ClementBera 9/23/2013 10:58'!
determinedBy
	^ determinedBy! !

!DBVariable methodsFor: 'accessing' stamp: 'ClementBera 9/23/2013 10:58'!
determinedBy: anObject
	determinedBy := anObject! !

!DBVariable methodsFor: 'initialize' stamp: 'ClementBera 9/23/2013 10:58'!
initialize

	super initialize.

	value := 0.
	constraints := OrderedCollection new: 2.
	determinedBy := nil.
	walkStrength := DBStrength absoluteWeakest.
	stay := true.
	mark := 0.! !

!DBVariable methodsFor: 'printing' stamp: 'ClementBera 9/23/2013 11:00'!
longPrintOn: aStream

	self shortPrintOn: aStream.
	aStream nextPutAll: '   Constraints: '.
	(constraints isEmpty)
		ifTrue: [aStream cr; tab; nextPutAll: 'none']
		ifFalse:
			[constraints do:
				[: c | aStream cr; tab. c shortPrintOn: aStream]].
	(determinedBy isNil) ifFalse:
		[aStream cr; nextPutAll: '   Determined by: '.
		 aStream cr; tab. determinedBy shortPrintOn: aStream].
	aStream cr.! !

!DBVariable methodsFor: 'accessing' stamp: 'ClementBera 9/23/2013 10:58'!
mark
	^ mark! !

!DBVariable methodsFor: 'accessing' stamp: 'ClementBera 9/23/2013 10:58'!
mark: anObject
	mark := anObject! !

!DBVariable methodsFor: 'printing' stamp: 'ClementBera 9/23/2013 11:00'!
printOn: aStream

	self shortPrintOn: aStream! !

!DBVariable methodsFor: 'accessing' stamp: 'ClementBera 9/23/2013 10:59'!
removeConstraint: c
	"Remove all traces of c from this variable."

	constraints remove: c ifAbsent: [].
	determinedBy == c ifTrue: [determinedBy := nil].! !

!DBVariable methodsFor: 'update' stamp: 'ClementBera 9/23/2013 10:59'!
setValue: aValue
	"Attempt to assign the given value to me using a strength of
	 #preferred."

	self setValue: aValue strength: #preferred.! !

!DBVariable methodsFor: 'update' stamp: 'ClementBera 9/23/2013 11:00'!
setValue: aValue strength: strengthSymbol
	"Attempt to assign the given value to me using the given strength."

	| editConstraint |
	editConstraint := DBEditConstraint var: self strength: strengthSymbol.
	(editConstraint isSatisfied) ifTrue:
		[self value: aValue.
		 DBPlanner propagateFrom: self].
	editConstraint destroyConstraint.! !

!DBVariable methodsFor: 'printing' stamp: 'ClementBera 9/23/2013 11:02'!
shortPrintOn: aStream

	aStream nextPutAll: 'V(', self printString, ', '.
	aStream nextPutAll: walkStrength printString, ', '.
	(stay isNil) ifFalse:
		[aStream nextPutAll: (stay ifTrue: ['stay, '] ifFalse: ['changing, '])].
	aStream nextPutAll: value printString.
	aStream nextPutAll: ')'.
	aStream cr.! !

!DBVariable methodsFor: 'accessing' stamp: 'ClementBera 9/23/2013 10:59'!
stay
	^ stay! !

!DBVariable methodsFor: 'accessing' stamp: 'ClementBera 9/23/2013 10:59'!
stay: anObject
	stay := anObject! !

!DBVariable methodsFor: 'accessing' stamp: 'ClementBera 9/23/2013 10:59'!
value
	^ value! !

!DBVariable methodsFor: 'accessing' stamp: 'ClementBera 9/23/2013 10:59'!
value: anObject
	value := anObject! !

!DBVariable methodsFor: 'accessing' stamp: 'ClementBera 9/23/2013 10:59'!
walkStrength
	^ walkStrength! !

!DBVariable methodsFor: 'accessing' stamp: 'ClementBera 9/23/2013 10:59'!
walkStrength: anObject
	walkStrength := anObject! !

Object subclass: #MultiProcessor
	instanceVariableNames: 'mutex processor guardedProcessorProtocol unguardedProcessorProtocol owner registerState coInterpreter threadIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Processors'!

!MultiProcessor class methodsFor: 'instance creation' stamp: 'eem 10/19/2010 14:52'!
for: aProcessorAlien coInterpreter: coInterpreter
	^self new
		processor: aProcessorAlien;
		coInterpreter: coInterpreter;
		yourself! !

!MultiProcessor methodsFor: 'initialize-release' stamp: 'eem 10/19/2010 14:32'!
coInterpreter: aCoInterpreter
	coInterpreter := aCoInterpreter! !

!MultiProcessor methodsFor: 'message forwarding' stamp: 'eem 10/20/2010 17:28'!
doesNotUnderstand: aMessage
	"Forward a message to the actual processor, managing a thread-switch if necessary.
	 Catch ProcessorSimulationTraps and raise them outside of the critical section to
	 avoid deadlock when reentering the VM from a trap and switching threads in the run-time."
	| selector result trap |
	selector := aMessage selector.
	(guardedProcessorProtocol includes: selector) ifFalse:
		[^(unguardedProcessorProtocol includes: selector)
			ifTrue: [processor perform: selector withArguments: aMessage arguments]
			ifFalse: [super doesNotUnderstand: aMessage]].
	result := [mutex critical:
				[owner ~~ mutex owningProcess ifTrue:
					[owner ifNotNil:
						[registerState at: owner put: processor registerState].
					 (registerState at: (owner := mutex owningProcess) ifAbsent: nil)
						ifNil: [coInterpreter initializeProcessorForThreadIndex: (threadIndex := threadIndex + 1)]
						ifNotNil: [:newState| processor setRegisterState: newState]].
				 processor perform: selector withArguments: aMessage arguments]]
					on: ProcessorSimulationTrap, Error
					do: [:ex| trap := ex].
	^trap ifNil: [result] ifNotNil: [trap signal]! !

!MultiProcessor methodsFor: 'initialize-release' stamp: 'eem 10/20/2010 12:42'!
initialize
	registerState := WeakIdentityKeyDictionary new.
	mutex := Mutex new.
	threadIndex := 0.
	guardedProcessorProtocol := unguardedProcessorProtocol := Set new! !

!MultiProcessor methodsFor: 'initialize-release' stamp: 'eem 9/3/2013 11:33'!
processor: aProcessor
	processor := aProcessor.
	guardedProcessorProtocol := aProcessor class selectors asSet
									addAll: aProcessor class superclass selectors;
									yourself.
	unguardedProcessorProtocol := #(#'Cog API' #opcodes #disassembly #printing)
										inject: Set new
										into: [ :protocol :category|
											protocol
												addAll: (aProcessor class organization listAtCategoryNamed: category);
												addAll: (aProcessor class superclass organization listAtCategoryNamed: category);
												yourself].
	guardedProcessorProtocol removeAll: unguardedProcessorProtocol! !

Object subclass: #RichObject
	instanceVariableNames: ''
	classVariableNames: 'DeviceA DeviceB DevicePacketKind HandlerA HandlerB Idler WorkPacketKind Worker'
	poolDictionaries: ''
	category: 'Cog-Benchmarks-Richards'!

!RichObject commentStamp: '<historical>' prior: 0!
This class mostly adds some constants that are used in the Richards benchmarks.!

RichObject subclass: #RichDeviceTaskDataRecord
	instanceVariableNames: 'pending'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Benchmarks-Richards'!

!RichDeviceTaskDataRecord commentStamp: '<historical>' prior: 0!
A task that suspends itself after each time it has been run to simulate waiting for data from an external device.
!

!RichDeviceTaskDataRecord methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 16:10'!
pending
	^ pending! !

!RichDeviceTaskDataRecord methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 16:10'!
pending: anObject
	pending := anObject! !

RichObject subclass: #RichHandlerTaskDataRecord
	instanceVariableNames: 'workIn deviceIn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Benchmarks-Richards'!

!RichHandlerTaskDataRecord commentStamp: '<historical>' prior: 0!
A task that manipulates work packets and then suspends itself.!

!RichHandlerTaskDataRecord methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 16:10'!
deviceIn
	^ deviceIn! !

!RichHandlerTaskDataRecord methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 16:10'!
deviceIn: anObject
	deviceIn := anObject! !

!RichHandlerTaskDataRecord methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 16:10'!
deviceInAdd: packet
    deviceIn := self append: packet head: deviceIn! !

!RichHandlerTaskDataRecord methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 16:10'!
workIn
	^ workIn! !

!RichHandlerTaskDataRecord methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 16:10'!
workIn: anObject
	workIn := anObject! !

!RichHandlerTaskDataRecord methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 16:11'!
workInAdd: packet
    workIn := self append: packet head: workIn! !

RichObject subclass: #RichIdleTaskDataRecord
	instanceVariableNames: 'control count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Benchmarks-Richards'!

!RichIdleTaskDataRecord commentStamp: '<historical>' prior: 0!
An idle task doesn't do any work itself but cycles control between the two device tasks.!

!RichIdleTaskDataRecord methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 16:18'!
control
	^ control! !

!RichIdleTaskDataRecord methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 16:18'!
control: anObject
	control := anObject! !

!RichIdleTaskDataRecord methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 16:18'!
count
	^ count! !

!RichIdleTaskDataRecord methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 16:18'!
count: anObject
	count := anObject! !

!RichIdleTaskDataRecord methodsFor: 'initialize' stamp: 'ClementBera 9/27/2013 16:17'!
initialize
	control := 1.
    	count := 10000! !

!RichObject class methodsFor: 'initialize' stamp: 'ClementBera 9/27/2013 15:20'!
initialize
	super initialize.
    	DeviceA := 5.
    	DeviceB := 6.
    	DevicePacketKind := 1.
    	HandlerA := 3.
    	HandlerB := 4.
    	Idler := 1.
    	Worker := 2.
    	WorkPacketKind := 2! !

!RichObject methodsFor: 'utilities' stamp: 'ClementBera 9/27/2013 15:19'!
append: packet head: queueHead
    | mouse link |
    packet link: nil.
    queueHead ifNil: [ ^ packet ].
    mouse := queueHead.
    [ (link := mouse link) isNil]
	whileFalse: [ mouse := link ].
    mouse link: packet.
    ^ queueHead! !

RichObject subclass: #RichPacket
	instanceVariableNames: 'data datum identity kind link'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Benchmarks-Richards'!

!RichPacket commentStamp: '<historical>' prior: 0!
A simple package of data that is manipulated by the tasks.  The exact layout of the payload data carried by a packet is not importaint, and neither is the nature of the work performed on packets by the tasks. Besides carrying data, packets form linked lists and are hence used both as data and worklists.!

!RichPacket class methodsFor: 'instance creation' stamp: 'ClementBera 9/27/2013 15:21'!
create: link identity: identity kind: kind 
    ^ self new
		link: link
		identity: identity
		kind: kind! !

!RichPacket methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 15:21'!
data
	^ data! !

!RichPacket methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 15:21'!
datum
	^ datum! !

!RichPacket methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 15:21'!
datum: anObject
	datum := anObject! !

!RichPacket methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 15:21'!
identity
	^ identity! !

!RichPacket methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 15:21'!
identity: anObject
	identity := anObject! !

!RichPacket methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 15:21'!
kind
	^ kind! !

!RichPacket methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 15:21'!
link
	^ link! !

!RichPacket methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 15:21'!
link: anObject
	link := anObject! !

!RichPacket methodsFor: 'initialize' stamp: 'ClementBera 9/27/2013 15:20'!
link: aLink identity: anIdentity kind: aKind 
    link := aLink.
    identity := anIdentity. 
    kind := aKind.
    datum := 1.
    data := ByteArray new: 4! !

RichObject subclass: #RichRunner
	instanceVariableNames: 'taskList currentTask currentTaskIdentity taskTable queuePacketCount holdCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Benchmarks-Richards'!

!RichRunner commentStamp: '<historical>' prior: 0!
Richards simulates the task dispatcher of an operating system.!

!RichRunner class methodsFor: 'starting' stamp: 'ClementBera 9/27/2013 15:58'!
start
    "RichardsBenchmark start"

    ^self new start! !

!RichRunner methodsFor: 'creation' stamp: 'ClementBera 9/27/2013 16:18'!
createDevice: identity priority: priority work: work state: state 
    | data |
    data := RichDeviceTaskDataRecord new.
    self
	createTask: identity
	priority: priority
	work: work
	state: state
	function: 
	    [:work1 :word | | data1 functionWork |
	    data1 := word.
	    functionWork := work1.
	    functionWork 
		ifNil:
		    [(functionWork := data1 pending) isNil
			ifTrue: [self wait]
			ifFalse: 
			    [data1 pending: nil.
			    self queuePacket: functionWork]]
		ifNotNil: 
		    [data1 pending: functionWork.
		    self holdSelf]]
	data: data! !

!RichRunner methodsFor: 'creation' stamp: 'ClementBera 9/27/2013 16:18'!
createHandler: identity priority: priority work: work state: state 
    | data |
    data := RichHandlerTaskDataRecord new.
    self
	createTask: identity
	priority: priority
	work: work
	state: state
	function: 
	    [:work1 :word | | data1 workPacket count devicePacket |
	    data1 := word.
	    work1 
		ifNotNil: [WorkPacketKind == work1 kind 
		    ifTrue: [data1 workInAdd: work1]
		    ifFalse: [data1 deviceInAdd: work1]].
	    (workPacket := data1 workIn) 
		ifNil: [self wait]
		ifNotNil: 
		    [count := workPacket datum.
		    count > 4
			ifTrue: 
			    [data1 workIn: workPacket link.
			    self queuePacket: workPacket]
			ifFalse:
			    [(devicePacket := data1 deviceIn) 
				ifNil: [self wait]
				ifNotNil: 
				    [data1 deviceIn: devicePacket link.
				    devicePacket datum: (workPacket data at: count).
				    workPacket datum: count + 1.
				    self queuePacket: devicePacket]]]]
	data: data! !

!RichRunner methodsFor: 'creation' stamp: 'ClementBera 9/27/2013 16:18'!
createIdler: identity priority: priority work: work state: state 
    | data |
    data := RichIdleTaskDataRecord new.
    self
	createTask: identity
	priority: priority
	work: work
	state: state
	function: 
	    [:work1 :word | | data1 |
	    data1 := word.
	    data1 count: data1 count - 1.
	    0 = data1 count
		ifTrue: [self holdSelf]
		ifFalse:
		    [0 = (data1 control bitAnd: 1)
			ifTrue: 
			    [data1 control: data1 control // 2.
			    self release: DeviceA]
			ifFalse: 
			    [data1 control: (data1 control // 2 bitXor: 53256).
			    self release: DeviceB]]]
	data: data! !

!RichRunner methodsFor: 'creation' stamp: 'ClementBera 9/27/2013 15:27'!
createPacket: link identity: identity kind: kind 
    ^ RichPacket
		create: link
		identity: identity
		kind: kind! !

!RichRunner methodsFor: 'creation' stamp: 'ClementBera 9/27/2013 15:28'!
createTask: identity priority: priority work: work state: state function: aBlock data: data 
    | t |
    t := RichTaskControlBlock
		link: taskList
		create: identity
		priority: priority
		initialWorkQueue: work
		initialState: state
		function: aBlock
		privateData: data.
    taskList := t.
    taskTable at: identity put: t! !

!RichRunner methodsFor: 'creation' stamp: 'ClementBera 9/27/2013 16:18'!
createWorker: identity priority: priority work: work state: state 
    | data |
    data := RichWorkerTaskDataRecord new.
    self
	createTask: identity
	priority: priority
	work: work
	state: state
	function: 
	    [:work1 :word | | data1 |
	    data1 := word.
	    work1
		ifNil: [self wait]
		ifNotNil: 
		    [data1 destination: (HandlerA = data1 destination
			    ifTrue: [HandlerB]
			    ifFalse: [HandlerA]).
		    work1 identity: data1 destination.
		    work1 datum: 1.
		    1 to: 4 do: [ :i | 
			data1 count: data1 count + 1.
			data1 count > 26 ifTrue: [data1 count: 1].
			work1 data at: i put: $A asInteger + data1 count - 1].
		    self queuePacket: work1]]
	data: data! !

!RichRunner methodsFor: 'private' stamp: 'ClementBera 9/27/2013 15:30'!
findTask: identity 
    | t |
    t := taskTable at: identity.
    t ifNil: [self error: 'findTask failed'].
    ^ t! !

!RichRunner methodsFor: 'private' stamp: 'ClementBera 9/27/2013 15:35'!
holdSelf
    holdCount := holdCount + 1.
    currentTask taskHolding: true.
    ^ currentTask link! !

!RichRunner methodsFor: 'private' stamp: 'ClementBera 9/27/2013 15:35'!
initScheduler
    queuePacketCount := holdCount := 0.
    taskTable := Array new: 6.
    taskList := nil! !

!RichRunner methodsFor: 'private' stamp: 'ClementBera 9/27/2013 15:37'!
queuePacket: packet 
    | t |
    t := self findTask: packet identity.
    t ifNil: [ ^ nil ].
    queuePacketCount := queuePacketCount + 1.
    packet link: nil.
    packet identity: currentTaskIdentity.
    ^ t addInput: packet checkPriority: currentTask! !

!RichRunner methodsFor: 'private' stamp: 'ClementBera 9/27/2013 15:38'!
release: identity 
    | t |
    t := self findTask: identity.
    t ifNil: [ ^ nil ].
    t taskHolding: false.
    ^ t priority > currentTask priority
	ifTrue: [ t ]
	ifFalse: [ currentTask ]! !

!RichRunner methodsFor: 'scheduling' stamp: 'ClementBera 9/27/2013 16:00'!
schedule
    currentTask := taskList. 
    [currentTask isNil]
	whileFalse: 
	    [currentTask isTaskHoldingOrWaiting
		ifTrue: [currentTask := currentTask link]
		ifFalse: 
		    [currentTaskIdentity := currentTask identity.
		    currentTask := currentTask runTask]]! !

!RichRunner methodsFor: 'initialize' stamp: 'ClementBera 9/27/2013 16:01'!
start
    | workQ |
    self initScheduler.
    self
	createIdler: Idler
	priority: 0
	work: nil
	state: RichTaskState running.
    workQ := self
		createPacket: nil
		identity: Worker
		kind: WorkPacketKind.
    workQ := self
		createPacket: workQ
		identity: Worker
		kind: WorkPacketKind.
    self
	createWorker: Worker
	priority: 1000
	work: workQ
	state: RichTaskState waitingWithPacket.
    workQ := self
		createPacket: nil
		identity: DeviceA
		kind: DevicePacketKind.
    workQ := self
		createPacket: workQ
		identity: DeviceA
		kind: DevicePacketKind.
    workQ := self
		createPacket: workQ
		identity: DeviceA
		kind: DevicePacketKind.
    self
	createHandler: HandlerA
	priority: 2000
	work: workQ
	state: RichTaskState waitingWithPacket.
    workQ := self
		createPacket: nil
		identity: DeviceB
		kind: DevicePacketKind.
    workQ := self
		createPacket: workQ
		identity: DeviceB
		kind: DevicePacketKind.
    workQ := self
		createPacket: workQ
		identity: DeviceB
		kind: DevicePacketKind.
    self
	createHandler: HandlerB
	priority: 3000
	work: workQ
	state: RichTaskState waitingWithPacket.
    self
	createDevice: DeviceA
	priority: 4000
	work: nil
	state: RichTaskState waiting.
    self
	createDevice: DeviceB
	priority: 5000
	work: nil
	state: RichTaskState waiting.
    self schedule.
    queuePacketCount = 23246 & (holdCount = 9297) ifFalse: [self error: 'wrong result'].
! !

!RichRunner methodsFor: 'private' stamp: 'ClementBera 9/27/2013 15:40'!
wait 
    currentTask taskWaiting: true.
    ^ currentTask! !

RichObject subclass: #RichTaskState
	instanceVariableNames: 'packetPendingIV taskHolding taskWaiting'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Benchmarks-Richards'!

!RichTaskState commentStamp: '<historical>' prior: 0!
Abstract task that manipulates work packets.!

RichTaskState subclass: #RichTaskControlBlock
	instanceVariableNames: 'link identity priority input state function handle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Benchmarks-Richards'!

!RichTaskControlBlock commentStamp: '<historical>' prior: 0!
A task control block manages a task and the queue of work packages associated with it.!

!RichTaskControlBlock class methodsFor: 'instance creation' stamp: 'ClementBera 9/27/2013 16:17'!
link: link create: identity priority: priority initialWorkQueue: initialWorkQueue initialState: initialState function: aBlock privateData: privateData 
    ^ self new
		link: link
		identity: identity
		priority: priority
		initialWorkQueue: initialWorkQueue
		initialState: initialState
		function: aBlock
		privateData: privateData! !

!RichTaskControlBlock methodsFor: 'scheduling' stamp: 'ClementBera 9/27/2013 16:15'!
addInput: packet checkPriority: oldTask
    input 
	ifNil: 
	    [input := packet.
	    packetPendingIV := true.
	    priority > oldTask priority ifTrue: [ ^ self ]]
	ifNotNil: 
	    [ input := self append: packet head: input ].
    ^ oldTask! !

!RichTaskControlBlock methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 16:13'!
identity
	^ identity! !

!RichTaskControlBlock methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 16:13'!
link
	^ link! !

!RichTaskControlBlock methodsFor: 'initialize' stamp: 'ClementBera 9/27/2013 16:12'!
link: aLink identity: anIdentity priority: aPriority initialWorkQueue: anInitialWorkQueue initialState: anInitialState function: aBlock privateData: aPrivateData 
    link := aLink.
    identity := anIdentity.
    priority := aPriority.
    input := anInitialWorkQueue.
    packetPendingIV := anInitialState isPacketPending.
    taskWaiting := anInitialState isTaskWaiting.
    taskHolding := anInitialState isTaskHolding.
    function := aBlock.
    handle := aPrivateData! !

!RichTaskControlBlock methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 16:13'!
priority
	^ priority! !

!RichTaskControlBlock methodsFor: 'scheduling' stamp: 'ClementBera 9/27/2013 16:16'!
runTask
    | message |
    self isWaitingWithPacket
	ifTrue: 
	    [message := input.
	    input := message link.
	    input 
		ifNil: [self running]
		ifNotNil: [self packetPending]]
	ifFalse: [message := nil].
    ^ function value: message value: handle! !

!RichTaskState class methodsFor: 'instance creation' stamp: 'ClementBera 9/27/2013 16:09'!
packetPending
    ^super new packetPending! !

!RichTaskState class methodsFor: 'instance creation' stamp: 'ClementBera 9/27/2013 16:09'!
running
    ^super new running! !

!RichTaskState class methodsFor: 'instance creation' stamp: 'ClementBera 9/27/2013 16:09'!
waiting
    ^super new waiting! !

!RichTaskState class methodsFor: 'instance creation' stamp: 'ClementBera 9/27/2013 16:09'!
waitingWithPacket
    ^super new waitingWithPacket! !

!RichTaskState methodsFor: 'testing' stamp: 'ClementBera 9/27/2013 16:06'!
isPacketPending
    ^packetPendingIV! !

!RichTaskState methodsFor: 'testing' stamp: 'ClementBera 9/27/2013 16:07'!
isRunning
    ^packetPendingIV not and: [taskWaiting not and: [taskHolding not]]! !

!RichTaskState methodsFor: 'testing' stamp: 'ClementBera 9/27/2013 16:06'!
isTaskHolding
    ^taskHolding! !

!RichTaskState methodsFor: 'testing' stamp: 'ClementBera 9/27/2013 16:07'!
isTaskHoldingOrWaiting
    ^taskHolding or: [packetPendingIV not and: [taskWaiting]]! !

!RichTaskState methodsFor: 'testing' stamp: 'ClementBera 9/27/2013 16:06'!
isTaskWaiting
    ^taskWaiting! !

!RichTaskState methodsFor: 'testing' stamp: 'ClementBera 9/27/2013 16:07'!
isWaiting
    ^packetPendingIV not and: [taskWaiting and: [taskHolding not]]! !

!RichTaskState methodsFor: 'testing' stamp: 'ClementBera 9/27/2013 16:07'!
isWaitingWithPacket
    ^packetPendingIV and: [taskWaiting and: [taskHolding not]]! !

!RichTaskState methodsFor: 'initialize' stamp: 'ClementBera 9/27/2013 16:06'!
packetPending
    packetPendingIV := true.
    taskWaiting := false.
    taskHolding := false! !

!RichTaskState methodsFor: 'initialize' stamp: 'ClementBera 9/27/2013 16:06'!
running
    packetPendingIV := taskWaiting := taskHolding := false! !

!RichTaskState methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 16:07'!
taskHolding: anObject
	^ taskHolding := anObject! !

!RichTaskState methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 16:07'!
taskWaiting: anObject
	^ taskWaiting := anObject! !

!RichTaskState methodsFor: 'initialize' stamp: 'ClementBera 9/27/2013 16:06'!
waiting
    packetPendingIV := taskHolding := false.
    taskWaiting := true! !

!RichTaskState methodsFor: 'initialize' stamp: 'ClementBera 9/27/2013 16:06'!
waitingWithPacket
    taskHolding := false.
    taskWaiting := packetPendingIV := true! !

RichObject subclass: #RichWorkerTaskDataRecord
	instanceVariableNames: 'destination count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Benchmarks-Richards'!

!RichWorkerTaskDataRecord commentStamp: '<historical>' prior: 0!
A task that manipulates work packets.!

!RichWorkerTaskDataRecord methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 16:11'!
count
	^ count! !

!RichWorkerTaskDataRecord methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 16:11'!
count: anObject
	count := anObject! !

!RichWorkerTaskDataRecord methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 16:11'!
destination
	^ destination! !

!RichWorkerTaskDataRecord methodsFor: 'accessing' stamp: 'ClementBera 9/27/2013 16:11'!
destination: anObject
	destination := anObject! !

!RichWorkerTaskDataRecord methodsFor: 'as yet unclassified' stamp: 'ClementBera 10/7/2013 10:36'!
initialize
    destination := HandlerA.
    count := 0 ! !

Object subclass: #SMarkHarness
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Benchmarks-SMark'!

!SMarkHarness commentStamp: '<historical>' prior: 0!
A benchmark harness steers the execution and reporting of benchmarks.
For that purpose, it will use a designated benchmark runner to do the execution and a benchmark reporter to output the results.
The benchmark harness is also parameterized by the benchmark suites that are to be executed.

The simplest way to execute a benchmark suite is to use SMarkSuite >> #run.

However, directly using the harness classes gives more freedom on reporting and execution strategies.

A typical call of the harness from the commandline would result in the following invokation:
	SMarkHarness run: {'SMarkHarness'. 'SMarkLoops.benchIntLoop'. 1. 1. 5}!

SMarkHarness subclass: #ReBenchHarness
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Benchmarks-SMark'!

!ReBenchHarness commentStamp: 'StefanMarr 5/16/2011 09:10' prior: 0!
The ReBenchHarness is optimized for use from the command-line.
It is especially meant to be used together with ReBench, a tool to execute and document benchmarks reproducibly.

See: https://github.com/smarr/ReBench#readme!

!ReBenchHarness class methodsFor: 'helper' stamp: 'StefanMarr 12/30/2011 19:59'!
defaultArgumentParser
	^ ReBenchHarnessArgumentParser! !

!ReBenchHarness class methodsFor: 'defaults' stamp: ''!
defaultReporter
	^ ReBenchReporter! !

!ReBenchHarness class methodsFor: 'defaults' stamp: 'sm 5/25/2011 17:06'!
defaultRunner
	^ SMarkWeakScalingRunner! !

!ReBenchHarness class methodsFor: 'helper' stamp: 'sm 5/25/2011 17:20'!
usageBenchmarkParameters: usage
	^ usage,		' processes          optional, number of processes/threads used by the benchmarks', String crlf,
				' inner-iterations   optional, number of iterations done by a single process', String crlf,
				' problemSize        optional, depending on benchmark for instance size of used data set', String crlf.
				! !

!ReBenchHarness class methodsFor: 'helper' stamp: 'sm 5/25/2011 17:20'!
usageHeader
	| usage |
	usage := 'SMark Benchmark Framework, version: ', self version, String crlf.
	usage := usage, String crlf.
	usage := usage, 'Usage: <vm+image> ', self name,
				' <suiteOrBenchmark> [processes [inner-iterations [problemSize]]]', String crlf.
	usage := usage, String crlf.
	
	usage := usage, '  This harness is used for weak-scalling benchmarks.', String crlf.
	usage := usage, '  Use the SMarkHarness for more general settings, it offers more options.', String crlf.
	
	usage := usage, String crlf.
	^ usage! !

!ReBenchHarness class methodsFor: 'helper' stamp: ''!
usageReporter: usage
	"Will rely on default, which is good for ReBench, so do not advertise option."
	^ usage! !

!ReBenchHarness class methodsFor: 'helper' stamp: ''!
usageRunner: usage
	"Will rely on default, which is good for ReBench, so do not advertise option."
	^ usage! !

!SMarkHarness class methodsFor: 'helper' stamp: 'StefanMarr 12/30/2011 19:59'!
defaultArgumentParser
	^ SMarkHarnessArgumentParser! !

!SMarkHarness class methodsFor: 'defaults' stamp: ''!
defaultOutputDestination
	^ Smalltalk at:       #ScriptConsole
	            ifAbsent: [SMarkReporter defaultOutputDestination]! !

!SMarkHarness class methodsFor: 'defaults' stamp: ''!
defaultReporter
	^ SMarkReporter defaultReporter! !

!SMarkHarness class methodsFor: 'defaults' stamp: ''!
defaultRunner
	^ SMarkSuite defaultRunner! !

!SMarkHarness class methodsFor: 'benchmarking' stamp: 'sm 5/25/2011 17:41'!
execute: runner andReport: reporter
	runner reportConfiguration: self defaultOutputDestination.
	runner execute.
	reporter runner: runner.
	reporter outputStream: self defaultOutputDestination.
	reporter report.! !

!SMarkHarness class methodsFor: 'benchmarking' stamp: ''!
execute: aBenchmarkOrSuite using: aRunnerClass andReport: withAReporterClass
	| parsedBenchmarkOrSuite runner reporter |
	
	parsedBenchmarkOrSuite := self parseBenchmarkOrSuite: aBenchmarkOrSuite.
	
	runner := aRunnerClass new.
	reporter := withAReporterClass new.
	self instructRunner: runner with: parsedBenchmarkOrSuite.
	self execute: runner andReport: reporter.   ! !

!SMarkHarness class methodsFor: 'helper' stamp: 'StefanMarr 12/30/2011 20:00'!
parseArguments: arguments
	| parser |
	parser := self defaultArgumentParser new.
	parser harness: self.
	^ parser parse: arguments.! !

!SMarkHarness class methodsFor: 'script entry' stamp: 'StephaneDucasse 6/16/2013 20:45'!
run: arguments
	"Executed from the command line using something similar to
	 ./vm my.image SMarkHarness SMarkRunner SMarkReporter SMarkLoops\>\>benchIntLoop 1 1 5
	 ./vm my.image SMarkHarness SMarkRunner SMarkReporter SMarkLoops.benchIntLoop 1 1 5"

	| runner reporter runnerAndReporter |
	
	(self shouldShowUsage: arguments)
		ifTrue: [
			self usage.
			^ self.
		].
	
	runnerAndReporter := self parseArguments: arguments.
	runner := runnerAndReporter first.
	reporter := runnerAndReporter second.  
	
	self execute: runner andReport: reporter. ! !

!SMarkHarness class methodsFor: 'helper' stamp: ''!
shouldShowUsage: arguments
	
	arguments size < 2 ifTrue: [^ true ].
	
	^ arguments anySatisfy: [:elem | (elem = '--help') or: [elem = '-?'] ].  ! !

!SMarkHarness class methodsFor: 'helper' stamp: 'StephaneDucasse 6/16/2013 21:04'!
usage
	| usage |
	"Example usage: SMarkHarness SMarkRunner SMarkReporter SMarkLoops.benchIntLoop 1 1 5"
	
	usage := self usageHeader.
	
	usage := usage, 'Arguments:', String crlf.
	usage := self usageRunner:   usage.
	usage := self usageReporter: usage.
	usage := usage, ' suiteOrBenchmark   required, either a SMarkSuite with benchmarks,', String crlf.
	usage := usage, '                              or a benchmark denoted by Suite.benchName', String crlf.
	usage := self usageBenchmarkParameters: usage.
	
	self defaultOutputDestination print: usage.! !

!SMarkHarness class methodsFor: 'helper' stamp: ''!
usageBenchmarkParameters: usage
	^ usage,	' iterations         optional, number of times the benchmarks are repeated', String crlf,
				' processes          optional, number of processes/threads used by the benchmarks', String crlf,
				' problemSize        optional, depending on benchmark for instance number of', String crlf,
				'                              inner iterations or size of used data set', String crlf.
! !

!SMarkHarness class methodsFor: 'helper' stamp: ''!
usageHeader
	| usage |
	usage := 'SMark Benchmark Framework, version: ', self version, String crlf.
	usage := usage, String crlf.
	usage := usage, 'Usage: <vm+image> ', self name, ' [runner] [reporter] <suiteOrBenchmark>', String crlf.
	usage := usage, '                               [iterations [processes [problemSize]]]', String crlf.
	usage := usage, String crlf.
	^ usage! !

!SMarkHarness class methodsFor: 'helper' stamp: ''!
usageReporter: usage
	^ usage,	' reporter           optional, a SMarkReporter class that processes', String crlf,
				'                              and displays the results', String crlf.
	! !

!SMarkHarness class methodsFor: 'helper' stamp: ''!
usageRunner: usage
	^ usage, ' runner             optional, a SMarkRunner class that executes the benchmarks', String crlf.! !

!SMarkHarness class methodsFor: 'helper' stamp: ''!
version
	(Smalltalk classNamed: #ConfigurationOfBenchmarking)
		ifNotNilDo: [:cfg |
			^ cfg project currentVersion versionNumber asString.
		].
	  
	(Smalltalk classNamed: #MCPackage)
		ifNotNilDo: [:mcp |
			| package |
			package := mcp named: 'SMark'.
			package hasWorkingCopy ifTrue: [
				^ package workingCopy ancestors first name.
			].
		].
	
	^ ''.! !

Object subclass: #SMarkHarnessArgumentParser
	instanceVariableNames: 'runner reporter suiteOrBenchmark iterations processes problemSize i current numParams currentObj arguments suite specificBenchmark suiteClass harness'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Benchmarks-SMark'!

SMarkHarnessArgumentParser subclass: #ReBenchHarnessArgumentParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Benchmarks-SMark'!

!ReBenchHarnessArgumentParser methodsFor: 'argument parsing' stamp: 'sm 5/25/2011 17:17'!
determineBenchmarkParametersFromArguments
	i := i + 1.
	i <= numParams ifTrue: [
		processes := (arguments at: i) asInteger.
		i := i + 1.
		i <= numParams ifTrue: [
			iterations := (arguments at: i) asInteger.
			i := i + 1.
			i <= numParams ifTrue: [
				problemSize := arguments at: i.
			]
		]
	].! !

!ReBenchHarnessArgumentParser methodsFor: 'argument parsing' stamp: ''!
determineReporter
	reporter := harness defaultReporter new.! !

!ReBenchHarnessArgumentParser methodsFor: 'argument parsing' stamp: ''!
determineRunner
	runner := harness defaultRunner new.! !

!ReBenchHarnessArgumentParser methodsFor: 'helper' stamp: 'sm 5/25/2011 17:31'!
instructRunner
	super instructRunner.
	
	runner iterations: runner class defaultNumberOfIterations.
	runner innerIterations: iterations.! !

!SMarkHarnessArgumentParser methodsFor: 'argument parsing' stamp: 'sm 5/25/2011 17:38'!
determineBenchmarkParameters
	"Initialize with defaults, will be overwritten in case
	 it is specified."
	iterations := runner class defaultNumberOfIterations.
	processes  := runner class defaultNumberOfProcesses.
	problemSize:= suiteClass defaultProblemSize.
	
	self determineBenchmarkParametersFromArguments.! !

!SMarkHarnessArgumentParser methodsFor: 'argument parsing' stamp: ''!
determineBenchmarkParametersFromArguments
	i := i + 1.
	i <= numParams ifTrue: [
		iterations := (arguments at: i) asInteger.
		i := i + 1.
		i <= numParams ifTrue: [
			processes := (arguments at: i) asInteger.
			i := i + 1.
			i <= numParams ifTrue: [
				problemSize := arguments at: i.
			]
		]
	].! !

!SMarkHarnessArgumentParser methodsFor: 'argument parsing' stamp: ''!
determineReporter
	(currentObj isKindOf: SMarkReporter)
		ifFalse: [ reporter := harness defaultReporter new. ]
		ifTrue:  [ reporter := currentObj.
			i := i + 1.
			i <= numParams ifTrue: [
				current := arguments at: i.
			]
		].! !

!SMarkHarnessArgumentParser methodsFor: 'argument parsing' stamp: ''!
determineRunner
	(currentObj isKindOf: SMarkRunner)
		ifFalse: [ runner := harness defaultRunner new. ]
		ifTrue:  [ runner := currentObj.
			i := i + 1.
			i <= numParams ifTrue: [
				current := arguments at: i.
				currentObj := (Smalltalk classNamed: current) ifNotNilDo: [:cls | cls new].
			]
		].! !

!SMarkHarnessArgumentParser methodsFor: 'argument parsing' stamp: 'sm 5/25/2011 17:26'!
determineSuiteOrBenchmark
	self parseBenchmarkOrSuite: current.! !

!SMarkHarnessArgumentParser methodsFor: 'accessing' stamp: ''!
harness: aHarness
	harness := aHarness! !

!SMarkHarnessArgumentParser methodsFor: 'helper' stamp: 'sm 5/25/2011 17:29'!
instructRunner
	suite := suiteClass new.
	specificBenchmark ifNotNil: [
		suite runOnly: specificBenchmark.
	].
	
	runner suite: suite.
 	runner iterations: iterations.
	runner processes: processes.
	runner problemSize: problemSize.! !

!SMarkHarnessArgumentParser methodsFor: 'parsing' stamp: 'sm 5/25/2011 17:27'!
parse: argumentsArray
	arguments := argumentsArray.
	numParams := arguments size.
	
	i := 2.
	current := arguments at: i.
	currentObj := (Smalltalk classNamed: current) ifNotNilDo: [:cls | cls new].
		
	self determineRunner.
	self determineReporter.
	
	self determineSuiteOrBenchmark.
	
	self determineBenchmarkParameters.
	
	self instructRunner.
	
	^ {runner. reporter}! !

!SMarkHarnessArgumentParser methodsFor: 'argument parsing' stamp: ''!
parseBenchmarkOrSuite: aBenchmarkOrSuite
	"Identify the benchmark suite or suite and benchmark method
	 that should be executed. The string should be of the format 'Class>>benchName' or 'Class.benchName' for shell/bash compatibility.
	 Accepts a string, class, or array.
	 Returns, a class, or an array of a class and a symbol."
	| parsed |
	(aBenchmarkOrSuite isKindOf: Class)
		ifTrue: [
			suiteClass := aBenchmarkOrSuite.
			^ suiteClass
		].
	  
	(aBenchmarkOrSuite isKindOf: Array)
		ifTrue:  [ parsed := aBenchmarkOrSuite. ]
		ifFalse: [ parsed := aBenchmarkOrSuite findTokens: '>.'. ].
	
	((parsed size > 2) or: [parsed size < 1])
				ifTrue: [ Error signal: 'The passed argument has to represent two elements. A class/classname and a method symbol' ].
	
	suiteClass := parsed first.
	
	(suiteClass isKindOf: Class) 
		ifFalse: [ suiteClass := Smalltalk at: (suiteClass asSymbol) ifAbsent: [Error signal: 'Class that was supposed to represent a benchmark suite was not found: ', suiteClass asString ]].
	
	parsed size = 1
		ifTrue: [^suiteClass].

	specificBenchmark := parsed second asSymbol.
	
	^ { suiteClass. specificBenchmark }
! !

Object subclass: #SMarkReporter
	instanceVariableNames: 'runner stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Benchmarks-SMark'!

!SMarkReporter commentStamp: '<historical>' prior: 0!
SMarkReporter is a simple formatter of benchmark results. 

Subclass such as SMarkSimpleStatisticsReporter might implement more advanced reporting functionality, e.g., including a statistical evaluation of the results.

Example:

	| f |
	f := TextStream on: String new.
	SMarkSimpleStatisticsReporter reportFor: (SMarkTestRunnerSuiteForAutosizing run: 10) on: f.
	f contents!

!SMarkReporter class methodsFor: 'defaults' stamp: ''!
defaultOutputDestination
	^ ScriptConsole! !

!SMarkReporter class methodsFor: 'defaults' stamp: ''!
defaultReporter
	^ SMarkSimpleStatisticsReporter! !

!SMarkReporter class methodsFor: 'reporting' stamp: ''!
reportFor: aRunner
	self reportFor: aRunner on: self defaultOutputDestination.! !

!SMarkReporter class methodsFor: 'reporting' stamp: ''!
reportFor: aRunner on: aStream
	| reporter |
	reporter := self new.
	reporter runner: aRunner.
	reporter outputStream: aStream.
	reporter report.
	^ reporter.! !

!SMarkReporter methodsFor: 'reporting' stamp: ''!
benchmarkFooter: aName
	stream cr.! !

!SMarkReporter methodsFor: 'reporting' stamp: ''!
benchmarkHeader: aName
	stream << 'Benchmark ' << (aName asString); cr.! !

!SMarkReporter methodsFor: 'reporting' stamp: ''!
footer
	"No output at the moment"
	^ self! !

!SMarkReporter methodsFor: 'reporting' stamp: ''!
header
	| suiteName |
	suiteName := runner suite class name asString.
	stream << 'Report for: ' << suiteName; cr.! !

!SMarkReporter methodsFor: 'initialization' stamp: 'StephaneDucasse 6/16/2013 21:10'!
initialize
	super initialize.
	stream := self class defaultOutputDestination.! !

!SMarkReporter methodsFor: 'accessing' stamp: ''!
outputStream: aStream
	stream := aStream  ! !

!SMarkReporter methodsFor: 'accessing' stamp: ''!
report
	self header.
	
	runner results keysAndValuesDo: [:key :value |
		self benchmarkHeader: key.
		self reportAllRuns: value of: key.
		self benchmarkFooter: key.
	].

	self footer.
	^ self! !

!SMarkReporter methodsFor: 'reporting' stamp: 'CamilloBruni 9/5/2011 13:13'!
reportAllRuns: aListOfResults of: benchmark
	aListOfResults do: [:result |
		result criteria keysAndValuesDo: [:benchName :timer |
			stream << benchName << ': ' << (timer totalTime asString, 'ms'); cr.]]! !

!SMarkReporter methodsFor: 'accessing' stamp: ''!
runner: aRunner
	runner := aRunner.! !

SMarkReporter subclass: #SMarkSimpleStatisticsReporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Benchmarks-SMark'!

SMarkSimpleStatisticsReporter subclass: #ReBenchReporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Benchmarks-SMark'!

!ReBenchReporter commentStamp: '<historical>' prior: 0!
A ReBenchReporter is reporter for the ReBench framework (cf. https://github.com/smarr/ReBench).
It is used be the ReBenchHarness, which is the main class of interest for users that just want to execute benchmarks.!

!ReBenchReporter methodsFor: 'as yet unclassified' stamp: 'StefanMarr 5/16/2011 15:23'!
benchmarkHeader: aName
	^ self! !

!SMarkSimpleStatisticsReporter methodsFor: 'statistics' stamp: 'StefanMarr 3/20/2011 12:05'!
confidenceVariance: times
	| numMeasurements |
	numMeasurements := times size.
	(numMeasurements >= 30) 
		ifTrue: [
			^ (self gaussianConfidenceFactor) * (times stdev) / (numMeasurements asFloat sqrt)].
		
	"use the students T distribution for small probe counts"
	^ (self studentsTConfidenceFactorFor: numMeasurements) * (times stdev) / (numMeasurements asFloat sqrt)! !

!SMarkSimpleStatisticsReporter methodsFor: 'statistics' stamp: 'StefanMarr 3/20/2011 11:49'!
gaussianConfidenceFactor
	"used for large probe counts >= 30"
	"1 ~ 68.27%"
	"1.644853626951 ~ 90%"
	"2 ~ 95.45%"
	^ 1.644853626951! !

!SMarkSimpleStatisticsReporter methodsFor: 'reporting' stamp: 'StefanMarr 5/16/2011 16:08'!
reportAllRuns: aListOfResults of: benchmark
	| criteria |

	criteria := aListOfResults first criteria.
	
	criteria keysDo: [:criterion |
		| times |
		times := self resultsFor: criterion from: aListOfResults.
		self reportResult: times for: criterion of: benchmark.
		stream cr.
	].! !

!SMarkSimpleStatisticsReporter methodsFor: 'reporting' stamp: 'CamilloBruni 9/6/2011 10:41'!
reportResult: aResultsArray for: aCriterion of: benchmark
	| convidenceVariance significantDigits |

	stream << benchmark <<  ' ' <<  aCriterion <<  ': iterations='.
	aResultsArray size printOn: stream .
	stream << ' runtime: '.
	
	aResultsArray size < 2 ifTrue: [
		aResultsArray average printOn: stream.
		stream << 'ms'.
		^ self.
	].
	
	convidenceVariance := self confidenceVariance: aResultsArray.  
	
	"only print significant "
	significantDigits := self significantDigits: convidenceVariance.

	aResultsArray average printOn: stream showingDecimalPlaces: significantDigits.
	stream << 'ms +/-'.
	convidenceVariance printOn: stream showingDecimalPlaces: significantDigits.! !

!SMarkSimpleStatisticsReporter methodsFor: 'helper' stamp: 'StefanMarr 5/16/2011 16:02'!
resultsFor: aCriterion from: aListOfResults
	^aListOfResults collect: [:result | (result criteria at: aCriterion) totalTime]
	! !

!SMarkSimpleStatisticsReporter methodsFor: 'statistics' stamp: 'StefanMarr 3/20/2011 11:46'!
significantDigits: confidenceVariance
	confidenceVariance = 0 
		ifTrue: [ ^ 2].
	
	confidenceVariance >= 10
		ifTrue: [ ^ 0].
	
	^ 1 - (confidenceVariance log floor)! !

!SMarkSimpleStatisticsReporter methodsFor: 'statistics' stamp: 'StefanMarr 3/20/2011 12:03'!
studentsTConfidenceFactorFor: aNumberOfMeasurements
	"used for small probe counts < 30"
	"the students T distribution sucks to calculate since the value depends on the probeCout"
	"these values are for a confidence interval of ~90%"
	| values |
	values := Array new: 30.
	values at: 1  put: 6.314.
	values at: 2  put: 2.920.
	values at: 3  put: 2.353.
	values at: 4  put: 2.132.
	values at: 5  put: 2.015.
	values at: 6  put: 1.943.
	values at: 7  put: 1.895.
	values at: 8  put: 1.860.
	values at: 9  put: 1.833.
	values at: 10 put: 1.812.
	values at: 11 put: 1.796.
	values at: 12 put: 1.782.
	values at: 13 put: 1.771.
	values at: 14 put: 1.761.
	values at: 15 put: 1.753.
	values at: 16 put: 1.746.
	values at: 17 put: 1.740.
	values at: 18 put: 1.734.
	values at: 19 put: 1.729.
	values at: 20 put: 1.725.
	values at: 21 put: 1.721.
	values at: 22 put: 1.717.
	values at: 23 put: 1.714.
	values at: 24 put: 1.711.
	values at: 25 put: 1.708.
	values at: 26 put: 1.706.
	values at: 27 put: 1.703.
	values at: 28 put: 1.701.
	values at: 29 put: 1.699.
	values at: 30 put: 1.697.
	^ values at: aNumberOfMeasurements.
	! !

!SMarkSimpleStatisticsReporter methodsFor: 'helper' stamp: 'StefanMarr 3/20/2011 19:40'!
totalResultsFor: aListOfResults
	^aListOfResults collect: [:timer | timer total]
	! !

Object subclass: #SMarkResult
	instanceVariableNames: 'time benchName suite criteria'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Benchmarks-SMark'!

!SMarkResult commentStamp: 'StefanMarr 3/18/2011 23:45' prior: 0!
A benchmark result is characterized by:
 - the total execution time (#total is the least a benchmark results in)
 - the name of the benchmark that was executed
 - the suite object specifies the used input used for the benchmark
 - dictionary of additional the criteria and the related timings

A benchmark can produced multiple resuts for different criteria. The standard criterion is #total.!

!SMarkResult methodsFor: 'accessing' stamp: ''!
benchmarkName
	^ benchName! !

!SMarkResult methodsFor: 'accessing' stamp: ''!
benchmarkName: aString
	benchName := aString! !

!SMarkResult methodsFor: 'accessing' stamp: ''!
criteria
	^ criteria! !

!SMarkResult methodsFor: 'accessing' stamp: ''!
criteria: aCollectionOfTimers
	criteria := aCollectionOfTimers! !

!SMarkResult methodsFor: 'accessing' stamp: ''!
suite
	^ suite! !

!SMarkResult methodsFor: 'accessing' stamp: ''!
suite: aBenchmarkSuite
	suite := aBenchmarkSuite! !

!SMarkResult methodsFor: 'accessing' stamp: ''!
total
	^ time! !

!SMarkResult methodsFor: 'accessing' stamp: ''!
total: aTime
	time := aTime! !

Object subclass: #SMarkRunner
	instanceVariableNames: 'numIterations suite runner results currentBenchmark timers problemSize numProcesses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Benchmarks-SMark'!

SMarkRunner subclass: #SMarkAutosizeRunner
	instanceVariableNames: 'targetTime innerLoopIterations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Benchmarks-SMark'!

!SMarkAutosizeRunner class methodsFor: 'defaults' stamp: 'StefanMarr 3/19/2011 19:17'!
defaultTargetTime
	"300 milliseconds seems to be a reasonable target time for most problems.
	 It is a compromise between the general measurment noise as well as timer accuracy
	 and the absolute runtime of benchmarks"
	^ 300! !

!SMarkAutosizeRunner methodsFor: 'initialization' stamp: 'StefanMarr 3/19/2011 19:59'!
initialize
	super initialize.
	targetTime := self class defaultTargetTime.! !

!SMarkAutosizeRunner methodsFor: 'benchmarking' stamp: 'StefanMarr 3/20/2011 10:27'!
performBenchmark: aSelector
	"First determine a useful number of inner loop iterations until the targetTime is reached."
	| execTime i |
	"make sure no timers are recorded for this"
	timers := nil.
	
	i := 1.
	execTime := Time millisecondsToRun: [ suite perform: aSelector. ].
	
	[ execTime > targetTime ] whileFalse: [
		i := i * 2. "Was thinking of doing something fancy here, but just go with this simple staight-forward solution"
		execTime := Time millisecondsToRun: [ 1 to: i do: [:ignored| suite perform: aSelector]].
	].

	innerLoopIterations := i.
	
	"Then start executing the benchmark"
	^ super performBenchmark: aSelector.! !

!SMarkAutosizeRunner methodsFor: 'benchmarking' stamp: 'StefanMarr 3/20/2011 10:49'!
runBaseBenchmark
	"baseBenchmark is not supported with autosizing. I do not see how that can be made possible since all different benchmarks will have different number of iterations, and the only way how a consistent baseline could be found would be to normalize the results, but well, incooprorating the baseline measurement with the statistical evaluation is harder than just substracting a one time value..., I am not going to do that here for the moment. Stefan 2011-03-20"
	
	(suite respondsTo: #baseBenchmark) 
		ifFalse: [ ^ nil ].
	
	"I decided to go here with a silent solution to avoid thinking about logging frameworks and Transcript to console convertion..."
	self recordResults: (self class defaultTimer new: 'total') for: #baseBenchmark  ! !

!SMarkAutosizeRunner methodsFor: 'accessing' stamp: 'StefanMarr 3/19/2011 19:18'!
targetTime
	"Target time in milliseconds"
	^ targetTime! !

!SMarkAutosizeRunner methodsFor: 'accessing' stamp: 'StefanMarr 3/19/2011 19:18'!
targetTime: anIntInMilliseconds
	"Target time in milliseconds"
	targetTime := anIntInMilliseconds! !

!SMarkAutosizeRunner methodsFor: 'benchmarking' stamp: 'StefanMarr 3/20/2011 10:31'!
timedBenchmarkExecution: aSelector
	"Will do a timed execution of the benchmark and return the result timer"
	| timer |
	timers := Dictionary new.

	timer := self createTimer: 'total'.
	
	timer start.
	1 to: innerLoopIterations do: [:ignored|
		suite perform: aSelector.
	].
	timer stop.
	
	self recordResults: timer for: aSelector.
	
	^ timer! !

SMarkRunner subclass: #SMarkCogRunner
	instanceVariableNames: 'warmingUp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Benchmarks-SMark'!

!SMarkCogRunner commentStamp: 'StefanMarr 12/30/2011 23:24' prior: 0!
This runner is doing warmup on for Cog VMs with just-in-time compilation.
The goal is to bring the JIT compiler into a steady state where no jitting is performed anymore during benchmarking.!

!SMarkCogRunner methodsFor: 'initialization' stamp: 'StefanMarr 12/30/2011 22:51'!
initialize
	super initialize.
	warmingUp := false.! !

!SMarkCogRunner methodsFor: 'initialization' stamp: 'StefanMarr 12/30/2011 23:26'!
performBenchmark: aSelector
	"Based on an email by Eliot from May 16th, 2011.
	 The first time a method is executed it will get into the inline cache.
	 The second time, it is found in the inline cache, which triggers the JIT compiler to produce code.
	 Thus, the third time it should be executed in the steady state."
	warmingUp := true.
		suite runBenchmark: aSelector.
		Smalltalk garbageCollect.
		suite runBenchmark: aSelector.
		Smalltalk garbageCollect.
	warmingUp := false.
	
	^ super performBenchmark: aSelector.! !

!SMarkCogRunner methodsFor: 'initialization' stamp: 'StefanMarr 12/30/2011 22:57'!
recordResults: timer for: aSelector
	"Only record the results when we are not in warmup mode."
	warmingUp ifFalse: [
		super recordResults: timer for: aSelector.
	].! !

SMarkRunner subclass: #SMarkProfileRunner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Benchmarks-SMark'!

!SMarkProfileRunner commentStamp: '<historical>' prior: 0!
This runner profiles the benchmarks for better analysis. Unlike the classical benchmark runner this one will not collect the results. Instead it will execute the benchmarks in the system profiler.!

!SMarkProfileRunner class methodsFor: 'profiling' stamp: 'CamilloBruni 1/28/2013 18:19'!
execute: aSuite selector: aBenchmarkSelector
	| runner |
	runner := self new.
	aSuite runner: runner.
	runner 
		suite: aSuite;
		execute: aBenchmarkSelector.
	^ runner! !

!SMarkProfileRunner class methodsFor: 'profiling' stamp: 'CamilloBruni 1/28/2013 18:31'!
execute: aSuite selector: aBenchmarkSelector iterations: nIterations
	| runner |
	runner := self new.
	aSuite runner: runner.
	runner 
		suite: aSuite;
		iterations: nIterations;
		execute: aBenchmarkSelector.
	^ runner! !

!SMarkProfileRunner methodsFor: 'profiling' stamp: 'CamilloBruni 1/28/2013 18:24'!
execute
	"run all benchmnarks in a benchmark suite "
	[ suite run ] timeProfile! !

!SMarkProfileRunner methodsFor: 'profiling' stamp: 'CamilloBruni 1/28/2013 18:28'!
execute: aSelector
	
	[ self performBenchmark: aSelector ] timeProfile! !

!SMarkProfileRunner methodsFor: 'initialization' stamp: 'CamilloBruni 1/28/2013 18:28'!
initialize
	super initialize.
	numIterations := 1.! !

!SMarkProfileRunner methodsFor: 'benchmarks' stamp: 'CamilloBruni 1/28/2013 18:34'!
performBenchmark: aSelector
	currentBenchmark := aSelector.
	
	1 to: numIterations do: [:i|
		suite runBenchmark: aSelector ].	
	
	currentBenchmark := nil.! !

!SMarkProfileRunner methodsFor: 'benchmarks' stamp: 'CamilloBruni 1/28/2013 18:34'!
timedBenchmarkExecution: aSelector
	suite perform: aSelector! !

!SMarkRunner class methodsFor: 'defaults' stamp: 'StefanMarr 3/21/2011 11:43'!
defaultNumberOfIterations
	^ 1! !

!SMarkRunner class methodsFor: 'defaults' stamp: 'StefanMarr 5/14/2011 11:09'!
defaultNumberOfProcesses
	^ 1! !

!SMarkRunner class methodsFor: 'defaults' stamp: 'StefanMarr 3/20/2011 20:56'!
defaultTimer
	^ SMarkTimer! !

!SMarkRunner class methodsFor: 'benchmarking' stamp: 'StefanMarr 3/20/2011 19:51'!
execute: aSuite
	^ self execute: aSuite with: 1.! !

!SMarkRunner class methodsFor: 'benchmarking' stamp: 'StefanMarr 3/20/2011 19:51'!
execute: aSuite with: nIterations
	| runner |
	runner := self new.
	aSuite runner: runner.
	runner suite: aSuite.
	runner iterations: nIterations.  
	runner execute.
	^ runner! !

!SMarkRunner methodsFor: 'helper' stamp: 'StefanMarr 3/20/2011 10:28'!
createTimer: name
	"Create and register a new timer for the current benchmark"
	| timer |
	timer := self class defaultTimer new: name.
	
	timers ifNotNil: [
		timers at: name put: timer.
	].
	
	^ timer.! !

!SMarkRunner methodsFor: 'execution' stamp: 'StefanMarr 3/13/2011 23:05'!
execute
	suite run.
	self runBaseBenchmark.
	^ results
	! !

!SMarkRunner methodsFor: 'initialization' stamp: 'StefanMarr 5/14/2011 11:10'!
initialize
	super initialize.
	numIterations := self class defaultNumberOfIterations.
	numProcesses  := self class defaultNumberOfProcesses.
	results := Dictionary new.! !

!SMarkRunner methodsFor: 'accessing' stamp: 'StefanMarr 3/21/2011 12:20'!
iterations
	^ numIterations! !

!SMarkRunner methodsFor: 'accessing' stamp: 'StefanMarr 3/21/2011 12:20'!
iterations: anInteger
	numIterations := anInteger! !

!SMarkRunner methodsFor: 'benchmarking' stamp: 'StefanMarr 4/15/2011 11:50'!
performBenchmark: aSelector
	currentBenchmark := aSelector.
	
	1 to: numIterations do: [:i|
		"self timedBenchmarkExecution: aSelector."
		suite runBenchmark: aSelector.  
	].	
	
	currentBenchmark := nil.
	
	^ results at: (suite benchmarkNameForSelector: aSelector)! !

!SMarkRunner methodsFor: 'printing' stamp: 'CamilloBruni 9/5/2011 13:13'!
printOn: aStream
	^ self reportOn: aStream.! !

!SMarkRunner methodsFor: 'accessing' stamp: 'StefanMarr 5/8/2013 13:55'!
problemSize
	<omniUnenforced> "Hint for the OMOP that it is part of the meta infrastructure"
	^ problemSize! !

!SMarkRunner methodsFor: 'accessing' stamp: 'StefanMarr 8/21/2012 09:44'!
problemSize: aValue
	"Do some conversion to make it easier for the benchmarks"
	(aValue isString and: [aValue isAllDigits]) ifTrue: [
		problemSize := Number readFrom: aValue.
		^ self.
	].

	problemSize := aValue! !

!SMarkRunner methodsFor: 'accessing' stamp: 'StefanMarr 5/14/2011 11:08'!
processes
	"The standard runner does use only a single process, but in case a benchmark supports parallelism it can query for the intended degree of parallelism"
	^ numProcesses! !

!SMarkRunner methodsFor: 'accessing' stamp: 'StefanMarr 5/14/2011 11:08'!
processes: anInt
	"The standard runner does use only a single process, but a benchmark can use that to do its own parallelism"
	numProcesses := anInt! !

!SMarkRunner methodsFor: 'helper' stamp: 'StefanMarr 3/20/2011 21:01'!
recordResults: timer for: aSelector
	| result name |
	name := suite benchmarkNameForSelector: aSelector.
	
	result := SMarkResult new.
	result total: timer totalTime.
	result benchmarkName: name.
	result suite: suite.
	result criteria: timers.
	
	(results at: name ifAbsentPut: OrderedCollection new) add: result.! !

!SMarkRunner methodsFor: 'accessing' stamp: 'StefanMarr 4/15/2011 16:46'!
report
	SMarkReporter defaultReporter reportFor: self.  
	! !

!SMarkRunner methodsFor: 'reporting' stamp: 'sm 5/25/2011 17:50'!
reportConfiguration: aStream
	aStream << 'Runner Configuration:';cr.
	aStream << ('  iterations: ', numIterations asString); cr.
	aStream << ('  processes: ', numProcesses asString); cr.
	aStream << ('  problem size: ', problemSize asString); cr.
! !

!SMarkRunner methodsFor: 'reporting' stamp: 'StefanMarr 4/15/2011 16:47'!
reportOn: aStream
	SMarkReporter defaultReporter reportFor: self on: aStream  
	! !

!SMarkRunner methodsFor: 'accessing' stamp: 'StefanMarr 3/18/2011 19:41'!
results
	^ results! !

!SMarkRunner methodsFor: 'benchmarking' stamp: 'StefanMarr 3/18/2011 18:42'!
runBaseBenchmark
	"In certain sitatuations it is one wants a baseline that is incooprated in all 
	 benchmark results to be substracted from the final values.
	
	#baseBenchmark can be used to charaterize such a baseline"
	
	(suite respondsTo: #baseBenchmark) 
		ifFalse: [ ^ nil ].
	
	^ self performBenchmark: #baseBenchmark.! !

!SMarkRunner methodsFor: 'accessing' stamp: 'StefanMarr 3/20/2011 18:45'!
suite
	^ suite! !

!SMarkRunner methodsFor: 'accessing' stamp: 'StefanMarr 4/15/2011 16:14'!
suite: aBenchmarkSuite
	suite := aBenchmarkSuite.
	suite runner: self.! !

!SMarkRunner methodsFor: 'benchmarking' stamp: 'ReinoutStevens 12/6/2011 14:30'!
timedBenchmarkExecution: aSelector
	"Will do a timed execution of the benchmark and return the result timer"
	| timer result |
	timers := Dictionary new.

	timer := self createTimer: 'total'.
	
	timer start.
	result := suite perform: aSelector.
	timer stop.
	suite processResult: result withTimer: timer.
	
	self recordResults: timer for: aSelector.
	
	^ timer! !

SMarkRunner subclass: #SMarkWeakScalingRunner
	instanceVariableNames: 'numInnerIterations runningProcesses completionSignal runningProcessesMtx'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Benchmarks-SMark'!

!SMarkWeakScalingRunner class methodsFor: 'defaults' stamp: 'StefanMarr 4/15/2011 15:42'!
defaultNumberOfInnerIterations
	"The number of iterations of the inner loop
	 in which the benchmark is executed."
	^ 1! !

!SMarkWeakScalingRunner methodsFor: 'benchmarking' stamp: 'sm 5/30/2011 17:13'!
execute: aSelector withProcesses: numberOfProcesses withTimer: timer
	"This case is meant for all cases. REM: this is also used for numProc==1 to be able to measure the process start overhead in all cases.
	 It will start the processes and wait for their completion."
	
	| processes |
	processes			:= Array new: numberOfProcesses.
	runningProcessesMtx := Semaphore forMutualExclusion.
	completionSignal		:= Semaphore new.
	runningProcesses := numberOfProcesses.
	
	"First initialize the processes"
	1 to: numberOfProcesses do: [ :procNum |
		| proc |
		proc := SMarkWeakScalingRunnerExecutor createFor: aSelector for: numInnerIterations with: self and: suite.
		proc priority: Processor highestPriority.
		proc name: (self class name, '-',  procNum asString).
		processes at: procNum put: proc.
		"On: procNum"
	].
	
	"Now, execute the benchmark and do the timing now"
	timer start.
	1 to: numberOfProcesses do: [ :procNum |
		(processes at: procNum) resume.
	].
	completionSignal wait.
	timer stop.
	! !

!SMarkWeakScalingRunner methodsFor: 'benchmarking' stamp: 'sm 5/30/2011 16:17'!
executorCompleted
	runningProcessesMtx critical: [
		runningProcesses := runningProcesses - 1.
		(runningProcesses == 0) ifTrue: [
			completionSignal signal.
		]
	]! !

!SMarkWeakScalingRunner methodsFor: 'initialization' stamp: 'StefanMarr 4/15/2011 15:43'!
initialize
	super initialize.
	numProcesses			:= self class defaultNumberOfProcesses.
	numInnerIterations	:= self class defaultNumberOfInnerIterations.
! !

!SMarkWeakScalingRunner methodsFor: 'benchmarking' stamp: 'StefanMarr 4/15/2011 15:43'!
innerIterations
	"The number of inner iterations the benchmark is executed inside a processes"
	^ numInnerIterations! !

!SMarkWeakScalingRunner methodsFor: 'benchmarking' stamp: 'StefanMarr 4/15/2011 15:43'!
innerIterations: anInteger
	"The number of inner iterations the benchmark is executed inside a processes"
	numInnerIterations := anInteger! !

!SMarkWeakScalingRunner methodsFor: 'benchmarking' stamp: 'StefanMarr 4/15/2011 10:54'!
processes
	^ numProcesses! !

!SMarkWeakScalingRunner methodsFor: 'benchmarking' stamp: 'StefanMarr 4/15/2011 10:53'!
processes: anInteger
	numProcesses := anInteger! !

!SMarkWeakScalingRunner methodsFor: 'reporting' stamp: 'sm 5/25/2011 17:50'!
reportConfiguration: aStream
	super reportConfiguration: aStream.
	aStream << ('inner iterations: ', numInnerIterations asString); cr.! !

!SMarkWeakScalingRunner methodsFor: 'benchmarking' stamp: 'sm 5/25/2011 18:31'!
timedBenchmarkExecution: aSelector
	"Will do a timed execution of the benchmark and return the result timer"
	| timer |
	timers := Dictionary new.

	timer := self createTimer: 'total'.
	
	self execute: aSelector withProcesses: numProcesses withTimer: timer.
	
	self recordResults: timer for: aSelector.
	
	^ timer! !

Object subclass: #SMarkSuite
	instanceVariableNames: 'runner selectedBenchmarks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Benchmarks-SMark'!

!SMarkSuite commentStamp: '<historical>' prior: 0!
A Benchmark Suite is a set of benchmarks and it knows what exactly needs to be executed.
However, it does not really know how to execute it.
It knows all the magic, that is, how to set up and tear down the environment for the benchmarks, but does not have the knowledge of how many iterations need to be done and how to evaluate any results that might be produced.

Please see also SMarkHarness, which is the main class relevant for users to execute benchmarks with SMark.

Usage:

Choose a suite (i.e. one of my subclasses) and use the class-side #run or run: messages.

To get an example print the result of the following expression:
	
	SMarkCompiler run: 10
	
	SMarkLoops runOnly: #benchArrayAccess
!

SMarkSuite subclass: #SMarkDeltaBlue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Benchmarks-DeltaBlue'!

!SMarkDeltaBlue commentStamp: '<historical>' prior: 0!
One-way constraint solver Benchmark. The main focus in DeltaBlue is on polymorphism and object-oriented programming

To run the benchmark, execute the expression 'SMarkDeltaBlue run: 10'.!

!SMarkDeltaBlue methodsFor: 'benchmarking' stamp: 'ClemenTBera 9/23/2013 13:17'!
benchDeltaBlue
	"This the combined benchmark."
	
	| n |
	
	n := self problemSize.
	
	DBStrength initialize.
	
	self doChain: n. 
	self doProjection: n! !

!SMarkDeltaBlue methodsFor: 'defaults' stamp: 'ClementBera 10/4/2013 10:41'!
defaultProblemSize
	^ 20000! !

!SMarkDeltaBlue methodsFor: 'benchmarking' stamp: 'ClementBera 9/23/2013 10:46'!
doChain: n

	| vars editConstraint plan planner |

	planner := DBPlanner new.
	vars := (1 to: n+1) collect: [ :i | DBVariable new].

	"thread a chain of equality constraints through the variables"
	1 to: n do:
		[ :i || v1 v2 |
		 v1 := vars at: i.
		 v2 := vars at: i + 1.
		 DBEqualityConstraint var: v1 var: v2 strength: #required].

	DBStayConstraint var: vars last strength: #strongDefault.
	editConstraint := DBEditConstraint var: (vars first) strength: #preferred.
	plan := planner extractPlanFromConstraints: (Array with: editConstraint).
	1 to: 100 do: [ :v | 
		vars first value: v.
		plan execute.
		vars last value ~= v ifTrue: [self error: 'Chain test failed!!!!']].
	editConstraint destroyConstraint! !

!SMarkDeltaBlue methodsFor: 'benchmarking' stamp: 'ClementBera 9/23/2013 10:47'!
doProjection: n
	"This test constructs a two sets of variables related to each other by
	 a simple linear transformation (scale and offset)."

	| scale offset src dst planner dests |
	planner := DBPlanner new.
	dests := OrderedCollection new.
	scale := DBVariable value: 10.
	offset := DBVariable value: 1000.
	1 to: n do:
		[ :i |
		src := DBVariable value: i.
		dst := DBVariable value: i.
		dests add: dst.
		DBStayConstraint var: src strength: #default.
		DBScaleConstraint var: src var: scale var: offset var: dst strength: #required].

	planner changeVar: src newValue: 17.
	dst value ~= 1170 ifTrue: [self error: 'Projection test 1 failed!!!!'].

	planner changeVar: dst newValue: 1050.
	src value ~= 5 ifTrue: [self error: 'Projection test 2 failed!!!!'].

	planner changeVar: scale newValue: 5.
	1 to: n - 1 do: [ :i |
		(dests at: i) value ~= (i*5 + 1000)
			ifTrue: [self error: 'Projection test 3 failed!!!!']].

	planner changeVar: offset newValue: 2000.
	1 to: n - 1 do: [ :i |
		(dests at: i) value ~= (i*5 + 2000)
			ifTrue: [self error: 'Projection test 4 failed!!!!']].! !

!SMarkDeltaBlue methodsFor: 'accessing' stamp: 'ClementBera 9/23/2013 11:05'!
problemSize
	<omniUnenforced> "Hint for the OMOP that it is part of the meta infrastructure"
	| ps |
	ps := super problemSize.
	
	ps isInteger ifFalse: [	^ self defaultProblemSize].
		
	^ ps! !

SMarkSuite subclass: #SMarkRichards
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Benchmarks-Richards'!

!SMarkRichards commentStamp: '<historical>' prior: 0!
Richards is an OS kernel simulation benchmark, originally written in BCPL by Martin Richards. The main focus in Richards is on property access and calling functions and methods.

To run the benchmark, execute the expression 'SMarkRichards run: 10'.!

!SMarkRichards methodsFor: 'benchs' stamp: 'ClementBera 9/27/2013 16:27'!
benchRichards

	RichObject initialize.
	self problemSize timesRepeat: [ RichRunner start ]! !

!SMarkRichards methodsFor: 'benchs' stamp: 'ClementBera 9/27/2013 15:56'!
defaultProblemSize
	^ 50! !

!SMarkRichards methodsFor: 'benchs' stamp: 'ClementBera 9/27/2013 15:56'!
problemSize
	<omniUnenforced> "Hint for the OMOP that it is part of the meta infrastructure"
	| ps |
	ps := super problemSize.
	
	ps isInteger ifFalse: [	^ self defaultProblemSize].
		
	^ ps! !

!SMarkSuite class methodsFor: 'defaults' stamp: ''!
defaultProblemSize
	^ nil! !

!SMarkSuite class methodsFor: 'defaults' stamp: 'StefanMarr 12/30/2011 22:43'!
defaultRunner
	^ self onCog: [SMarkCogRunner]
	       else:  [SMarkRunner]! !

!SMarkSuite class methodsFor: 'benchmarking' stamp: ''!
isAbstractClass
	"This is a hack that is necessary in Squeak since it does not provide #isAbstractClass.
	 Actually this class is supposed to be abstract, but well, inheritance..."
	
	^ false! !

!SMarkSuite class methodsFor: 'platform support' stamp: 'StefanMarr 4/5/2012 22:20'!
onCog: cogSpecificBlock else: general
	^ (Smalltalk vm isRunningCogit)
		ifTrue:  [cogSpecificBlock value]
		ifFalse: [general value]! !

!SMarkSuite class methodsFor: 'profiling' stamp: 'CamilloBruni 1/28/2013 18:22'!
profile: aSelector
	^ self profileRunner 
		execute: self new selector: aSelector.! !

!SMarkSuite class methodsFor: 'profiling' stamp: 'CamilloBruni 1/28/2013 18:30'!
profile: aSelector iterations: nIterations
	^ self profileRunner 
		execute: self new selector: aSelector iterations: nIterations.! !

!SMarkSuite class methodsFor: 'profiling' stamp: 'CamilloBruni 1/28/2013 18:21'!
profileAll
	^ self profileRunner 
		execute: self new.! !

!SMarkSuite class methodsFor: 'profiling' stamp: 'CamilloBruni 1/28/2013 18:17'!
profileRunner
	^ SMarkProfileRunner! !

!SMarkSuite class methodsFor: 'benchmarking' stamp: 'StephaneDucasse 6/16/2013 12:11'!
run
	"Execute the suite one time."
	^ self defaultRunner execute: self new.! !

!SMarkSuite class methodsFor: 'benchmarking' stamp: 'StephaneDucasse 6/16/2013 12:11'!
run: nIterations
	"Execute the suite a given number of iterations."
	
	^ self defaultRunner execute: self new with: nIterations.! !

!SMarkSuite class methodsFor: 'benchmarking' stamp: 'StefanMarr 6/30/2013 00:57'!
runOnly: aSelector
  "aSelector should refer to a benchmark method.
   Example:
     SMarkLoops runOnly: #benchFloatLoop
  "
  ^ self defaultRunner execute: (self new runOnly: aSelector)! !

!SMarkSuite class methodsFor: 'benchmarking' stamp: 'StephaneDucasse 6/16/2013 21:03'!
runOnly: aSelector iterations: anInteger
	"Execute only the bench name aSelector from the suite."
	
	^ self defaultRunner execute: (self new runOnly: aSelector) with: anInteger! !

!SMarkSuite methodsFor: 'helper' stamp: ''!
benchmarkNameForSelector: selector
	"Extracts the actual name of the benchmark from the selector"
	(selector beginsWith: #bench) ifTrue: [ ^ selector copyFrom: 6 to: selector size].
	^ selector asSymbol
	! !

!SMarkSuite methodsFor: 'running' stamp: ''!
cleanUpInstanceVariables
	"Make sure all variables that are 'user variables' get cleaned"
	
	self class allInstVarNames do: [ :name |
		name = 'runner' ifFalse: [
			self instVarNamed: name put: nil ] ]! !

!SMarkSuite methodsFor: 'benchmarking' stamp: ''!
performCustomSelector: aSelector with: aPrefix
	| customSelector |
	customSelector := (aPrefix, aSelector capitalized) asSymbol.
	(self respondsTo: customSelector) ifTrue: [ 
		self perform: customSelector].! !

!SMarkSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 5/8/2013 13:55'!
problemSize
	<omniUnenforced> "Hint for the OMOP that it is part of the meta infrastructure"
	runner             ifNil: [^ self class defaultProblemSize].
	runner problemSize ifNil: [^ self class defaultProblemSize].
	^ runner problemSize! !

!SMarkSuite methodsFor: 'benchmarking' stamp: 'ReinoutStevens 12/6/2011 14:31'!
processResult: anObject withTimer: aSMarkTimer
	"subclass responsability. You can verify your results here, or do things with the timer."
	^self.! !

!SMarkSuite methodsFor: 'benchmarking' stamp: ''!
run
	"Executes all the benchmarks in the suite, 
	 coordinating with the runner when necessary"
	
	| potentialBenchmarkSelectors |
	selectedBenchmarks
		ifNotNil: [ potentialBenchmarkSelectors := selectedBenchmarks ]
		ifNil:    [ potentialBenchmarkSelectors := self class allSelectors ].				
	
	potentialBenchmarkSelectors
		do: [ :selector |
			(self shouldRunSelector: selector)
				ifTrue: [
					runner performBenchmark: selector ]
		].
	! !

!SMarkSuite methodsFor: 'benchmarking' stamp: ''!
runBenchmark: aSelector
	
	[self setUp.
	 self performCustomSelector: aSelector with: #setUp.
	 runner timedBenchmarkExecution: aSelector] ensure: [
		self performCustomSelector: aSelector with: #tearDown.
		self tearDown.
		self cleanUpInstanceVariables]! !

!SMarkSuite methodsFor: 'benchmarking' stamp: ''!
runOnly: aSymbol
	selectedBenchmarks := IdentitySet newFrom: { aSymbol }.! !

!SMarkSuite methodsFor: 'accessing' stamp: ''!
runner
	^ runner! !

!SMarkSuite methodsFor: 'accessing' stamp: ''!
runner: aRunner
	runner := aRunner.! !

!SMarkSuite methodsFor: 'benchmarking' stamp: ''!
selectedBenchmarks
	^ selectedBenchmarks! !

!SMarkSuite methodsFor: 'running' stamp: 'StefanMarr 6/30/2013 00:59'!
setUp
	"It is the subclass' responsibility to set up the necessary environment for a benchmark"
	^ self! !

!SMarkSuite methodsFor: 'testing' stamp: 'StefanMarr 6/30/2013 00:59'!
shouldRunSelector: selector
	"Tells whether the given selector is in the form bench*, and thus is a benchmark that should be executed."
	
	(selector includes: $:) ifTrue: [ ^ false ].
	^ selector beginsWith: #bench! !

!SMarkSuite methodsFor: 'running' stamp: 'StefanMarr 6/30/2013 00:58'!
tearDown
	"It is the subclass' responsibility to clean up the environment after a benchmark"
	^ self! !

Object subclass: #SMarkTimer
	instanceVariableNames: 'startTime elapsedTime name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Benchmarks-SMark'!

!SMarkTimer commentStamp: '<historical>' prior: 0!
A SMarkTimer is a simple timer.
A subclass can measure alternative metrics, or for instance use different time sources.

A subclass of SMarkRunner can then use the custom timer class by overriding SMarkRunner class >> #defaultTimer.!

!SMarkTimer class methodsFor: 'instance creation' stamp: 'StefanMarr 3/14/2011 08:54'!
new: aName
	| timer |
	
	timer := super new.
	timer name: aName.
	
	^timer! !

!SMarkTimer methodsFor: 'timing' stamp: 'StephaneDucasse 6/16/2013 21:15'!
currentMillis

	^ Time millisecondClockValue! !

!SMarkTimer methodsFor: 'initialization' stamp: 'ReinoutStevens 12/6/2011 14:32'!
initialize
	super initialize.
	elapsedTime := 0! !

!SMarkTimer methodsFor: 'accessing' stamp: 'StefanMarr 3/14/2011 08:54'!
name
	^name! !

!SMarkTimer methodsFor: 'accessing' stamp: 'StefanMarr 3/14/2011 08:54'!
name: aString
	name := aString ! !

!SMarkTimer methodsFor: 'timing' stamp: 'StefanMarr 3/14/2011 08:54'!
reset
	startTime := 0.
	elapsedTime := 0.! !

!SMarkTimer methodsFor: 'timing' stamp: 'StefanMarr 3/20/2011 12:24'!
start
	startTime := self currentMillis.! !

!SMarkTimer methodsFor: 'timing' stamp: 'StefanMarr 3/20/2011 12:25'!
stop
	| elapsedInThisPeriod current |
	current := self currentMillis.
	
	elapsedInThisPeriod := Time milliseconds: current since: startTime.
	
	elapsedTime := elapsedTime + elapsedInThisPeriod.! !

!SMarkTimer methodsFor: 'accessing' stamp: 'StefanMarr 3/14/2011 08:54'!
totalTime
	^elapsedTime! !

Object subclass: #SMarkTransporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Benchmarks-SMark'!

!SMarkTransporter commentStamp: 'StefanMarr 4/5/2012 21:43' prior: 0!
SMarkTransporter is a used to interact with a git-fileout system used in the RoarVM project to manage Smalltalk source code.

SMarkTransporter is not actually a Transporter class, since there are currently no needs for customization.
Thus, it is just a dummy class for future use, and to hold #transportersForFileOutMenu.
!

!SMarkTransporter class methodsFor: 'transporter' stamp: 'StefanMarr 4/5/2012 21:46'!
transportersForFileOutMenu
	^ { (Smalltalk at: #Transporter ifAbsent: [^#()])
			forPackage: (PackageInfo named: 'SMark') }! !

Object subclass: #SMarkWeakScalingRunnerExecutor
	instanceVariableNames: 'numInnerIterations benchmarkSelector suite runner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Benchmarks-SMark'!

!SMarkWeakScalingRunnerExecutor class methodsFor: 'as yet unclassified' stamp: 'sm 5/30/2011 16:33'!
createFor: aSelector for: numIterations with: aRunner and: aSuite
	| o |
	o := self new.
	o runner: aRunner.
	o suite: aSuite.
	o innerIterations: numIterations.
	o benchmarkSelector: aSelector.
	^ ([ o run ] newProcess)! !

!SMarkWeakScalingRunnerExecutor methodsFor: 'accessing' stamp: 'sm 5/30/2011 16:20'!
benchmarkSelector: aSelector
	benchmarkSelector := aSelector! !

!SMarkWeakScalingRunnerExecutor methodsFor: 'accessing' stamp: 'sm 5/30/2011 16:20'!
innerIterations: anInt
	numInnerIterations := anInt! !

!SMarkWeakScalingRunnerExecutor methodsFor: 'benchmarking' stamp: 'sm 5/30/2011 16:22'!
run
	1 to: numInnerIterations do: [:i |
		suite perform: benchmarkSelector.].
	
	runner executorCompleted.! !

!SMarkWeakScalingRunnerExecutor methodsFor: 'accessing' stamp: 'sm 5/30/2011 16:21'!
runner: aRunner
	runner := aRunner! !

!SMarkWeakScalingRunnerExecutor methodsFor: 'accessing' stamp: 'sm 5/30/2011 16:21'!
suite: aSuite
	suite := aSuite! !

Object subclass: #ShootoutBody
	instanceVariableNames: 'x y z vx vy vz mass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Benchmarks-Shootout'!

!ShootoutBody class methodsFor: 'constants' stamp: ''!
daysPerYear
	^365.24! !

!ShootoutBody class methodsFor: 'constants' stamp: ''!
jupiter
	^self new
		x: 4.84143144246472090
		y: -1.16032004402742839
		z: -1.03622044471123109e-1
		vx: 1.66007664274403694e-3 * self daysPerYear
		vy: 7.69901118419740425e-3 * self daysPerYear
		vz: -6.90460016972063023e-5 * self daysPerYear
		mass: 9.54791938424326609e-4 * self solarMass! !

!ShootoutBody class methodsFor: 'constants' stamp: ''!
neptune
	^self new
		x: 1.53796971148509165e1
		y: -2.59193146099879641e1
		z: 1.79258772950371181e-1
		vx: 2.68067772490389322e-3 * self daysPerYear
		vy: 1.62824170038242295e-3 * self daysPerYear
		vz: -9.51592254519715870e-5 * self daysPerYear
		mass: 5.15138902046611451e-5 * self solarMass! !

!ShootoutBody class methodsFor: 'constants' stamp: ''!
pi
	^3.141592653589793! !

!ShootoutBody class methodsFor: 'constants' stamp: ''!
saturn
	^self new
		x: 8.34336671824457987
		y: 4.12479856412430479
		z: -4.03523417114321381e-1
		vx: -2.76742510726862411e-3 * self daysPerYear
		vy: 4.99852801234917238e-3 * self daysPerYear
		vz: 2.30417297573763929e-5 * self daysPerYear
		mass: 2.85885980666130812e-4 * self solarMass! !

!ShootoutBody class methodsFor: 'constants' stamp: 'eem 7/28/2008 12:42'!
solarMass
	^4.0 * self pi * self pi! !

!ShootoutBody class methodsFor: 'constants' stamp: ''!
sun
	^self new
		x: 0.0
		y: 0.0
		z: 0.0
		vx: 0.0
		vy: 0.0
		vz: 0.0
		mass: self solarMass! !

!ShootoutBody class methodsFor: 'constants' stamp: ''!
uranus
	^self new
		x: 1.28943695621391310e1
		y: -1.51111514016986312e1
		z: -2.23307578892655734e-1
		vx: 2.96460137564761618e-3 * self daysPerYear
		vy: 2.37847173959480950e-3 * self daysPerYear
		vz: -2.96589568540237556e-5 * self daysPerYear
		mass: 4.36624404335156298e-5 * self solarMass! !

!ShootoutBody methodsFor: 'nbody' stamp: ''!
addMomentumTo: anArray
	anArray at: 1 put: (anArray at: 1) + (vx * mass).
	anArray at: 2 put: (anArray at: 2) + (vy * mass).
	anArray at: 3 put: (anArray at: 3) + (vz * mass).
	^anArray! !

!ShootoutBody methodsFor: 'nbody' stamp: ''!
and: aBody velocityAfter: dt
	| dx dy dz distance mag |
	dx := x - aBody x.
	dy := y - aBody y.
	dz := z - aBody z.

	distance := ((dx*dx) + (dy*dy) + (dz*dz)) sqrt.
	mag := dt / (distance * distance * distance).

	self decreaseVelocity: dx y: dy z: dz m: aBody mass * mag.
	aBody increaseVelocity: dx y: dy z: dz m: mass * mag! !

!ShootoutBody methodsFor: 'nbody' stamp: ''!
decreaseVelocity: dx y: dy z: dz m: m
	vx := vx - (dx * m).
	vy := vy - (dy * m).
	vz := vz - (dz * m)! !

!ShootoutBody methodsFor: 'nbody' stamp: ''!
increaseVelocity: dx y: dy z: dz m: m
	vx := vx + (dx * m).
	vy := vy + (dy * m).
	vz := vz + (dz * m)! !

!ShootoutBody methodsFor: 'nbody' stamp: 'eem 7/28/2008 12:44'!
kineticEnergy
	^0.5 * mass * ((vx * vx) + (vy * vy) + (vz * vz))! !

!ShootoutBody methodsFor: 'accessing' stamp: ''!
mass
	^mass! !

!ShootoutBody methodsFor: 'nbody' stamp: ''!
offsetMomentum: anArray
	| m |
	m := self class solarMass.
	vx := (anArray at: 1) negated / m.
	vy := (anArray at: 2) negated / m.
	vz := (anArray at: 3) negated / m! !

!ShootoutBody methodsFor: 'nbody' stamp: ''!
positionAfter: dt
	x := x + (dt * vx).
	y := y + (dt * vy).
	z := z + (dt * vz)! !

!ShootoutBody methodsFor: 'nbody' stamp: ''!
potentialEnergy: aBody
	| dx dy dz distance |
	dx := x - aBody x.
	dy := y - aBody y.
	dz := z - aBody z.

	distance := ((dx*dx) + (dy*dy) + (dz*dz)) sqrt.
	^mass * aBody mass / distance! !

!ShootoutBody methodsFor: 'accessing' stamp: ''!
x
	^x! !

!ShootoutBody methodsFor: 'accessing' stamp: ''!
x: d1 y: d2 z: d3 vx: d4 vy: d5 vz: d6 mass: d7
	x := d1.
	y := d2.
	z := d3.
	vx := d4.
	vy := d5.
	vz := d6.
	mass := d7! !

!ShootoutBody methodsFor: 'accessing' stamp: ''!
y
	^y! !

!ShootoutBody methodsFor: 'accessing' stamp: ''!
z
	^z! !

Object subclass: #ShootoutChameneosColour
	instanceVariableNames: 'color'
	classVariableNames: 'Blue Red Yellow'
	poolDictionaries: ''
	category: 'Cog-Benchmarks-Shootout'!

!ShootoutChameneosColour class methodsFor: 'accessing' stamp: ''!
blue
   ^Blue! !

!ShootoutChameneosColour class methodsFor: 'accessing' stamp: ''!
blue: anObject
   Blue := anObject! !

!ShootoutChameneosColour class methodsFor: 'initialize-release' stamp: ''!
createBlue
   "comment stating purpose of message"

   ^super new color: #blue! !

!ShootoutChameneosColour class methodsFor: 'initialize-release' stamp: ''!
createRed
   "comment stating purpose of message"

   ^super new color: #red! !

!ShootoutChameneosColour class methodsFor: 'initialize-release' stamp: ''!
createYellow
   "comment stating purpose of message"

   ^super new color: #yellow! !

!ShootoutChameneosColour class methodsFor: 'printing' stamp: ''!
generateReportOfColoursOn: readOut
   | colours |
   colours := Array
            with: Blue
            with: Red
            with: Yellow.
   colours do:
         [:aColour |
         colours do:
               [:anotherColour |
               aColour printOn: readOut.
               readOut nextPutAll: ' + '.
               anotherColour printOn: readOut.
               readOut nextPutAll: ' -> '.
               (aColour complementaryColourFor: anotherColour) printOn: readOut.
               readOut nl]].
   ^readOut! !

!ShootoutChameneosColour class methodsFor: 'initialize-release' stamp: ''!
initialize
   "self initialize"

   Red := self createRed.
   Blue := self createBlue.
   Yellow := self createYellow! !

!ShootoutChameneosColour class methodsFor: 'accessing' stamp: ''!
red
   ^Red! !

!ShootoutChameneosColour class methodsFor: 'accessing' stamp: ''!
red: anObject
   Red := anObject! !

!ShootoutChameneosColour class methodsFor: 'accessing' stamp: ''!
yellow
   ^Yellow! !

!ShootoutChameneosColour class methodsFor: 'accessing' stamp: ''!
yellow: anObject
   Yellow := anObject! !

!ShootoutChameneosColour methodsFor: 'accessing' stamp: ''!
color
   ^color! !

!ShootoutChameneosColour methodsFor: 'accessing' stamp: ''!
color: aColor
   color := aColor! !

!ShootoutChameneosColour methodsFor: 'as yet unclassified' stamp: ''!
complementaryColourFor: aChameneosColour
   "determine the complementary colour defined as..."

   self == aChameneosColour ifTrue: [^self].
   self isBlue
      ifTrue:
         [aChameneosColour isRed
            ifTrue: [^self class yellow]
            ifFalse: [^self class red]].
   self isRed
      ifTrue:
         [aChameneosColour isBlue
            ifTrue: [^self class yellow]
            ifFalse: [^self class blue]].
   aChameneosColour isBlue
      ifTrue: [^self class red]
      ifFalse: [^self class blue]! !

!ShootoutChameneosColour methodsFor: 'testing' stamp: ''!
hasSameColorAs: aChameneos
   ^self color == aChameneos color! !

!ShootoutChameneosColour methodsFor: 'testing' stamp: ''!
isBlue
   ^self == self class blue! !

!ShootoutChameneosColour methodsFor: 'testing' stamp: ''!
isRed
   ^self == self class red! !

!ShootoutChameneosColour methodsFor: 'testing' stamp: ''!
isYellow
   ^self == self class yellow! !

!ShootoutChameneosColour methodsFor: 'printing' stamp: ''!
printOn: aStream
   aStream nextPutAll: self color! !

Object subclass: #ShootoutCreature
	instanceVariableNames: 'creatureName colour selfMet creaturesMet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Benchmarks-Shootout'!

!ShootoutCreature class methodsFor: 'initialize-release' stamp: 'eem 8/1/2008 16:15'!
withName: aName colour: aColour
   ^(ShootoutCreature new initialize)
      name: aName;
      colour: aColour! !

!ShootoutCreature methodsFor: 'accessing' stamp: ''!
colour
   ^colour! !

!ShootoutCreature methodsFor: 'accessing' stamp: ''!
colour: anObject
   colour := anObject! !

!ShootoutCreature methodsFor: 'accessing' stamp: ''!
creaturesMet
   ^creaturesMet! !

!ShootoutCreature methodsFor: 'accessing' stamp: ''!
creaturesMet: anObject
   creaturesMet := anObject! !

!ShootoutCreature methodsFor: 'initialize-release' stamp: ''!
initialize
   selfMet := 0.
   creaturesMet := 0! !

!ShootoutCreature methodsFor: 'accessing' stamp: ''!
name
   ^creatureName! !

!ShootoutCreature methodsFor: 'accessing' stamp: ''!
name: anObject
   creatureName := anObject! !

!ShootoutCreature methodsFor: 'accessing' stamp: ''!
selfMet
   ^selfMet! !

!ShootoutCreature methodsFor: 'accessing' stamp: ''!
selfMet: anObject
   ^selfMet := anObject! !

!ShootoutCreature methodsFor: 'controlling' stamp: ''!
visitMall: mall

   [| partner |
   partner := mall visitWith: self.
   partner ifNotNil:
         [colour := colour complementaryColourFor: partner colour.
         self == partner ifTrue: [selfMet := selfMet + 1].
         creaturesMet := creaturesMet + 1].
   partner isNil]
         whileFalse! !

Object subclass: #ShootoutMall
	instanceVariableNames: 'guard maxRendezvous open process queue cache pairCache'
	classVariableNames: 'Units'
	poolDictionaries: ''
	category: 'Cog-Benchmarks-Shootout'!

!ShootoutMall class methodsFor: 'initialize-release' stamp: ''!
createAllowing: maxRendezvous
   "Private"

   ^self basicNew initialize maxRendezvous: maxRendezvous! !

!ShootoutMall class methodsFor: 'initialize-release' stamp: 'eem 8/1/2008 16:15'!
createCreaturesWith: aCollectionOfColours
   "Private"

   | aName |
   aName := 0.
   ^aCollectionOfColours collect:
         [:aColour |
         aName := aName + 1.
         ShootoutCreature withName: aName colour: aColour]! !

!ShootoutMall class methodsFor: 'printing' stamp: ''!
generateReportFor: creatures printOn: stream
   | sum |
   sum := creatures inject: 0 into: [:accum :each | accum + each creaturesMet].
   creatures do:
         [:aCreature |
         aCreature creaturesMet printOn: stream.
         stream
            space;
            nextPutAll: (self units at: aCreature selfMet + 1);
            nl].
   stream space.
   sum printString
      do: [:el | stream nextPutAll: (self units at: el digitValue + 1)]
      separatedBy: [stream space].
   ^stream! !

!ShootoutMall class methodsFor: 'printing' stamp: ''!
generateReportForColours: colours printOn: stream
   stream space.
   colours do: [:colour | colour printOn: stream] separatedBy: [stream space].
   ^stream! !

!ShootoutMall class methodsFor: 'initialize-release' stamp: ''!
initialize
   "self initialize"

   Units := #('zero' 'one' 'two' 'three' 'four' 'five' 'six' 'seven' 'eight' 'nine')! !

!ShootoutMall class methodsFor: 'initialize-release' stamp: ''!
new
   ^self shouldNotImplement! !

!ShootoutMall class methodsFor: 'private' stamp: ''!
openMall: aMall forCreatures: creatures usingGuard: sema
   | processes |
   processes := creatures
            collect: [:aCreature |
               [aCreature visitMall: aMall.
               sema signal] newProcess].
   processes do:
         [:proc |
         proc priority: Processor userBackgroundPriority.
         proc resume]! !

!ShootoutMall class methodsFor: 'initialize-release' stamp: ''!
openMallWith: aCollectionOfColours forNumberOfMeets: aNumber
   | mall creatures guard |
   mall := self createAllowing: aNumber.
   mall run.
   creatures := self createCreaturesWith: aCollectionOfColours.
   guard := Semaphore new.
   self
      openMall: mall
      forCreatures: creatures
      usingGuard: guard.
   self
      waitForClosingOfMall: mall
      withCreatures: creatures
      usingGuard: guard.
   ^creatures! !

!ShootoutMall class methodsFor: 'public' stamp: 'eem 8/1/2008 16:16'!
runBenchMark: number on: anOutputStream
   "self runBenchMark: 60000 on: Transcript."

   | firstTestColours secondTestColours blue red yellow creatures |
   blue := ShootoutChameneosColour blue.
   red := ShootoutChameneosColour red.
   yellow := ShootoutChameneosColour yellow.
   firstTestColours := Array
            with: blue
            with: red
            with: yellow.
   secondTestColours := (OrderedCollection new)
            add: blue;
            add: red;
            add: yellow;
            add: red;
            add: yellow;
            add: blue;
            add: red;
            add: yellow;
            add: red;
            add: blue;
            yourself.
   (ShootoutChameneosColour generateReportOfColoursOn: anOutputStream) nl.
   (self generateReportForColours: firstTestColours printOn: anOutputStream)
      nl.
   creatures := ShootoutMall openMallWith: firstTestColours forNumberOfMeets: number.
   (self generateReportFor: creatures printOn: anOutputStream)
      nl;
      nl.
   (self generateReportForColours: secondTestColours printOn: anOutputStream)
      nl.
   creatures := ShootoutMall openMallWith: secondTestColours forNumberOfMeets: number.
   (self generateReportFor: creatures printOn: anOutputStream)
      nl;
      nl! !

!ShootoutMall class methodsFor: 'accessing' stamp: ''!
units
   ^Units! !

!ShootoutMall class methodsFor: 'private' stamp: ''!
waitForClosingOfMall: aMall withCreatures: creatures usingGuard: guard
   creatures size timesRepeat: [guard wait].
   aMall close! !

!ShootoutMall methodsFor: 'controlling' stamp: ''!
close
   open := false! !

!ShootoutMall methodsFor: 'initialize-release' stamp: 'eem 8/1/2008 16:14'!
initialize
   guard := Semaphore forMutualExclusion.
   queue := SharedQueue new.
   cache := OrderedCollection new.
   1 to: 10 do: [:x | cache add: ShootoutPair new]! !

!ShootoutMall methodsFor: 'accessing' stamp: ''!
maxRendezvous: max
   maxRendezvous := max! !

!ShootoutMall methodsFor: 'private' stamp: ''!
obtainPair
   ^cache removeFirst! !

!ShootoutMall methodsFor: 'private' stamp: ''!
processVisitors
   [open] whileTrue:
         [1 to: maxRendezvous
            do:
               [:x |
               | first second |
               first := queue next.
               second := queue next.
               self setPartnersOn: first and: second.
               first signal.
               second signal].
         [queue isEmpty] whileFalse: [queue next signal]].
   process terminate.
   process := nil! !

!ShootoutMall methodsFor: 'private' stamp: ''!
releasePair: pair
   pair release.
   cache addFirst: pair! !

!ShootoutMall methodsFor: 'initialize-release' stamp: ''!
run
   open := true.
   process ifNil:
         [process := [self processVisitors] newProcess.
         process priority: Processor userBackgroundPriority -1 ].
   process resume! !

!ShootoutMall methodsFor: 'private' stamp: ''!
setPartnersOn: first and: second
   first partner: second me.
   second partner: first me.
! !

!ShootoutMall methodsFor: 'private' stamp: ''!
shutdown
   [queue isEmpty] whileFalse: [queue next signal].
   process terminate.
   process := nil! !

!ShootoutMall methodsFor: 'controlling' stamp: ''!
visitWith: aChameneos
   | pair partner |
   pair := self obtainPair.
   pair me: aChameneos.
   queue nextPut: pair.
   pair wait.
   partner := pair partner.
   self releasePair: pair.
   ^partner! !

Object subclass: #ShootoutNBodySystem
	instanceVariableNames: 'bodies'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Benchmarks-Shootout'!

!ShootoutNBodySystem methodsFor: 'nbody' stamp: ''!
after: dt
	1 to: bodies size do: [:i|
		i+1 to: bodies size do: [:j|
			(bodies at: i) and: (bodies at: j) velocityAfter: dt].
	].
	bodies do: [:each| each positionAfter: dt]! !

!ShootoutNBodySystem methodsFor: 'nbody' stamp: ''!
energy
	| e |
	e := 0.0.
	1 to: bodies size do: [:i|
		e := e + (bodies at: i) kineticEnergy.

		i+1 to: bodies size do: [:j|
			e := e - ((bodies at: i) potentialEnergy: (bodies at: j))].
	].
	^e! !

!ShootoutNBodySystem methodsFor: 'initialize-release' stamp: 'eem 8/1/2008 16:08'!
initialize
	bodies := (OrderedCollection new
		add: ShootoutBody sun; add: ShootoutBody jupiter; add: ShootoutBody saturn;
		add: ShootoutBody uranus; add: ShootoutBody neptune; yourself) asArray.

	bodies first offsetMomentum:
		(bodies inject: (Array with: 0.0 with: 0.0 with: 0.0)
			into: [:m :each | each addMomentumTo: m])! !

Object subclass: #ShootoutPair
	instanceVariableNames: 'partner me sema'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Benchmarks-Shootout'!

!ShootoutPair class methodsFor: 'instance creation' stamp: ''!
new
   "Answer a newly created and initialized instance."
   ^super new initialize.! !

!ShootoutPair class methodsFor: 'instance creation' stamp: ''!
with: me
   "Answer a newly created and initialized instance."
self halt.
   ^super new initialize me: me! !

!ShootoutPair methodsFor: 'initialize-release' stamp: ''!
initialize
   "Initialize a newly created instance. This method must answer the receiver."

   partner := nil.
   me := nil.
   sema := Semaphore new.
   ^self! !

!ShootoutPair methodsFor: 'accessing' stamp: ''!
me
   ^me! !

!ShootoutPair methodsFor: 'accessing' stamp: ''!
me: anObject
   me := anObject! !

!ShootoutPair methodsFor: 'accessing' stamp: ''!
partner
   ^partner! !

!ShootoutPair methodsFor: 'accessing' stamp: ''!
partner: anObject
   partner := anObject! !

!ShootoutPair methodsFor: 'initialize-release' stamp: ''!
release
partner:=nil.! !

!ShootoutPair methodsFor: 'initialize-release' stamp: ''!
signal
   sema signal! !

!ShootoutPair methodsFor: 'initialize-release' stamp: ''!
wait
   sema wait! !

Object subclass: #ShootoutTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Benchmarks-Shootout'!

!ShootoutTests class methodsFor: 'platform' stamp: 'eem 11/17/2008 12:37'!
arg
	3 to: 5 do:
		[:i|
		(SmalltalkImage current getSystemAttribute: i) ifNotNil:
			[:aString|
			aString asInteger ifNotNil:
				[:arg| ^arg]]].
	^nil! !

!ShootoutTests class methodsFor: 'benchmark scripts' stamp: ''!
binarytrees
	self binarytrees: self arg to: self stdout.
	^''! !

!ShootoutTests class methodsFor: 'benchmarking' stamp: 'eem 8/1/2008 16:10'!
binarytrees: n to: output
	| minDepth maxDepth stretchDepth check longLivedTree iterations |
	minDepth := 4.
	maxDepth := minDepth + 2 max: n.
	stretchDepth := maxDepth + 1.

	check := (ShootoutTreeNode bottomUpTree: 0 depth: stretchDepth) itemCheck.
	output
		nextPutAll: 'stretch tree of depth '; print: stretchDepth; tab;
		nextPutAll: ' check: '; print: check; nl.

	longLivedTree := ShootoutTreeNode bottomUpTree: 0 depth: maxDepth.
	minDepth to: maxDepth by: 2 do: [:depth|
		iterations := 1 bitShift: maxDepth - depth + minDepth.

		check := 0.
		1 to: iterations do: [:i|
			check := check + (ShootoutTreeNode bottomUpTree: i depth: depth) itemCheck.
			check := check + (ShootoutTreeNode bottomUpTree: -1*i depth: depth) itemCheck
			].
		output
			print:  (2*iterations); tab;
			nextPutAll: ' trees of depth '; print: depth; tab;
			nextPutAll: ' check: '; print: check; nl
		].

	output
		nextPutAll: 'long lived tree of depth '; print: maxDepth; tab;
		nextPutAll: ' check: '; print: longLivedTree itemCheck; nl! !

!ShootoutTests class methodsFor: 'benchmark scripts' stamp: 'eem 8/1/2008 16:26'!
chameneosredux2
	self chameneosredux: self arg to: self stdout.
	^''! !

!ShootoutTests class methodsFor: 'benchmarking' stamp: 'eem 8/1/2008 16:26'!
chameneosredux: arg to: aStream
   ShootoutMall runBenchMark: arg on: aStream! !

!ShootoutTests class methodsFor: 'benchmark scripts' stamp: 'eem 5/4/2010 11:46'!
collectReferenceTimes
	"Run the benchmarks 3 times and take their average, e.g. suitable
	 for filling in values for referenceTimesForClosureInterpreter"

	"ShootoutTests collectReferenceTimes"
	| n refs |
	Transcript clear.
	n := 3.
	refs := (1 to: n) collect: [:i| ShootoutTests runAllToInternalStream].
	^{	refs.
		(1 to: refs first size) collect:
			[:i|
			((refs inject: 0 into: [:sum :ref| (ref at: i) + sum]) / n) rounded] }! !

!ShootoutTests class methodsFor: 'benchmark scripts' stamp: ''!
nbody
	self nbody: self arg to: self stdout! !

!ShootoutTests class methodsFor: 'benchmarking' stamp: 'eem 8/1/2008 16:09'!
nbody: count to: output
	| bodies |
	bodies := ShootoutNBodySystem new initialize.

	output print: bodies energy digits: 9; cr.
	count timesRepeat: [bodies after: 0.01].
	output print: bodies energy digits: 9; cr.
	^''! !

!ShootoutTests class methodsFor: 'profiling' stamp: 'eem 10/16/2010 19:33'!
profileAll
	"self profileAll"
	| stream |
	stream := DummyStream new.
	self nbody: 200000 "20000000" to: stream.
	self binarytrees: 15 to: stream.
	self chameneosredux: 260000 to: stream.
	self threadring: 10000000 to: stream! !

!ShootoutTests class methodsFor: 'benchmark scripts' stamp: 'eem 5/4/2010 11:44'!
referenceTimesForClosureInterpreter
	 "ClosureVM (QF 1.2.23 + Closure Bytecodes) on Eliot's 2010 vintage 2.66GHz Intel Core i7 MacBook Pro"
	^Dictionary new
		at: #nbody put: 4543;
		at: #binarytrees put: 6944;
		at: #chameneosredux put: 5799;
		at: #threadring put: 5623;
		yourself

	 "ClosureVM (QF 1.2.23 + Closure Bytecodes) on Eliot's 2006 vintage 2.16GHz Intel Core Duo MacBook Pro"
	"^Dictionary new
		at: #nbody put: 7660;
		at: #binarytrees put: 14417;
		at: #chameneosredux put: 8478;
		at: #threadring put: 8718;
		yourself"! !

!ShootoutTests class methodsFor: 'benchmark scripts' stamp: 'eem 6/24/2010 19:57'!
referenceTimesForSqueakVM
	 "Squeak VM (4.2.2beta1 + Closure Bytecodes) on Eliot's 2010 vintage 2.66GHz Intel Core i7 MacBook Pro"
	^Dictionary new
		at: #nbody put: 4917;
		at: #binarytrees put: 8593;
		at: #chameneosredux put: 5405;
		at: #threadring put: 3789;
		yourself! !

!ShootoutTests class methodsFor: 'reporting' stamp: 'eem 10/24/2008 16:44'!
report: name time: millisecs reference: reference on: aStream
	aStream
		cr;
		nextPutAll: name; cr;
		nextPutAll: ' took '; print: millisecs / 1000.0; nextPutAll: ' seconds'; cr; flush;
		nextPutAll: 'ratio: '; print: ((millisecs / reference) roundTo: 0.001);
		nextPutAll: '   % change: '; print: ((millisecs - reference * 100 / reference) roundTo: 0.01); nextPut: $%;
		cr; flush! !

!ShootoutTests class methodsFor: 'benchmark scripts' stamp: 'eem 6/24/2010 20:01'!
runAllToDummyStream
	"Transcript clear.
	 self runAllToDummyStream"
	^self runAllToDummyStreamVs: self referenceTimesForClosureInterpreter! !

!ShootoutTests class methodsFor: 'benchmark scripts' stamp: 'eem 6/24/2010 20:00'!
runAllToDummyStreamVs: referenceTimes
	"Transcript clear.
	 self runAllToDummyStreamVs: self referenceTimesForClosureInterpreter"
	"Transcript clear.
	 self runAllToDummyStreamVs: self referenceTimesForSqueakVM"
	| stream times ratios geometricMean |
	stream := DummyStream new.
	times := Array new writeStream.
	ratios := Array new writeStream.
	{ [self nbody: 200000 "20000000" to: stream].
	   [self binarytrees: 15 to: stream].
	   [self chameneosredux: 260000 to: stream].
	   [self threadring: 10000000 to: stream] } do:
		[:block | | benchmark reference t |
		benchmark := (self selectorForSimpleBlock: block) copyUpTo: $:.
		reference := referenceTimes at: benchmark asSymbol.
		Smalltalk garbageCollect.
		times nextPut: (t := Time millisecondsToRun: block).
		ratios nextPut: t asFloat / reference.
		self report: block decompile printString time: t reference: reference on: Transcript].
	geometricMean := (ratios contents inject: 1 into: [:m :n| m * n]) raisedTo: 1 / ratios position.
	Transcript
		nextPutAll: 'geometric mean '; print: (geometricMean roundTo: 0.001);
		nextPutAll: '   average speedup '; print: ((geometricMean - 1 * 100) roundTo: 0.01); nextPut: $%; cr; cr; flush.
	^times contents! !

!ShootoutTests class methodsFor: 'benchmark scripts' stamp: 'eem 6/24/2010 20:01'!
runAllToInternalStream
	"Transcript clear.
	 self runAllToInternalStream"
	^self runAllToInternalStreamVs: self referenceTimesForClosureInterpreter! !

!ShootoutTests class methodsFor: 'benchmark scripts' stamp: 'eem 6/24/2010 19:59'!
runAllToInternalStreamVs: referenceTimes
	"Transcript clear.
	 self runAllToInternalStreamVs: self referenceTimesForClosureInterpreter"
	"Transcript clear.
	 self runAllToInternalStreamVs: self referenceTimesForSqueakVM"
	| stream times ratios geometricMean |
	stream := (ByteString new: 10000) writeStream.
	times := Array new writeStream.
	ratios := Array new writeStream.
	{ [self nbody: 200000 "20000000" to: stream].
	   [self binarytrees: 15 to: stream].
	   [self chameneosredux: 260000 to: stream].
	   [self threadring: 10000000 to: stream] } do:
		[:block | | benchmark reference t |
		benchmark := (self selectorForSimpleBlock: block) copyUpTo: $:.
		reference := referenceTimes at: benchmark asSymbol.
		Smalltalk garbageCollect.
		times nextPut: (t := Time millisecondsToRun: block).
		ratios nextPut: t asFloat / reference.
		self report: block decompile printString time: t reference: reference on: Transcript].
	geometricMean := (ratios contents inject: 1 into: [:m :n| m * n]) raisedTo: 1 / ratios position.
	Transcript
		nextPutAll: 'geometric mean '; print: (geometricMean roundTo: 0.001);
		nextPutAll: '   average speedup '; print: ((geometricMean - 1 * 100) roundTo: 0.01); nextPut: $%; cr; cr; flush.
	^times contents! !

!ShootoutTests class methodsFor: 'benchmark scripts' stamp: 'eem 6/24/2010 20:01'!
runAllToTranscript
	"Transcript clear.
	 self runAllToTranscript"
	^self runAllToTranscriptVs: self referenceTimesForClosureInterpreter! !

!ShootoutTests class methodsFor: 'benchmark scripts' stamp: 'eem 6/24/2010 20:00'!
runAllToTranscriptVs: referenceTimes
	"Transcript clear.
	 self runAllToTranscriptVs: self referenceTimesForClosureInterpreter"
	"Transcript clear.
	 self runAllToTranscriptVs: self referenceTimesForSqueakVM"
	| times ratios geometricMean |
	times := Array new writeStream.
	ratios := Array new writeStream.
	{ [self nbody: 200000 "20000000" to: Transcript].
	   [self binarytrees: 15 to: Transcript].
	   [self chameneosredux: 260000 to: Transcript].
	   [self threadring: 10000000 to: Transcript] } do:
		[:block | | benchmark reference t |
		benchmark := (self selectorForSimpleBlock: block) copyUpTo: $:.
		reference := referenceTimes at: benchmark asSymbol.
		Smalltalk garbageCollect.
		times nextPut: (t := Time millisecondsToRun: block).
		ratios nextPut: t asFloat / reference.
		self report: block decompile printString time: t reference: reference on: Transcript].
	geometricMean := (ratios contents inject: 1 into: [:m :n| m * n]) raisedTo: 1 / ratios position.
	Transcript
		nextPutAll: 'geometric mean '; print: (geometricMean roundTo: 0.001);
		nextPutAll: '   average speedup '; print: ((geometricMean - 1 * 100) roundTo: 0.01); nextPut: $%; cr; cr; flush.
	^times contents! !

!ShootoutTests class methodsFor: 'benchmark scripts' stamp: 'eem 10/30/2008 10:43'!
selectorForSimpleBlock: aBlock
	| is |
	is := InstructionStream on: aBlock method.
	is pc: aBlock startpc.
	is scanFor:
		[:x| | selectorOrScanner |
		(selectorOrScanner := is selectorToSendOrSelf) ~~ is ifTrue:
			[^selectorOrScanner].
		false].
	^nil! !

!ShootoutTests class methodsFor: 'platform' stamp: 'eem 12/22/2010 14:59'!
stdin
   ^StandardFileStream stdIn! !

!ShootoutTests class methodsFor: 'platform' stamp: 'eem 12/22/2010 14:59'!
stdout
   ^StandardFileStream stdOut! !

!ShootoutTests class methodsFor: 'benchmarking' stamp: 'eem 6/9/2009 12:25'!
threadRing: aSemaphore output: output
   | first last |
   503 to: 1 by: -1 do: [:i|
      first := ShootoutThread named: i next: first done: aSemaphore output: output.
      last isNil ifTrue: [ last := first ].
   ].
   last nextThread: first.
   ^first ! !

!ShootoutTests class methodsFor: 'benchmark scripts' stamp: 'eem 6/9/2009 12:30'!
threadring
  self threadring: self arg to: self stdout.
   ^''! !

!ShootoutTests class methodsFor: 'benchmarking' stamp: 'eem 6/9/2009 12:29'!
threadring: arg to: output
   | done |
   (self threadRing: (done := Semaphore new) output: output) takeToken: arg.
   done wait! !

Object subclass: #ShootoutThread
	instanceVariableNames: 'name nextThread token semaphore done output'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Benchmarks-Shootout'!

!ShootoutThread class methodsFor: 'instance creation' stamp: 'eem 6/9/2009 12:28'!
named: anInteger next: aThread done: aSemaphore output: aStream
   ^self new name: anInteger; nextThread: aThread; done: aSemaphore; output: aStream; fork ! !

!ShootoutThread class methodsFor: 'instance creation' stamp: ''!
new
   ^self basicNew semaphore: Semaphore new ! !

!ShootoutThread methodsFor: 'accessing' stamp: ''!
done: aSemaphore
   done := aSemaphore ! !

!ShootoutThread methodsFor: 'accessing' stamp: ''!
fork
   [ self run ] fork ! !

!ShootoutThread methodsFor: 'accessing' stamp: ''!
name: anInteger
   name := anInteger ! !

!ShootoutThread methodsFor: 'accessing' stamp: ''!
nextThread: aThread
   nextThread := aThread ! !

!ShootoutThread methodsFor: 'accessing' stamp: 'eem 6/9/2009 12:26'!
output: anObject
	"Set the value of output"

	output := anObject! !

!ShootoutThread methodsFor: 'accessing' stamp: 'eem 6/9/2009 12:33'!
run
   [ self tokenNotDone ] whileTrue: [ nextThread takeToken: token - 1 ].
   output print: name.
   output name = 'stdout'
	ifTrue: [output nl]
	ifFalse: [output cr; flush].
   done signal ! !

!ShootoutThread methodsFor: 'accessing' stamp: ''!
semaphore: aSemaphore
   semaphore := aSemaphore ! !

!ShootoutThread methodsFor: 'accessing' stamp: ''!
takeToken: x
   token := x.
   semaphore signal ! !

!ShootoutThread methodsFor: 'accessing' stamp: ''!
tokenNotDone
   semaphore wait.
   ^token > 0 ! !

Object subclass: #ShootoutTreeNode
	instanceVariableNames: 'left right item'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Benchmarks-Shootout'!

!ShootoutTreeNode class methodsFor: 'instance creation' stamp: ''!
bottomUpTree: anItem depth: anInteger
	^(anInteger > 0)
		ifTrue: [
			self
				left: (self bottomUpTree: 2*anItem - 1 depth: anInteger - 1)
				right: (self bottomUpTree: 2*anItem depth: anInteger - 1) 
				item: anItem
			]
		ifFalse: [self left: nil right: nil item: anItem]! !

!ShootoutTreeNode class methodsFor: 'instance creation' stamp: ''!
left: leftChild right: rightChild item: anItem
	^(super new) left: leftChild right: rightChild item: anItem! !

!ShootoutTreeNode methodsFor: 'accessing' stamp: ''!
itemCheck
	^left isNil
		ifTrue: [item] ifFalse: [item + (left itemCheck - right itemCheck)]! !

!ShootoutTreeNode methodsFor: 'initialize-release' stamp: ''!
left: leftChild right: rightChild item: anItem
	left := leftChild.
	right := rightChild.
	item := anItem! !

Object subclass: #SpurBootstrapMonticelloPackagePatcher
	instanceVariableNames: 'sourceDir destDir'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Bootstrapping'!

!SpurBootstrapMonticelloPackagePatcher commentStamp: 'eem 1/15/2014 17:59' prior: 0!
A SpurBootstrapMonticelloPackagePatcher is used to construct a new set of patched Monticello packages for Spur.  The use case is some bootstrap process loads a set of Monticello packages.  To repeat the bootstrap with a Spur image the bootstrap must use suitably patched Monticello packages containing the new method versions on the class side of SpurBootstrap.

Instance Variables
	destDir:			<FileDirectory>
	sourceDir:		<FileDirectory>

destDir
	- directory to which patched packages are to be written

sourceDir
	- directory from which packages to be patched are to be read!

!SpurBootstrapMonticelloPackagePatcher class methodsFor: 'baselines' stamp: 'eem 5/10/2014 11:36'!
squeak45baseline
	"The base Squeak-4.5-13680 package set."
	^#(	name 'base-Squeak45-eem'
		repository ('http://source.squeak.org/squeak45')
		dependency ('Squeak-Version' 'Squeak-Version-ar.4662' '6bfece28-65a4-b147-9462-417b2e86acd0')
		dependency ('311Deprecated' '311Deprecated-nice.2' '6df45c33-740a-fc4f-b3d0-45412ad7d284')
		dependency ('39Deprecated' '39Deprecated-ar.19' '8da20c38-7d28-3241-9f29-da261d6f9bfe')
		dependency ('45Deprecated' '45Deprecated-fbs.24' '4033c169-94c6-7741-9aee-5a7570a7ec7a')
		dependency ('Balloon' 'Balloon-nice.24' '97e2ed51-707d-4da1-ab4f-35add3deee5e')
		dependency ('Network' 'Network-nice.150' 'c844e5ea-c919-44fc-905e-69487b035947')
		dependency ('Compression' 'Compression-fbs.40' '82b0d6e4-0239-1241-968c-461a785fb6a7')
		dependency ('Graphics' 'Graphics-nice.289' 'e809bcbf-53e1-420b-846a-9e86e0dd1f06')
		dependency ('Multilingual' 'Multilingual-fbs.194' '07f4a7b5-7169-3345-85fc-5a8ba04e5323')
		dependency ('CollectionsTests' 'CollectionsTests-dtl.214' 'cf157d3a-2d71-46f3-86ce-450ee24e8d27')
		dependency ('PackageInfo-Base' 'PackageInfo-Base-nice.68' 'b6669527-9a35-4783-a64f-8f2af97e330b')
		dependency ('Compiler' 'Compiler-nice.279' '94b1b5f8-f71b-4425-b035-461d3dc94e3f')
		dependency ('Environments' 'Environments-ul.46' 'cfd9e7f7-6a4b-400e-b9c7-9c6239da4752')
		dependency ('Kernel' 'Kernel-dtl.836' '410e695f-7f23-43e4-9dc2-d292b9954f0d')
		dependency ('MonticelloConfigurations' 'MonticelloConfigurations-fbs.123' 'b9735d10-7cf4-a746-8a64-b50fa9cf273f')
		dependency ('Tools' 'Tools-cmm.519' 'dae6bdb9-8b54-491a-a2a4-0b114f02e10d')
		dependency ('MorphicExtras' 'MorphicExtras-tpr.147' 'e76a71a5-6be9-4420-b71a-2c92d900c476')
		dependency ('Files' 'Files-dtl.130' '8ee82071-69f7-446d-8ed7-77eafc838f03')
		dependency ('System' 'System-dtl.666' '098b856a-ecc5-498a-bceb-ef3457d3511e')
		dependency ('Collections' 'Collections-ul.564' '4b9a37ef-df86-40a0-a0dd-8e8b2c04d4ed')
		dependency ('Monticello' 'Monticello-cmm.586' 'a4dbd656-e50a-47ba-8661-44f8c87bb3e0')
		dependency ('EToys' 'EToys-cmm.117' 'c3e71dbe-17af-4b71-ad9c-c0bb2a2bc193')
		dependency ('Exceptions' 'Exceptions-cmm.49' '6cede9fe-b13d-481a-b8de-bb004ece1145')
		dependency ('FlexibleVocabularies' 'FlexibleVocabularies-bf.13' '55c72a72-619e-4a81-831f-303600bbd792')
		dependency ('GraphicsTests' 'GraphicsTests-fbs.38' '081189cc-a44f-fa4e-965e-25438280ea93')
		dependency ('Installer-Core' 'Installer-Core-cmm.392' '7cb5c040-6f68-479d-bc9e-0b264b172443')
		dependency ('KernelTests' 'KernelTests-nice.259' '0f7301b0-612c-49d8-936f-775995b35e0f')
		dependency ('GetText' 'GetText-nice.34' '4d432f8e-55be-428a-9138-63dd1738035e')
		dependency ('Sound' 'Sound-nice.38' 'b626daf0-be23-4fb8-b2d5-04b9cd370539')
		dependency ('ToolBuilder-Tests' 'ToolBuilder-Tests-cmm.1' 'e77685b9-ca09-40c0-b84e-6caee75f4075')
		dependency ('Morphic' 'Morphic-cmm.720' 'e5e81c18-990b-4e35-b325-adb032b8418d')
		dependency ('MorphicTests' 'MorphicTests-nice.24' 'e33a9ad3-2f39-4c19-a3a7-dc87f18177fc')
		dependency ('MorphicExtrasTests' 'MorphicExtrasTests-fbs.3' '1c039763-bc92-834c-943e-d96d8820cbd7')
		dependency ('MultilingualTests' 'MultilingualTests-fbs.18' '07e26018-8455-3349-9b44-9ecb4aaeefb2')
		dependency ('Nebraska' 'Nebraska-nice.36' 'cc80dca4-ed72-4c39-952c-3b37886100de')
		dependency ('NetworkTests' 'NetworkTests-fbs.37' '97699685-5826-fe47-af98-356971abf2fb')
		dependency ('PreferenceBrowser' 'PreferenceBrowser-fbs.49' '72d30dfa-0ff5-4347-9823-eb77ae236f8f')
		dependency ('Protocols' 'Protocols-nice.46' '15b63671-d541-4c1d-9ff5-72da4fc5bfe9')
		dependency ('SMBase' 'SMBase-nice.132' 'a70c8bd2-3eee-4e21-b9c6-113f6b194527')
		dependency ('SMLoader' 'SMLoader-fbs.79' '9f7d983e-d958-4115-94aa-21302f89ad8b')
		dependency ('ST80' 'ST80-cmm.172' '47b2f84a-6951-480b-88f2-b2726dba08bd')
		dependency ('ST80Tests' 'ST80Tests-nice.2' '7ee5426b-73f1-48ac-8ec4-3943dc452cb6')
		dependency ('ST80Tools' 'ST80Tools-fbs.1' '108ec7bc-d1f5-dd4b-9511-e7a653a71e9f')
		dependency ('SUnit' 'SUnit-fbs.99' 'a5be81dd-6e9f-8d41-a091-3c6c27a28abe')
		dependency ('SUnitGUI' 'SUnitGUI-fbs.59' '0bfcf308-0d02-a749-9930-6229492cca48')
		dependency ('ScriptLoader' 'ScriptLoader-cmm.338' 'adb79117-0915-40a5-a5ee-c766e4b50d42')
		dependency ('Services-Base' 'Services-Base-topa.51' '94328e86-1643-4090-8f18-bc4467119161')
		dependency ('SmallLand-ColorTheme' 'SmallLand-ColorTheme-fbs.6' 'a78b81e3-3b11-c24e-9c84-3bb5319e0858')
		dependency ('SystemChangeNotification-Tests' 'SystemChangeNotification-Tests-nice.23' '3eed6d26-4aef-4095-a604-d9f914240281')
		dependency ('Tests' 'Tests-cmm.290' 'f3fccfae-6baf-4093-ba62-e15ef110a687')
		dependency ('ToolBuilder-Kernel' 'ToolBuilder-Kernel-nice.60' '86949a07-725b-4a27-a7cd-a827c74f48be')
		dependency ('ToolBuilder-MVC' 'ToolBuilder-MVC-fbs.34' 'aded987d-5cd5-6f41-9635-1d38da947ddf')
		dependency ('ToolBuilder-Morphic' 'ToolBuilder-Morphic-fbs.91' 'abaa076b-af43-af42-8c98-7a71482c6a30')
		dependency ('ToolBuilder-SUnit' 'ToolBuilder-SUnit-fbs.19' '3e30756c-2af8-0741-836f-0d42a9d5af32')
		dependency ('ToolsTests' 'ToolsTests-cmm.68' '98c1608a-6cb3-4a03-a28a-dd101e6c876b')
		dependency ('MonticelloForTraits' 'MonticelloForTraits-fbs.1' '160be615-5ab7-4148-a7cb-60dd629ab085')
		dependency ('Traits' 'Traits-topa.302' '58712f55-3f3f-467e-ac0e-e118c9737c53')
		dependency ('TraitsTests' 'TraitsTests-fbs.13' '0429146f-6767-4a4f-8fce-37571625920a')
		dependency ('TrueType' 'TrueType-nice.28' '42a74f04-e193-455b-a2c1-14ec51724234')
		dependency ('Universes' 'Universes-nice.46' '805eb73f-391b-4e3f-aef9-64add79e4e8c')
		dependency ('VersionNumber' 'VersionNumber-cmm.4' '68fb1f05-d3e2-4c9b-9234-20a9bed166dc')
		dependency ('XML-Parser' 'XML-Parser-fbs.36' 'a2d9791a-c341-564b-9b57-a0fe9f42b66f')
		dependency ('ReleaseBuilder' 'ReleaseBuilder-cmm.114' 'ea773780-69e1-48dd-a16c-e167acb9de04')
		dependency ('ShoutCore' 'ShoutCore-cwp.40' '81b3e230-2e8a-42c5-9521-e54338fadb6f')
		dependency ('VersionNumberTests' 'VersionNumberTests-fbs.4' '953a944c-9648-dd4b-898e-9e10e0507b91')
		dependency ('HelpSystem-Core' 'HelpSystem-Core-ul.56' '6d8a0d54-5f60-da45-8c3c-d42ea8abd999')
		dependency ('HelpSystem-Tests' 'HelpSystem-Tests-fbs.15' '8927a848-29a0-f54c-8c79-efb8070c4702')
		dependency ('Help-Squeak-Project' 'Help-Squeak-Project-kfr.10' 'b86eb622-cc53-634d-aa65-aed2c86263f9')
		dependency ('Help-Squeak-TerseGuide' 'Help-Squeak-TerseGuide-dtl.2' '8b18cab9-7183-4c5e-8cac-f79c4400da43')
		dependency ('SystemReporter' 'SystemReporter-ul.21' '34c5c48c-e7cc-4dfe-8133-6dec3bc63ff7')
		dependency ('BalloonTests' 'BalloonTests-egp.2' 'a8206c39-12ee-4222-a29a-caa537e037c4')
		dependency ('CommandLine' 'CommandLine-fbs.2' '414e59b8-4f4a-814d-9dac-b7b9886e92a0')
		dependency ('UpdateStream' 'UpdateStream-nice.4' '5fcdedce-88aa-469a-bf8b-32820f051c4f')
		)! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'initialization' stamp: 'eem 5/10/2014 13:46'!
directoryFrom: dirName
	^FileDirectory on: (dirName first = $/
							ifTrue: [dirName]
							ifFalse: [(FileDirectory default directoryNamed: dirName) fullName])! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'repository population' stamp: 'eem 5/11/2014 10:57'!
download: baseConfigurationOrArray "<MCConfiguration|Array>" from: repo
	| base |
	base := baseConfigurationOrArray isArray
				ifTrue: [MCConfiguration fromArray: baseConfigurationOrArray]
				ifFalse: [baseConfigurationOrArray].
	self packagesAndPatches keysAndValuesDo:
		[:package :patches| | dependency |
		dependency := base dependencies detect: [:dep| dep package name = package name].
		self downloadToSourceDirAllPackageVersionsStartingWith: dependency versionInfo
			from: repo].! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'repository population' stamp: 'eem 5/10/2014 14:33'!
downloadToSourceDirAllPackageVersionsStartingWith: aMCVersionInfo from: repo 
	| localRepo priorName |
	priorName := MCVersionName on: (aMCVersionInfo versionName
											copyReplaceAll: aMCVersionInfo versionNumber asString
											with: (aMCVersionInfo versionNumber - 1) asString).
	localRepo := MCDirectoryRepository directory: sourceDir.
	(repo possiblyNewerVersionsOfAnyOf: {priorName asMCVersionName}) do:
		[:newerVersion | 
		(localRepo includesVersionNamed: newerVersion) ifFalse:
			[localRepo storeVersion: (repo versionNamed: newerVersion)]]! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'private-accessing' stamp: 'eem 1/15/2014 17:06'!
filesForPackage: package in: aDirectory
	^aDirectory fileNames select:
		[:fileName|
		(fileName beginsWith: package name)
		 and: [(fileName at: package name size + 1) isLetter not]]! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'initialization' stamp: 'eem 5/10/2014 13:45'!
from: sourceDirName to: destDirName
	sourceDir := self directoryFrom: sourceDirName.
	destDir := self directoryFrom: destDirName! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'private-accessing' stamp: 'eem 3/3/2014 18:54'!
immediateClassDefinitionFor: className from: definitions
	| classDef |
	classDef := definitions detect: [:d| d isClassDefinition and: [d className = className]].
	classDef variables removeAllSuchThat:
		[:varDef|
		 varDef isInstanceVariable and: [varDef name = 'value']].
	classDef instVarNamed: 'type' put: #immediate.
	^MCAddition of: classDef! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'private-accessing' stamp: 'eem 3/3/2014 18:50'!
modifiedCharacterDefinitionsIn: definitions
	| rewriter |
	rewriter := RBParseTreeRewriter new.
	rewriter
		replace: 'value' with: 'self asInteger';
		replace: 'value := ``@args' with: 'DELETEME'.
	^(((definitions select: [:d| d isMethodDefinition and: [d fullClassName = #Character]])
		collect: [:d| { d. self patchDefinition: d withRewriter: rewriter} ]
		thenSelect: [:pair| pair first source ~= pair second source])
			collect: [:pair| pair second])! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'private-accessing' stamp: 'eem 1/15/2014 17:00'!
packages
	"SpurBootstrapMonticelloPackagePatcher new packages"
	| packages |
	packages := Set new.
	SpurBootstrap new prototypeClassNameMetaSelectorMethodDo:
		[:className :isMeta :selector :method| | class |
		 class := Smalltalk classNamed: className.
		 isMeta ifTrue:
			[class := class class].
		 packages add: ((class includesSelector: selector)
							ifTrue: [PackageOrganizer default packageOfMethod: (class >> selector) methodReference]
							ifFalse: [PackageOrganizer default  packageOfClass: class])].
	^packages! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'private-accessing' stamp: 'eem 2/5/2014 19:41'!
packagesAndPatches
	"SpurBootstrapMonticelloPackagePatcher new packagesAndPatches"
	| packagesAndPatches |
	packagesAndPatches := Dictionary new.
	SpurBootstrap new prototypeClassNameMetaSelectorMethodDo:
		[:className :isMeta :selector :method| | class methodReference source |
		 class := Smalltalk classNamed: className.
		 isMeta ifTrue:
			[class := class class].
		 methodReference := (class includesSelector: selector) ifTrue:
								[(class >> selector) methodReference].
		 source := method getSourceFromFile asString allButFirst: method selector size - selector size.
		 source first ~= selector first ifTrue:
			[source replaceFrom: 1 to: selector size with: selector startingAt: 1].
		 (packagesAndPatches
				at: (methodReference
						ifNotNil: [PackageOrganizer default packageOfMethod: methodReference]
						ifNil: [PackageOrganizer default  packageOfClass: class])
				ifAbsentPut: [OrderedCollection new])
			add: (MCAddition of: (MCMethodDefinition
									className: className
									classIsMeta: isMeta
									selector: selector
									category: (methodReference
												ifNotNil: [methodReference category]
												ifNil: [Categorizer default])
									timeStamp: method timeStamp
									source: source))].
	^packagesAndPatches! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'patching' stamp: 'eem 3/1/2014 09:53'!
patch
	"(SpurBootstrapMonticelloPackagePatcher new
			from: '/Users/eliot/Squeak/Squeak4.5-spur/squeakv3-package-cache'
			to: '/Users/eliot/Squeak/Squeak4.5-spur/package-cache')
		patch"
	"(SpurBootstrapMonticelloPackagePatcher new
			from: '/Users/eliot/Glue/repositories/nsboot/Squeak4.3/squeak-package-cache'
			to: '/Users/eliot/Glue/repositories/nsboot/Squeak4.3/package-cache')
		patch"
	(sourceDir exists and: [destDir exists]) ifFalse:
		[self error: 'one or both of the directories don''t exist'].
	self packagesAndPatches keysAndValuesDo:
		[:package :patches|
		 (self filesForPackage: package in: sourceDir) do:
			[:packageFile|
			 self patchPackage: packageFile with: patches for: package]]! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'patching' stamp: 'eem 5/11/2014 10:35'!
patchAsNeeded
	(sourceDir exists and: [destDir exists]) ifFalse:
		[self error: 'one or both of the directories don''t exist'].
	self packagesAndPatches keysAndValuesDo:
		[:package :patches|
		 (self filesForPackage: package in: sourceDir) do:
			[:packageFile|
			 (destDir includesKey: packageFile) ifFalse:
				[self patchPackage: packageFile with: patches for: package]]]! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'patching' stamp: 'eem 2/5/2014 12:27'!
patchDefinition: aMCMethodDefinition withRewriter: aRBParseTreeRewriter 
	| parseTree |
	parseTree := RBParser
					parseMethod: aMCMethodDefinition source
					onError: [:str :pos | self halt].
	aRBParseTreeRewriter executeTree: parseTree.
	^MCMethodDefinition 
		className: aMCMethodDefinition className
		classIsMeta:aMCMethodDefinition classIsMeta
		selector: aMCMethodDefinition selector
		category: aMCMethodDefinition category
		timeStamp: aMCMethodDefinition timeStamp
		source: aRBParseTreeRewriter tree newSource! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'patching' stamp: 'eem 3/3/2014 18:50'!
patchForPackage: package withPatches: patches snapshot: snapshot
	(package includesClass: Character) ifTrue:
		[patches
			addAll: ((self modifiedCharacterDefinitionsIn: snapshot definitions)
						select:
							[:def|
							 patches noneSatisfy:
								[:addition|
								def isMethodDefinition
								and: [addition definition selector = def selector
								and: [addition definition className = def className
								and: [addition definition classIsMeta = def classIsMeta]]]]]
						thenCollect:
							[:def|
							 ((def source includesSubString: 'DELETEME')
								ifTrue: [MCRemoval]
								ifFalse: [MCAddition]) of: def]);
			add: (self immediateClassDefinitionFor: #Character from: snapshot definitions)].
	(package includesClass: SmallInteger) ifTrue:
		[patches
			add: (self immediateClassDefinitionFor: #SmallInteger from: snapshot definitions)].
	^MCPatch operations: patches! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'patching' stamp: 'eem 1/15/2014 17:42'!
patchPackage: packageFileName with: patches for: package
	| version newVersion |
	version := self versionFor: packageFileName.
	newVersion := self version: version withPatches: patches for: package.
	self storeVersion: newVersion! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'repository population' stamp: 'eem 5/11/2014 10:51'!
spur
	| url |
	url := 'http://source.squeak.org/spur'.
	^MCRepositoryGroup default repositories 
		detect: [:r| r description = url]
		ifNone:
			[MCHttpRepository fillInTheBlankConfigure:
				(MCHttpRepository
					creationTemplateLocation: url
					user: 'user with write permission'
					password: 'password')]! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'patching' stamp: 'eem 1/15/2014 17:51'!
storeVersion: newVersion
	[(MCDirectoryRepository new directory: destDir) storeVersion: newVersion]
		on: FileExistsException
		do: [:ex| ex resume: (ex fileClass forceNewFileNamed: ex fileName)]! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'repository population' stamp: 'eem 5/11/2014 10:51'!
trunk
	| url |
	url := 'http://source.squeak.org/trunk'.
	^MCRepositoryGroup default repositories 
		detect: [:r| r description = url]
		ifNone: [MCHttpRepository
					location: url
					user: 'squeak'
					password: 'squeak']! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'repository population' stamp: 'eem 5/11/2014 10:57'!
updateSpurRepository
	"self new from: 'trunkpackages' to: 'spurpackages'; updateSpurRepository"
	"AndreasSystemProfiler spyOn: [self new from: 'trunkpackages' to: 'spurpackages'; updateSpurRepository]"
	sourceDir assureExistence.
	self download: self class squeak45baseline from: self trunk.
	destDir assureExistence.
	self patchAsNeeded.
	self uploadFrom: (MCDirectoryRepository directory: destDir) to: self spur! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'repository population' stamp: 'eem 5/11/2014 10:54'!
uploadFrom: localRepo to: uploadRepository
	localRepo allVersionsDo:
		[:version|
		(uploadRepository includesVersionNamed: version info name) ifFalse:
			[uploadRepository storeVersion: version]]! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'patching' stamp: 'eem 3/7/2014 17:06'!
version: version withPatches: patches for: package
	| snapshot ancestry |
	snapshot := MCPatcher
					apply: (self patchForPackage: package withPatches: patches snapshot: version snapshot)
					to: version snapshot.
	ancestry := MCWorkingAncestry new addAncestor: version info.
	^MCVersion
		package: version package
		info: (ancestry
				infoWithName: version info name
				message:	version info name,
							' patched for Spur by ',
							(CCodeGenerator shortMonticelloDescriptionForClass: self class),
							'\\' withCRs,
							version info message)
		snapshot: snapshot
		dependencies: {} "punt on computing dependencies; there are't any so far"
! !

!SpurBootstrapMonticelloPackagePatcher methodsFor: 'patching' stamp: 'eem 1/15/2014 17:18'!
versionFor: packageFileName
	^sourceDir
		readOnlyFileNamed: packageFileName
		do: [:fs|
			((MCVersionReader readerClassForFileNamed: fs fullName)
				on: fs fileName: fs fullName)
					version]! !

Object subclass: #SpurBootstrapNewspeakFilePatcher
	instanceVariableNames: 'source substitutions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Bootstrapping'!

!SpurBootstrapNewspeakFilePatcher methodsFor: 'patching' stamp: 'eem 2/26/2014 07:24'!
editTo: dest "<FileStream>"
	source reopen.
	[substitutions do:
		[:tuple|
		 [:start :end :substitution|
		  [source position + 1 < start] whileTrue:
			[dest nextPut: source next].
		   dest nextPutAll: (substitution
							copyReplaceAll: (String with: Character cr)
							with: (String with: Character lf)).
		   source skip: end - start + 1] valueWithArguments: tuple].
	 dest nextPutAll: source upToEnd]
		ensure: [source close]! !

!SpurBootstrapNewspeakFilePatcher methodsFor: 'parsing' stamp: 'eem 2/25/2014 10:27'!
findClassDeclarationFor: className in: ast "<ClassDeclarationAST>" "^(ClassDeclarationAST|nil)"
	^ast instanceSide nestedClasses
		detect: [:classDecl| classDecl name = className]
		ifNone: []! !

!SpurBootstrapNewspeakFilePatcher methodsFor: 'parsing' stamp: 'eem 2/25/2014 16:35'!
findMethodDeclarationFor: selector "<Symbol>" in: ast "<ClassDeclarationAST>" "^(MethodAST|nil)"
	ast instanceSide categories do:
		[:categoryAST|
		 categoryAST methods do:
			[:methodAST|
			methodAST pattern selector = selector ifTrue:
				[^methodAST]]].
	^nil! !

!SpurBootstrapNewspeakFilePatcher methodsFor: 'initialize-release' stamp: 'eem 2/25/2014 16:48'!
initialize
	substitutions := SortedCollection sortBlock: [:tupleA :tupleB | tupleA first <= tupleB first]! !

!SpurBootstrapNewspeakFilePatcher methodsFor: 'patching' stamp: 'eem 2/28/2014 14:19'!
newspeakSourceFor: method "<CompiledMethod>" selector: selector "<Symbol>"
	| source startIndex nextIndex |
	source := method getSourceFromFile asString allButFirst: method selector size - selector size.
	source first ~= selector first ifTrue:
		[source replaceFrom: 1 to: selector size with: selector startingAt: 1].

	"map comments to Newspeak format..."
	startIndex := 1.
	[(startIndex := source indexOf: $" startingAt: startIndex) > 0] whileTrue:
		[nextIndex := source indexOf: $" startingAt: startIndex + 1.
		 nextIndex < startIndex ifTrue:
			[self error: 'matching close comment not found'].
		 source := source copyReplaceFrom: nextIndex to: nextIndex with: ' *)'.
		 source := source copyReplaceFrom: startIndex to: startIndex with: '(* '.
		 startIndex := nextIndex + 5].

	"map assignments to Newspeak format"
	startIndex := 1.
	[(startIndex := source indexOfSubCollection: ':=' startingAt: startIndex) > 0] whileTrue:
		[nextIndex := startIndex.
		 [(source at: nextIndex - 1) isSeparator] whileTrue:
			[nextIndex := nextIndex - 1].
		 source := source copyReplaceFrom: nextIndex to: startIndex + 1 with: '::'.
		 startIndex := nextIndex + 1].

	"add the horror-show parentheses"
	startIndex := source indexOf: Character cr.
	source := source copyReplaceFrom: startIndex to: startIndex - 1 with: ' = ('.
	source := source, (String with: Character cr with: $) ).
	^source! !

!SpurBootstrapNewspeakFilePatcher methodsFor: 'parsing' stamp: 'eem 2/26/2014 07:23'!
parse
	| platform |
	platform := BlackMarket platform.
	^[(NewspeakParsing
			usingPlatform: platform
			grammar: (NewspeakGrammar parserLib: (CombinatorialParsing usingPlatform: platform))
			asts: (NewspeakASTs usingLib: platform)) Parser new compilationUnit parse: source]
		ensure: [source close]! !

!SpurBootstrapNewspeakFilePatcher methodsFor: 'patching' stamp: 'eem 2/25/2014 16:56'!
patch: className inDirectory: dir
	"SpurBootstrapNewspeakFilePatcher new
		patch: 'KernelForSqueak'
		inDirectory: '../newspeak'"
	| directory |
	directory := FileDirectory default directoryNamed: dir.
	source := directory oldFileNamed: className, '.ns3'.
	self substitute: self parse.
	self editTo: (directory forceNewFileNamed: className, '.ns3.patched')! !

!SpurBootstrapNewspeakFilePatcher methodsFor: 'patching' stamp: 'eem 2/25/2014 16:56'!
substitute: ast "<ClassDeclarationAST>"
															
	SpurBootstrap new prototypeClassNameMetaSelectorMethodDo:
		[:className :isMeta :selector :method| | source |
		 method primitive = 0 ifTrue: "all primitives are in the VMMirror package"
		 	[(self findClassDeclarationFor: className in: ast) ifNotNil:
				[:classDecl|
				 (self findMethodDeclarationFor: selector in: classDecl) ifNotNil:
					[:methodDecl|
					 source := self newspeakSourceFor: method selector: selector.
					 substitutions add: {methodDecl start. methodDecl end. source}]]]]! !

!Stream methodsFor: '*Cog-Benchmarks-Shootout-platform' stamp: ''!
nl
   self nextPut: Character lf! !

!Stream methodsFor: '*Cog-Benchmarks-Shootout-platform' stamp: ''!
print: number digits: decimalPlaces
   | precision rounded |
   decimalPlaces <= 0 ifTrue: [^ number rounded printString].
   precision := Utilities floatPrecisionForDecimalPlaces: decimalPlaces.
   rounded := number roundTo: precision.
   self nextPutAll: 
      ((rounded asScaledDecimal: decimalPlaces) printString copyUpTo: $s)! !

!Stream methodsFor: '*Cog-Benchmarks-Shootout-platform' stamp: ''!
print: number paddedTo: width
   self nextPutAll: (number printStringLength: width padded: false)! !

Object subclass: #SpurBootstrap
	instanceVariableNames: 'oldHeap newHeap oldHeapSize newHeapSize oldHeapNumObjs newHeapNumObjs map reverseMap classToIndex oldInterpreter lastClassTablePage literalMap methodClasses installedPrototypes sizeSym rehashSym classMetaclass'
	classVariableNames: 'ImageHeaderFlags ImageName ImageScreenSize TransformedImage'
	poolDictionaries: 'VMObjectIndices'
	category: 'Cog-Bootstrapping'!

!SpurBootstrap commentStamp: 'eem 9/11/2013 05:45' prior: 0!
SpurBootstrap bootstraps an image in SpurMemoryManager format from a Squeak V3 + closures format.

e.g.
	(SpurBootstrap32 new on: '/Users/eliot/Cog/startreader.image')
		transform;
		launch

Bootstrap issues:
- should it implement a deterministic Symbol identityHash? This means set a Symbol's identityHash at instance creation time
  based on its string hash so that e.g. MethodDIctionary instances have a deterministic order and don't need to be rehashed on load.
- should it collapse ContextPart and MethodContext down onto Context (and perhaps eliminate BlockContext)?

Instance Variables
	classToIndex:			<Dictionary>
	lastClassTablePage:	<Integer>
	map:					<Dictionary>
	methodClasses:		<Set>
	newHeap:				<SpurMemoryManager>
	oldHeap:				<NewObjectMemory>
	oldInterpreter:			<StackInterpreterSimulator>
	reverseMap:			<Dictionary>
	symbolMap:				<Dictionary>

classToIndex
	- oldClass to new classIndex map

lastClassTablePage
	- oop in newHeap of last classTable page.  U<sed in validation to filter-out class table.

methodClasses
	- cache of methodClassAssociations for classes in which modified methods are installed

map
	- oldObject to newObject map

newHeap
	- the output, bootstrapped image

oldHeap
	- the input, image

oldInterpreter
	- the interpreter associated with oldHeap, needed for a hack to grab WeakArray

reverseMap
	- newObject to oldObject map

symbolMap
	- symbol toi symbol oop in oldHeap, used to map prototype methdos to methods in oldHeap!

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 3/10/2014 19:04'!
BehaviorPROTOTYPEallInstances
	"Answer all instances of the receiver."
	<primitive: 177>
	"The primitive can fail because memory is low.  If so, fall back on the old
	 enumeration code, which gives the system a chance to GC and/or grow.
	 Because aBlock might change the class of inst (for example, using become:),
	 it is essential to compute next before aBlock value: inst."
	| inst insts next |
	insts := WriteStream on: (Array new: 64).
	inst := self someInstance.
	[inst == nil] whileFalse:
		[next := inst nextInstance.
		 (inst == insts or: [inst == insts originalContents]) ifFalse: [insts nextPut: inst].
		 inst := next].
	^insts contents! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 3/10/2014 18:42'!
BehaviorPROTOTYPEallInstancesDo: aBlock
	"Evaluate aBlock with each of the current instances of the receiver."
	| instances inst next |
	instances := self allInstancesOrNil.
	instances ifNotNil:
		[instances do: aBlock.
		 ^self].
	"allInstancesOrNil can fail because memory is low.  If so, fall back on the old
	 enumeration code.  Because aBlock might change the class of inst (for example,
	 using become:), it is essential to compute next before aBlock value: inst."
	inst := self someInstance.
	[inst == nil] whileFalse:
		[next := inst nextInstance.
		 aBlock value: inst.
		 inst := next]! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 3/10/2014 19:04'!
BehaviorPROTOTYPEallInstancesOrNil
	"Answer all instances of the receiver, or nil if the primitive
	 fails, which it may be due to being out of memory."
	<primitive: 177>
	^nil! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 2/26/2014 07:51'!
BehaviorPROTOTYPEbasicNew
	"Primitive. Answer an instance of the receiver (which is a class) with no 
	 indexable variables. Fail if the class is indexable. Essential. See Object 
	 documentation whatIsAPrimitive.
	
	 If the primitive fails because space is low then the scavenger
	 will run before the method is activated.  Check arguments and
	 retry via handleFailingBasicNew if they're OK."

	<primitive: 70>
	self isVariable ifTrue: [^self basicNew: 0].
	"space must have been low, and the scavenger must have run.
	 retry after the scavenge."
	^self handleFailingBasicNew! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 2/26/2014 07:52'!
BehaviorPROTOTYPEbasicNew: sizeRequested 
	"Primitive. Answer an instance of this class with the number of indexable
	 variables specified by the argument, sizeRequested.  Fail if this class is not
	 indexable or if the argument is not a positive Integer, or if there is not
	 enough memory available. Essential. See Object documentation whatIsAPrimitive.
	
	 If the primitive fails because space is low then the scavenger will run before the
	 method is activated.  Check args and retry via handleFailingBasicNew: if they're OK."

	<primitive: 71>
	self isVariable ifFalse:
		[self error: self printString, ' cannot have variable sized instances'].
	(sizeRequested isInteger and: [sizeRequested >= 0]) ifTrue:
		["arg okay; space must have been low, and the scavenger must have run.
		  retry after the scavenge"
		^self handleFailingBasicNew: sizeRequested].
	self primitiveFailed! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 3/12/2014 10:32'!
BehaviorPROTOTYPEbyteSizeOfInstance
	"Answer the total memory size of an instance of the receiver."

	<primitive: 181>
	self isVariable ifTrue:
		[^self byteSizeOfInstanceOfSize: 0].
	self primitiveFailed! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 3/12/2014 10:32'!
BehaviorPROTOTYPEbyteSizeOfInstanceOfSize: basicSize
	"Answer the total memory size of an instance of the receiver
	 with the given number of indexable instance variables."

	<primitive: 181>
	self isVariable ifFalse:
		[basicSize = 0 ifTrue:
			[^self byteSizeOfInstance]].
	self primitiveFailed! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 2/25/2014 11:25'!
BehaviorPROTOTYPEelementSize
	"Answer the size in bytes of an element in the receiver.  The formats are
			0	= 0 sized objects (UndefinedObject True False et al)
			1	= non-indexable objects with inst vars (Point et al)
			2	= indexable objects with no inst vars (Array et al)
			3	= indexable objects with inst vars (MethodContext AdditionalMethodState et al)
			4	= weak indexable objects with inst vars (WeakArray et al)
			5	= weak non-indexable objects with inst vars (ephemerons) (Ephemeron)
			6	= unused
			7	= immediates (SmallInteger, Character)
			8	= unused
			9	= 64-bit indexable
		10-11	= 32-bit indexable (Bitmap)
		12-15	= 16-bit indexable
		16-23	= 8-bit indexable
		24-31	= compiled methods (CompiledMethod)"
	| instSpec |
	instSpec := self instSpec.
	instSpec < 9 ifTrue: [^Smalltalk wordSize].
	instSpec >= 16 ifTrue: [^1].
	instSpec >= 12 ifTrue: [^2].
	instSpec >= 10 ifTrue: [^4].
	^8! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 2/26/2014 07:56'!
BehaviorPROTOTYPEhandleFailingBasicNew
	"handleFailingBasicNew gets sent after basicNew has failed and allowed
	 a scavenging garbage collection to occur.  The scavenging collection
	 will have happened as the VM is activating the (failing) basicNew.  If
	 handleFailingBasicNew fails then the scavenge failed to reclaim sufficient
	 space and a global garbage collection is required.  Retry after garbage
	 collecting and growing memory if necessary.

	 Primitive. Answer an instance of this class with the number of indexable
	 variables specified by the argument, sizeRequested.  Fail if this class is not
	 indexable or if the argument is not a positive Integer, or if there is not
	 enough memory available. Essential. See Object documentation whatIsAPrimitive."

	<primitive: 70>
	Smalltalk garbageCollect < 1048576 ifTrue:
		[Smalltalk growMemoryByAtLeast: 1048576].
	^self handleFailingFailingBasicNew "retry after global garbage collect"! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 3/12/2014 10:32'!
BehaviorPROTOTYPEhandleFailingBasicNew: sizeRequested
	"handleFailingBasicNew: gets sent after basicNew: has failed and allowed
	 a scavenging garbage collection to occur.  The scavenging collection
	 will have happened as the VM is activating the (failing) basicNew:.  If
	 handleFailingBasicNew: fails then the scavenge failed to reclaim sufficient
	 space and a global garbage collection is required.  Retry after garbage
	 collecting and growing memory if necessary.

	 Primitive. Answer an instance of this class with the number of indexable
	 variables specified by the argument, sizeRequested.  Fail if this class is not
	 indexable or if the argument is not a positive Integer, or if there is not
	 enough memory available. Essential. See Object documentation whatIsAPrimitive."

	<primitive: 71>
	| bytesRequested |
	bytesRequested := self byteSizeOfInstanceOfSize: sizeRequested.
	Smalltalk garbageCollect < bytesRequested ifTrue:
		[Smalltalk growMemoryByAtLeast: bytesRequested].
	"retry after global garbage collect and possible grow"
	^self handleFailingFailingBasicNew: sizeRequested! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 2/26/2014 08:00'!
BehaviorPROTOTYPEhandleFailingFailingBasicNew
	"This basicNew gets sent after handleFailingBasicNew: has done a full
	 garbage collection and possibly grown memory.  If this basicNew fails
	 then the system really is low on space, so raise the OutOfMemory signal.

	 Primitive. Answer an instance of this class with the number of indexable
	 variables specified by the argument, sizeRequested.  Fail if this class is not
	 indexable or if the argument is not a positive Integer, or if there is not
	 enough memory available. Essential. See Object documentation whatIsAPrimitive."

	<primitive: 70>
	"space must be low"
	OutOfMemory signal.
	^self basicNew  "retry if user proceeds"! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 2/26/2014 08:01'!
BehaviorPROTOTYPEhandleFailingFailingBasicNew: sizeRequested
	"This basicNew: gets sent after handleFailingBasicNew: has done a full
	 garbage collection and possibly grown memory.  If this basicNew: fails
	 then the system really is low on space, so raise the OutOfMemory signal.

	 Primitive. Answer an instance of this class with the number of indexable
	 variables specified by the argument, sizeRequested.  Fail if this class is not
	 indexable or if the argument is not a positive Integer, or if there is not
	 enough memory available. Essential. See Object documentation whatIsAPrimitive."

	<primitive: 71>
	"space must be low."
	OutOfMemory signal.
	^self basicNew: sizeRequested  "retry if user proceeds"! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 2/25/2014 11:32'!
BehaviorPROTOTYPEidentityHash
	"Answer a SmallInteger whose value is related to the receiver's identity.
	 Behavior implements identityHash to allow the VM to use an object representation which
	 does not include a direct reference to an object's class in an object.  If the VM is using
	 this implementation then classes are held in a class table and instances contain the index
	 of their class in the table.  A class's class table index is its identityHash so that an instance
	 can be created without searching the table for a class's index.  The VM uses this primitive
	 to enter the class into the class table, assigning its identityHash with an as yet unused
	 class table index. If this primitive fails it means that the class table is full.  In Spur as of
	 2014 there are 22 bits of classTable index and 22 bits of identityHash per object.

	 Primitive. Essential. Do not override. See Object documentation whatIsAPrimitive."

	<primitive: 175>
	self primitiveFailed! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 9/5/2013 15:53'!
BehaviorPROTOTYPEinstSize
	"Answer the number of named instance variables
	(as opposed to indexed variables) of the receiver.
	 Above Cog Spur the class format is
		<5 bits inst spec><16 bits inst size>"
	^format bitAnd: 16rFFFF! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 2/25/2014 11:24'!
BehaviorPROTOTYPEinstSpec
	"Answer the instance specification part of the format that defines what kind of object
	 an instance of the receiver is.  The formats are
			0	= 0 sized objects (UndefinedObject True False et al)
			1	= non-indexable objects with inst vars (Point et al)
			2	= indexable objects with no inst vars (Array et al)
			3	= indexable objects with inst vars (MethodContext AdditionalMethodState et al)
			4	= weak indexable objects with inst vars (WeakArray et al)
			5	= weak non-indexable objects with inst vars (ephemerons) (Ephemeron)
			6	= unused
			7	= immediates (SmallInteger, Character)
			8	= unused
			9	= 64-bit indexable
		10-11	= 32-bit indexable (Bitmap)
		12-15	= 16-bit indexable
		16-23	= 8-bit indexable
		24-31	= compiled methods (CompiledMethod)"
	^(format bitShift: -16) bitAnd: 16r1F! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 2/25/2014 11:24'!
BehaviorPROTOTYPEisBits
	"Answer whether the receiver contains just bits (not pointers).
	 Above Cog Spur the class format is
		<5 bits inst spec><16 bits inst size>
	 where the 5-bit inst spec is
			0	= 0 sized objects (UndefinedObject True False et al)
			1	= non-indexable objects with inst vars (Point et al)
			2	= indexable objects with no inst vars (Array et al)
			3	= indexable objects with inst vars (MethodContext AdditionalMethodState et al)
			4	= weak indexable objects with inst vars (WeakArray et al)
			5	= weak non-indexable objects with inst vars (ephemerons) (Ephemeron)
			6	= unused
			7	= immediates (SmallInteger, Character)
			8	= unused
			9	= 64-bit indexable
		10-11	= 32-bit indexable (Bitmap)
		12-15	= 16-bit indexable
		16-23	= 8-bit indexable
		24-31	= compiled methods (CompiledMethod)"
	^self instSpec >= 7! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 2/25/2014 11:24'!
BehaviorPROTOTYPEisBytes
	"Answer whether the receiver has 8-bit instance variables.
	 Above Cog Spur the class format is
		<5 bits inst spec><16 bits inst size>
	 where the 5-bit inst spec is
			0	= 0 sized objects (UndefinedObject True False et al)
			1	= non-indexable objects with inst vars (Point et al)
			2	= indexable objects with no inst vars (Array et al)
			3	= indexable objects with inst vars (MethodContext AdditionalMethodState et al)
			4	= weak indexable objects with inst vars (WeakArray et al)
			5	= weak non-indexable objects with inst vars (ephemerons) (Ephemeron)
			6	= unused
			7	= immediates (SmallInteger, Character)
			8	= unused
			9	= 64-bit indexable
		10-11	= 32-bit indexable (Bitmap)
		12-15	= 16-bit indexable
		16-23	= 8-bit indexable
		24-31	= compiled methods (CompiledMethod)"
	^self instSpec >= 16! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 3/3/2014 17:23'!
BehaviorPROTOTYPEisEphemeronClass
	"Answer whether the receiver has ephemeral instance variables.  The garbage collector will
	 fire (queue for finalization) any ephemeron whose first instance variable is not referenced
	 other than from the transitive closure of references from ephemerons. Hence referring to
	 an object from the first inst var of an ephemeron will cause the ephemeron to fire when
	 the rest of the system does not refer to the object and that object is ready to be collected.
	 Since references from the remaining inst vars of an ephemeron will not prevent the ephemeron
	 from firing, ephemerons may act as the associations in weak dictionaries such that the value
	 (e.g. properties attached to the key) will not prevent firing when the key is no longer referenced
	 other than from ephemerons.  Ephemerons can therefore be used to implement instance-based
	 pre-mortem finalization."
	^self instSpec = 5! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 3/3/2014 17:23'!
BehaviorPROTOTYPEisImmediateClass
	"Answer whether the receiver has immediate instances.  Immediate instances
	 store their value in their object pointer, not in an object body.  Hence immediates
	 take no space and are immutable.  The immediates are distinguished by tag bits
	 in the pointer. They include SmallIntegers and Characters.  Hence in the 32-bit
	 system SmallIntegers are 31-bit signed integers and Characters are 30-bit
	 unsigned character codes."
	^self instSpec = 7! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 3/1/2014 10:19'!
BehaviorPROTOTYPEisVariable
	"Answer whether the receiver has indexable variables.
	 Above Cog Spur the class format is
		<5 bits inst spec><16 bits inst size>
	 where the 5-bit inst spec is
			0	= 0 sized objects (UndefinedObject True False et al)
			1	= non-indexable objects with inst vars (Point et al)
			2	= indexable objects with no inst vars (Array et al)
			3	= indexable objects with inst vars (MethodContext AdditionalMethodState et al)
			4	= weak indexable objects with inst vars (WeakArray et al)
			5	= weak non-indexable objects with inst vars (ephemerons) (Ephemeron)
			6	= unused
			7	= immediates (SmallInteger, Character)
			8	= unused
			9	= 64-bit indexable
		10-11	= 32-bit indexable (Bitmap)
		12-15	= 16-bit indexable
		16-23	= 8-bit indexable
		24-31	= compiled methods (CompiledMethod)"
	| instSpec |
	instSpec := self instSpec.
	^instSpec >= 2 and: [instSpec <= 4 or: [instSpec >= 9]]! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 3/3/2014 17:23'!
BehaviorPROTOTYPEkindOfSubclass
	"Answer a String that is the keyword that describes the receiver's kind of subclass,
	 either a regular subclass, a variableSubclass, a variableByteSubclass,
	 a variableWordSubclass, a weakSubclass, an ephemeronSubclass or an immediateSubclass.
	 c.f. typeOfClass"
	^self isVariable
		ifTrue:
			[self isBits
				ifTrue:
					[self isBytes
						ifTrue: [' variableByteSubclass: ']
						ifFalse: [' variableWordSubclass: ']]
				ifFalse:
					[self isWeak
						ifTrue: [' weakSubclass: ']
						ifFalse: [' variableSubclass: ']]]
		ifFalse:
			[self isImmediateClass
				ifTrue: [' immediateSubclass: ']
				ifFalse:
					[self isEphemeronClass
						ifTrue: [' ephemeronSubclass: ']
						ifFalse: [' subclass: ']]]! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 1/29/2014 16:49'!
BehaviorPROTOTYPEshouldNotBeRedefined
	"Answer if the receiver should not be redefined.
	 The assumption is that classes in Smalltalk specialObjects and 
	 instance-specific Behaviors should not be redefined"

	^(Smalltalk specialObjectsArray
		identityIndexOf: self
		ifAbsent: [(self isKindOf: self) ifTrue: [1] ifFalse: [0]]) ~= 0! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 3/3/2014 17:23'!
BehaviorPROTOTYPEtypeOfClass
	"Answer a symbol uniquely describing the type of the receiver. c.f. kindOfSubclass"
	self isBytes ifTrue:
		[^self instSpec = CompiledMethod instSpec
			ifTrue: [#compiledMethod] "Very special!!"
			ifFalse: [#bytes]].
	(self isWords and: [self isPointers not]) ifTrue:
		[^self instSpec = SmallInteger instSpec
			ifTrue: [#immediate] "Very special!!"
			ifFalse: [#words]].
	self isWeak ifTrue: [^#weak].
	self isVariable ifTrue: [^#variable].
	self isEphemeronClass ifTrue: [^#ephemeron].
	^#normal! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 10/11/2013 12:55'!
CharacterPROTOTYPEDollarEquals: aCharacter 
	"Primitive. Answer if the receiver and the argument are the
	 same object (have the same object pointer). Optional. See
	 Object documentation whatIsAPrimitive."
	<primitive: 110>
	^self == aCharacter! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 2/5/2014 12:57'!
CharacterPROTOTYPEasInteger
	"Answer the receiver's character code."
	<primitive: 171>
	^self primitiveFailed! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 2/5/2014 12:57'!
CharacterPROTOTYPEasciiValue
	"Answer the receiver's character code.
	 This will be ascii for characters with value <= 127,
	 and Unicode for those with higher values."
	<primitive: 171>
	^self primitiveFailed! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 2/5/2014 12:52'!
CharacterPROTOTYPEclone
	"Answer the receiver, because Characters are unique."
	^self! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 2/5/2014 12:52'!
CharacterPROTOTYPEcopy
	"Answer the receiver, because Characters are unique."
	^self! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 2/5/2014 12:52'!
CharacterPROTOTYPEdeepCopy
	"Answer the receiver, because Characters are unique."
	^self! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 2/5/2014 12:55'!
CharacterPROTOTYPEhash
	"Hash is reimplemented because = is implemented.
	 Answer the receiver's character code."
	<primitive: 171>
	^self primitiveFailed! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 2/5/2014 12:56'!
CharacterPROTOTYPEidentityHash
	"Answer the receiver's character code."
	<primitive: 171>
	^self primitiveFailed! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 2/5/2014 12:53'!
CharacterPROTOTYPEshallowCopy
	"Answer the receiver, because Characters are unique."
	^self! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 2/5/2014 12:53'!
CharacterPROTOTYPEveryDeepCopyWith: deepCopier
	"Answer the receiver, because Characters are unique."
	^self! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 9/24/2013 23:43'!
CharacterclassPROTOTYPEdigitValue: x 
	"Answer the Character whose digit value is x. For example,
	 answer $9 for x=9, $0 for x=0, $A for x=10, $Z for x=35."

	| n |
	n := x asInteger.
	^self value: (n < 10 ifTrue: [n + 48] ifFalse: [n + 55])! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 2/5/2014 12:49'!
CharacterclassPROTOTYPEvalue: anInteger
	"Answer the Character whose value is anInteger."
	<primitive: 170>
	^self primitiveFailed! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 3/3/2014 18:17'!
ClassBuilderPROTOTYPEcomputeFormat: type instSize: newInstSize forSuper: newSuper ccIndex: ccIndex
	"Compute the new format for making oldClass a subclass of newSuper.
	 Answer the format or nil if there is any problem."
	| instSize isVar isWords isPointers isWeak |
	type == #compiledMethod ifTrue:
		[newInstSize > 0 ifTrue:
			[self error: 'A compiled method class cannot have named instance variables'.
			^nil].
		^CompiledMethod format].
	instSize := newInstSize + (newSuper ifNil:[0] ifNotNil:[newSuper instSize]).
	instSize > 65535 ifTrue:
		[self error: 'Class has too many instance variables (', instSize printString,')'.
		^nil].
	type == #normal ifTrue:[isVar := isWeak := false. isWords := isPointers := true].
	type == #bytes ifTrue:[isVar := true. isWords := isPointers := isWeak := false].
	type == #words ifTrue:[isVar := isWords := true. isPointers := isWeak := false].
	type == #variable ifTrue:[isVar := isPointers := isWords := true. isWeak := false].
	type == #weak ifTrue:[isVar := isWeak := isWords := isPointers := true].
	type == #ephemeron ifTrue:[isVar := false. isWeak := isWords := isPointers := true].
	type == #immediate ifTrue:[isVar := isWeak := isPointers := false. isWords := true].
	(isPointers not and: [instSize > 0]) ifTrue:
		[self error: 'A non-pointer class cannot have named instance variables'.
		^nil].
	^self format: instSize variable: isVar words: isWords pointers: isPointers weak: isWeak! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 3/3/2014 18:34'!
ClassBuilderPROTOTYPEformat: nInstVars variable: isVar words: isWords pointers: isPointers weak: isWeak
	"Compute the format for the given instance specfication.
	 Above Cog Spur the class format is
		<5 bits inst spec><16 bits inst size>
	 where the 5-bit inst spec is
			0	= 0 sized objects (UndefinedObject True False et al)
			1	= non-indexable objects with inst vars (Point et al)
			2	= indexable objects with no inst vars (Array et al)
			3	= indexable objects with inst vars (MethodContext AdditionalMethodState et al)
			4	= weak indexable objects with inst vars (WeakArray et al)
			5	= weak non-indexable objects with inst vars (ephemerons) (Ephemeron)
			6	= unused
			7	= immediates (SmallInteger, Character)
			8	= unused
			9	= reserved for 64-bit indexable
		10-11	= 32-bit indexable (Bitmap)
		12-15	= 16-bit indexable
		16-23	= 8-bit indexable
		24-31	= compiled methods (CompiledMethod)"
	| instSpec |
	instSpec := isWeak
					ifTrue:
						[isVar
							ifTrue: [4]
							ifFalse: [5]]
					ifFalse:
						[isPointers
							ifTrue:
								[isVar
									ifTrue: [nInstVars > 0 ifTrue: [3] ifFalse: [2]]
									ifFalse: [nInstVars > 0 ifTrue: [1] ifFalse: [0]]]
							ifFalse:
								[isVar
									ifTrue: [isWords ifTrue: [12] ifFalse: [16]]
									ifFalse: [7]]].
	^(instSpec bitShift: 16) + nInstVars! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 3/3/2014 17:09'!
ClassBuilderPROTOTYPEsuperclass: aClass
	immediateSubclass: t instanceVariableNames: f 
	classVariableNames: d poolDictionaries: s category: cat
	"This is the standard initialization message for creating a
	 new immediate class as a subclass of an existing class."
	| env |
	aClass instSize > 0
		ifTrue: [^self error: 'cannot make an immediate subclass of a class with named fields'].
	aClass isVariable
		ifTrue: [^self error: 'cannot make an immediate subclass of a class with indexed instance variables'].
	aClass isPointers
		ifFalse: [^self error: 'cannot make an immediate subclass of a class without pointer fields'].
	"Cope with pre-environment and environment versions. Simplify asap."
	env := (Smalltalk classNamed: #EnvironmentRequest)
				ifNil: [aClass environment]
				ifNotNil: [:erc| erc signal ifNil: [aClass environment]].
	^self 
		name: t
		inEnvironment: env
		subclassOf: aClass
		type: #immediate
		instanceVariableNames: f
		classVariableNames: d
		poolDictionaries: s
		category: cat! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 5/31/2014 07:32'!
ClassBuilderPROTOTYPEupdate: oldClass to: newClass
	"Convert oldClass, all its instances and possibly its meta class into newClass,
	 instances of newClass and possibly its meta class. The process is surprisingly
	 simple in its implementation and surprisingly complex in its nuances and potentially
	 bad side effects.
	 We can rely on two assumptions (which are critical):
		#1: The method #updateInstancesFrom: will not create any lasting pointers to
			 'old' instances ('old' is quote on quote since #updateInstancesFrom: will do
			 a become of the old vs. the new instances and therefore it will not create
			 pointers to *new* instances before the #become: which are *old* afterwards)
		#2: The non-preemptive execution of the critical piece of code guarantees that
			 nobody can get a hold by 'other means' (such as process interruption and
			 reflection) on the old instances.
	 Given the above two, we know that after #updateInstancesFrom: there are no pointers
	 to any old instances. After the forwarding become there will be no pointers to the old
	 class or meta class either.
	 Andreas Raab, 2/27/2003 23:42"
	| meta |
	meta := oldClass isMeta.
	"Note: Everything from here on will run without the ability to get interrupted
	to prevent any other process to create new instances of the old class."
	["Note: The following removal may look somewhat obscure and needs an explanation.
	  When we mutate the class hierarchy we create new classes for any existing subclass.
	  So it may look as if we don't have to remove the old class from its superclass. However,
	  at the top of the hierarchy (the first class we reshape) that superclass itself is not newly
	  created so therefore it will hold both the oldClass and newClass in its (obsolete or not)
	  subclasses. Since the #become: below will transparently replace the pointers to oldClass
	  with newClass the superclass would have newClass in its subclasses TWICE. With rather
	  unclear effects if we consider that we may convert the meta-class hierarchy itself (which
	  is derived from the non-meta class hierarchy).
	  Due to this problem ALL classes are removed from their superclass just prior to converting
	  them. Here, breaking the superclass/subclass invariant really doesn't matter since we will
	  effectively remove the oldClass (becomeForward:) just a few lines below."

		oldClass superclass removeSubclass: oldClass.
		oldClass superclass removeObsoleteSubclass: oldClass.

		"make sure that the VM cache is clean"
		oldClass methodDict do: [:cm | cm flushCache].
		
		"Convert the instances of oldClass into instances of newClass"
		newClass updateInstancesFrom: oldClass.

		meta
			ifTrue:
				[oldClass becomeForward: newClass.
				 oldClass updateMethodBindingsTo: oldClass binding]
			ifFalse:
				[{oldClass. oldClass class} elementsForwardIdentityTo: {newClass. newClass class}.
				 oldClass updateMethodBindingsTo: oldClass binding.
				 oldClass class updateMethodBindingsTo: oldClass class binding].

		"eem 5/31/2014 07:22 At this point there used to be a garbage collect whose purpose was
		 to ensure no old instances existed after the becomeForward:.  Without the GC it was possible
		 to resurrect old instances using e.g. allInstancesDo:.  This was because the becomeForward:
		 updated references from the old objects to new objects but didn't destroy the old objects.
		 But as of late 2013/early 2014 becomeForward: has been modified to free all the old objects."]
			valueUnpreemptively! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 5/27/2014 11:08'!
ClassDescriptionPROTOTYPEupdateMethodBindingsTo: aBinding
	"ClassBuilder support for maintaining valid method bindings."
	methodDict do: [:method| method methodClassAssociation: aBinding]! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 3/3/2014 13:37'!
ClassPROTOTYPEimmediateSubclass: t instanceVariableNames: f classVariableNames: d poolDictionaries: s category: cat 
	"This is the standard initialization message for creating a new
	 immediate class as a subclass of an existing class (the receiver)."
	^ClassBuilder new
		superclass: self
		immediateSubclass: t
		instanceVariableNames: f
		classVariableNames: d
		poolDictionaries: s
		category: cat! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 3/10/2014 19:04'!
MethodContextPROTOTYPEallInstances
	"Answer all instances of the receiver."
	<primitive: 177>
	"The primitive can fail because memory is low.  If so, fall back on the old
	 enumeration code, which gives the system a chance to GC and/or grow.
	 Because aBlock might change the class of inst (for example, using become:),
	 it is essential to compute next before aBlock value: inst.
	 Only count until thisContext since this context has been created only to
	 compute the existing instances."
	| inst insts next |
	insts := WriteStream on: (Array new: 64).
	inst := self someInstance.
	[inst == thisContext or: [inst == nil]] whileFalse:
		[next := inst nextInstance.
		 insts nextPut: inst.
		 inst := next].
	^insts contents! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 3/10/2014 18:57'!
MethodContextPROTOTYPEallInstancesDo: aBlock
	"Evaluate aBlock with each of the current instances of the receiver."
	| instances inst next |
	instances := self allInstancesOrNil.
	instances ifNotNil:
		[instances do: aBlock.
		 ^self].
	"allInstancesOrNil can fail because memory is low.  If so, fall back on the old
	 enumeration code.  Because aBlock might change the class of inst (for example,
	 using become:), it is essential to compute next before aBlock value: inst.
	 Only count until thisContext since evaluation of aBlock will create new contexts."
	inst := self someInstance.
	[inst == thisContext or: [inst == nil]] whileFalse:
		[next := inst nextInstance.
		 aBlock value: inst.
		 inst := next]! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 9/6/2013 14:31'!
ProtoObjectPROTOTYPEscaledIdentityHash
	"For identityHash values returned by primitive 75, answer
	 such values times 2^8.  Otherwise, match the existing
	 identityHash implementation"

	^self identityHash * 256 "bitShift: 8"! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 9/5/2013 16:49'!
SmallIntegerPROTOTYPEasCharacter
	<primitive: 170>
	^self primitiveFailed! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 3/5/2014 14:53'!
SmalltalkImagePROTOTYPEcompactClassesArray
	"Smalltalk compactClassesArray"
	"Backward-compatibility support.  Spur does not have compact classes."
	^{}! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 3/19/2014 13:51'!
SmalltalkImagePROTOTYPEgrowMemoryByAtLeast: numBytes
	"Grow memory by at least the requested number of bytes.
	 Primitive.  Essential. Fail if no memory is available."
	<primitive: 180>
	(numBytes isInteger and: [numBytes > 0]) ifTrue:
		[OutOfMemory signal].
	^self primitiveFailed! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 9/5/2013 17:10'!
SmalltalkImagePROTOTYPEmaxIdentityHash
	"Answer the maximum identityHash value supported by the VM."
	<primitive: 176>
	^self primitiveFailed! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 9/21/2013 07:39'!
SmalltalkImagePROTOTYPEsetGCParameters
	"Adjust the VM's default GC parameters to avoid too much tenuring.
	 Maybe this should be left to the VM?"

	| proportion edenSize survivorSize averageObjectSize numObjects |
	proportion := 0.9. "tenure when 90% of pastSpace is full"
	edenSize := SmalltalkImage current vmParameterAt: 44.
	survivorSize := edenSize / 5.0. "David's paper uses 140Kb eden + 2 x 28kb survivor spaces; Spur uses the same ratios :-)"
	averageObjectSize := 8 * self wordSize. "a good approximation"
	numObjects := (proportion * survivorSize / averageObjectSize) rounded.
	SmalltalkImage current vmParameterAt: 6 put: numObjects  "tenure when more than this many objects survive the GC"! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 3/12/2014 10:31'!
SpaceTallyPROTOTYPEspaceForInstancesOf: aClass
	"Answer a pair of the number of bytes consumed by all instances of the
	 given class, including their object headers, and the number of instances."

	| instances total |
	instances := aClass allInstances.
	instances isEmpty ifTrue: [^#(0 0)].
	total := 0.
	aClass isVariable
		ifTrue:
			[instances do:
				[:i| total := total + (aClass byteSizeOfInstanceOfSize: i basicSize)]]
		ifFalse:
			[total := instances size * aClass byteSizeOfInstance].
	^{ total. instances size }! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 3/19/2014 14:08'!
SystemDictionaryPROTOTYPEgrowMemoryByAtLeast: numBytes
	"Grow memory by at least the requested number of bytes.
	 Primitive.  Fail if no memory is available.  Essential."
	<primitive: 180>
	^(numBytes isInteger and: [numBytes > 0])
		ifTrue: [OutOfMemory signal]
		ifFalse: [self primitiveFailed]! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 9/5/2013 17:10'!
SystemDictionaryPROTOTYPEmaxIdentityHash
	"Answer the maximum identityHash value supported by the VM."
	<primitive: 176>
	^self primitiveFailed! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 9/21/2013 07:39'!
SystemDictionaryPROTOTYPEsetGCParameters
	"Adjust the VM's default GC parameters to avoid too much tenuring.
	 Maybe this should be left to the VM?"

	| proportion edenSize survivorSize averageObjectSize numObjects |
	proportion := 0.9. "tenure when 90% of pastSpace is full"
	edenSize := SmalltalkImage current vmParameterAt: 44.
	survivorSize := edenSize / 5.0. "David's paper uses 140Kb eden + 2 x 28kb survivor spaces; Spur uses the same ratios :-)"
	averageObjectSize := 8 * self wordSize. "a good approximation"
	numObjects := (proportion * survivorSize / averageObjectSize) rounded.
	SmalltalkImage current vmParameterAt: 6 put: numObjects  "tenure when more than this many objects survive the GC"! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 3/10/2014 19:05'!
SystemNavigationPROTOTYPEallObjects
	"Answer an Array of all objects in the system.  Fail if
	 there isn't enough memory to instantiate the result."
	<primitive: 178>
	^self primitiveFailed! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 3/11/2014 13:59'!
SystemNavigationPROTOTYPEallObjectsDo: aBlock 
	"Evaluate the argument, aBlock, for each object in the system, excluding immediates
	 such as SmallInteger and Character."
	self allObjectsOrNil
		ifNotNil: [:allObjects| allObjects do: aBlock]
		ifNil:
			["Fall back on the old single object primitive code.  With closures, this needs
			  to use an end marker (lastObject) since activation of the block will create
			  new contexts and cause an infinite loop.  The lastObject must be created
			  before calling someObject, so that the VM can settle the enumeration (e.g.
			  by flushing new space) as a side effect of  someObject"
			| object lastObject |
			lastObject := Object new.
			object := self someObject.
			[lastObject == object or: [0 == object]] whileFalse:
				[aBlock value: object.
				 object := object nextObject]]! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 3/11/2014 13:56'!
SystemNavigationPROTOTYPEallObjectsOrNil
	"Answer an Array of all objects in the system.  Fail if there isn't
	 enough memory to instantiate the result and answer nil."
	<primitive: 178>
	^nil! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 2/6/2014 14:38'!
WideStringPROTOTYPEat: index
	"Answer the Character stored in the field of the receiver indexed by the
	 argument.  Primitive.  Fail if the index argument is not an Integer or is out
	 of bounds.  Essential.  See Object documentation whatIsAPrimitive."

	<primitive: 63>
	^index isInteger
		ifTrue:
			[self errorSubscriptBounds: index]
		ifFalse:
			[index isNumber
				ifTrue: [self at: index asInteger]
				ifFalse: [self errorNonIntegerIndex]]! !

!SpurBootstrap class methodsFor: 'method prototypes' stamp: 'eem 2/6/2014 14:40'!
WideStringPROTOTYPEat: index put: aCharacter
	"Store the Character into the field of the receiver indicated by the index.
	 Primitive.  Fail if the index is not an Integer or is out of bounds, or if the
	 argument is not a Character.  Essential.  See Object documentation whatIsAPrimitive."

	<primitive: 64>
	^aCharacter isCharacter
		ifTrue:
			[index isInteger
				ifTrue: [self errorSubscriptBounds: index]
				ifFalse: [self errorNonIntegerIndex]]
		ifFalse:
			[self errorImproperStore]! !

!SpurBootstrap class methodsFor: 'utilities' stamp: 'eem 2/28/2014 17:00'!
bootstrapImage: imageFileBaseName
	"SpurBootstrap bootstrapImage: '/Users/eliot/Squeak/Squeak4.5/Squeak4.5-13680'"
	| imageFormat |
	imageFormat := ImageFormat fromFile: imageFileBaseName, '.image'.
	imageFormat requiresClosureSupport ifFalse:
		[self error: 'Can''t bootstrap this image since Spur assumes closure support.'].
	imageFormat requiresSpurSupport ifTrue:
		[self error: 'This image is already in Spur format.'].
	imageFormat is32Bit ifTrue:
		[^SpurBootstrap32 new bootstrapImage: imageFileBaseName].
	self error: '64-bit support and 64-bit generation as-yet-unimplemented'! !

!SpurBootstrap class methodsFor: 'tests' stamp: 'eem 3/3/2014 18:39'!
testComputeFormat
	"self testComputeFormat"
	#(	(normal 0)
		(bytes 16)
		(words 12)
		(variable 2)
		(weak 4)
		(ephemeron 5)
		(immediate 7)
		(compiledMethod 24)) do:
		[:tuple|
		 [:type :instSpec| | fmt |
		   fmt := [self ClassBuilderPROTOTYPEcomputeFormat: type instSize: 0 forSuper: Object ccIndex: 0]
					on: MessageNotUnderstood
					do: [:ex|
						ex message selector ~~ #format:variable:words:pointers:weak: ifTrue:
							[ex pass].
						self perform: #ClassBuilderPROTOTYPEformat:variable:words:pointers:weak:
							withArguments: ex message arguments].
		   self assert: (fmt >> 16 = instSpec
						or: [type = #compiledMethod and: [fmt = CompiledMethod format]]).
		 ] valueWithArguments: tuple]! !

!SpurBootstrap methodsFor: 'bootstrap methods' stamp: 'eem 9/19/2013 10:42'!
addNewMethods
	"Get the simulator to add any and all missing methods immediately."
	| cmaiaSym basSym |
	cmaiaSym := self findSymbol: #compiledMethodAt:ifAbsent:.
	basSym := self findSymbol: #basicAddSelector:withMethod:.
	basSym ifNil:
		[basSym := self findSymbol: #addSelectorSilently:withMethod:].
	self allPrototypeClassNamesDo:
		[:sym :symIsMeta| | class |
		class := self findClassNamed: (literalMap at: sym).
		symIsMeta ifTrue: [class := oldHeap fetchClassOfNonImm: class].
		self prototypeClassNameMetaSelectorMethodDo:
			[:className :isMeta :selector :method| | methodOrNil |
			(className = sym
			 and: [symIsMeta = isMeta]) ifTrue:
				["probe method dictionary of the class for each method, installing a dummy if not found."
				 "Transcript cr; nextPutAll: 'checking for '; nextPutAll: selector; flush."
				 methodOrNil := self interpreter: oldInterpreter
									object: class
									perform: cmaiaSym
									withArguments: {literalMap at: selector. oldHeap nilObject}.
				 methodOrNil = oldHeap nilObject
					ifTrue: "no method.  install the real thing now"
						[Transcript
							cr;
							nextPutAll: 'installing ';
							nextPutAll: className;
							nextPutAll: (isMeta ifTrue: [' class>>'] ifFalse: ['>>']);
							store: selector;
							flush.
						 self interpreter: oldInterpreter
							object: class
							perform: basSym
							withArguments: { literalMap at: selector.
											   self installableMethodFor: method
												selector: selector
												className: className
												isMeta: isMeta}.
						installedPrototypes add: method selector]
					ifFalse: "existing method; collect the methodClassAssociation; its needed later"
						[methodClasses add: (oldInterpreter methodClassAssociationOf: methodOrNil)]]]]! !

!SpurBootstrap methodsFor: 'method prototypes' stamp: 'eem 9/6/2013 21:32'!
allPrototypeClassNamesDo: aBlock
	"self basicNew allPrototypeClassNames"
	| pairs |
	pairs := Set new.
	self prototypeClassNameMetaSelectorMethodDo:
		[:className :isMeta :selector :method |
		pairs add: {className. isMeta}].
	pairs do: [:pair| aBlock value: pair first value: pair last]! !

!SpurBootstrap methodsFor: 'method prototypes' stamp: 'eem 9/6/2013 21:25'!
allPrototypeMethodSymbols
	"self basicNew allPrototypeMethodSymbols"
	| symbols |
	symbols := Set new.
	self prototypeClassNameMetaSelectorMethodDo:
		[:className :isMeta :selector :method |
		symbols
			add: className;
			add: selector;
			addAll: (method literals select: [:l| l isSymbol and: [l ~~ method selector]])].
	^symbols! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 11/12/2013 15:04'!
allocateClassTable
	"Allocate the root of the classTable plus enough pages to accomodate all classes in
	 the classToIndex map.  Don't fill in the entries yet; the classes have yet to be cloned."
	| tableRoot page maxSize numPages |
	tableRoot := newHeap
					allocateSlots: newHeap classTableRootSlots + newHeap hiddenRootSlots
					format: newHeap arrayFormat
					classIndex: newHeap arrayClassIndexPun.
	self assert: (newHeap numSlotsOf: tableRoot) = (newHeap classTableRootSlots + newHeap hiddenRootSlots).
	self assert: (newHeap formatOf: tableRoot) = newHeap arrayFormat.
	self assert: (newHeap classIndexOf: tableRoot) = newHeap arrayClassIndexPun.
	newHeap nilFieldsOf: tableRoot.
	"first page is strong"
	page := newHeap
					allocateSlots: newHeap classTablePageSize
					format: newHeap arrayFormat
					classIndex: newHeap arrayClassIndexPun.
	self assert: (newHeap numSlotsOf: page) = newHeap classTablePageSize.
	self assert: (newHeap formatOf: tableRoot) = newHeap arrayFormat.
	self assert: (newHeap classIndexOf: tableRoot) = newHeap arrayClassIndexPun.
	self assert: (newHeap objectAfter: tableRoot limit: newHeap freeStart) = page.
	lastClassTablePage := page.
	newHeap nilFieldsOf: page.
	newHeap storePointer: 0 ofObject: tableRoot withValue: page.
	newHeap hiddenRootsObj: tableRoot.
	maxSize := classToIndex inject: 0 into: [:a :b| a max: b].
	numPages := (maxSize + newHeap classTableMinorIndexMask / newHeap classTablePageSize) truncated.
	2 to: numPages do:
		[:i|
		page := newHeap
					allocateSlots: newHeap classTablePageSize
					format: newHeap arrayFormat
					classIndex: newHeap arrayClassIndexPun.
		self assert: (newHeap numSlotsOf: page) = newHeap classTablePageSize.
		self assert: (newHeap formatOf: page) = newHeap arrayFormat.
		self assert: (newHeap classIndexOf: page) = newHeap arrayClassIndexPun.
		newHeap fillObj: page numSlots: newHeap classTablePageSize with: newHeap nilObject.
		newHeap storePointer: i - 1 ofObject: tableRoot withValue: page.
		self assert: (newHeap objectAfter: (newHeap fetchPointer: i - 2 ofObject: tableRoot)  limit: newHeap freeStart) = page.
		lastClassTablePage := page].
	"and once again to recompute numClassTablePages post building the class table."
	newHeap instVarNamed: 'numClassTablePages' put: nil.
	newHeap hiddenRootsObj: tableRoot! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 10/8/2013 12:22'!
allocateFreeLists
	"Allocate the freeLists array."
	| freeListsOop |
	freeListsOop := newHeap
						allocateSlots: newHeap numFreeLists
						format: newHeap wordIndexableFormat
						classIndex: newHeap wordSizeClassIndexPun.
	self assert: (newHeap objectAfter: newHeap trueObject) = freeListsOop.
	0 to: newHeap numFreeLists - 1 do:
		[:i|
		newHeap
			storePointerUnchecked: freeListsOop
			ofObject: freeListsOop
			withValue: 0]! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 1/12/2014 16:36'!
bootstrapImage
	oldHeap fullGC.
	self measureOldHeapPostGC.
	self initMaps.
	self findRequiredGlobals.
	Transcript cr; nextPutAll: 'transforming image...'; flush.
	self cloneNilTrueAndFalse.
	self allocateFreeLists.
	self buildClassMap.
	self allocateClassTable.
	self cloneObjects.
	self fillInObjects.
	self fillInClassTable.
	newHeapSize := newHeap freeStart.
	newHeap initializePostBootstrap.
	self measureNewHeapPostInitPostBootstrap! !

!SpurBootstrap methodsFor: 'public access' stamp: 'eem 3/1/2014 12:59'!
bootstrapImage: imageName
	| dirName baseName dir |
	dirName := FileDirectory dirPathFor: imageName.
	baseName := (imageName endsWith: '.image')
					ifTrue: [FileDirectory baseNameFor: imageName]
					ifFalse: [FileDirectory localNameFor: imageName].
	dir := FileDirectory on: dirName.
	self on: (dir fullNameFor: baseName, '.image').
	[self transform]
		on: Halt
		do: [:ex|
			"suppress halts from the usual suspects (development time halts)"
			(#(fullGC compactImage) includes: ex signalerContext sender selector)
				ifTrue: [ex resume]
				ifFalse: [ex pass]].
	self writeSnapshot: (dir fullNameFor: baseName, '-spur.image')
		ofTransformedImage: newHeap
		headerFlags: oldInterpreter getImageHeaderFlags
		screenSize: oldInterpreter savedWindowSize.
	dir copyFileNamed: (dir fullNameFor: baseName, '.changes')
		toFileNamed: (dir fullNameFor: baseName, '-spur.changes')! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 9/5/2013 12:53'!
buildClassMap
	"enumerate all objects asking isBehavior:?  (class == Metaclass or class class == Metaclass) doesn't work for Newspeak"
	"Build a map from all classes in oldHeap to a class index.
	 ONLY DEALS WITH CLASSES THAT HAVE INSTANCES!!!! (can walk superclass chain?  Can walk subclasses set? Can ask class == Metaclass or class class == Metaclass class?)"
	| classes classTableIndex |
	self defineKnownClassIndices.
	classes := classToIndex keys asSet.
	classTableIndex := classToIndex inject: 0 into: [:a :b| a max: b].
	oldHeap allObjectsDo:
		[:oldObj| | oldClass |
		 oldClass := oldHeap fetchClassOfNonImm: oldObj.
		 self assert: (oldHeap isPointersNonImm: oldClass).
		 (classes includes: oldClass) ifFalse:
			[classes add: oldClass.
			 classToIndex at: oldClass put: (classTableIndex := classTableIndex + 1)]]! !

!SpurBootstrap methodsFor: 'method prototypes' stamp: 'eem 9/6/2013 12:24'!
classNameForPrototypeMethod: protoMethod
	| protoSelector |
	protoSelector := protoMethod selector.
	^(protoSelector first: (protoSelector indexOfSubCollection: 'PROTOTYPE') - 1) asSymbol! !

!SpurBootstrap methodsFor: 'class indices' stamp: 'eem 8/30/2013 14:45'!
classTableSize
	^newHeap classIndexMask + 1! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 9/1/2013 18:00'!
clone: oldObj classIndex: classIndex
	| newObj |
	newObj := newHeap
				allocateSlots: (oldHeap fetchWordLengthOf: oldObj)
				format: (self newFormatFor: oldObj)
				classIndex: classIndex.
	reverseMap at: newObj put: oldObj.
	^map at: oldObj put: newObj! !

!SpurBootstrap methodsFor: 'bootstrap methods' stamp: 'eem 3/26/2014 17:56'!
cloneArrayLiteral: anArray
	"Currently serves only to clone the #(0 0) literal in SpaceTallyPROTOTYPEspaceForInstancesOf:"
	| array |
	array := oldHeap instantiateClass: (oldHeap splObj: ClassArray) indexableSize: anArray size.
	1 to: anArray size do:
		[:i| | lit |
		lit := anArray at: i.
		lit class caseOf: {
			[SmallInteger] -> [oldHeap
									storePointerUnchecked: i - 1
									ofObject: array
									withValue: (oldHeap integerObjectOf: lit)] }].
	^array
! !

!SpurBootstrap methodsFor: 'bootstrap methods' stamp: 'eem 9/8/2013 14:00'!
cloneMethodProxy: proxy "<VMCompiledMethodProxy>"
	| bytes newMethod |
	bytes := proxy size - proxy initialPC + 1.
	newMethod := CompiledMethod
						newMethod: bytes
						header: proxy header.
	false
		ifTrue:
			[1 to: proxy numLiterals - 2 do:
				[:i| | literal |
				literal := (proxy literalAt: i) oop.
				literal := (oldHeap isIntegerObject: literal)
							ifTrue: [oldHeap integerValueOf: literal]
							ifFalse: ['literal', i printString].
				newMethod literalAt: i put: literal].
			newMethod
				literalAt: proxy numLiterals - 1
					put: (oldHeap stringOf: (proxy literalAt: proxy numLiterals - 1) oop) asSymbol;
				literalAt: proxy numLiterals
					put: (Smalltalk bindingOf: #Character)]
		ifFalse:
			[1 to: proxy numLiterals - 1 do:
				[:i| newMethod literalAt: i put: (proxy literalAt: i)].
			newMethod
				literalAt: proxy numLiterals
				put: (Smalltalk bindingOf: #Character)].
	proxy initialPC to: proxy size do:
		[:i| newMethod at: i put: (proxy at: i)].
	^newMethod! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 9/4/2013 17:05'!
cloneNilTrueAndFalse
	{	oldHeap nilObject.
		oldHeap falseObject.
		oldHeap trueObject. }
		with: (self firstOrdinaryClassIndex to: self firstOrdinaryClassIndex + 2)
		do: [:obj :classIndex|
			classToIndex at: (oldHeap fetchClassOfNonImm: obj) put: classIndex.
			self clone: obj classIndex: classIndex].
	newHeap
		nilObject: (map at: oldHeap nilObject); "needed for nilling objects etc"
		falseObject: (map at: oldHeap falseObject);
		trueObject: (map at: oldHeap trueObject)! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 9/11/2013 05:20'!
cloneObjects
	| characterClass characterTable compactClasses oldObj oldClass |
	characterClass := oldHeap classCharacter.
	characterTable := oldHeap characterTable.
	compactClasses := oldHeap splObj: CompactClasses.
	oldObj := oldHeap objectAfter: oldHeap trueObject.
	[oldObj < oldHeap freeStart] whileTrue:
		[oldClass := oldHeap fetchClassOfNonImm: oldObj.
		 (oldObj ~= characterTable
		 and: [oldObj ~= compactClasses
		 and: [oldClass ~= characterClass]]) ifTrue:
			[self clone: oldObj classIndex: (classToIndex at: oldClass)].
		 oldObj := oldHeap objectAfter: oldObj].
	newHeap
		specialObjectsOop: (map at: oldHeap specialObjectsOop);
		lastHash: oldHeap lastHash! !

!SpurBootstrap methodsFor: 'testing' stamp: 'eem 9/30/2013 16:14'!
coHeapFrom: aSpur32BitMMLESimulator
	| coHeap |
	coHeap := Spur32BitMMLECoSimulator new.
	aSpur32BitMMLESimulator class allInstVarNames do:
		[:ivn|
		coHeap instVarNamed: ivn put: (aSpur32BitMMLESimulator instVarNamed: ivn)].
	coHeap scavenger instVarNamed: 'manager' put: coHeap.
	^coHeap! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 9/20/2013 11:27'!
compactImage
	| firstFree lastUsed |
	newHeap allHeapEntitiesDo:
		[:o|
		(newHeap isFreeObject: o)
			ifTrue: [firstFree ifNil: [firstFree := o]]
			ifFalse: [lastUsed := o]].
	lastUsed < firstFree ifTrue: "nothing to do"
		[^self].
	self halt! !

!SpurBootstrap methodsFor: 'class indices' stamp: 'eem 9/19/2013 11:01'!
defineKnownClassIndices
	"The classTable is laid out
		- to make it easy to map immediates to classes; the tag pattern of an immediate is its class index.
		  hence there are two entries for SmallInteger
		- to assign small indices to well-known classes such as Array, Message et al
		- to leave plenty of room for new known classes; hence the first page contains only well-known classes
		- to enable overlaps and avoid conflicts with indices in the specialObjectsArray (?really? eem)
		- to provide a WeakArray pun for the pages of the table itself so that these do not show up as instances of WeakArray"
	| classMethodContext classBlockClosure classMessage "no api method for these" |
	classMessage := oldHeap splObj: (VMObjectIndices bindingOf: #ClassMessage) value.
	classMethodContext := oldHeap splObj: (VMObjectIndices bindingOf: #ClassMethodContext) value.
	classBlockClosure := oldHeap splObj: (VMObjectIndices bindingOf: #ClassBlockClosure) value.
	"c.f. SpurMemoryManager class>>intializeCompactClassIndices".
	classToIndex keysDo:
		[:oldClass|
		self assert: (oldInterpreter addressCouldBeClassObj: oldClass)].
	classToIndex
		at: oldHeap classSmallInteger put: 1; "N.B. must fill-in index 3 manually"
		at: oldHeap classCharacter put: 2;
		"at: oldHeap classSmallInteger put: 3" "N.B. must fill-in index 3 manually"
		"leave room for up to 15 tagged classes"
		"leave room for up to 16 puns"
		at: oldHeap classLargeNegativeInteger put: 32;
		at: oldHeap classLargePositiveInteger put: 33;
		at: oldHeap classFloat put: 34;

		at: "oldHeap" classMessage put: 35;
		at: "oldHeap" classMethodContext put: 36;
		at: "oldHeap" classBlockClosure put: 37;

		at: oldHeap classSemaphore put: 48;
		"at: oldHeap classMutex put: 49; see below"

		at: oldHeap classByteArray put: 50;
		at: oldHeap classArray put: 51;
		at: oldHeap classString put: 52;
		at: oldHeap classBitmap put: 53;
		at: oldHeap classPoint put: 54.

	{{oldHeap classMutex. 49}.
	 {oldHeap classExternalAddress. 128}.
	 {oldHeap classExternalData. 129}.
	 {oldHeap classExternalFunction. 130}.
	 {oldHeap classExternalLibrary. 131}.
	 {oldHeap classExternalStructure. 132}.
	 {oldHeap classAlien. 133}.
	 {oldHeap classUnsafeAlien. 134}}
		do: [:pair|
			[:oop :index|
			oop ~= oldHeap nilObject ifTrue:
				[classToIndex at: oop put: index]] valueWithArguments: pair].

	classToIndex keysDo:
		[:oldClass|
		self assert: (oldInterpreter addressCouldBeClassObj: oldClass)]! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 9/18/2013 10:57'!
fillInClassTable
	| firstPage maxIndex |
	maxIndex := 0.
	classToIndex keysAndValuesDo:
		[:oldClass :index| | newClass page |
		maxIndex := maxIndex max: index.
		newClass := map at: oldClass.
		self assert: (newHeap isPointersNonImm: newClass).
		newHeap setHashBitsOf: newClass to: index.
		page := newHeap
					fetchPointer: index >> newHeap classTableMajorIndexShift
					ofObject: newHeap classTableRootObj.
		newHeap
			storePointer: (index bitAnd: newHeap classTableMinorIndexMask)
			ofObject: page
			withValue: newClass.
		self assert: (newHeap classAtIndex: index) = newClass].
	firstPage := newHeap
					fetchPointer: 0
					ofObject: newHeap classTableRootObj.
	newHeap
		storePointer: 1
			ofObject: firstPage
				withValue: (map at: oldHeap classSmallInteger);
		storePointer: 2
			ofObject: firstPage
				withValue: (map at: oldHeap classCharacter);
		storePointer: 3
			ofObject: firstPage
				withValue: (map at: oldHeap classSmallInteger);
		storePointer: newHeap arrayClassIndexPun
			ofObject: firstPage
				withValue: (map at: oldHeap classArray);
		storePointer: newHeap arrayClassIndexPun
			ofObject: firstPage
				withValue: (map at: oldHeap classArray).

	newHeap classTableIndex: maxIndex! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 8/31/2013 09:08'!
fillInCompiledMethod: newObj from: oldObj
	self fillInBitsObject: newObj from: oldObj.
	self fillInPointerObject: newObj from: oldObj! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 8/31/2013 08:02'!
fillInObjects
	oldHeap allObjectsDo:
		[:oldObj|
		(map at: oldObj ifAbsent: nil) ifNotNil:
			[:newObj|
			(newHeap isCompiledMethod: newObj)
				ifTrue: [self fillInCompiledMethod: newObj from: oldObj]
				ifFalse:
					[(newHeap isPointersNonImm: newObj)
						ifTrue: [self fillInPointerObject: newObj from: oldObj]
						ifFalse: [self fillInBitsObject: newObj from: oldObj]]]]! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 2/10/2014 16:35'!
fillInPointerObject: newObj from: oldObj
	"Fill-in a newObj with appropriately mapped contents from oldObj.
	 Filter-out the character table and the compact classes array.
	 Map character objects to immediate characters."
	0 to: (oldHeap lastPointerOf: oldObj) / oldHeap wordSize - 1 do:
		[:i| | oldValue newValue |
		oldValue := oldHeap fetchPointer: i ofObject: oldObj.
		newValue := (oldHeap isIntegerObject: oldValue)
						ifTrue: [oldValue]
						ifFalse:
							[map at: oldValue ifAbsent:
								[(oldValue = oldHeap characterTable
								  or: [oldValue = (oldHeap splObj: CompactClasses)])
									ifTrue: [newHeap nilObject]
									ifFalse:
										[self assert: (oldHeap fetchClassOfNonImm: oldValue) = oldHeap classCharacter.
										 newHeap characterObjectOf:
											(oldHeap integerValueOf:
												(oldHeap fetchPointer: CharacterValueIndex ofObject: oldValue))]]].
		newHeap
			storePointerUnchecked: i
			ofObject: newObj
			withValue: newValue].
	(self isOldObjABehavior: oldObj) ifTrue:
		[self mapOldBehavior: oldObj toNewBehavior: newObj]! !

!SpurBootstrap methodsFor: 'bootstrap methods' stamp: 'eem 9/6/2013 21:18'!
findClassNamed: symbolOop 
	oldHeap allObjectsDo:
		[:o|
		((oldHeap isPointersNonImm: o)
		 and: [(oldInterpreter addressCouldBeClassObj: o)
		 and: [(oldHeap fetchPointer: oldInterpreter classNameIndex ofObject: o) = symbolOop]]) ifTrue:
			[^o]].
	^nil! !

!SpurBootstrap methodsFor: 'bootstrap methods' stamp: 'eem 3/26/2014 17:42'!
findLiteral: aLiteral
	| symbolOop smalltalk array |
	aLiteral isString ifTrue:
		[^self stringFor: aLiteral].
	aLiteral isFloat ifTrue:
		[^oldInterpreter floatObjectOf: aLiteral].
	aLiteral isArray ifTrue:
		[^self cloneArrayLiteral: aLiteral].
	self assert: aLiteral isVariableBinding.
	symbolOop := self findSymbol: aLiteral key.
	smalltalk := oldHeap splObj: 8.
	array := oldHeap fetchPointer: 1 ofObject: smalltalk.
	self assert: (oldHeap isArray: array).
	0 to: (oldHeap fetchWordLengthOf: array) - 1 do:
		[:i| | bindingOrNil |
		bindingOrNil := oldHeap fetchPointer: i ofObject: array.
		(bindingOrNil ~= oldHeap nilObject
		 and: [symbolOop = (oldHeap fetchPointer: KeyIndex ofObject: bindingOrNil)
		 and: [aLiteral key == #Smalltalk
				ifTrue:
					[(oldHeap fetchPointer: ValueIndex ofObject: bindingOrNil) = smalltalk]
				ifFalse:
					[oldInterpreter
						classNameOf: (oldHeap fetchPointer: ValueIndex ofObject: bindingOrNil)
						Is: aLiteral key]]]) ifTrue:
			[^bindingOrNil]].
	self error: 'couldn''t find literal ', aLiteral printString! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 9/20/2013 17:51'!
findRequiredGlobals
	"Look for the necessary gobal bindings in the prototype methods in the old image.
	 This has to be done early by sending bindingOf: to Smalltalk.  Also find out
	 Metaclass, needed for identofying classes."
	| globals bindingOf |
	globals := Set new.
	self prototypeClassNameMetaSelectorMethodDo:
		[:c :m :s :method|
		globals addAll: (method literals select: [:l|
										l isVariableBinding
										and: [l key isSymbol
										and: [(Smalltalk bindingOf: l key) == l]]])].
	bindingOf := self findSymbol: #bindingOf:.
	self withExecutableInterpreter: oldInterpreter
		do:	[globals do:
				[:global|
				literalMap
					at: global
					put: (self interpreter: oldInterpreter
							object: (oldHeap splObj: 8) "Smalltalk"
							perform: bindingOf
							withArguments: {self findSymbol: global key})]].

	classMetaclass := oldHeap fetchClassOfNonImm: (oldHeap fetchClassOfNonImm: oldHeap classArray)! !

!SpurBootstrap methodsFor: 'bootstrap methods' stamp: 'eem 9/6/2013 12:49'!
findSymbol: aString
	"Find the Symbol equal to aString in oldHeap."
	| symbolClass |
	symbolClass := self symbolClass.
	oldHeap allObjectsDo:
		[:o|
		(symbolClass = (oldHeap fetchClassOfNonImm: o)
		 and: [(oldHeap byteLengthOf: o) = aString size
		 and: [aString = (oldHeap stringOf: o)]]) ifTrue:
			[^o]].
	^nil! !

!SpurBootstrap methodsFor: 'class indices' stamp: 'eem 8/30/2013 15:18'!
firstOrdinaryClassIndex
	^newHeap classTablePageSize! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 9/18/2013 16:55'!
followForwardingPointers
	newHeap allObjectsDo:
		[:o|
		(newHeap isForwarded: o) ifFalse:
			[0 to: (newHeap numPointerSlotsOf: o) - 1 do:
				[:i| | field |
				field := newHeap fetchPointer: i ofObject: o.
				(newHeap isOopForwarded: field) ifTrue:
					[newHeap
						storePointer: i
						ofObject: o
						withValue: (newHeap followForwarded: field)]]]]! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 9/20/2013 15:55'!
freeForwarders
	"Check that all forwarders have been followed.  Then free them."
	| numForwarders numFreed |
	numForwarders := numFreed := 0.
	newHeap allObjectsDo:
		[:o|
		(newHeap isForwarded: o)
			ifTrue: [numForwarders := numForwarders + 1]
			ifFalse:
				[0 to: (newHeap numPointerSlotsOf: o) - 1 do:
					[:i|
					self assert: (newHeap isOopForwarded: (newHeap fetchPointer: i ofObject: o)) not]]].
	Transcript ensureCr;  nextPutAll: 'freeing '; print: numForwarders; nextPutAll: ' forwarders'; cr; flush.
	newHeap allObjectsDo:
		[:o|
		(newHeap isForwarded: o) ifTrue:
			[numFreed := numFreed + 1.
			 newHeap freeObject: o]].
	self assert: numFreed = numForwarders! !

!SpurBootstrap methodsFor: 'bootstrap methods' stamp: 'eem 9/7/2013 17:02'!
indexOfSelector: selectorOop in: methodDict
	SelectorStart to: (oldHeap fetchWordLengthOf: methodDict) - 1 do:
		[:i|
		(oldHeap fetchPointer: i ofObject: methodDict) = selectorOop ifTrue:
			[^i]].
	self error: 'could not find selector in method dict'! !

!SpurBootstrap methodsFor: 'initialize-release' stamp: 'eem 12/5/2013 14:18'!
initMaps
	map := Dictionary new: oldHeap memory size // 4.
	reverseMap := Dictionary new: oldHeap memory size // 4.
	classToIndex := Dictionary new: 1024.
	literalMap := IdentityDictionary new.
	methodClasses := Set new.
	installedPrototypes := Set new.
	sizeSym := rehashSym := classMetaclass := nil! !

!SpurBootstrap methodsFor: 'bootstrap methods' stamp: 'eem 9/19/2013 10:35'!
installModifiedMethods
	"Install all the methods in the class-side method prototypes protocol in the relevant classes
	 in the new image.  First use the simulator to get the image to intern all symbols and add
	 dummy methods under new selectors.  With that done we can manually replace the relevant
	 methods with the prototypes, mapping selectors and global variables as required."
	self withExecutableInterpreter: oldInterpreter
		do: [self internAllSymbols.
			 self addNewMethods.
			 self replaceMethods.
			 self modifyCharacterMethods]! !

!SpurBootstrap methodsFor: 'bootstrap methods' stamp: 'eem 2/6/2014 13:41'!
installableMethodFor: aCompiledMethod selector: selector className: className isMeta: isMeta
	"Create a sourceless method to install in the bootstrapped image.  It will allow the
	 bootstrap to limp along until the relevant transformed Monticello package is loaded."
	| compiledMethodClass sourcelessMethod bytes newMethod |
	compiledMethodClass := self findClassNamed: (self findSymbol: #CompiledMethod).
	"the prototypes have source pointers.  the Character methods to be replaced don't."
	sourcelessMethod := aCompiledMethod trailer hasSourcePointer
							ifTrue: [aCompiledMethod copyWithTempsFromMethodNode: aCompiledMethod methodNode]
							ifFalse: [aCompiledMethod].
	bytes := sourcelessMethod size - sourcelessMethod initialPC + 1.
	newMethod := self
					interpreter: oldInterpreter
					object: compiledMethodClass
					perform: (self findSymbol: #newMethod:header:)
					withArguments: { oldHeap integerObjectOf: bytes.
									   oldHeap integerObjectOf: sourcelessMethod header }.
	1 to: sourcelessMethod numLiterals - 2 do:
		[:i| | literal oop |
		literal := sourcelessMethod literalAt: i.
		oop := (literal isLiteral or: [literal isVariableBinding])
					ifTrue:
						[literal isInteger
							ifTrue: [oldHeap integerObjectOf: literal]
							ifFalse: [literalMap at: literal ifAbsent: [self findLiteral: literal]]]
					ifFalse: "should be a VMObjectProxy"
						[literal oop].
		oldHeap storePointer: i ofObject: newMethod withValue: oop].
	oldHeap
		storePointer: sourcelessMethod numLiterals - 1
		ofObject: newMethod
		withValue: (selector isSymbol
						ifTrue: [self findSymbol: selector]
						ifFalse: [selector oop]);
		storePointer: sourcelessMethod numLiterals
		ofObject: newMethod
		withValue: (self methodClassForClassName: className
						isMeta: isMeta).
	sourcelessMethod initialPC to: sourcelessMethod size do:
		[:i|
		oldHeap storeByte: i - 1 ofObject: newMethod withValue: (sourcelessMethod byteAt: i)].
	^newMethod! !

!SpurBootstrap methodsFor: 'bootstrap methods' stamp: 'eem 9/19/2013 10:50'!
internAllSymbols
	"Ensure that all symbols in the method prototypes are interned so that later we can install them.
	 Enter them into the map, this system's symbol -> oldHeap's version.
	 Do this by interpreting Symbol intern: 'aSymbol' for each symbol."
	| internSym |
	internSym := self findSymbol: #intern:.
	self allPrototypeMethodSymbols do:
		[:sym|
		(self findSymbol: sym)
			ifNotNil: [:imageSym| literalMap at: sym put: imageSym]
			ifNil:[Transcript cr; nextPutAll: 'interning '; nextPutAll: sym; flush.
				"Interpret Symbol intern: sym to ... intern it :-)"
				literalMap
					at: sym
					put: (self interpreter: oldInterpreter
							object: self symbolClass
							perform: internSym
							withArguments: {self stringFor: sym})]].
	literalMap keysAndValuesDo:
		[:symOrGlobal :imageSymOrGlobal|
		symOrGlobal isSymbol ifTrue:
			[self assert: symOrGlobal = (oldHeap stringOf: imageSymOrGlobal)]]! !

!SpurBootstrap methodsFor: 'bootstrap methods' stamp: 'eem 9/17/2013 16:51'!
interpreter: sim object: receiver perform: selector withArguments: arguments
	"Interpret an expression in oldHeap using oldInterpreter.
	 Answer the result."
	| fp savedpc savedsp result startByteCount |
	savedpc := sim localIP.
	savedsp := sim localSP.
	sim internalPush: receiver.
	arguments do: [:arg| sim internalPush: arg].
	sim
		argumentCount: arguments size;
		messageSelector: selector.
	fp := sim localFP.
	startByteCount := sim byteCount.
	"sim byteCount = 66849 ifTrue: [self halt]."
	sim normalSend.
	sim incrementByteCount. "otherwise, send is not counted"
	["sim byteCount = 66849 ifTrue: [self halt]."
	 "(sim byteCount > 7508930 and: [sim localFP = -16r27894]) ifTrue:
		[self halt]."
	 fp = sim localFP] whileFalse:
		[sim singleStep].
	result := sim internalPopStack.
	self assert: savedsp = sim localSP.
	self assert: sim localIP - 1 = savedpc.
	sim localIP: savedpc.
	^result! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 9/20/2013 17:49'!
isOldObjABehavior: oldObj
	| oldObjClass oldObjClassClass |
	^(classToIndex includesKey: oldObj)
	or: [oldObjClass := oldHeap fetchClassOfNonImm: oldObj.
		oldObjClassClass := oldHeap fetchClassOfNonImm: oldObjClass.
		oldObjClass = classMetaclass
		or: [oldObjClassClass = classMetaclass]]! !

!SpurBootstrap methodsFor: 'testing' stamp: 'eem 9/30/2013 15:42'!
launch
	self launch: newHeap
		simulatorClass: StackInterpreterSimulator
		headerFlags: oldInterpreter getImageHeaderFlags! !

!SpurBootstrap methodsFor: 'testing' stamp: 'eem 1/13/2014 11:56'!
launch: heap simulatorClass: simulatorClass headerFlags: headerFlags
	| sim methodCacheSize |
	sim := simulatorClass onObjectMemory: heap.
	heap coInterpreter: sim.
	(sim class allInstVarNames includes: 'cogCodeSize')
		ifTrue:
			[sim initializeInterpreter: 0.
			 methodCacheSize := sim methodCache size * heap wordSize.
			 sim instVarNamed: 'heapBase' put: heap startOfMemory;
				instVarNamed: 'numStackPages' put: 8;
				instVarNamed: 'cogCodeSize' put: 1024*1024;
				moveMethodCacheToMemoryAt: sim cogCodeSize + sim computeStackZoneSize;
				movePrimTraceLogToMemoryAt: sim cogCodeSize + sim computeStackZoneSize + methodCacheSize;
				"sendTrace: 1+ 2 + 8 + 16;"
			 	initializeCodeGenerator]
		ifFalse:
			[sim initializeInterpreter: 0].
	heap
		initializeNewSpaceVariables;
		bootstrapping: false;
		assimilateNewSegment: (heap segmentManager segments at: 0).
	sim
		setImageHeaderFlagsFrom: headerFlags;
		imageName: ImageName;
		flushExternalPrimitives;
		openAsMorph;
		transcript: Transcript. "deep copy copies this"
	"sim
		instVarNamed: 'printSends' put: true;
		instVarNamed: 'printReturns' put: true;
		instVarNamed: 'methodDictLinearSearchLimit' put: SmallInteger maxVal." "for now"
	heap
		setCheckForLeaks: 0;
		runLeakCheckerForFullGC: true.

	sim halt; run! !

!SpurBootstrap methodsFor: 'testing' stamp: 'eem 9/30/2013 15:41'!
launchSaved
	self launch: TransformedImage veryDeepCopy
		simulatorClass: StackInterpreterSimulator
		headerFlags: ImageHeaderFlags! !

!SpurBootstrap methodsFor: 'testing' stamp: 'eem 9/30/2013 16:05'!
launchSavedWithJIT
	self launch: (self coHeapFrom: TransformedImage veryDeepCopy)
		simulatorClass: CogVMSimulator
		headerFlags: ImageHeaderFlags! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 2/10/2014 17:25'!
mapOldBehavior: oldObj toNewBehavior: newObj
	"Map the old format inst var's value to the new value.
	 In addition, for Character, make it immediate and remove its instance variable."
	newHeap
		storePointerUnchecked: InstanceSpecificationIndex
		ofObject: newObj
		withValue: (self newClassFormatFor: oldObj).
	oldObj = oldHeap classCharacter ifTrue:
		[InstanceSpecificationIndex + 1 to: (oldHeap numSlotsOf: oldObj) do:
			[:i| | var field |
			var := oldHeap fetchPointer: i ofObject: oldObj.
			((oldHeap fetchClassOf: var) = oldHeap classArray
			 and: [(oldHeap numSlotsOf: var) = 1
			 and: [field := oldHeap fetchPointer: 0 ofObject: var.
				(oldHeap fetchClassOf: field) = oldHeap classString
			 and: [(oldHeap lengthOf: field) = 5
			 and: [(oldHeap str: 'value'  n: (oldHeap firstIndexableField: field) cmp: 5) = 0]]]]) ifTrue:
				[newHeap
					storePointerUnchecked: i
					ofObject: newObj
					withValue: newHeap nilObject.
				 ^self]]]! !

!SpurBootstrap methodsFor: 'stats' stamp: 'eem 1/12/2014 16:38'!
measureNewHeapPostInitPostBootstrap
	| savedEndOfMemory |
	"need to hack around the fact that newHeap isn't all there yet.
	 In particular, it has no freeList so can't free space from
	 freeOldSpaceStart to endOfMemory to make oldSpace enumerable."
	newHeapNumObjs := 0.
	savedEndOfMemory := newHeap endOfMemory.
	newHeap setEndOfMemory: newHeap freeOldSpaceStart.
	newHeap allObjectsDo: [:o| newHeapNumObjs := newHeapNumObjs + 1].
	newHeap setEndOfMemory: savedEndOfMemory! !

!SpurBootstrap methodsFor: 'stats' stamp: 'eem 1/12/2014 16:35'!
measureOldHeapPostGC
	oldHeapSize := oldHeap freeStart.
	oldHeapNumObjs := 0.
	oldHeap allObjectsDo: [:o| oldHeapNumObjs := oldHeapNumObjs + 1]! !

!SpurBootstrap methodsFor: 'bootstrap methods' stamp: 'eem 9/19/2013 10:42'!
methodClassForClassName: classNameSymbol isMeta: isMeta 
	| class |
	class := self findClassNamed: (literalMap at: classNameSymbol).
	isMeta ifTrue: [class := oldHeap fetchClassOfNonImm: class].
	methodClasses do:
		[:mca|
		class = (oldHeap fetchPointer: ValueIndex ofObject: mca) ifTrue:
			[^mca]].
	oldHeap allObjectsDo:
		[:o| | methodClassAssociation |
		(oldHeap isCompiledMethod: o) ifTrue:
			[methodClassAssociation := oldInterpreter methodClassAssociationOf: o.
			 class == (oldHeap fetchPointer: ValueIndex ofObject: methodClassAssociation) ifTrue:
				[methodClasses add: methodClassAssociation.
				 ^methodClassAssociation]]].
	self error: 'could not find methodClassAssociation for ', classNameSymbol, (isMeta ifTrue: [' class'] ifFalse:[''])! !

!SpurBootstrap methodsFor: 'bootstrap methods' stamp: 'eem 9/9/2013 10:37'!
modifyCharacterMethods
	| cc md mda |
	cc := oldHeap classCharacter.
	md := oldHeap fetchPointer: MethodDictionaryIndex ofObject: cc.
	mda := oldHeap fetchPointer: MethodArrayIndex ofObject: md..
	0 to: (oldHeap fetchWordLengthOf: mda) - 1 do:
		[:i| | method |
		method := oldHeap fetchPointer: i ofObject: mda.
		method ~= oldHeap nilObject ifTrue:
			[(self replacementForCharacterMethod: method) ifNotNil:
				[:replacement|
				Transcript
					cr;
					nextPutAll: 'replacing Character>>#';
					nextPutAll: (oldHeap stringOf: (oldHeap fetchPointer: i + SelectorStart ofObject: md));
					flush. 
				oldHeap
					storePointer: i
					ofObject: mda
					withValue: replacement]]]! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 12/17/2013 17:21'!
newClassFormatFor: oldClassObj
	"OLD: 		<2 bits=instSize//64><5 bits=cClass><4 bits=instSpec><6 bits=instSize\\64><1 bit=0>
	 NEW: 		<5 bits inst spec><16 bits inst size>"
	| oldFormat instSize newInstSpec |
	((oldInterpreter classNameOf: oldClassObj Is: 'SmallInteger')
	 or: [oldInterpreter classNameOf: oldClassObj Is: 'Character']) ifTrue:
		[^newHeap integerObjectOf: newHeap instSpecForImmediateClasses << 16].
	oldFormat := oldHeap formatOfClass: oldClassObj. "N.B. SmallInteger with tag bit cleared"
	oldFormat := oldFormat >> 1.
	instSize := ((oldFormat bitShift: -10) bitAnd: 16rC0) + ((oldFormat bitShift: -1) bitAnd: 16r3F) - 1.
	newInstSpec := #(0 1 2 3 4 nil 10 9 16 16 16 16 24 24 24 24) at: ((oldFormat bitShift: -7) bitAnd: 16rF) + 1.
	^newHeap integerObjectOf: newInstSpec << 16 + instSize! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 8/30/2013 10:32'!
newFormatFor: oldObj
	"OLD:
	 0	no fields
	 1	fixed fields only (all containing pointers)
	 2	indexable fields only (all containing pointers)
	 3	both fixed and indexable fields (all containing pointers)
	 4	both fixed and indexable weak fields (all containing pointers).

	 5	unused
	 6	indexable word fields only (no pointers)
	 7	indexable long (64-bit) fields (only in 64-bit images)
 
	 8-11	indexable byte fields only (no pointers) (low 2 bits are low 2 bits of size)
	 12-15	compiled methods:
	 	    # of literal oops specified in method header,
	 	    followed by indexable bytes (same interpretation of low 2 bits as above)"

	"NEW:
	 0 = 0 sized objects (UndefinedObject True False et al)
	 1 = non-indexable objects with inst vars (Point et al)
	 2 = indexable objects with no inst vars (Array et al)
	 3 = indexable objects with inst vars (MethodContext AdditionalMethodState et al)
	 4 = weak indexable objects with inst vars (WeakArray et al)
	 5 = weak non-indexable objects with inst vars (ephemerons) (Ephemeron)

	 and here it gets messy, we need 8 CompiledMethod values, 8 byte values, 4 16-bit values, 2 32-bit values and a 64-bit value, = 23 values, 23 + 5 = 30, so there may be room.

	 9 (?) 64-bit indexable
	 10 - 11 32-bit indexable
	 12 - 15 16-bit indexable
	 16 - 23 byte indexable
	 24 - 31 compiled method"
	| oldFormat |
	oldFormat := oldHeap formatOf: oldObj.
	oldFormat <= 4 ifTrue:
		[^oldFormat].
	oldFormat >= 12 ifTrue: "CompiledMethod"
		[^24 + (self wordSize - (oldHeap byteLengthOf: oldObj) bitAnd: self wordSizeMask)].
	oldFormat >= 8 ifTrue: "ByteArray et al"
		[^16 + (self wordSize - (oldHeap byteLengthOf: oldObj) bitAnd: self wordSizeMask)].
	oldFormat = 6 ifTrue: "32-bit indexable"
		[^10 + ((oldHeap byteLengthOf: oldObj) bitAnd: self wordSizeMask) sign].
	oldFormat = 7 ifTrue: "64-bit indexable"
		[^9].
	self error: 'illegal old format'! !

!SpurBootstrap methodsFor: 'initialize-release' stamp: 'eem 5/28/2014 11:16'!
on: imageName
	StackInterpreter initializeWithOptions: Dictionary new.
	(oldInterpreter := StackInterpreterSimulator new)
		openOn: imageName extraMemory: 0;
		assertValidExecutionPointersAtEachStep: false.
	oldHeap := oldInterpreter objectMemory.
	newHeap := Spur32BitMMLESimulator new.
	newHeap
		allocateMemoryOfSize: (oldHeap youngStart * 3 / 2 roundUpTo: 1024 * 1024)
		newSpaceSize: 2 * 1024 * 1024
		stackSize: 1024 * 1024
		codeSize: 0.
	newHeap setCheckForLeaks: 15 - 6. "don't check become; or newSpace; soooo many rehashes in bootstrap"
	newHeap bootstrapping: true.
	self initMaps! !

!SpurBootstrap methodsFor: 'method prototypes' stamp: 'eem 9/7/2013 13:24'!
prototypeClassNameMetaSelectorMethodDo: quaternaryBlock
	"Evaluate aBlock with class name, class is meta, method and selector.
	 For now find methods in class-side category #'method prototypes'.
	 Scheme could be extended to have different protocols for different
	 Squeak/Pharo versions."
	(SpurBootstrap class organization listAtCategoryNamed: #'method prototypes') do:
		[:protoSelector| | method className isMeta |
		method := SpurBootstrap class >> protoSelector.
		className := self classNameForPrototypeMethod: method.
		(isMeta := className endsWith: 'class') ifTrue:
			[className := (className allButLast: 5) asSymbol].
		quaternaryBlock
			value: className
			value: isMeta
			value: (self selectorForPrototypeMethod: method)
			value: method]! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 11/14/2013 15:08'!
rehashImage
	"Rehash all collections in newHeap.
	 Find out which classes implement rehash, entering a 1 against their classIndex in rehashFlags.
	 Enumerate all objects, rehashing those whose class has a bit set in rehashFlags."
	| n sim rehashFlags |
	sim := StackInterpreterSimulator onObjectMemory: newHeap.
	newHeap coInterpreter: sim.
	sim bootstrapping: true.
	sim initializeInterpreter: 0.
	sim instVarNamed: 'methodDictLinearSearchLimit' put: SmallInteger maxVal.

	newHeap
		setHashBitsOf: newHeap nilObject to: 1;
		setHashBitsOf: newHeap falseObject to: 2;
		setHashBitsOf: newHeap trueObject to: 3.

	rehashFlags := ByteArray new: newHeap numClassTablePages * newHeap classTablePageSize.
	n := 0.
	newHeap classTableObjectsDo:
		[:class| | classIndex |
		sim messageSelector: (map at: rehashSym).
		"Lookup rehash but don't be fooled by ProtoObject>>rehash, which is just ^self."
		((sim lookupMethodNoMNUEtcInClass: class) = 0
		 and: [(sim isQuickPrimitiveIndex: (sim primitiveIndexOf: (sim instVarNamed: 'newMethod'))) not]) ifTrue:
			[n := n + 1.
			 classIndex := newHeap rawHashBitsOf: class.
			 rehashFlags
				at: classIndex >> 3 + 1
				put: ((rehashFlags at: classIndex >> 3 + 1)
						bitOr: (1 << (classIndex bitAnd: 7)))]].
	Transcript cr; print: n; nextPutAll: ' classes understand rehash. rehashing instances...'; flush.
	n := 0.
	self withExecutableInterpreter: sim
		do: [sim setBreakSelector: 'error:'.
			 "don't rehash twice (actually without limit), so don't rehash any new objects created."
			 newHeap allExistingOldSpaceObjectsDo:
				[:o| | classIndex |
				classIndex := newHeap classIndexOf: o.
				((rehashFlags at: classIndex >> 3 + 1) anyMask: 1 << (classIndex bitAnd: 7)) ifTrue:
					[(n := n + 1) \\ 8 = 0 ifTrue:
					 	[Transcript nextPut: $.; flush].
					 "2845 = n ifTrue: [self halt]."
					 "Rehash an object if its size is > 0.
					  Symbol implements rehash, but let's not waste time rehashing it; in Squeak
					  up to 2013 symbols are kept in a set which will get reashed anyway..
					  Don't rehash empty collections; they may be large for a reason and rehashing will shrink them."
					 ((sim addressCouldBeClassObj: o)
					   or: [(self interpreter: sim
							object: o
							perform: (map at: sizeSym)
							withArguments: #()) = (newHeap integerObjectOf: 0)]) ifFalse:
						[self interpreter: sim
							object: o
							perform: (map at: rehashSym)
							withArguments: #()]]]]! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 9/13/2013 18:15'!
rememberRehashSymbol
	rehashSym := self findSymbol: #rehash.
	sizeSym := self findSymbol: #size! !

!SpurBootstrap methodsFor: 'bootstrap methods' stamp: 'eem 9/19/2013 10:41'!
replaceMethods
	"Replace all the modified method prototypes."
	self allPrototypeClassNamesDo:
		[:sym :symIsMeta| | class |
		class := self findClassNamed: (literalMap at: sym).
		symIsMeta ifTrue: [class := oldHeap fetchClassOfNonImm: class].
		self prototypeClassNameMetaSelectorMethodDo:
			[:className :isMeta :selector :method| | replacement methodDict index |
			(className = sym
			 and: [symIsMeta = isMeta]) ifTrue:
				[(installedPrototypes includes: method selector) ifFalse:
					["probe method dictionary of the class for each method, installing a dummy if not found."
					Transcript
						cr;
						nextPutAll: 'replacing ';
						nextPutAll: className;
						nextPutAll: (isMeta ifTrue: [' class>>'] ifFalse: ['>>']);
						store: selector;
						flush.
					replacement := self installableMethodFor: method
										selector: selector
										className: className
										isMeta: isMeta.
					methodDict := oldHeap fetchPointer: MethodDictionaryIndex ofObject: class.
					index := self indexOfSelector: (literalMap at: selector) in: methodDict.
					oldHeap
						storePointer: index - SelectorStart
						ofObject: (oldHeap fetchPointer: MethodArrayIndex ofObject: methodDict)
						withValue: replacement.
					installedPrototypes add: method selector]]]]! !

!SpurBootstrap methodsFor: 'bootstrap methods' stamp: 'eem 9/20/2013 10:33'!
replacementForCharacterMethod: characterMethodOop
	"Answer a replacement method for the argument if it refers
	 to Character's old inst var value.  Otherwise answer nil."
	| proxy asIntegerProxy clone assembly newInsts newMethod |
	"(oldHeap stringOf: (oldHeap longAt: characterMethodOop + (oldHeap lastPointerOf: characterMethodOop) - 4)) = 'isOctetCharacter' ifTrue:
		[self halt]."
	proxy := VMCompiledMethodProxy new
				for: characterMethodOop
				coInterpreter: oldInterpreter
				objectMemory: oldHeap.
	clone := self cloneMethodProxy: proxy.
	"Quick methods accessing value should have been replaced.  The halt will fire if there
	 is a missing prototype for such a method on the class side of SpurBootstrap.  The
	 relevant Character prototypes there so far are Character>>asInteger, Character>>
	 asciiValue, Character>>hash & Character>>identityHash.  Conceivably the bootstrap
	 could be applied to an image that has others; hence the halt."
	clone isReturnField ifTrue: [self halt].
	clone hasInstVarRef ifFalse:
		[^nil].
	clone setSourcePointer: 0.
	asIntegerProxy := VMObjectProxy new
							for: (literalMap at: #asInteger)
							coInterpreter: oldInterpreter
							objectMemory: oldHeap.
	assembly := BytecodeDisassembler new disassemble: clone.
	assembly literals: (assembly literals allButLast: 2), {asIntegerProxy}, (assembly literals last: 2).
		"Do this by looking for index of pushReceiverVariable: and replacing it by pushSelf, send asInteger"
	newInsts := (assembly instructions piecesCutWhere:
					[:msgOrLabelAssoc :nextInst|
					 msgOrLabelAssoc isVariableBinding not
					 and: [msgOrLabelAssoc selector == #pushReceiverVariable:]]) fold:
				[:a :b|
				 a allButLast,
				 {	Message selector: #pushReceiver.
					Message
						selector: #send:super:numArgs:
						arguments: {asIntegerProxy. false. 0}},
				 b].
	assembly instructions: newInsts.
	newMethod := assembly assemble.
	^self
		installableMethodFor: newMethod
		selector: clone selector
		className: #Character
		isMeta: false! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 1/13/2014 11:21'!
reportSizes
	| change oldAvgBytes newAvgBytes |
	change := newHeapSize - oldHeapSize / oldHeapSize.
	oldAvgBytes := oldHeapSize asFloat / oldHeapNumObjs.
	Transcript
		nextPutAll: 'done.'; cr;
		nextPutAll: 'old heap size: '; print: oldHeapSize; tab;
		nextPutAll: ' (avg obj bytes '; print: (oldAvgBytes roundTo: 0.01); nextPutAll: ' words '; print: (oldAvgBytes / self wordSize roundTo: 0.01); nextPut: $); cr;
		nextPutAll: 'initial new heap size: '; print: newHeapSize; cr;
		nextPutAll: 'change: '; print: (change * 100.0 roundTo: 0.01); nextPut: $%; cr;
		flush.
	newHeapSize := newHeap endOfMemory
					- newHeap scavenger eden limit
					- newHeap totalFreeListBytes.
	change := newHeapSize - oldHeapSize / oldHeapSize.
	newAvgBytes := newHeapSize asFloat / newHeapNumObjs.
	Transcript
		nextPutAll: 'final new heap size: '; print: newHeapSize; tab;
		nextPutAll: ' (avg obj bytes '; print: (newAvgBytes roundTo: 0.01); nextPutAll: ' words '; print: (newAvgBytes / self wordSize roundTo: 0.01); nextPut: $); cr;
		nextPutAll: 'change: '; print: (change * 100.0 roundTo: 0.01); nextPut: $%; cr;
		flush! !

!SpurBootstrap methodsFor: 'development support' stamp: 'eem 10/11/2013 09:57'!
saveTransformedImage
	ImageHeaderFlags := oldInterpreter getImageHeaderFlags.
	ImageScreenSize := oldInterpreter savedWindowSize.
	ImageName := oldInterpreter imageName.
	newHeap coInterpreter: nil.
	(newHeap class allInstVarNames select: [:ivn| ivn beginsWith: 'stat']) do:
		[:ivn| newHeap instVarNamed: ivn put: 0].
	TransformedImage := newHeap veryDeepCopy! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 12/11/2013 09:14'!
scavengeImage
	"Scavenge the image to get it into a simpler state."
	newHeap coInterpreter voidVMStateForSnapshotFlushingExternalPrimitivesIf: false.
	newHeap flushNewSpace! !

!SpurBootstrap methodsFor: 'method prototypes' stamp: 'eem 10/11/2013 12:58'!
selectorForPrototypeMethod: protoMethod
	| protoSelector |
	protoSelector := protoMethod selector.
	protoSelector := protoSelector last: protoSelector size
						- (protoSelector indexOfSubCollection: 'PROTOTYPE')
						- 'PROTOTYPE' size
						+ 1.
	(protoSelector beginsWith: 'Dollar') ifTrue:
		[protoSelector := (Dictionary newFromPairs: #('DollarEquals:' #=))
							at: protoSelector].
	^protoSelector asSymbol! !

!SpurBootstrap methodsFor: 'bootstrap methods' stamp: 'eem 9/7/2013 14:01'!
stringFor: aString
	| string |
	string := oldHeap instantiateClass: (oldHeap splObj: ClassByteString) indexableSize: aString size.
	1 to: aString size do:
		[:i| oldHeap storeByte: i - 1 ofObject: string withValue: (aString at: i) asInteger].
	^string
! !

!SpurBootstrap methodsFor: 'bootstrap methods' stamp: 'eem 9/6/2013 13:17'!
symbolClass
	^oldHeap fetchClassOfNonImm: (oldHeap splObj: SelectorDoesNotUnderstand)! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 1/13/2014 11:21'!
transform
	self rememberRehashSymbol.
	self findRequiredGlobals.
	self installModifiedMethods.
	self bootstrapImage.
	self validate.
	self rememberRehashSymbol.
	self rehashImage.
	self followForwardingPointers.
	self scavengeImage.
	self freeForwarders.
	self compactImage.
	self reportSizes! !

!SpurBootstrap methodsFor: 'bootstrap image' stamp: 'eem 2/26/2014 15:22'!
validate
	| p n duplicates maxClassIndex savedEndOfMemory |
	self assert: (reverseMap at: newHeap specialObjectsOop) = oldHeap specialObjectsOop.
	self assert: (map at: oldHeap specialObjectsOop) = newHeap specialObjectsOop.
	self assert: (reverseMap at: newHeap classTableRootObj ifAbsent: []) isNil.

	duplicates := { 3. newHeap arrayClassIndexPun. newHeap weakArrayClassIndexPun }.
	maxClassIndex := classToIndex inject: 0 into: [:a :b| a max: b].
	self assert: ((newHeap arrayClassIndexPun to: maxClassIndex) select:
					[:idx| | classObj |
					(classObj := newHeap classOrNilAtIndex: idx) ~= newHeap nilObject
					and: [(newHeap classIndexOf: classObj) = (newHeap rawHashBitsOf: classObj)]]) isEmpty.
	0 to: maxClassIndex do:
		[:index| | classObj |
		(index <= newHeap tagMask
		 and: [index > newHeap isForwardedObjectClassIndexPun]) ifTrue:
			[(classObj := newHeap classOrNilAtIndex: index) = newHeap nilObject
				ifTrue:
					[self assert: (classToIndex keyAtValue: index ifAbsent: []) isNil]
				ifFalse:
					[self assert: (newHeap classIndexOf: classObj) ~= (newHeap rawHashBitsOf: classObj).
					(duplicates includes: index) ifFalse:
						[self assert: (newHeap rawHashBitsOf: classObj) = index]]]].
	classToIndex keysAndValuesDo:
		[:oldClass :idx|
		self assert: (newHeap rawHashBitsOf: (map at: oldClass)) = idx. 
		self assert: oldClass = (reverseMap at: (newHeap classAtIndex: idx))].
	n := 0.
	savedEndOfMemory := newHeap endOfMemory.
	newHeap setEndOfMemory: newHeap freeOldSpaceStart.
	newHeap allObjectsDo:
		[:o|
		(o <= newHeap trueObject
		 or: [o > lastClassTablePage]) ifTrue:
			[self assert: (reverseMap includesKey: o).
			 self assert: (newHeap fetchClassOfNonImm: o) = (map at: (oldHeap fetchClassOfNonImm: (reverseMap at: o)))].
		n := n + 1.
		p := o].
	newHeap setEndOfMemory: savedEndOfMemory.
	self touch: p.
	self assert: (n between: map size and: map size + 6). "+ 6 is room for freelists & classTable"

	"check some class properties to ensure the format changes are correct"
	self assert: (newHeap fixedFieldsOfClassFormat: (newHeap formatOfClass: newHeap classArray)) = 0.
	self assert: (newHeap instSpecOfClassFormat: (newHeap formatOfClass: newHeap classArray)) = newHeap arrayFormat! !

!SpurBootstrap methodsFor: 'bootstrap methods' stamp: 'eem 12/11/2013 09:15'!
withExecutableInterpreter: sim do: aBlock
	"With the oldInterpreter ready to execute code, evaluate aBlock,
	 then return the interpreter (and the heap) to the ``just snapshotted'' state."
	| savedpc initialContext finalContext |
	sim
		initStackPages;
		loadInitialContext;
		internalizeIPandSP.
	initialContext := sim frameContext: sim localFP.
	savedpc := sim localIP.
	"sim printHeadFrame."
	aBlock value.
	"sim printHeadFrame."
	sim
		internalPush: sim localIP;
		externalizeIPandSP.
	"now undo the execution state"
	finalContext := sim voidVMStateForSnapshotFlushingExternalPrimitivesIf: false.
	self assert: initialContext = finalContext.
	self assert: sim localIP = savedpc.
	sim objectMemory
		storePointer: SuspendedContextIndex
		ofObject: sim activeProcess
		withValue: finalContext! !

!SpurBootstrap methodsFor: 'word size' stamp: 'eem 8/30/2013 10:59'!
wordSize
	^self subclassResponsibility! !

!SpurBootstrap methodsFor: 'word size' stamp: 'eem 8/30/2013 10:59'!
wordSizeMask
	^self subclassResponsibility! !

!SpurBootstrap methodsFor: 'testing' stamp: 'eem 5/28/2014 11:09'!
writeSnapshot: imageFileName ofTransformedImage: spurHeap headerFlags: headerFlags screenSize: screenSizeInteger
	"The bootstrapped image typically contains a few big free chunks and one huge free chunk.
	 Test snapshot writing and loading by turning the largest non-huge chunks into segment bridges
	 and saving."
	| penultimate ultimate sizes counts barriers sim |
	sim := StackInterpreterSimulator onObjectMemory: spurHeap.
	sim bootstrapping: true.
	spurHeap coInterpreter: sim.
	sim initializeInterpreter: 0;
		setImageHeaderFlagsFrom: headerFlags;
		setDisplayForm: (Form extent: screenSizeInteger >> 16 @ (screenSizeInteger bitAnd: 16rFFFF)).
	spurHeap allOldSpaceEntitiesDo: [:e| penultimate := ultimate. ultimate := e].
	self assert: (spurHeap isFreeObject: penultimate).
	self assert: (spurHeap isSegmentBridge: ultimate).
	sizes := Bag new.
	spurHeap allObjectsInFreeTree: (spurHeap freeLists at: 0) do:
		[:f|
		sizes add: (spurHeap bytesInObject: f)].
	counts := sizes sortedCounts.
	self assert: counts last key = 1. "1 huge chunk"
	counts size > 1
		ifTrue:
			[self assert: ((counts at: counts size - 1) key > 2
						and: [(counts at: counts size - 1) value > 1024]).
			barriers := (1 to: (counts at: counts size - 1) key) collect:
							[:ign| spurHeap allocateOldSpaceChunkOfExactlyBytes: (counts at: counts size - 1) value].
			barriers := barriers, {spurHeap allocateOldSpaceChunkOfExactlyBytes: (spurHeap bytesInObject: penultimate)}]
		ifFalse:
			[barriers := {spurHeap allocateOldSpaceChunkOfExactlyBytes: (spurHeap bytesInObject: penultimate)}].
	barriers last ifNotNil:
		[:end|
		spurHeap setEndOfMemory: end.
		spurHeap allOldSpaceEntitiesDo: [:e| penultimate := ultimate. ultimate := e].
		self assert: (spurHeap addressAfter: ultimate) = end].
	spurHeap checkFreeSpace.
	spurHeap runLeakCheckerForFullGC: true.
	spurHeap segmentManager initializeFromFreeChunks: (barriers sort collect: [:b| spurHeap objectStartingAt: b]).
	spurHeap checkFreeSpace.
	spurHeap runLeakCheckerForFullGC: true.
	sim bereaveAllMarriedContextsForSnapshotFlushingExternalPrimitivesIf: true.
	sim imageName: imageFileName.
	sim writeImageFileIO! !

!SpurBootstrap methodsFor: 'testing' stamp: 'eem 11/17/2013 16:04'!
writeSnapshotOfTransformedImage
	self writeSnapshotOfTransformedImageAs: 'spur.image'! !

!SpurBootstrap methodsFor: 'testing' stamp: 'eem 12/11/2013 10:15'!
writeSnapshotOfTransformedImageAs: imageFileName
	"The bootstrapped image typically contains a few big free chunks and one huge free chunk.
	 Test snapshot writing and loading by turning the largest non-huge chunks into segment bridges
	 and saving."
	| penultimate ultimate heap sizes counts barriers sim |
	heap := TransformedImage veryDeepCopy.
	sim := StackInterpreterSimulator onObjectMemory: heap.
	sim bootstrapping: true.
	heap coInterpreter: sim.
	sim initializeInterpreter: 0;
		setImageHeaderFlagsFrom: ImageHeaderFlags;
		setDisplayForm: (Form extent: ImageScreenSize >> 16 @ (ImageScreenSize bitAnd: 16rFFFF)).
	heap allOldSpaceEntitiesDo: [:e| penultimate := ultimate. ultimate := e].
	self assert: (heap isFreeObject: penultimate).
	self assert: (heap isSegmentBridge: ultimate).
	sizes := Bag new.
	heap allObjectsInFreeTree: (heap freeLists at: 0) do:
		[:f|
		sizes add: (heap bytesInObject: f)].
	counts := sizes sortedCounts.
	self assert: counts last key = 1. "1 huge chunk"
	counts size > 1
		ifTrue:
			[self assert: ((counts at: counts size - 1) key > 2
						and: [(counts at: counts size - 1) value > 1024]).
			barriers := (1 to: (counts at: counts size - 1) key) collect:
							[:ign| heap allocateOldSpaceChunkOfExactlyBytes: (counts at: counts size - 1) value].
			barriers := barriers, {heap allocateOldSpaceChunkOfExactlyBytes: (heap bytesInObject: penultimate)}]
		ifFalse:
			[barriers := {heap allocateOldSpaceChunkOfExactlyBytes: (heap bytesInObject: penultimate)}].
	heap setEndOfMemory: barriers last.
	heap allOldSpaceEntitiesDo: [:e| penultimate := ultimate. ultimate := e].
	self assert: (heap addressAfter: ultimate) = barriers last.
	heap checkFreeSpace.
	heap runLeakCheckerForFullGC: true.
	heap segmentManager initializeFromFreeChunks: (barriers sort collect: [:b| heap objectStartingAt: b]).
	heap checkFreeSpace.
	heap runLeakCheckerForFullGC: true.
	sim bereaveAllMarriedContextsForSnapshotFlushingExternalPrimitivesIf: true.
	sim imageName: imageFileName.
	sim writeImageFileIO! !

SpurBootstrap subclass: #SpurBootstrap32
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Bootstrapping'!

!SpurBootstrap32 methodsFor: 'bootstrap' stamp: 'eem 8/31/2013 08:57'!
fillInBitsObject: newObj from: oldObj
	0 to: (oldHeap fetchLong32LengthOf: oldObj) - 1 do:
		[:i|
		newHeap
			storeLong32: i
			ofObject: newObj
			withValue: (oldHeap fetchLong32: i ofObject: oldObj)]! !

!SpurBootstrap32 methodsFor: 'word size' stamp: 'eem 8/30/2013 10:34'!
wordSize
	^4! !

!SpurBootstrap32 methodsFor: 'word size' stamp: 'eem 8/30/2013 10:34'!
wordSizeMask
	^3! !

SpurBootstrap subclass: #SpurBootstrap64
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Bootstrapping'!

!SpurBootstrap64 methodsFor: 'word size' stamp: 'eem 8/30/2013 10:33'!
wordSizeMask
	^7! !

InstructionClient subclass: #ETC
	instanceVariableNames: 'scanner blockEnd joinOffsets sends contextStack currentContext blockEndStack topIsVector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Scripts'!

!ETC commentStamp: '<historical>' prior: 0!
I am a quick-hack type-checker (Eliot's Type Checker) that answers a dictionary of receiver to selector sets for a given method.!

!ETC class methodsFor: 'utilities' stamp: 'eem 10/12/2009 09:22'!
sendsForMethod: aMethod
	^(self new setMethod: aMethod) sends! !

!ETC class methodsFor: 'utilities' stamp: 'eem 8/16/2010 16:07'!
sendsToInstVar: instVarName in: class
	"Answer all selectors sent to instVarName in class's methods"
	| idx ref selectors |
	idx := class instVarIndexFor: instVarName ifAbsent: [^Set new].
	ref := {#inst. idx}.
	selectors := Set new.
	class methodsDo:
		[:m| selectors addAll: ((self sendsForMethod: m) at: ref ifAbsent: [#()])].
	^selectors! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 10/12/2009 09:32'!
blockReturnTop
	"Return Top Of Stack bytecode."
	currentContext pop.
	scanner pc < blockEnd
		ifTrue: [self doJoin]
		ifFalse: [currentContext := contextStack removeLast.
				blockEnd := blockEndStack removeLast]! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 9/11/2009 13:51'!
doDup
	currentContext doDup! !

!ETC methodsFor: 'private' stamp: 'eem 9/11/2009 14:23'!
doJoin
	scanner pc < blockEnd ifTrue:
		[currentContext instVarNamed: 'stackp' put: (joinOffsets at: scanner pc)]! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 9/11/2009 13:51'!
doPop
	currentContext doPop! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 9/11/2009 13:58'!
jump: offset
	"Unconditional Jump bytecode."
	offset > 0 ifTrue:
		[joinOffsets at: scanner pc + offset put: currentContext stackPtr.
		 self doJoin]! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 10/12/2009 09:32'!
jump: offset if: condition 
	"Conditional Jump bytecode."
	currentContext pop.
	offset > 0 ifTrue:
		[joinOffsets at: scanner pc + offset put: currentContext stackPtr]! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 10/12/2009 09:54'!
methodReturnConstant: value
	currentContext isExecutingBlock
		ifTrue: [currentContext push: value.
				self blockReturnTop]
		ifFalse: [self doJoin]! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 10/12/2009 09:56'!
methodReturnReceiver
	currentContext isExecutingBlock
		ifTrue: [self pushReceiver.
				self blockReturnTop]
		ifFalse: [self doJoin]! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 10/12/2009 09:57'!
methodReturnTop
	currentContext isExecutingBlock
		ifTrue: [self blockReturnTop]
		ifFalse: [currentContext pop.
				self doJoin]! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 10/12/2009 09:32'!
popIntoLiteralVariable: anAssociation
	currentContext pop! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 10/12/2009 09:32'!
popIntoReceiverVariable: offset
	currentContext pop! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 10/12/2009 09:33'!
popIntoRemoteTemp: remoteTempIndex inVectorAt: tempVectorIndex
	currentContext pop! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 10/12/2009 09:33'!
popIntoTemporaryVariable: offset
	| vector |
	topIsVector
		ifTrue:
			[vector := currentContext top.
			 1 to: vector size do:
				[:i|
				vector
					at: i
					put: 'remote ', i printString,
						' @ ', (offset + 1) printString,
						' in ', currentContext startpc printString].
			 currentContext popIntoTemporaryVariable: offset]
		ifFalse:
			[currentContext pop]! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 9/11/2009 14:00'!
pushActiveContext
	currentContext pushActiveContext! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 11/6/2012 10:58'!
pushClosureCopyNumCopiedValues: numCopied numArgs: numArgs blockSize: blockSize
	"Push Closure bytecode.  Either compute the end of the block if this is
	 the block we're analysing, or skip it, adjusting the stack as appropriate."
	| blockClosure j |
	blockEndStack addLast: blockEnd.
	blockEnd := scanner pc + blockSize.
	contextStack addLast: currentContext.
	currentContext
		pc: scanner pc;
		pushClosureCopyNumCopiedValues: numCopied numArgs: numArgs blockSize: blockSize.
	blockClosure := currentContext top.
	currentContext := blockClosure asContext.
	1 to: numArgs do:
		[:i| currentContext push: 'blkarg', i printString].
	1 to: numCopied do:
		[:i| currentContext push: (blockClosure at: i)].
	j := numArgs + numCopied.
	[scanner willPushNil] whileTrue:
		[scanner interpretNextInstructionFor: self.
		 currentContext at: currentContext stackPtr put: 'blktmp', (j := j + 1) printString]

	"ETC sendsForMethod: (ETC compiledMethodAt: #pushClosureCopyNumCopiedValues:numArgs:blockSize:)"! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 9/11/2009 15:38'!
pushConsArrayWithElements: numElements
	currentContext pushConsArrayWithElements: numElements! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 9/11/2009 14:07'!
pushConstant: value
	currentContext pushConstant: value! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 9/11/2009 14:08'!
pushLiteralVariable: anAssociation
	currentContext push: anAssociation! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 9/11/2009 15:38'!
pushNewArrayOfSize: numElements
	currentContext pushNewArrayOfSize: numElements.
	scanner willStorePop ifTrue:
		[topIsVector := true.
		 scanner interpretNextInstructionFor: self.
		 topIsVector := false]! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 9/11/2009 14:08'!
pushReceiver
	currentContext push: #self! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 10/12/2009 09:29'!
pushReceiverVariable: offset
	currentContext push: {#inst. offset + 1}! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 9/11/2009 14:09'!
pushRemoteTemp: remoteTempIndex inVectorAt: tempVectorIndex
	currentContext pushRemoteTemp: remoteTempIndex inVectorAt: tempVectorIndex! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 9/11/2009 14:10'!
pushTemporaryVariable: offset
	currentContext pushTemporaryVariable: offset! !

!ETC methodsFor: 'instruction decoding' stamp: 'eem 10/12/2009 09:36'!
send: selector super: supered numArgs: numArgs
	numArgs timesRepeat: [currentContext pop].
	currentContext pop ifNotNil:
		[:top|
		((top isArray and: [top size = 2 and: [top first == #inst]])
		 or: [top == #self]) ifTrue:
			[(sends at: top ifAbsentPut: [Set new]) add: selector]].
	currentContext push: 'send ', selector! !

!ETC methodsFor: 'results' stamp: 'eem 10/12/2009 09:22'!
sends
	[scanner atEnd] whileFalse:
		[scanner interpretNextInstructionFor: self].
	^sends! !

!ETC methodsFor: 'initialize-release' stamp: 'eem 10/12/2009 09:35'!
setMethod: aCompiledMethod
	scanner := InstructionStream new method: aCompiledMethod pc: aCompiledMethod initialPC.
	contextStack := OrderedCollection new.
	currentContext := MethodContext
						sender: nil
						receiver: nil
						method: aCompiledMethod
						arguments: ((1 to: aCompiledMethod numArgs) collect:
										[:i| 'arg', i printString]).
	aCompiledMethod numArgs + 1 to: aCompiledMethod numTemps do:
		[:i| currentContext at: i put: 'tmp', (i - aCompiledMethod numArgs) printString].
	sends := Dictionary new.
	joinOffsets := Dictionary new.
	blockEndStack := OrderedCollection new.
	blockEnd := aCompiledMethod endPC.
	topIsVector := false! !

SmartSyntaxInterpreterPlugin subclass: #BochsIA32Plugin
	instanceVariableNames: 'prevInterruptCheckChain'
	classVariableNames: ''
	poolDictionaries: 'VMBasicConstants'
	category: 'Cog-ProcessorPlugins'!

!BochsIA32Plugin commentStamp: '<historical>' prior: 0!
I provide access to the Bochs C++ IA32 processor emulator.!

!BochsIA32Plugin class methodsFor: 'translation' stamp: 'eem 1/15/2009 15:23'!
declareCVarsIn: aCCodeGenerator
	"prevInterruptCheckChain lives in sqBochsIA32Plugin.c"
	super declareCVarsIn: aCCodeGenerator.
	aCCodeGenerator removeVariable: 'prevInterruptCheckChain'! !

!BochsIA32Plugin class methodsFor: 'translation' stamp: 'eem 12/3/2008 10:25'!
hasHeaderFile
	"We need a header to declare newcpu and pull in bochs.h & cpu.h"
	^true! !

!BochsIA32Plugin methodsFor: 'interruption' stamp: 'eem 10/20/2010 12:16'!
forceStopOnInterrupt
	interpreterProxy getInterruptPending ifTrue:
		[self forceStopRunning]! !

!BochsIA32Plugin methodsFor: 'primitives' stamp: 'eem 10/5/2009 14:00'!
"cpuAlien <BochsIA32Alien>" primitiveDisassembleAt: address "<Integer>" InMemory: memory "<Bitmap|ByteArray|WordArray>"
	"Return an Array of the instruction length and its decompilation as a string for the instruction at address in memory."
	| cpuAlien cpu instrLenOrErr resultObj log logLen logObj logObjData |
	<var: #cpu type: #'void *'>
	cpuAlien := self primitive: #primitiveDisassembleAtInMemory
					parameters: #(Unsigned WordsOrBytes)
					receiver: #Oop.
	(cpu := self startOfData: cpuAlien) = 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrBadReceiver].
	instrLenOrErr := self disassembleFor: cpu
						At: address
						In: memory
						Size: (interpreterProxy byteSizeOf: memory cPtrAsOop).
	instrLenOrErr < 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrInappropriate].
	log := self getlog: (self cCode: [self addressOf: logLen] inSmalltalk: [logLen := 0]).
	resultObj := interpreterProxy instantiateClass: interpreterProxy classArray indexableSize: 2.
	resultObj = 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrNoMemory].

	"Easier keeping the damn thing on the stack than using pushRemappableOop:/popRemappableOop.
	 Where is topRemappableOop when you need it?"
	interpreterProxy pushRemappableOop: resultObj.
	logObj := interpreterProxy
				instantiateClass: interpreterProxy classString
				indexableSize: logLen.
	interpreterProxy failed ifTrue:
		[interpreterProxy popRemappableOop.
		 ^interpreterProxy primitiveFailFor: PrimErrNoMemory].
	logObjData := interpreterProxy arrayValueOf: logObj.
	self cCode: 'memcpy(logObjData, log, logLen)' inSmalltalk: [logObjData. log].
	resultObj := interpreterProxy popRemappableOop.
	interpreterProxy
		storePointer: 0
		ofObject: resultObj
		withValue: (interpreterProxy integerObjectOf: instrLenOrErr).
	interpreterProxy storePointer: 1 ofObject: resultObj withValue: logObj.

	^resultObj! !

!BochsIA32Plugin methodsFor: 'primitives' stamp: 'eem 10/5/2009 14:00'!
primitiveErrorAndLog
	| log logLen resultObj logObj logObjData |
	<var: #log type: #'char *'>
	<var: #logObjData type: #'char *'>
	self primitive: #primitiveErrorAndLog parameters: #().

	log := self getlog: (self cCode: [self addressOf: logLen] inSmalltalk: [logLen := 0]).
	resultObj := interpreterProxy instantiateClass: interpreterProxy classArray indexableSize: 2.
	resultObj = 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrNoMemory].

	interpreterProxy
		storePointer: 0
		ofObject: resultObj
		withValue: (interpreterProxy integerObjectOf: self errorAcorn).

	logLen > 0 ifTrue:
		[interpreterProxy pushRemappableOop: resultObj.
		logObj := interpreterProxy
					instantiateClass: interpreterProxy classString
					indexableSize: logLen.
		interpreterProxy failed ifTrue:
			[interpreterProxy popRemappableOop.
			 ^interpreterProxy primitiveFailFor: PrimErrNoMemory].

		resultObj := interpreterProxy popRemappableOop.
		logObjData := interpreterProxy arrayValueOf: logObj.
		self cCode: 'memcpy(logObjData, log, logLen)' inSmalltalk: [logObjData. log].
		interpreterProxy storePointer: 1 ofObject: resultObj withValue: logObj].
	interpreterProxy pop: 1 thenPush: resultObj! !

!BochsIA32Plugin methodsFor: 'primitives' stamp: 'eem 1/15/2009 09:57'!
"cpuAlien <BochsIA32Alien>" primitiveFlushICacheFrom: startAddress "<Integer>" To: endAddress "<Integer>"
	"Flush the icache in the requested range"
	| cpuAlien cpu |
	<var: #cpu type: 'void *'>
	cpuAlien := self primitive: #primitiveFlushICacheFromTo
					parameters: #(Unsigned Unsigned)
					receiver: #Oop.
	(cpu := self startOfData: cpuAlien) = 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrBadReceiver].
	self flushICache: cpu From: startAddress To: endAddress! !

!BochsIA32Plugin methodsFor: 'primitives' stamp: 'eem 1/14/2009 15:28'!
primitiveNewCPU
	| cpu |
	<var: #cpu type: 'void *'>
	self primitive: #primitiveNewCPU parameters: #().

	cpu := self cCode: 'newCPU()' inSmalltalk: [0].
	cpu = 0 ifTrue:
		[^interpreterProxy primitiveFail].
	interpreterProxy
		pop: 1
		thenPush: (interpreterProxy positive32BitIntegerFor:
										(self cCoerceSimple: cpu
											to: 'unsigned long'))! !

!BochsIA32Plugin methodsFor: 'primitives' stamp: 'eem 1/14/2009 15:28'!
primitiveResetCPU
	| cpuAlien cpu maybeErr |
	<var: #cpu type: 'void *'>
	cpuAlien := self primitive: #primitiveResetCPU parameters: #() receiver: #Oop.
	(cpu := self startOfData: cpuAlien) = 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrBadReceiver].
	maybeErr := self resetCPU: cpu.
	maybeErr ~= 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrInappropriate].
	^cpuAlien! !

!BochsIA32Plugin methodsFor: 'primitives' stamp: 'eem 7/19/2013 11:37'!
"cpuAlien <BochsIA32Alien>" primitiveRunInMemory: memory "<Bitmap|ByteArray|WordArray>" minimumAddress: minAddress "<Integer>" maximumAddress: maxAddress "<Integer>" readOnlyBelow: minWriteMaxExecAddress "<Integer>"
	"Run the cpu using the first argument as the memory and the following arguments defining valid addresses, running until it halts or hits an exception."
	| cpuAlien cpu memorySize maybeErr |
	<var: #cpu type: #'void *'>
	cpuAlien := self primitive: #primitiveRunInMemoryMinAddressMaxAddressReadWrite
					parameters: #(WordsOrBytes Unsigned Unsigned Unsigned)
					receiver: #Oop.
	(cpu := self startOfData: cpuAlien) = 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrBadReceiver].
	prevInterruptCheckChain := interpreterProxy setInterruptCheckChain: #forceStopOnInterrupt asSymbol.
	prevInterruptCheckChain = #forceStopOnInterrupt asSymbol ifTrue:
		[prevInterruptCheckChain = 0].
	memorySize := interpreterProxy byteSizeOf: memory cPtrAsOop.
	maybeErr := self runCPU: cpu
					In: memory
					Size: (memorySize min: maxAddress)
					MinAddressRead: minAddress
					Write: minWriteMaxExecAddress.
	interpreterProxy setInterruptCheckChain: prevInterruptCheckChain.
	maybeErr ~= 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrInappropriate].
	^cpuAlien! !

!BochsIA32Plugin methodsFor: 'primitives' stamp: 'eem 10/20/2010 16:08'!
"cpuAlien <BochsIA32Alien>" primitiveRunInMemory: memory "<Bitmap|ByteArray|WordArray>" minimumAddress: minAddress "<Integer>" readOnlyBelow: minWriteMaxExecAddress "<Integer>"
	"Run the cpu using the first argument as the memory and the following arguments defining valid addresses, running until it halts or hits an exception."
	| cpuAlien cpu maybeErr |
	<var: #cpu type: #'void *'>
	cpuAlien := self primitive: #primitiveRunInMemoryMinimumAddressReadWrite
					parameters: #(WordsOrBytes Unsigned Unsigned)
					receiver: #Oop.
	(cpu := self startOfData: cpuAlien) = 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrBadReceiver].
	prevInterruptCheckChain := interpreterProxy setInterruptCheckChain: #forceStopOnInterrupt asSymbol.
	prevInterruptCheckChain = #forceStopOnInterrupt asSymbol ifTrue:
		[prevInterruptCheckChain = 0].
	maybeErr := self runCPU: cpu
					In: memory
					Size: (interpreterProxy byteSizeOf: memory cPtrAsOop)
					MinAddressRead: minAddress
					Write: minWriteMaxExecAddress.
	interpreterProxy setInterruptCheckChain: prevInterruptCheckChain.
	maybeErr ~= 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrInappropriate].
	^cpuAlien! !

!BochsIA32Plugin methodsFor: 'primitives' stamp: 'eem 7/19/2013 11:38'!
"cpuAlien <BochsIA32Alien>" primitiveSingleStepInMemory: memory "<Bitmap|ByteArray|WordArray>" minimumAddress: minAddress "<Integer>" maximumAddress: maxAddress "<Integer>" readOnlyBelow: minWriteMaxExecAddress "<Integer>"
	"Single-step the cpu using the first argument as the memory and the following arguments defining valid addresses."
	| cpuAlien cpu memorySize maybeErr |
	<var: #cpu type: #'void *'>
	cpuAlien := self primitive: #primitiveSingleStepInMemoryMinAddressMaxAddressReadWrite
					parameters: #(WordsOrBytes Unsigned Unsigned Unsigned)
					receiver: #Oop.
	(cpu := self startOfData: cpuAlien) = 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrBadReceiver].
	memorySize := interpreterProxy byteSizeOf: memory cPtrAsOop.
	maybeErr := self singleStepCPU: cpu
					In: memory
					Size: (memorySize min: maxAddress)
					MinAddressRead: minAddress
					Write: minWriteMaxExecAddress.
	maybeErr ~= 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrInappropriate].
	^cpuAlien! !

!BochsIA32Plugin methodsFor: 'primitives' stamp: 'eem 10/20/2010 16:08'!
"cpuAlien <BochsIA32Alien>" primitiveSingleStepInMemory: memory "<Bitmap|ByteArray|WordArray>" minimumAddress: minAddress "<Integer>"  readOnlyBelow: minWriteMaxExecAddress "<Integer>"
	"Single-step the cpu using the first argument as the memory and the following arguments defining valid addresses."
	| cpuAlien cpu maybeErr |
	<var: #cpu type: #'void *'>
	cpuAlien := self primitive: #primitiveSingleStepInMemoryMinimumAddressReadWrite
					parameters: #(WordsOrBytes Unsigned Unsigned)
					receiver: #Oop.
	(cpu := self startOfData: cpuAlien) = 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrBadReceiver].
	maybeErr := self singleStepCPU: cpu
					In: memory
					Size: (interpreterProxy byteSizeOf: memory cPtrAsOop)
					MinAddressRead: minAddress
					Write: minWriteMaxExecAddress.
	maybeErr ~= 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrInappropriate].
	^cpuAlien! !

!BochsIA32Plugin methodsFor: 'alien support' stamp: 'eem (auto pragmas 12/08) 12/11/2008 09:57'!
sizeField: rcvr
	"Answer the first field of rcvr which is assumed to be an Alien of at least 8 bytes"
	<inline: true>
	^self longAt: rcvr + BaseHeaderSize! !

!BochsIA32Plugin methodsFor: 'alien support' stamp: 'eem (auto pragmas 12/08) 12/11/2008 09:55'!
startOfData: rcvr "<Alien oop> ^<Integer>"
	"Answer the start of rcvr's data.  For direct aliens this is the address of
	 the second field.  For indirect and pointer aliens it is what the second field points to."
	<inline: true>
	^(self sizeField: rcvr) > 0
	 	ifTrue: [rcvr + BaseHeaderSize + BytesPerOop]
		ifFalse: [self longAt: rcvr + BaseHeaderSize + BytesPerOop]! !

SmartSyntaxInterpreterPlugin subclass: #GdbARMPlugin
	instanceVariableNames: 'prevInterruptCheckChain'
	classVariableNames: ''
	poolDictionaries: 'VMBasicConstants'
	category: 'Cog-ProcessorPlugins'!

!GdbARMPlugin commentStamp: '<historical>' prior: 0!
I provide access to the ARMulator ARM emulator and the libopcodes ARM disassembler.!

!GdbARMPlugin class methodsFor: 'translation' stamp: 'eem 1/15/2009 15:23'!
declareCVarsIn: aCCodeGenerator
	"prevInterruptCheckChain lives in sqGdbARMPlugin.c"
	super declareCVarsIn: aCCodeGenerator.
	aCCodeGenerator removeVariable: 'prevInterruptCheckChain'! !

!GdbARMPlugin class methodsFor: 'translation' stamp: 'eem 12/3/2008 10:25'!
hasHeaderFile
	"We need a header to declare newcpu and pull in bochs.h & cpu.h"
	^true! !

!GdbARMPlugin methodsFor: 'interruption' stamp: 'eem 10/20/2010 12:16'!
forceStopOnInterrupt
	interpreterProxy getInterruptPending ifTrue:
		[self forceStopRunning]! !

!GdbARMPlugin methodsFor: 'primitives' stamp: 'eem 10/5/2009 14:00'!
"cpuAlien <GdbARMAlien>" primitiveDisassembleAt: address "<Integer>" InMemory: memory "<Bitmap|ByteArray|WordArray>"
	"Return an Array of the instruction length and its decompilation as a string for the instruction at address in memory."
	| cpuAlien cpu instrLenOrErr resultObj log logLen logObj logObjData |
	<var: #cpu type: #'void *'>
	cpuAlien := self primitive: #primitiveDisassembleAtInMemory
					parameters: #(Unsigned WordsOrBytes)
					receiver: #Oop.
	(cpu := self startOfData: cpuAlien) = 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrBadReceiver].
	instrLenOrErr := self disassembleFor: cpu
						At: address
						In: memory
						Size: (interpreterProxy byteSizeOf: memory cPtrAsOop).
	instrLenOrErr < 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrInappropriate].
	log := self getlog: (self cCode: [self addressOf: logLen] inSmalltalk: [logLen := 0]).
	resultObj := interpreterProxy instantiateClass: interpreterProxy classArray indexableSize: 2.
	resultObj = 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrNoMemory].

	"Easier keeping the damn thing on the stack than using pushRemappableOop:/popRemappableOop.
	 Where is topRemappableOop when you need it?"
	interpreterProxy pushRemappableOop: resultObj.
	logObj := interpreterProxy
				instantiateClass: interpreterProxy classString
				indexableSize: logLen.
	interpreterProxy failed ifTrue:
		[interpreterProxy popRemappableOop.
		 ^interpreterProxy primitiveFailFor: PrimErrNoMemory].
	logObjData := interpreterProxy arrayValueOf: logObj.
	self cCode: 'memcpy(logObjData, log, logLen)' inSmalltalk: [logObjData. log].
	resultObj := interpreterProxy popRemappableOop.
	interpreterProxy
		storePointer: 0
		ofObject: resultObj
		withValue: (interpreterProxy integerObjectOf: instrLenOrErr).
	interpreterProxy storePointer: 1 ofObject: resultObj withValue: logObj.

	^resultObj! !

!GdbARMPlugin methodsFor: 'primitives' stamp: 'eem 10/5/2009 14:00'!
primitiveErrorAndLog
	| log logLen resultObj logObj logObjData |
	<var: #log type: #'char *'>
	<var: #logObjData type: #'char *'>
	self primitive: #primitiveErrorAndLog parameters: #().

	log := self getlog: (self cCode: [self addressOf: logLen] inSmalltalk: [logLen := 0]).
	resultObj := interpreterProxy instantiateClass: interpreterProxy classArray indexableSize: 2.
	resultObj = 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrNoMemory].

	interpreterProxy
		storePointer: 0
		ofObject: resultObj
		withValue: (interpreterProxy integerObjectOf: self errorAcorn).

	logLen > 0 ifTrue:
		[interpreterProxy pushRemappableOop: resultObj.
		logObj := interpreterProxy
					instantiateClass: interpreterProxy classString
					indexableSize: logLen.
		interpreterProxy failed ifTrue:
			[interpreterProxy popRemappableOop.
			 ^interpreterProxy primitiveFailFor: PrimErrNoMemory].

		resultObj := interpreterProxy popRemappableOop.
		logObjData := interpreterProxy arrayValueOf: logObj.
		self cCode: 'memcpy(logObjData, log, logLen)' inSmalltalk: [logObjData. log].
		interpreterProxy storePointer: 1 ofObject: resultObj withValue: logObj].
	interpreterProxy pop: 1 thenPush: resultObj! !

!GdbARMPlugin methodsFor: 'primitives' stamp: 'eem 1/15/2009 09:57'!
"cpuAlien <GdbARMAlien>" primitiveFlushICacheFrom: startAddress "<Integer>" To: endAddress "<Integer>"
	"Flush the icache in the requested range"
	| cpuAlien cpu |
	<var: #cpu type: 'void *'>
	cpuAlien := self primitive: #primitiveFlushICacheFromTo
					parameters: #(Unsigned Unsigned)
					receiver: #Oop.
	(cpu := self startOfData: cpuAlien) = 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrBadReceiver].
	self flushICache: cpu From: startAddress To: endAddress! !

!GdbARMPlugin methodsFor: 'primitives' stamp: 'eem 1/14/2009 15:28'!
primitiveNewCPU
	| cpu |
	<var: #cpu type: 'void *'>
	self primitive: #primitiveNewCPU parameters: #().

	cpu := self cCode: 'newCPU()' inSmalltalk: [0].
	cpu = 0 ifTrue:
		[^interpreterProxy primitiveFail].
	interpreterProxy
		pop: 1
		thenPush: (interpreterProxy positive32BitIntegerFor:
										(self cCoerceSimple: cpu
											to: 'unsigned long'))! !

!GdbARMPlugin methodsFor: 'primitives' stamp: 'eem 1/14/2009 15:28'!
primitiveResetCPU
	| cpuAlien cpu maybeErr |
	<var: #cpu type: 'void *'>
	cpuAlien := self primitive: #primitiveResetCPU parameters: #() receiver: #Oop.
	(cpu := self startOfData: cpuAlien) = 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrBadReceiver].
	maybeErr := self resetCPU: cpu.
	maybeErr ~= 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrInappropriate].
	^cpuAlien! !

!GdbARMPlugin methodsFor: 'primitives' stamp: 'eem 11/21/2013 16:40'!
"cpuAlien <GdbARMAlien>" primitiveRunInMemory: memory "<Bitmap|ByteArray|WordArray>" minimumAddress: minAddress "<Integer>" maximumAddress: maxAddress "<Integer>" readOnlyBelow: minWriteMaxExecAddress "<Integer>"
	"Run the cpu using the first argument as the memory and the following arguments defining valid addresses, running until it halts or hits an exception."
	| cpuAlien cpu memorySize maybeErr |
	<var: #cpu type: #'void *'>
	cpuAlien := self primitive: #primitiveRunInMemoryMinAddressMaxAddressReadWrite
					parameters: #(WordsOrBytes Unsigned Unsigned Unsigned)
					receiver: #Oop.
	(cpu := self startOfData: cpuAlien) = 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrBadReceiver].
	prevInterruptCheckChain := interpreterProxy setInterruptCheckChain: #forceStopOnInterrupt asSymbol.
	prevInterruptCheckChain = #forceStopOnInterrupt asSymbol ifTrue:
		[prevInterruptCheckChain = 0].
	memorySize := interpreterProxy byteSizeOf: memory cPtrAsOop.
	maybeErr := self runCPU: cpu
					In: memory
					Size: (memorySize min: maxAddress)
					MinAddressRead: minAddress
					Write: minWriteMaxExecAddress.
	interpreterProxy setInterruptCheckChain: prevInterruptCheckChain.
	maybeErr ~= 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrInappropriate].
	^cpuAlien! !

!GdbARMPlugin methodsFor: 'primitives' stamp: 'tpr 5/8/2014 08:23'!
"cpuAlien <GdbARMAlien>" primitiveRunInMemory: memory "<Bitmap|ByteArray|WordArray>" minimumAddress: minAddress "<Integer>" readOnlyBelow: minWriteMaxExecAddress "<Integer>"
	"Run the cpu using the first argument as the memory and the following arguments defining valid addresses, running until it halts or hits an exception.
	Note that minWriteMaxExecAddress is both the minimum writeable address AND the maximum executable address"
	| cpuAlien cpu maybeErr |
	<var: #cpu type: #'void *'>
	cpuAlien := self primitive: #primitiveRunInMemoryMinimumAddressReadWrite
					parameters: #(WordsOrBytes Unsigned Unsigned)
					receiver: #Oop.
	(cpu := self startOfData: cpuAlien) = 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrBadReceiver].
	prevInterruptCheckChain := interpreterProxy setInterruptCheckChain: #forceStopOnInterrupt asSymbol.
	prevInterruptCheckChain = #forceStopOnInterrupt asSymbol ifTrue:
		[prevInterruptCheckChain = 0].
	maybeErr := self runCPU: cpu
					In: memory
					Size: (interpreterProxy byteSizeOf: memory cPtrAsOop)
					MinAddressRead: minAddress
					Write: minWriteMaxExecAddress.
	interpreterProxy setInterruptCheckChain: prevInterruptCheckChain.
	maybeErr ~= 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrInappropriate].
	^cpuAlien! !

!GdbARMPlugin methodsFor: 'primitives' stamp: 'eem 11/21/2013 16:37'!
"cpuAlien <GdbARMAlien>" primitiveSingleStepInMemory: memory "<Bitmap|ByteArray|WordArray>" minimumAddress: minAddress "<Integer>" maximumAddress: maxAddress "<Integer>" readOnlyBelow: minWriteMaxExecAddress "<Integer>"
	"Single-step the cpu using the first argument as the memory and the following arguments defining valid addresses, running until it halts or hits an exception."
	| cpuAlien cpu memorySize maybeErr |
	<var: #cpu type: #'void *'>
	cpuAlien := self primitive: #primitiveSingleStepInMemoryMinAddressMaxAddressReadWrite
					parameters: #(WordsOrBytes Unsigned Unsigned Unsigned)
					receiver: #Oop.
	(cpu := self startOfData: cpuAlien) = 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrBadReceiver].
	prevInterruptCheckChain := interpreterProxy setInterruptCheckChain: #forceStopOnInterrupt asSymbol.
	prevInterruptCheckChain = #forceStopOnInterrupt asSymbol ifTrue:
		[prevInterruptCheckChain = 0].
	memorySize := interpreterProxy byteSizeOf: memory cPtrAsOop.
	maybeErr := self singleStepCPU: cpu
					In: memory
					Size: (memorySize min: maxAddress)
					MinAddressRead: minAddress
					Write: minWriteMaxExecAddress.
	interpreterProxy setInterruptCheckChain: prevInterruptCheckChain.
	maybeErr ~= 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrInappropriate].
	^cpuAlien! !

!GdbARMPlugin methodsFor: 'primitives' stamp: 'eem 10/20/2010 16:08'!
"cpuAlien <GdbARMAlien>" primitiveSingleStepInMemory: memory "<Bitmap|ByteArray|WordArray>" minimumAddress: minAddress "<Integer>"  readOnlyBelow: minWriteMaxExecAddress "<Integer>"
	"Single-step the cpu using the first argument as the memory and the following arguments defining valid addresses."
	| cpuAlien cpu maybeErr |
	<var: #cpu type: #'void *'>
	cpuAlien := self primitive: #primitiveSingleStepInMemoryMinimumAddressReadWrite
					parameters: #(WordsOrBytes Unsigned Unsigned)
					receiver: #Oop.
	(cpu := self startOfData: cpuAlien) = 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrBadReceiver].
	maybeErr := self singleStepCPU: cpu
					In: memory
					Size: (interpreterProxy byteSizeOf: memory cPtrAsOop)
					MinAddressRead: minAddress
					Write: minWriteMaxExecAddress.
	maybeErr ~= 0 ifTrue:
		[^interpreterProxy primitiveFailFor: PrimErrInappropriate].
	^cpuAlien! !

!GdbARMPlugin methodsFor: 'alien support' stamp: 'eem (auto pragmas 12/08) 12/11/2008 09:57'!
sizeField: rcvr
	"Answer the first field of rcvr which is assumed to be an Alien of at least 8 bytes"
	<inline: true>
	^self longAt: rcvr + BaseHeaderSize! !

!GdbARMPlugin methodsFor: 'alien support' stamp: 'eem (auto pragmas 12/08) 12/11/2008 09:55'!
startOfData: rcvr "<Alien oop> ^<Integer>"
	"Answer the start of rcvr's data.  For direct aliens this is the address of
	 the second field.  For indirect and pointer aliens it is what the second field points to."
	<inline: true>
	^(self sizeField: rcvr) > 0
	 	ifTrue: [rcvr + BaseHeaderSize + BytesPerOop]
		ifFalse: [self longAt: rcvr + BaseHeaderSize + BytesPerOop]! !

!MethodContext methodsFor: '*Cog-Tests-xrays' stamp: 'eem 6/16/2009 18:52'!
xray
	"Lift the veil from a context and answer an integer describing its interior state.
	 Used for e.g. VM tests so they can verify they're testing what they think they're testing.
	 0 implies a vanilla heap context.
	 Bit 0 = is or was married to a frame
	 Bit 1 = is still married to a frame
	 Bit 2 = frame is executing machine code
	 Bit 3 = has machine code pc (as opposed to nil or a bytecode pc)
	 Bit 4 = method is currently compiled to machine code"
	<primitive: 213>
	^0 "Can only fail if unimplemented; therefore simply answer 0"! !

!MethodContext methodsFor: '*Cog-Tests-xrays' stamp: 'eem 6/16/2009 18:44'!
xrayIsDivorced
	^(self xray bitAnd: 3) = 1! !

!MethodContext methodsFor: '*Cog-Tests-xrays' stamp: 'eem 6/16/2009 18:52'!
xrayIsExecutingMachineCode
	^self xray anyMask: 4! !

!MethodContext methodsFor: '*Cog-Tests-xrays' stamp: 'eem 6/16/2009 18:43'!
xrayIsMarried
	^self xray anyMask: 2! !

!MethodContext methodsFor: '*Cog-Tests-xrays' stamp: 'eem 6/16/2009 18:52'!
xrayLastExecutedMachineCode
	^self xray anyMask: 8! !

!MethodContext methodsFor: '*Cog-Tests-xrays' stamp: 'eem 6/16/2009 18:53'!
xrayMethodIsCompiledToMachineCode
	^self xray anyMask: 16! !

AbstractLauncher subclass: #CommandLineLauncher
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Scripting'!

!CommandLineLauncher class methodsFor: 'activation' stamp: 'eem 10/23/2008 13:41'!
activate
	"Register this launcher with the auto start class"

	self autoStarter addLauncherFirst: self! !

!CommandLineLauncher class methodsFor: 'accessing' stamp: 'eem 10/23/2008 13:56'!
extractParameters

	| pName value index globals |
	globals := Dictionary new.
	index := 2.
	[pName := Smalltalk getSystemAttribute: index.
	pName isEmptyOrNil] whileFalse:[
		index := index + 1.
		value := Smalltalk getSystemAttribute: index.
		value ifNil: [value := ''].
 		globals at: pName asLowercase put: value.
		index := index + 1].
	^globals! !

!CommandLineLauncher class methodsFor: 'class initialization' stamp: 'eem 10/23/2008 13:45'!
initialize
	self activate! !

!CommandLineLauncher methodsFor: 'running' stamp: 'eem 10/23/2008 14:05'!
parameters: startupParameters
	"AnstractLauncher class>>extractParameters extracts from the wrong index for Mac OS"
	super parameters: self class extractParameters! !

!CommandLineLauncher methodsFor: 'running' stamp: 'eem 10/23/2008 14:09'!
startUp
	"UnixProcess stdOut print: parameters; nl."
	(parameters includesKey: '-doit') ifTrue:
		[Compiler evaluate: (parameters at: '-doit').
		 Smalltalk quitPrimitive]! !

Object subclass: #CrashReportsMailer
	instanceVariableNames: 'mailDirectory destination startDate endDate rs causes soloTime meetingTime'
	classVariableNames: ''
	poolDictionaries: 'ChronologyConstants'
	category: 'Cog-Scripts'!

!CrashReportsMailer commentStamp: '<historical>' prior: 0!
This class generates an almost complete crash report that still needs editing for categories and then posts it after editing.!

!CrashReportsMailer class methodsFor: 'instance creation' stamp: 'eem 6/25/2010 14:16'!
mailDirectory: aFileDirectoryOrString destination: anEmailAddress week: startDate
	^self new
		mailDirectory: aFileDirectoryOrString
		destination: anEmailAddress
		startDate: (TimeStamp fromSeconds: startDate asDate asSeconds)
		endDate:  (TimeStamp fromSeconds: (startDate asDate addDays: 7) asSeconds)

	"(self mailDirectory: '/Users/eliot/Library/Mail/IMAP-emiranda@ussc9-mail01.qwaq.com/INBOX.imapmbox/Messages'
		destination: 'eng@teleplace.com'
		week: '05/15/2010') generateReport"! !

!CrashReportsMailer class methodsFor: 'instance creation' stamp: 'eem 6/28/2010 14:05'!
mailDirectory: aFileDirectoryOrString destination: anEmailAddress week: startDateString soloTime: soloDurationOrString meetingTime: meetingDurationOrString
	| startDate |
	startDate := ((startDateString includes: $-)
					ifTrue: [(#(2 3 1) collect: [:i| (startDateString subStrings: '-') at: i]) fold: [:a :b| a,'/',b]]
					ifFalse: [startDateString]) asDate.
	^self new
		mailDirectory: aFileDirectoryOrString
		destination: anEmailAddress
		startDate: (TimeStamp fromSeconds: startDate asSeconds)
		endDate:  (TimeStamp fromSeconds: (startDate addDays: 7) asSeconds - 1)
		soloTime: soloDurationOrString asDuration
		meetingTime: meetingDurationOrString asDuration

	"(self mailDirectory: '/Users/eliot/Library/Mail/IMAP-emiranda@ussc9-mail01.qwaq.com/INBOX.imapmbox/Messages'
		destination: 'eng@teleplace.com'
		week: '05/15/2010'
		soloTime: '20:19:38:55'
		meetingTime: '7:23:44:45') generateReport"! !

!CrashReportsMailer methodsFor: 'reporting' stamp: 'eem 6/25/2010 20:41'!
addReportFor: lines
	rs	resetContents;
		tab;
		nextPutAll: ((lines detect: [:l| l beginsWith: 'Subject:']) ifNotNil:
							[:l| l allButFirst: (l indexOfSubCollection: ' Teleplace Bug')]);
		crtab: 2;
		nextPutAll: (lines detect: [:l| l beginsWith: 'Date:']);
		cr.
	((lines anySatisfy: [:l| (l beginsWith: 'OS Version') and: [l includesSubString: 'Mac OS X']])
		ifTrue: [self reportForMacOS: lines]
		ifFalse: [(lines anySatisfy: [:l| l beginsWith: 'Module:'])
					ifTrue: [self reportForOldWin32: lines]
					ifFalse: [self reportForNewWin32: lines]]) ifNotNil:
			[:cause|
			(causes at: cause ifAbsentPut: [OrderedCollection new])
				addLast: rs contents]! !

!CrashReportsMailer methodsFor: 'parsing' stamp: 'eem 6/28/2010 12:07'!
breakIntoLines: aString
	^self pruneBogusEmptyLines:
		(Array streamContents:
			[:os| | is ss char |
			is := aString readStream.
			ss := ReadWriteStream on: String new.
			[is atEnd] whileFalse:
				[(char := is next) = Character lf
					ifTrue:
						[os nextPut: ss contents.
						 ss resetContents]
					ifFalse: [ss nextPut: char]].
			ss position > 0 ifTrue:
				[os nextPut: ss contents]])! !

!CrashReportsMailer methodsFor: 'parsing' stamp: 'eem 8/9/2010 13:42'!
candidateMessagesDo: aBlock
	"Evaluate aBlock with the file names of every file newer than the start date minus some slop"
	| start |
	start := (startDate minusDays: 7) asSeconds.
	mailDirectory entries do:
		[:dirEntry|
		((dirEntry name endsWith: '.emlx')
		 and: [dirEntry creationTime > start]) ifTrue:
			[aBlock value: dirEntry name]]! !

!CrashReportsMailer methodsFor: 'reporting' stamp: 'eem 6/25/2010 14:15'!
collectReportSummaries
	self candidateMessagesDo:
		[:fn|
		self ifCrashReport: fn do:
			[:lines|
			self addReportFor: lines]]! !

!CrashReportsMailer methodsFor: 'reporting' stamp: 'eem 8/9/2010 11:36'!
generateFinalReport
	| count numMac ws |
	count := causes inject: 0 into: [:sum :collection| sum + collection size].
	rs reset.
	rs print: count; nextPutAll: ' VM Crashes. ? OpenGL. ? Audio plugin. ? Video plugin. ? Python plugin.  ? core VM. ? unknown.'; cr.
	numMac := (causes keys select: [:k| k beginsWith: 'Mac:']) size.
	rs nextPutAll: 'win: '; print: count- numMac; cr.
	rs nextPutAll: 'mac: '; print: numMac; cr; cr.
	self reportCrashRates: count.
	causes keys asSortedCollection do:
		[:k|
		(causes at: k) do:
			[:report| rs nextPutAll: report].
		rs nextPutAll: k; cr; cr].
	(ws := Workspace new contents: rs contents)
		acceptAction: [:s| (UIManager default confirm: 'Sure you want to send?') ifTrue:
							[self mailReport: s.
							 ws acceptAction:
								[(UIManager default confirm: 'You''ve already sent this. Sure you want to send again?') ifTrue:
										[self mailReport: s]]]];
		openLabel: 'Customer VM Crashes ', startDate date printString, ' to ', endDate date printString;
		shouldStyle: false! !

!CrashReportsMailer methodsFor: 'reporting' stamp: 'eem 6/25/2010 14:15'!
generateReport
	causes := Dictionary new.
	self collectReportSummaries.
	self generateFinalReport! !

!CrashReportsMailer methodsFor: 'parsing' stamp: 'eem 8/9/2010 11:33'!
ifCrashReport: fileName do: aBlock
	"Answer the evaluation of aBlock with the lines for fileName if it is a crash report, or nil if not."
	| file lines subject |
	file := mailDirectory oldFileNamed: fileName.
	lines := [file contentsOfEntireFile]
				on: Error
				do: [:ex|
					file close.
					Transcript nextPutAll: fileName; nextPutAll: ': '; nextPutAll: ex messageText; flush.
					^nil].
	lines := self breakIntoLines: lines.
	subject := lines detect: [:l| l beginsWith: 'Subject:'] ifNone: [^nil].
	(subject includesSubString: 'Teleplace Bug Report: ') ifFalse: [^nil].
	#('@qwaq.com' '@teleplace.com' '@chonkaa.com' 'craig@netjam.org' 'skysound@mac.com') do:
		[:localEmail| (subject includesSubstring: localEmail caseSensitive: false) ifTrue: [^nil]].
	(lines anySatisfy:
		[:l|
		((l beginsWith: 'OS Version') and: [l includesSubString: 'Mac OS X'])
		or: [l beginsWith: 'Operating System:']]) ifFalse: [^nil].
	^aBlock value: lines! !

!CrashReportsMailer methodsFor: 'reporting' stamp: 'eem 6/25/2010 20:03'!
macOSDateFor: dateString 
	| tokens |
	tokens := dateString subStrings: ' -.+'.
	^TimeStamp
		date: (Date year: tokens first asInteger month: tokens second asInteger day: tokens third asInteger)
		time: tokens fourth asTime! !

!CrashReportsMailer methodsFor: 'initialize-release' stamp: 'eem 6/25/2010 20:38'!
mailDirectory: aFileDirectoryOrString destination: anEmailAddress startDate: startTimestamp endDate: endTimestamp
	mailDirectory := aFileDirectoryOrString isString
						ifTrue: [FileDirectory on: aFileDirectoryOrString]
						ifFalse: [aFileDirectoryOrString].
	destination := anEmailAddress.
	startDate := startTimestamp.
	endDate := endTimestamp.
	rs := ReadWriteStream on: (String new: 256)! !

!CrashReportsMailer methodsFor: 'initialize-release' stamp: 'eem 6/28/2010 09:46'!
mailDirectory: aFileDirectoryOrString destination: anEmailAddress startDate: startTimestamp endDate: endTimestamp soloTime: soloDuration meetingTime: meetingDuration
	mailDirectory := aFileDirectoryOrString isString
						ifTrue: [FileDirectory on: aFileDirectoryOrString]
						ifFalse: [aFileDirectoryOrString].
	destination := anEmailAddress.
	startDate := startTimestamp.
	endDate := endTimestamp.
	soloTime := soloDuration.
	meetingTime := meetingDuration.
	rs := ReadWriteStream on: (String new: 256)! !

!CrashReportsMailer methodsFor: 'mailing' stamp: 'eem 6/28/2010 12:46'!
mailReport: aText
	| msg |
	msg := MailMessage new
			setField: 'from' toString: 'eliot@teleplace.com';
			setField: 'to' toString: destination;
			setField: 'subject' toString:	'Customer VM Crashes ',
										(startDate date printFormat: #(3 2 1 $/ 1 2)),
										' - ',
										((endDate - 1 seconds) date printFormat: #(3 2 1 $/ 1 2));
			body: (MIMEDocument contentType: 'text/plain' content: aText asString).
	SMTPClient
		deliverMailFrom: msg from
		to: (Array with: msg to)
		text: msg text
		usingServer: MailComposition new smtpServer! !

!CrashReportsMailer methodsFor: 'parsing' stamp: 'eem 6/28/2010 11:31'!
pruneBogusEmptyLines: lines
	"Eliminate duplicate empty lines from broken CR-LF to LF-LF conversions."
	| firstEmpty lastEmpty |
	(firstEmpty := lines findFirst: [:l| l isEmpty]) = 0 ifTrue:
		[^lines].
	lastEmpty := firstEmpty.
	[(lines at: lastEmpty + 2) isEmpty] whileTrue:
		[lastEmpty := lastEmpty + 2].
	^(lines copyFrom: 1 to: firstEmpty - 1),
	   ((firstEmpty + 1 to: lastEmpty - 1 by: 2) collect: [:i| lines at: i]),
	   (lines copyFrom: lastEmpty + 1 to: lines size)! !

!CrashReportsMailer methodsFor: 'reporting' stamp: 'eem 6/28/2010 14:15'!
reportCrashRates: count
	{ soloTime. meetingTime }
		with: #('solo hours: ' 'meeting hours: ')
		do: [:time :label|
			rs	nextPutAll: label; print: (time asSeconds / SecondsInHour) rounded;
				space; nextPut: $(; print: time; nextPut: $); cr].
	rs cr.
	{ soloTime. meetingTime }
		with: #('solo' 'meeting')
		do: [:time :label|
			{ SecondsInHour. SecondsInDay }
				with: #('hour' 'day')
				do: [:period :periodLabel| | rate |
					rate := count / (time asSeconds / period).
					rs	print: (rate roundTo: (rate >= 1 ifTrue: [0.1] ifFalse: [0.001]));
						nextPutAll: ' crashes per '; nextPutAll: label; space; nextPutAll: periodLabel; cr]].
	rs cr; cr! !

!CrashReportsMailer methodsFor: 'reporting' stamp: 'eem 6/28/2010 12:18'!
reportForMacOS: lines
	| thread dateAndTime cStackTop cstIdx |

	thread := Integer readFrom: ((lines detect: [:l| l beginsWith: 'Crashed Thread: ']) allButFirst: 15) readStream skipSeparators.
	thread := 'Thread ', thread printString, ' Crashed'.
	lines withIndexDo:
		[:l :i|
		(l beginsWith: 'Date/Time:') ifTrue:
			[dateAndTime := l allButFirst: 11].
		((l beginsWith: thread)
		and: [i < lines size]) ifTrue:
			[cStackTop := lines at: (cstIdx := i + 1)]].
	[cstIdx <= lines size
	 and: [(lines at: cstIdx) notEmpty]] whileTrue:
		[(((lines at: cstIdx) includesSubString: ' _sigtramp ')
		 and: [((lines at: cstIdx + 1) includesSubString: ' ??? ')
		 and: [((lines at: cstIdx + 1) includesSubString: '0xffffffff 0 + 4294967295')]]) ifTrue:
			[cStackTop := lines at: cstIdx + 2.
			 cstIdx := lines size].
		 cstIdx := cstIdx + 1].
	dateAndTime := self macOSDateFor: dateAndTime.
	(dateAndTime between: startDate and: endDate) ifFalse:
		[^nil].
	^'Mac:', (cStackTop allButFirst: (cStackTop indexOf: Character space))! !

!CrashReportsMailer methodsFor: 'reporting' stamp: 'eem 7/20/2010 15:22'!
reportForNewWin32: lines
	| dateAndTime reason stStackTop cStackTop |

	lines withIndexDo:
		[:l :i|
		(l beginsWith: 'Session Summary:') ifTrue:
			[^nil]. "Not a VM bug report, ignore it."
		(dateAndTime isNil
		and: [(l beginsWith: '--------------------')
		and: [i < lines size]]) ifTrue:
			[dateAndTime := lines at: i + 1].
		((l beginsWith: 'Smalltalk stack dump:')
		and: [i < lines size]) ifTrue:
			[stStackTop := lines at: i + 1].
		((l beginsWith: 'Stack backtrace:')
		and: [i < lines size]) ifTrue:
			[cStackTop := lines at: i + 1]].
	dateAndTime isNil ifTrue:
		[^nil].
	dateAndTime := self win32DateFor: dateAndTime.
	(dateAndTime between: startDate and: endDate) ifFalse:
		[^nil].
	reason := (lines detect: [:l| l beginsWith: 'Reason: '] ifNone: []) ifNotNil: [:rl| rl allButFirst: 8].
	"a stack entry looks like
		 0x9c2490 I NetNameResolver class>localHostAddress 271185968: a(n) NetNameResolver class
		t293325136 s BlockClosure>on:do:"
	stStackTop ifNotNil:
		[stStackTop := (stStackTop subStrings: ' ') allButFirst: 2.
		 stStackTop := stStackTop first: (stStackTop findFirst: [:t| t first isDigit]) - 1.
		 stStackTop := stStackTop fold: [:a :b| a, ' ', b]].
	^String streamContents:
		[:s|
		reason ifNotNil: [s nextPutAll: reason; cr].
	 	stStackTop ifNotNil: [s nextPutAll: stStackTop; cr].
		cStackTop ifNotNil: [s nextPutAll: cStackTop]]! !

!CrashReportsMailer methodsFor: 'reporting' stamp: 'eem 6/28/2010 11:54'!
reportForOldWin32: lines
	| dateAndTime module idx stackTop |

	lines withIndexDo:
		[:l :i|
		(dateAndTime isNil
		and: [(l beginsWith: '--------------------')
		and: [i < lines size]]) ifTrue:
			[dateAndTime := lines at: i + 1].
		((l beginsWith: 'Stack dump:')
		and: [i < lines size]) ifTrue:
			 "Occasionally there is a bogus blank line between the label and the first entry"
			[(stackTop := (lines at: i + 1) isEmpty) ifTrue:
				[stackTop := lines at: i + 2]]].
	dateAndTime := self win32DateFor: dateAndTime.
	(dateAndTime between: startDate and: endDate) ifFalse:
		[^nil].
	module := (lines detect: [:l| l beginsWith: 'Module: ']) allButFirst: 8.
	(idx := module indexOfSubCollection: '\Teleplace') > 0 ifTrue:
		[module := module copyFrom: idx to: module size].
	(module first isLetter and: [module second = $:]) ifTrue:
		[module := module allButFirst: 2].
	"a stack entry looks like
		 0x9c2490 I NetNameResolver class>localHostAddress 271185968: a(n) NetNameResolver class
		293325136 s BlockClosure>on:do:
	 but if there is no stack there may be any old crap after Stack dump: so squash errors."
	[stackTop := (stackTop subStrings: ' ') allButFirst: 2.
	 stackTop := stackTop first: (stackTop findFirst: [:t| t first isDigit]) - 1.
	 stackTop := stackTop fold: [:a :b| a, ' ', b]]
		on: Error
		do: [:ex| stackTop := '?'].
	^stackTop, ' in ', module! !

!CrashReportsMailer methodsFor: 'reporting' stamp: 'eem 6/25/2010 14:10'!
win32DateFor: dateAndTimeString 
	"transform 'Thu Jun 24 14:11:18 2010' to 'Jun 24 2010 14:11:18' to allow parsing"
	| tokens |
	tokens := dateAndTimeString subStrings: ' '.
	^({ tokens second. tokens third. tokens fifth. tokens fourth } fold: [:a :b| a, ' ', b]) asTimeStamp! !

Alien variableByteSubclass: #CogProcessorAlien
	instanceVariableNames: ''
	classVariableNames: 'SavedState'
	poolDictionaries: ''
	category: 'Cog-Processors'!

!CogProcessorAlien commentStamp: 'lw 8/23/2012 19:15' prior: 0!
I am the superclass for the Simulation CPU instance wrappers. I ensure that methods used in both/all of them need not be copied.!

CogProcessorAlien variableByteSubclass: #BochsIA32Alien
	instanceVariableNames: ''
	classVariableNames: 'OpcodeExceptionMap PostBuildStackDelta'
	poolDictionaries: ''
	category: 'Cog-Processors'!

!BochsIA32Alien commentStamp: '<historical>' prior: 0!
I am a wrapper around the Bochs C++ IA32 CPU emulator.  Note that currently I provide no access to the x87/mmx FPU state, only providing access to the SSE/xmm registers.

Here is the configure script for the configuration this code assumes.  Offsets of fields will change with different configurations so they must agree.

----8<---- conf.COG ----8<----
#!!/bin/sh

# this sets up the compile for Cog.  Disable as much inessential stuff
# as possible leaving only the cpu/fpu & memory interface

set echo
# CFLAGS="-pipe -O3 -fomit-frame-pointer -finline-functions -falign-loops=16 -falign-jumps=16 -falign-functions=16 -falign-labels=16 -falign-loops-max-skip=15 -falign-jumps-max-skip=15 -fprefetch-loop-arrays $CFLAGS"
CFLAGS="-m32 $CFLAGS"
CFLAGS="-Dlongjmp=_longjmp -Dsetjmp=_setjmp $CFLAGS"
CFLAGS="-pipe -O3 -fomit-frame-pointer -finline-functions $CFLAGS"
CFLAGS="-g $CFLAGS"
CPATH="/sw/include"
CPPFLAGS=""
CXXFLAGS="$CFLAGS"
LDFLAGS="-L/sw/lib"

export CFLAGS
export CPATH
export CPPFLAGS
export CXXFLAGS
export LDFLAGS

./configure --enable-Cog \
	--enable-cpu-level=6 \
	--enable-sse=2 \
	--enable-assert-checks \
	--with-nogui \
		--disable-x86-64 \
		--disable-pae \
		--disable-large-pages \
		--disable-global-pages \
		--disable-mtrr \
		--disable-sb16 \
		--disable-ne2000 \
		--disable-pci \
		--disable-acpi \
		--disable-apic \
		--disable-clgd54xx \
		--disable-usb \
		--disable-plugins \
	${CONFIGURE_ARGS}

# apic == Advanced programmable Interrupt Controller
# acpi == Advanced Configuration and Power Interface
# pci == Peripheral Component Interconnect local bus
# clgd54xx == Cirrus Logic GD54xx video card
----8<---- conf.COG ----8<----!

!BochsIA32Alien class methodsFor: 'instance creation' stamp: 'eem 11/13/2011 11:13'!
dataSize
	^18096! !

!BochsIA32Alien class methodsFor: 'debugger' stamp: 'eem 2/14/2011 09:19'!
defaultIntegerBaseInDebugger
	^16! !

!BochsIA32Alien class methodsFor: 'class initialization' stamp: 'eem 11/21/2013 16:19'!
initialize
	"BochsIA32Alien initialize"
	PostBuildStackDelta := 0.
	OpcodeExceptionMap := Array new: 256 withAll: #handleExecutionPrimitiveFailureAt:in:.
	OpcodeExceptionMap
		at: 1 + self basicNew callOpcode			put: #handleCallFailureAt:in:;
		at: 1 + self basicNew jmpOpcode			put: #handleJmpFailureAt:in:;
		at: 1 + self basicNew retOpcode			put: #handleRetFailureAt:in:;
		at: 1 + self basicNew movALObOpcode	put: #handleMovALObFailureAt:in:;
		at: 1 + self basicNew movObALOpcode	put: #handleMovObALFailureAt:in:;
		at: 1 + self basicNew movGvEvOpcode	put: #handleMovGvEvFailureAt:in:;
		at: 1 + self basicNew movEvGvOpcode	put: #handleMovEvGvFailureAt:in:;
		at: 1 + self basicNew movGbEbOpcode	put: #handleMovGbEbFailureAt:in:;
		at: 1 + self basicNew movEbGbOpcode	put: #handleMovEbGbFailureAt:in:! !

!BochsIA32Alien class methodsFor: 'primitives' stamp: 'eem 12/11/2008 13:33'!
primitiveNewCPU
	"Answer the address of a new Bochs C++ class bx_cpu_c/BX_CPU_C x86 CPU emulator instance."
	<primitive: 'primitiveNewCPU' module: 'BochsIA32Plugin'>
	^self primitiveFailed! !

!BochsIA32Alien class methodsFor: 'accessing' stamp: 'eem 3/30/2009 11:36'!
setStackAlignmentDelta: 	stackAlignmentDelta
	self assert: stackAlignmentDelta isPowerOfTwo.
	PostBuildStackDelta :=  stackAlignmentDelta > 8
								ifTrue: [stackAlignmentDelta - 8]
								ifFalse: [0]! !

!BochsIA32Alien methodsFor: 'Cog API' stamp: 'eem 12/20/2008 10:55'!
abstractInstructionCompilerClass
	^CogIA32Compiler! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 5/7/2010 11:59'!
al
	^self eax bitAnd: 16rFF! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 5/7/2010 12:01'!
al: aByte
	self eax: ((self eax bitAnd: -16rFF) + aByte).
	^aByte! !

!BochsIA32Alien methodsFor: 'Cog API' stamp: 'eem 1/21/2009 15:49'!
bitsInWord
	^32! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 5/7/2010 11:59'!
bl
	^self ebx bitAnd: 16rFF! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 5/7/2010 12:01'!
bl: aByte
	self ebx: ((self ebx bitAnd: -16rFF) + aByte).
	^aByte! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'eem 1/17/2009 15:52'!
cResultRegister
	^self eax! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'eem 1/17/2009 15:52'!
cResultRegister: aValue
	^self eax: aValue! !

!BochsIA32Alien methodsFor: 'opcodes' stamp: 'eem 12/30/2008 09:14'!
callOpcode
	"[1] IA-32 Intel® Architecture Software Developer's Manual Volume 2B: Instruction Set Reference, N-Z.
		table A2, pA8"
	^16rE8! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 5/7/2010 11:59'!
cl
	^self ecx bitAnd: 16rFF! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 5/7/2010 12:01'!
cl: aByte
	self ecx: ((self ecx bitAnd: -16rFF) + aByte).
	^aByte! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/16/2009 17:52'!
cr0
	^self unsignedLongLongAt: 1009! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/16/2009 17:52'!
cr0: anUnsignedInteger
	^self unsignedLongLongAt: 1009 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/16/2009 17:52'!
cr1
	^self unsignedLongLongAt: 1013! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/16/2009 17:52'!
cr1: anUnsignedInteger
	^self unsignedLongLongAt: 1013 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/16/2009 17:52'!
cr2
	^self unsignedLongLongAt: 1017! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/16/2009 17:52'!
cr2: anUnsignedInteger
	^self unsignedLongLongAt: 1017 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/16/2009 17:52'!
cr3
	^self unsignedLongLongAt: 1021! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/16/2009 17:52'!
cr3: anUnsignedInteger
	^self unsignedLongLongAt: 1021 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/16/2009 17:52'!
cr4
	^self unsignedLongLongAt: 1029! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/16/2009 17:52'!
cr4: anUnsignedInteger
	^self unsignedLongLongAt: 1029 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 5/7/2010 11:59'!
dl
	^self edx bitAnd: 16rFF! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 5/7/2010 12:01'!
dl: aByte
	self edx: ((self edx bitAnd: -16rFF) + aByte).
	^aByte! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/11/2008 17:55'!
eax
	^self unsignedLongAt: 469! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/11/2008 17:55'!
eax: anUnsignedInteger
	^self unsignedLongAt: 469 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/11/2008 17:55'!
ebp
	^self unsignedLongAt: 489! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/11/2008 17:55'!
ebp: anUnsignedInteger
	^self unsignedLongAt: 489 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/11/2008 18:3'!
ebx
	^self unsignedLongAt: 481! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/11/2008 18:3'!
ebx: anUnsignedInteger
	^self unsignedLongAt: 481 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/11/2008 18:3'!
ecx
	^self unsignedLongAt: 473! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/11/2008 18:3'!
ecx: anUnsignedInteger
	^self unsignedLongAt: 473 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/11/2008 17:55'!
edi
	^self unsignedLongAt: 497! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/11/2008 17:55'!
edi: anUnsignedInteger
	^self unsignedLongAt: 497 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/11/2008 18:3'!
edx
	^self unsignedLongAt: 477! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/11/2008 18:3'!
edx: anUnsignedInteger
	^self unsignedLongAt: 477 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/11/2008 17:55'!
eflags
	^self unsignedLongAt: 513! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 9/18/2009 10:31'!
eflags: anUnsignedInteger
	^self unsignedLongAt: 513 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/11/2008 17:55'!
eip
	^self unsignedLongAt: 501! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/11/2008 17:55'!
eip: anUnsignedInteger
	^self unsignedLongAt: 501 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'eem 12/28/2008 16:20'!
endianness
	^#little! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/11/2008 17:55'!
esi
	^self unsignedLongAt: 493! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/11/2008 17:55'!
esi: anUnsignedInteger
	^self unsignedLongAt: 493 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/11/2008 17:55'!
esp
	^self unsignedLongAt: 485! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/11/2008 17:55'!
esp: anUnsignedInteger
	^self unsignedLongAt: 485 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'execution' stamp: 'eem 1/15/2009 16:09'!
flushICacheFrom: startAddress "<Integer>" to: endAddress "<Integer>"
	self primitiveFlushICacheFrom: startAddress To: endAddress! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'eem 1/9/2009 09:20'!
fp
	^self ebp! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'eem 12/6/2010 18:17'!
fp: anAddress
	"Set whatever the processor considers its frame pointer to anAddress."
	self ebp: anAddress! !

!BochsIA32Alien methodsFor: 'execution' stamp: 'eem 2/13/2009 16:00'!
frameBuildDeltaBytes
	"Answer how many words are pushed when a frame is built.  This is for the Cogit's stack alignment checking code."
	^4 "4 bytes pushed for $ebp"! !

!BochsIA32Alien methodsFor: 'error handling' stamp: 'eem 11/21/2013 16:14'!
handleCallFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>"
	"Convert an execution primitive failure for a call into a ProcessorSimulationTrap signal."
	|  relativeJump |
	relativeJump := memoryArray longAt: pc + 2 bigEndian: false.
	^(ProcessorSimulationTrap
			pc: pc
			nextpc: pc + 5
			address: (pc + 5 + relativeJump) signedIntToLong
			type: #call)
		signal! !

!BochsIA32Alien methodsFor: 'error handling' stamp: 'eem 11/21/2013 16:15'!
handleExecutionPrimitiveFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>"
	"Handle an execution primitive failure for an unhandled opcode."
	^self reportPrimitiveFailure! !

!BochsIA32Alien methodsFor: 'error handling' stamp: 'eem 11/21/2013 16:18'!
handleExecutionPrimitiveFailureIn: memoryArray "<Bitmap|ByteArray>" minimumAddress: minimumAddress
	"Handle an execution primitive failure.  Convert out-of-range call and absolute
	 memory read into register instructions into ProcessorSimulationTrap signals."
	"self printIntegerRegistersOn: Transcript"
	"self printRegistersOn: Transcript"
	| pc opcode |
	((pc := self eip) between: minimumAddress and: memoryArray byteSize - 1) ifTrue:
		[opcode := memoryArray byteAt: pc + 1.
		^self
			perform: (OpcodeExceptionMap at: opcode + 1)
			with: pc
			with: memoryArray].
	^self reportPrimitiveFailure! !

!BochsIA32Alien methodsFor: 'error handling' stamp: 'eem 11/22/2013 12:15'!
handleJmpFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>"
	"Convert an execution primitive failure for a jmp into a ProcessorSimulationTrap signal."
	|  relativeJump |
	relativeJump := memoryArray longAt: pc + 2 bigEndian: false.
	^(ProcessorSimulationTrap
			pc: pc
			nextpc: pc + 5
			address: (pc + 5 + relativeJump) signedIntToLong
			type: #jump)
		signal! !

!BochsIA32Alien methodsFor: 'error handling' stamp: 'eem 11/21/2013 16:21'!
handleMovALObFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>"
	"Convert an execution primitive failure for a read into eax into a ProcessorSimulationTrap signal."
	^(ProcessorSimulationTrap
			pc: pc
			nextpc: pc + 5
			address: (memoryArray unsignedLongAt: pc + 2 bigEndian: false)
			type: #read
			accessor: #eax:)
		signal! !

!BochsIA32Alien methodsFor: 'error handling' stamp: 'eem 11/21/2013 16:21'!
handleMovEbGbFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>"
	"Convert an execution primitive failure for a byte register write into a ProcessorSimulationTrap signal."
	| modrmByte |
	^(((modrmByte := memoryArray byteAt: pc + 2) bitAnd: 16rC0) = 16r80) "ModRegRegDisp32"
		ifTrue:
			[(ProcessorSimulationTrap
					pc: pc
					nextpc: pc + 6
					address: ((self perform: (#(eax ecx edx ebx esp ebp esi edi) at: (modrmByte bitAnd: 7) + 1))
							+ (memoryArray unsignedLongAt: pc + 3 bigEndian: false)
								bitAnd: 16rFFFFFFFF)
					type: #write
					accessor: (#(al cl dl bl ah ch dh bh) at: ((modrmByte >> 3 bitAnd: 7) + 1)))
				signal]
		ifFalse:
			[self reportPrimitiveFailure]! !

!BochsIA32Alien methodsFor: 'error handling' stamp: 'eem 11/21/2013 16:21'!
handleMovEvGvFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>"
	"Convert an execution primitive failure for a register write into a ProcessorSimulationTrap signal."
	| modrmByte |
	^((modrmByte := memoryArray byteAt: pc + 2) bitAnd: 16rC7) = 16r5 "ModRegInd & disp32"
		ifTrue:
			[(ProcessorSimulationTrap
					pc: pc
					nextpc: pc + 6
					address: (memoryArray unsignedLongAt: pc + 3 bigEndian: false)
					type: #write
					accessor: (#(eax ecx edx ebx esp ebp esi edi) at: ((modrmByte >> 3 bitAnd: 7) + 1)))
				signal]
		ifFalse:
			[self reportPrimitiveFailure]! !

!BochsIA32Alien methodsFor: 'error handling' stamp: 'eem 11/21/2013 16:21'!
handleMovGbEbFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>"
	"Convert an execution primitive failure for a byte register load into a ProcessorSimulationTrap signal."
	| modrmByte |
	^(((modrmByte := memoryArray byteAt: pc + 2) bitAnd: 16rC0) = 16r80) "ModRegRegDisp32"
		ifTrue:
			[(ProcessorSimulationTrap
					pc: pc
					nextpc: pc + 6
					address: ((self perform: (#(eax ecx edx ebx esp ebp esi edi) at: (modrmByte bitAnd: 7) + 1))
							+ (memoryArray unsignedLongAt: pc + 3 bigEndian: false)
								bitAnd: 16rFFFFFFFF)
					type: #read
					accessor: (#(al: cl: dl: bl: ah: ch: dh: bh:) at: ((modrmByte >> 3 bitAnd: 7) + 1)))
				signal]
		ifFalse:
			[self reportPrimitiveFailure]! !

!BochsIA32Alien methodsFor: 'error handling' stamp: 'eem 11/21/2013 16:21'!
handleMovGvEvFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>"
	"Convert an execution primitive failure for a register load into a ProcessorSimulationTrap signal."
	| modrmByte |
	^(((modrmByte := memoryArray byteAt: pc + 2) bitAnd: 16rC7) = 16r5) "ModRegInd & disp32"
		ifTrue:
			[(ProcessorSimulationTrap
					pc: pc
					nextpc: pc + 6
					address: (memoryArray unsignedLongAt: pc + 3 bigEndian: false)
					type: #read
					accessor: (#(eax: ecx: edx: ebx: esp: ebp: esi: edi:) at: ((modrmByte >> 3 bitAnd: 7) + 1)))
				signal]
		ifFalse:
			[self reportPrimitiveFailure]! !

!BochsIA32Alien methodsFor: 'error handling' stamp: 'eem 11/21/2013 16:21'!
handleMovObALFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>"
	"Convert an execution primitive failure for a write of eax into a ProcessorSimulationTrap signal."
	^(ProcessorSimulationTrap
			pc: pc
			nextpc: pc + 5
			address: (memoryArray unsignedLongAt: pc + 2 bigEndian: false)
			type: #write
			accessor: #eax)
		signal! !

!BochsIA32Alien methodsFor: 'error handling' stamp: 'eem 11/21/2013 16:21'!
handleRetFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>"
	"Convert an execution primitive failure for a ret into a ProcessorSimulationTrap signal."
	^(ProcessorSimulationTrap
			pc: pc
			nextpc: pc + 1
			address: (memoryArray unsignedLongAt: self esp + 1)
			type: #return
			accessor: #eip:)
		signal! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'eem 9/9/2009 21:27'!
integerRegisterState
	^{	self eax. self ebx. self ecx. self edx. self esp. self ebp. self esi. self edi.
		self eip. self eflags }! !

!BochsIA32Alien methodsFor: 'opcodes' stamp: 'eem 12/30/2008 09:15'!
jmpOpcode
	"[1] IA-32 Intel® Architecture Software Developer's Manual Volume 2B: Instruction Set Reference, N-Z.
		table A2, pA8"
	^16rE9! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'eem 10/20/2010 17:12'!
leafRetpcIn: aMemory
	^aMemory unsignedLongAt: self esp + 1 bigEndian: false! !

!BochsIA32Alien methodsFor: 'opcodes' stamp: 'eem 9/9/2009 21:24'!
lockPrefix
	^16rF0! !

!BochsIA32Alien methodsFor: 'opcodes' stamp: 'eem 12/30/2008 09:14'!
movALObOpcode
	"[1] IA-32 Intel® Architecture Software Developer's Manual Volume 2B: Instruction Set Reference, N-Z.
		table A2, pA7"
	^16rA1! !

!BochsIA32Alien methodsFor: 'opcodes' stamp: 'eem 5/7/2010 11:51'!
movEbGbOpcode
	"[1] IA-32 Intel® Architecture Software Developer's Manual Volume 2B: Instruction Set Reference, N-Z.
		table A2"
	^16r88! !

!BochsIA32Alien methodsFor: 'opcodes' stamp: 'eem 1/1/2009 22:26'!
movEvGvOpcode
	"[1] IA-32 Intel® Architecture Software Developer's Manual Volume 2B: Instruction Set Reference, N-Z.
		table A2, pA8"
	^16r89! !

!BochsIA32Alien methodsFor: 'opcodes' stamp: 'eem 5/7/2010 11:50'!
movGbEbOpcode
	"[1] IA-32 Intel® Architecture Software Developer's Manual Volume 2B: Instruction Set Reference, N-Z.
		table A2"
	^16r8A! !

!BochsIA32Alien methodsFor: 'opcodes' stamp: 'eem 12/30/2008 09:14'!
movGvEvOpcode
	"[1] IA-32 Intel® Architecture Software Developer's Manual Volume 2B: Instruction Set Reference, N-Z.
		table A2, pA8"
	^16r8B! !

!BochsIA32Alien methodsFor: 'opcodes' stamp: 'eem 1/2/2009 12:45'!
movObALOpcode
	"[1] IA-32 Intel® Architecture Software Developer's Manual Volume 2B: Instruction Set Reference, N-Z.
		table A2, pA7"
	^16rA3! !

!BochsIA32Alien methodsFor: 'opcodes' stamp: 'eem 12/12/2008 15:52'!
nopOpcode
	^16r90! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'eem 1/4/2009 13:08'!
pc
	"Return whatever the processor considers its program counter."
	^self eip! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'eem 1/5/2009 14:20'!
pc: anAddress
	"Set whatever the processor considers its program counter to anAddress."
	self eip: anAddress! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'eem 10/20/2010 17:14'!
popWordIn: aMemory 
	| sp word |
	word := aMemory unsignedLongAt: (sp := self esp) + 1 bigEndian: false.
	self esp: sp + 4.
	^word! !

!BochsIA32Alien methodsFor: 'execution' stamp: 'eem 3/30/2009 12:35'!
postCallArgumentsNumArgs: numArgs "<Integer>" in: memory "<ByteArray|Bitmap>"
	"Answer an argument vector of the requested size after a vanilla
	 ABI call.  On IA32 this typically means accessing stacked arguments
	 beyond the pushed return address and saved frame pointer.
	 For compatibility with Cog/Slang we answer unsigned values."
	^(9 to: numArgs * 4 + 5 by: 4) collect:
		[:i|
		memory unsignedLongAt: self ebp + i bigEndian: false]! !

!BochsIA32Alien methodsFor: 'primitives' stamp: 'eem 1/14/2009 15:26'!
primitiveDisassembleAt: address inMemory: memoryArray "<Bitmap|ByteArray>"
	"Answer an Array of the size and the disassembled code string for the instruction at the current instruction pointer in memory."
	<primitive: 'primitiveDisassembleAtInMemory' module: 'BochsIA32Plugin'>
	^self primitiveFailed! !

!BochsIA32Alien methodsFor: 'primitives' stamp: 'eem 12/12/2008 13:02'!
primitiveErrorAndLog
	"Answer an array of the current error code and log contents"
	<primitive: 'primitiveErrorAndLog' module: 'BochsIA32Plugin'>
	^self primitiveFailed! !

!BochsIA32Alien methodsFor: 'primitives' stamp: 'eem 1/15/2009 09:58'!
primitiveFlushICacheFrom: startAddress "<Integer>" To: endAddress "<Integer>"
	"Flush the icache in the requested range"
	<primitive: 'primitiveFlushICacheFromTo' module: 'BochsIA32Plugin'>
	^self primitiveFailed! !

!BochsIA32Alien methodsFor: 'primitives' stamp: 'eem 12/12/2008 13:29'!
primitiveResetCPU
	"Reset the receiver to registers all zero, and protected 32-bit mode."
	<primitive: 'primitiveResetCPU' module: 'BochsIA32Plugin'>
	^self reportPrimitiveFailure! !

!BochsIA32Alien methodsFor: 'primitives' stamp: 'eem 11/21/2013 16:19'!
primitiveRunInMemory: memoryArray "<Bitmap|ByteArray>" minimumAddress: minimumAddress "<Integer>" maximumAddress: maximimAddress "<Integer>" readOnlyBelow: minimumWritableAddress "<Integer>"
	"Run the receiver using the argument as the store.  Origin the argument at 0. i.e. the first byte of the
	 memoryArray is address 0.  Make addresses below minimumAddress illegal.  Convert out-of-range
	 calls, jumps and memory read/writes into ProcessorSimulationTrap signals."
	<primitive: 'primitiveRunInMemoryMinAddressMaxAddressReadWrite' module: 'BochsIA32Plugin' error: ec>
	^ec == #'inappropriate operation'
		ifTrue: [self handleExecutionPrimitiveFailureIn: memoryArray
					minimumAddress: minimumAddress]
		ifFalse: [self reportPrimitiveFailure]

	"self printRegistersOn: Transcript"! !

!BochsIA32Alien methodsFor: 'primitives' stamp: 'eem 11/21/2013 16:19'!
primitiveRunInMemory: memoryArray "<Bitmap|ByteArray>" minimumAddress: minimumAddress "<Integer>" readOnlyBelow: minimumWritableAddress "<Integer>"
	"Run the receiver using the argument as the store.  Origin the argument at 0. i.e. the first byte of the
	 memoryArray is address 0.  Make addresses below minimumAddress illegal.  Convert out-of-range
	 calls, jumps and memory read/writes into ProcessorSimulationTrap signals."
	<primitive: 'primitiveRunInMemoryMinimumAddressReadWrite' module: 'BochsIA32Plugin' error: ec>
	^ec == #'inappropriate operation'
		ifTrue: [self handleExecutionPrimitiveFailureIn: memoryArray
					minimumAddress: minimumAddress]
		ifFalse: [self reportPrimitiveFailure]

	"self printRegistersOn: Transcript"! !

!BochsIA32Alien methodsFor: 'primitives' stamp: 'eem 11/21/2013 16:19'!
primitiveSingleStepInMemory: memoryArray "<Bitmap|ByteArray>" minimumAddress: minimumAddress "<Integer>" maximumAddress: maximimAddress "<Integer>" readOnlyBelow: minimumWritableAddress "<Integer>"
	"Single-step the receiver using the argument as the store.  Origin the argument at 0. i.e. the first byte of the
	 memoryArray is address 0.  Make addresses below minimumAddress illegal.  Convert out-of-range
	 calls, jumps and memory read/writes into ProcessorSimulationTrap signals."
	<primitive: 'primitiveSingleStepInMemoryMinAddressMaxAddressReadWrite' module: 'BochsIA32Plugin' error: ec>
	^ec == #'inappropriate operation'
		ifTrue: [self handleExecutionPrimitiveFailureIn: memoryArray
					minimumAddress: minimumAddress]
		ifFalse: [self reportPrimitiveFailure]! !

!BochsIA32Alien methodsFor: 'primitives' stamp: 'eem 11/21/2013 16:20'!
primitiveSingleStepInMemory: memoryArray "<Bitmap|ByteArray>" minimumAddress: minimumAddress "<Integer>" readOnlyBelow: minimumWritableAddress "<Integer>"
	"Single-step the receiver using the argument as the store.  Origin the argument at 0. i.e. the first byte of the
	 memoryArray is address 0.  Make addresses below minimumAddress illegal.  Convert out-of-range
	 calls, jumps and memory read/writes into ProcessorSimulationTrap signals."
	<primitive: 'primitiveSingleStepInMemoryMinimumAddressReadWrite' module: 'BochsIA32Plugin' error: ec>
	^ec == #'inappropriate operation'
		ifTrue: [self handleExecutionPrimitiveFailureIn: memoryArray
					minimumAddress: minimumAddress]
		ifFalse: [self reportPrimitiveFailure]! !

!BochsIA32Alien methodsFor: 'printing' stamp: 'eem 12/9/2013 09:26'!
printFields: fields inRegisterState: registerStateVector on: aStream
	| rsvs |
	aStream ensureCr.
	rsvs := registerStateVector readStream.
	fields withIndexDo:
		[:sym :index| | val |
		sym = #cr
			ifTrue: [aStream cr]
			ifFalse:
				[(val := rsvs next) isNil ifTrue: [^self].
				(sym beginsWith: 'xmm')
					ifTrue:
						[aStream nextPutAll: sym; nextPut: $:; space.
						 val printOn: aStream base: 16 length: 16 padded: true.
						 aStream space; nextPut: $(.
						 "At the image level Float is apparently in big-endian format"
						 ((Float basicNew: 2)
						 	at: 2 put: (val bitAnd: 16rFFFFFFFF);
							at: 1 put: (val bitShift: -32);
							yourself)
								printOn: aStream.
						 aStream nextPut: $)]
					ifFalse:
						[aStream nextPutAll: sym; nextPut: $:; space.
						 val printOn: aStream base: 16 length: 8 padded: true.
						 #eflags == sym
							ifTrue:
								[aStream space.
								 'C-P-A-ZS---O' withIndexDo:
									[:flag :bitIndex|
									flag ~= $- ifTrue:
										[aStream nextPut: flag; nextPutAll: 'F='; print: (val bitAnd: 1 << (bitIndex - 1)) >> (bitIndex - 1); space]]]
							ifFalse:
								[val > 16 ifTrue:
									[aStream space; nextPut: $(.
									 val printOn: aStream base: 10 length: 1 padded: false.
									 aStream nextPut: $)]]].
						(fields at: index + 1) ~~ #cr ifTrue:
							[aStream tab]]]! !

!BochsIA32Alien methodsFor: 'printing' stamp: 'eem 9/9/2009 21:27'!
printIntegerRegistersOn: aStream
	self printRegisterState: self integerRegisterState on: aStream.
	aStream flush! !

!BochsIA32Alien methodsFor: 'printing' stamp: 'eem 12/9/2013 09:27'!
printRegisterState: registerStateVector on: aStream
	self printFields:
			((registerStateVector size < 18
			  or: [(11 to: 18) allSatisfy: [:i| (registerStateVector at: i) isZero]])
				ifTrue:
					[#(	eax ebx ecx edx cr
						esp ebp esi edi cr
						eip eflags cr )]
				ifFalse:
					[#(	eax ebx ecx edx cr
						esp ebp esi edi cr
						eip eflags cr
						xmm0low xmm1low cr
						xmm2low xmm3low cr
						xmm4low xmm5low cr
						xmm6low xmm7low cr )])
		inRegisterState: registerStateVector
		on: aStream! !

!BochsIA32Alien methodsFor: 'printing' stamp: 'eem 12/9/2013 09:30'!
printRegisterStateExceptPC: registerStateVector on: aStream
	self printFields:
			((registerStateVector size < 18
			  or: [(11 to: 18) allSatisfy: [:i| (registerStateVector at: i) isZero]])
				ifTrue:
					[#(	eax ebx ecx edx cr
						esp ebp esi edi cr)]
				ifFalse:
					[#(	eax ebx ecx edx cr
						esp ebp esi edi cr
						xmm0low xmm1low cr
						xmm2low xmm3low cr
						xmm4low xmm5low cr
						xmm6low xmm7low cr )])
		inRegisterState: registerStateVector
		on: aStream! !

!BochsIA32Alien methodsFor: 'execution' stamp: 'eem 1/22/2009 15:43'!
pushWord: aValue in: aMemory
	| sp |
	sp := (self esp: self esp - 4).
	aMemory longAt: sp + 1 put: aValue bigEndian: false! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 12/6/2010 09:29'!
registerAt: index 
	^self perform: (#(eax ecx edx ebx esp ebp esi edi) at: index + 1)! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'eem 4/17/2009 13:48'!
registerState
	^{	self eax. self ebx. self ecx. self edx. self esp. self ebp. self esi. self edi.
		self eip. self eflags.
		self xmm0low. self xmm1low. self xmm2low. self xmm3low.
		self xmm4low. self xmm5low. self xmm6low. self xmm7low }! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'eem 3/18/2014 10:39'!
registerStateGetters
	^#(	eax ebx ecx edx esp ebp esi edi eip eflags
		xmm0low xmm1low xmm2low xmm3low
		xmm4low xmm5low xmm6low xmm7low )! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'eem 12/5/2010 11:40'!
registerStatePCIndex
	^9! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'eem 3/18/2014 10:42'!
registerStateSetters
	^#(	eax: ebx: ecx: edx: esp: ebp: esi: edi: eip: eflags:
		xmm0low: xmm1low: xmm2low: xmm3low:
		xmm4low: xmm5low: xmm6low: xmm7low: )! !

!BochsIA32Alien methodsFor: 'execution' stamp: 'eem 4/16/2009 17:56'!
reset
	self primitiveResetCPU.
	"Enable SSE extensions by setting the OSFXSR (Operating System FXSAVE/FXRSTOR Support) bit"
	self cr4: (self cr4 bitOr: 1 << 9)! !

!BochsIA32Alien methodsFor: 'opcodes' stamp: 'eem 4/16/2009 13:42'!
retOpcode
	"[1] IA-32 Intel® Architecture Software Developer's Manual Volume 2B: Instruction Set Reference, N-Z.
		table A2, pA7"
	^16rC3! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'eem 10/20/2010 17:14'!
retpcIn: aMemory
	^aMemory unsignedLongAt: self ebp + 5 bigEndian: false! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 9/30/2009 13:16'!
saveEip
	^self unsignedLongAt: 1533! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 9/30/2009 13:16'!
saveEsp
	^self unsignedLongAt: 1537! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'eem 1/4/2009 10:57'!
setFramePointer: framePointer stackPointer: stackPointer
	"Initialize the processor's frame and stack pointers"
	self ebp: framePointer.
	self esp: stackPointer! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'eem 9/22/2009 13:24'!
setRegisterState: aRegisterStateArray
	"N.B. keep in sync with voidRegisterState"
	self eax: (aRegisterStateArray at: 1).
	self ebx: (aRegisterStateArray at: 2).
	self ecx: (aRegisterStateArray at: 3).
	self edx: (aRegisterStateArray at: 4).
	self esp: (aRegisterStateArray at: 5).
	self ebp: (aRegisterStateArray at: 6).
	self esi: (aRegisterStateArray at: 7).
	self edi: (aRegisterStateArray at: 8).
	self eip: (aRegisterStateArray at: 9).
	self eflags: (aRegisterStateArray at: 10).
	self xmm0low: (aRegisterStateArray at: 11).
	self xmm1low: (aRegisterStateArray at: 12).
	self xmm2low: (aRegisterStateArray at: 13).
	self xmm3low: (aRegisterStateArray at: 14).
	self xmm4low: (aRegisterStateArray at: 15).
	self xmm5low: (aRegisterStateArray at: 16).
	self xmm6low: (aRegisterStateArray at: 17).
	self xmm7low: (aRegisterStateArray at: 18)! !

!BochsIA32Alien methodsFor: 'execution' stamp: 'eem 5/6/2009 13:09'!
simulateCallOf: address nextpc: nextpc memory: aMemory
	"Simulate a frame-building call of address.  Build a frame since
	a) this is used for calls into the run-time which are unlikely to be leaf-calls, and
	b) stack alignment needs to be realistic for assert checking for platforms such as Mac OS X"
	self pushWord: nextpc in: aMemory.
	self pushWord: self ebp in: aMemory.
	self ebp: self esp.
	PostBuildStackDelta ~= 0 ifTrue:
		[self esp: self esp - PostBuildStackDelta].
	self eip: address! !

!BochsIA32Alien methodsFor: 'execution' stamp: 'eem 5/6/2009 13:10'!
simulateJumpCallOf: address memory: aMemory
	"Simulate a frame-building jump call of address (i.e. do not push the return pc
	 as this has already been done).  Build a frame since
	a) this is used for calls into the run-time which are unlikely to be leaf-calls, and
	b) stack alignment needs to be realistic for assert checking for platforms such as Mac OS X"
	self pushWord: self ebp in: aMemory.
	self ebp: self esp.
	PostBuildStackDelta ~= 0 ifTrue:
		[self esp: self esp - PostBuildStackDelta].
	self eip: address! !

!BochsIA32Alien methodsFor: 'execution' stamp: 'eem 3/30/2009 11:55'!
simulateLeafCallOf: address nextpc: nextpc memory: aMemory
	self pushWord: nextpc in: aMemory.
	self eip: address! !

!BochsIA32Alien methodsFor: 'execution' stamp: 'eem 3/30/2009 12:38'!
simulateLeafReturnIn: aMemory
	self eip: (self popWordIn: aMemory)! !

!BochsIA32Alien methodsFor: 'execution' stamp: 'eem 3/30/2009 11:27'!
simulateReturnIn: aMemory
	PostBuildStackDelta ~= 0 ifTrue:
		[self esp: self esp + PostBuildStackDelta].
	self ebp: (self popWordIn: aMemory).
	self eip: (self popWordIn: aMemory)! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'eem 12/13/2010 09:26'!
smashCallerSavedRegistersWithValuesFrom: base by: step
	#(eax: ecx: edx:)
	   withIndexDo:
		[:accessor :index|
		self perform: accessor with: index - 1 * step + base]! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'lw 8/8/2012 11:51'!
smashRegisterAccessors
	^#(eax: ebx: ecx: edx: esi: edi:)! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'eem 1/9/2009 09:20'!
sp
	^self esp! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'eem 12/6/2010 18:18'!
sp: anAddress
	"Set whatever the processor considers its stack pointer to anAddress."
	self esp: anAddress! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 9/30/2009 13:16'!
stopReason
	^self unsignedByteAt: 1577! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'eem 9/22/2009 13:23'!
voidRegisterState
	"N.B. keep in sync with setRegisterState:"
	self setRegisterState: (Array new: 18 withAll: 0)! !

!BochsIA32Alien methodsFor: 'accessing-abstract' stamp: 'eem 9/22/2009 16:31'!
withStackPointersInRegisterState: registerState do: aBinaryBlock
	^aBinaryBlock value: (registerState at: 5) value: (registerState at: 6)! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm0high
	^self unsignedLongLongAt: 1185! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm0high: anUnsignedInteger
	^self unsignedLongLongAt: 1185 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm0low
	^self unsignedLongLongAt: 1177! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm0low: anUnsignedInteger
	^self unsignedLongLongAt: 1177 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm1high
	^self unsignedLongLongAt: 1201! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm1high: anUnsignedInteger
	^self unsignedLongLongAt: 1201 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm1low
	^self unsignedLongLongAt: 1193! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm1low: anUnsignedInteger
	^self unsignedLongLongAt: 1193 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm2high
	^self unsignedLongLongAt: 1217! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm2high: anUnsignedInteger
	^self unsignedLongLongAt: 1217 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm2low
	^self unsignedLongLongAt: 1209! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm2low: anUnsignedInteger
	^self unsignedLongLongAt: 1209 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm3high
	^self unsignedLongLongAt: 1233! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm3high: anUnsignedInteger
	^self unsignedLongLongAt: 1233 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm3low
	^self unsignedLongLongAt: 1225! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm3low: anUnsignedInteger
	^self unsignedLongLongAt: 1225 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm4high
	^self unsignedLongLongAt: 1249! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm4high: anUnsignedInteger
	^self unsignedLongLongAt: 1249 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm4low
	^self unsignedLongLongAt: 1241! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm4low: anUnsignedInteger
	^self unsignedLongLongAt: 1241 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm5high
	^self unsignedLongLongAt: 1265! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm5high: anUnsignedInteger
	^self unsignedLongLongAt: 1265 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm5low
	^self unsignedLongLongAt: 1257! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm5low: anUnsignedInteger
	^self unsignedLongLongAt: 1257 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm6high
	^self unsignedLongLongAt: 1281! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm6high: anUnsignedInteger
	^self unsignedLongLongAt: 1281 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm6low
	^self unsignedLongLongAt: 1273! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm6low: anUnsignedInteger
	^self unsignedLongLongAt: 1273 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm7high
	^self unsignedLongLongAt: 1297! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm7high: anUnsignedInteger
	^self unsignedLongLongAt: 1297 put: anUnsignedInteger! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm7low
	^self unsignedLongLongAt: 1289! !

!BochsIA32Alien methodsFor: 'accessing' stamp: 'eem 4/15/2009 19:06'!
xmm7low: anUnsignedInteger
	^self unsignedLongLongAt: 1289 put: anUnsignedInteger! !

!CogProcessorAlien class methodsFor: 'class initialization' stamp: 'eem 3/18/2014 09:56'!
initialize
	SavedState := WeakIdentityKeyDictionary new.
	Smalltalk
		addToStartUpList: self;
		addToShutDownList: self! !

!CogProcessorAlien class methodsFor: 'instance creation' stamp: 'eem 3/18/2014 11:03'!
new
	^(self atAddress: self primitiveNewCPU) reset! !

!CogProcessorAlien class methodsFor: 'system startup' stamp: 'eem 3/18/2014 10:00'!
shutDown: quitting
	self allSubInstancesDo:
		[:processor|
		SavedState at: processor put: processor registerState]! !

!CogProcessorAlien class methodsFor: 'system startup' stamp: 'eem 3/18/2014 11:06'!
startUp: resuming
	resuming ifTrue:
		[SavedState keysAndValuesDo:
			[:processorOrNil :state|
			 processorOrNil ifNotNil:
				[processorOrNil addressFieldPut: processorOrNil class primitiveNewCPU.
				 state with: processorOrNil registerStateSetters do:
					[:value :setter|
					processorOrNil perform: setter with: value]]]].
	SavedState removeAll! !

!CogProcessorAlien methodsFor: 'Cog API' stamp: 'lw 7/10/2012 16:26'!
abstractInstructionCompilerClass
	self subclassResponsibility! !

!CogProcessorAlien methodsFor: 'accessing-abstract' stamp: 'lw 11/17/2012 21:38'!
cResultRegister
	^self subclassResponsibility! !

!CogProcessorAlien methodsFor: 'accessing-abstract' stamp: 'lw 11/17/2012 21:38'!
cResultRegister: aValue
	^self subclassResponsibility! !

!CogProcessorAlien methodsFor: 'opcodes' stamp: 'lw 7/11/2012 14:36'!
callOpcode
	self subclassResponsibility.! !

!CogProcessorAlien methodsFor: 'disassembly' stamp: 'eem 12/2/2010 10:24'!
decorateDisassembly: anInstructionString for: aSymbolManager "<Cogit>"
	| string i1 i2 v |
	string := anInstructionString.
	(i1 := string indexOfSubCollection: '%ds:0x') > 0 ifTrue:
		[i2 := i1 + 6.
		 ['0123456789abcdef' includes: (string at: i2)] whileTrue: [i2 := i2 + 1].
		 string := string
					copyReplaceFrom: i1 + 4
					to: i2 - 1
					with: (aSymbolManager lookupCHexString: (string copyFrom: i1 + 4 to: i2 - 1))].
	(i1 := string indexOfSubCollection: '%ss:0x') > 0 ifTrue:
		[i2 := i1 + 6.
		 ['0123456789abcdef' includes: (string at: i2)] whileTrue: [i2 := i2 + 1].
		 ((string at: i2) = $(
		 and: [(string at: i2 + 1) = $%]) ifTrue:
			[v := Integer readFrom: (ReadStream on: string from: i1 + 6 to: i2 - 1) base: 16.
			string := string
						copyReplaceFrom: i1
						to: i2 - 1
						with: ((v bitAnd: (1 bitShift: 31) - 1) - (v bitAnd: (1 bitShift: 31))) printString]].
	(i1 := string indexOfSubCollection: '$0x') > 0 ifTrue:
		[i2 := i1 + 3.
		 ['0123456789abcdef' includes: (string at: i2)] whileTrue: [i2 := i2 + 1].
		 string := string
					copyReplaceFrom: i1 + 1
					to: i2 - 1
					with: (aSymbolManager lookupCHexString: (string copyFrom: i1 + 1 to: i2 - 1))].
	((i1 := string indexOf: $() > 1
	 and: [(string at: i1 + 1) isDigit
	 and: [i1 < (i2 := string indexOf: $))]]) ifTrue:
		[string := string
					copyReplaceFrom: i1 + 1
					to: i2 - 1
					with: (aSymbolManager lookupCHexString: (string copyFrom: i1 + 1 to: i2 - 1))].
	^string! !

!CogProcessorAlien methodsFor: 'disassembly' stamp: 'lw 8/24/2012 19:18'!
decorateDisassembly: anInstructionString for: aSymbolManager "<Cogit>" fromAddress: address
	^self decorateDisassembly: anInstructionString for: aSymbolManager! !

!CogProcessorAlien methodsFor: 'disassembly' stamp: 'eem 1/11/2013 13:57'!
disassembleFrom: startAddress to: endAddress in: memory for: aSymbolManager "<Cogit>" labels: labelDictionary on: aStream
	| address |
	address := startAddress.
	[address <= endAddress] whileTrue:
		[[:sizeArg :stringArg| | size string |
		size := sizeArg.
		string := stringArg.
		(aSymbolManager labelForPC: address) ifNotNil:
			[:label| aStream nextPutAll: label; nextPut: $:; cr].
		(labelDictionary at: address ifAbsent: []) ifNotNil:
			[:label|
			label isArray
				ifTrue: [aStream
							nextPutAll: label first;
							nextPut: $:; cr;
							nextPutAll: (address printStringBase: 16 length: 8 padded: true) asLowercase;
							nextPut: $:; space;
							nextPutAll: (aSymbolManager perform: label second with: address) asString.
						string := nil.
						size := label third]
				ifFalse: [aStream nextPutAll: label; nextPut: $:; cr]].
		string ifNotNil:
			[aStream nextPutAll: (self decorateDisassembly: string for: aSymbolManager fromAddress: address)].
		aStream cr; flush.
		address := address + size]
			valueWithArguments: (self
									primitiveDisassembleAt: address
									inMemory: memory)]! !

!CogProcessorAlien methodsFor: 'disassembly' stamp: 'lw 8/9/2012 13:32'!
disassembleFrom: startAddress to: endAddress in: memory on: aStream
	| address |
	address := startAddress.
	[address < endAddress] whileTrue:
		[[:size :string|
		aStream nextPutAll: (address printStringBase: 16 length: 8 padded: true); nextPut: $:; tab; tab; nextPutAll: string; cr; flush.
		address := address + size]
			valueWithArguments: (self
									primitiveDisassembleAt: address
									inMemory: memory)]! !

!CogProcessorAlien methodsFor: 'disassembly' stamp: 'eem 1/20/2009 12:39'!
disassembleInstructionAt: pc In: memory
	^(self primitiveDisassembleAt: pc inMemory: memory) last! !

!CogProcessorAlien methodsFor: 'disassembly' stamp: 'eem 1/14/2009 15:27'!
disassembleInstructionAt: ip In: memory into: aBlock
	| lenAndDi |
	lenAndDi := self primitiveDisassembleAt: ip inMemory: memory.
	^aBlock value: lenAndDi last value: lenAndDi first! !

!CogProcessorAlien methodsFor: 'disassembly' stamp: 'lw 7/11/2012 13:40'!
disassembleNextInstructionIn: memory
	^(self primitiveDisassembleAt: self pc inMemory: memory) last! !

!CogProcessorAlien methodsFor: 'disassembly' stamp: 'tpr 5/23/2014 23:44'!
disassembleNextInstructionIn: memory for: aSymbolManager "<Cogit|nil>"
	| string |
	string := self pc < memory size 
				ifTrue: [(self primitiveDisassembleAt: self pc inMemory: memory) last.]
				ifFalse: [^self pc hex, ' : Invalid address'].
	^aSymbolManager
		ifNil: [string]
		ifNotNil: [self decorateDisassembly: string for: aSymbolManager]! !

!CogProcessorAlien methodsFor: 'accessing-abstract' stamp: 'lw 7/12/2012 22:16'!
endianness
	self subclassResponsibility! !

!CogProcessorAlien methodsFor: 'opcodes' stamp: 'lw 7/10/2012 16:23'!
nopOpcode
	self subclassResponsibility.! !

!CogProcessorAlien methodsFor: 'printing' stamp: 'lw 7/10/2012 16:22'!
printRegisterState: registerStateVector on: aStream

	self subclassResponsibility.! !

!CogProcessorAlien methodsFor: 'printing' stamp: 'eem 4/17/2009 13:59'!
printRegistersOn: aStream
	self printRegisterState: self registerState on: aStream.
	aStream flush! !

!CogProcessorAlien methodsFor: 'accessing-abstract' stamp: 'lw 11/17/2012 18:13'!
registerStatePCIndex
	"Return the index of the PC register among all register, assuming they are copied into a Smalltalk array."
	^self subclassResponsibility! !

!CogProcessorAlien methodsFor: 'error handling' stamp: 'lw 7/11/2012 17:04'!
reportPrimitiveFailure
	| errorAndLog |
	errorAndLog := self primitiveErrorAndLog.
	self error: 'Error ', errorAndLog first printString, (errorAndLog last ifNil: [''] ifNotNil: [:log| ': ', log])! !

!CogProcessorAlien methodsFor: 'execution' stamp: 'eem 1/27/2009 15:20'!
runInMemory: aMemory
	| result |
	result := self primitiveRunInMemory: aMemory minimumAddress: 0 readOnlyBelow: 0.
	result ~~ self ifTrue:
		[self error: 'eek!!']! !

!CogProcessorAlien methodsFor: 'execution' stamp: 'tpr 5/8/2014 08:24'!
runInMemory: aMemory minimumAddress: minimumAddress readOnlyBelow: minimumWritableAddress
"Note that minimumWritableAddress is both the minimum writeable address AND the maximum executable address"
	| result |
	result := self primitiveRunInMemory: aMemory
				minimumAddress: minimumAddress
				readOnlyBelow: minimumWritableAddress.
	result ~~ self ifTrue:
		[self error: 'eek!!']! !

!CogProcessorAlien methodsFor: 'execution' stamp: 'eem 10/21/2010 11:03'!
runInMemory: aMemory readExecuteOnlyBelow: minWriteMaxExecAddr
	| result |
	result := self primitiveRunInMemory: aMemory minimumAddress: 0 readOnlyBelow: minWriteMaxExecAddr.
	result ~~ self ifTrue:
		[self error: 'eek!!']! !

!CogProcessorAlien methodsFor: 'execution' stamp: 'eem 10/21/2010 10:58'!
singleStepIn: aMemory
	| result |
	result := self primitiveSingleStepInMemory: aMemory minimumAddress: 0 readOnlyBelow: aMemory size.
	result ~~ self ifTrue:
		[self error: 'eek!!']! !

!CogProcessorAlien methodsFor: 'execution' stamp: 'eem 1/27/2009 15:17'!
singleStepIn: aMemory minimumAddress: minimumAddress readOnlyBelow: minimumWritableAddress
	| result |
	result := self primitiveSingleStepInMemory: aMemory
				minimumAddress: minimumAddress
				readOnlyBelow: minimumWritableAddress.
	result ~~ self ifTrue:
		[self error: 'eek!!']! !

!CogProcessorAlien methodsFor: 'execution' stamp: 'eem 10/21/2010 11:05'!
singleStepIn: aMemory readExecuteOnlyBelow: minWriteMaxExecAddr
	| result |
	result := self primitiveSingleStepInMemory: aMemory minimumAddress: 0 readOnlyBelow: minWriteMaxExecAddr.
	result ~~ self ifTrue:
		[self error: 'eek!!']! !

!CogProcessorAlien methodsFor: 'accessing-abstract' stamp: 'lw 8/8/2012 11:50'!
smashRegisterAccessors
	self subclassResponsibility! !

!CogProcessorAlien methodsFor: 'accessing-abstract' stamp: 'lw 8/8/2012 11:50'!
smashRegistersWithValuesFrom: base by: step
	self smashRegisterAccessors
	   withIndexDo:
		[:accessor :index|
		self perform: accessor with: index - 1 * step + base]! !

CogProcessorAlien variableByteSubclass: #GdbARMAlien
	instanceVariableNames: ''
	classVariableNames: 'PostBuildStackDelta'
	poolDictionaries: ''
	category: 'Cog-Processors'!

!GdbARMAlien commentStamp: 'lw 8/23/2012 19:17' prior: 0!
I am a wrapper around the ARMulator CPU instance and emulator routines and I give access to disassembling using libopcodes. My C-part must be compiled with -DMODET, because otherwise my offesets are wrong by one field.!

!GdbARMAlien class methodsFor: 'instance creation' stamp: 'lw 7/11/2012 10:38'!
dataSize

	^1536! !

!GdbARMAlien class methodsFor: 'debugger' stamp: 'lw 6/25/2012 15:32'!
defaultIntegerBaseInDebugger
	^16! !

!GdbARMAlien class methodsFor: 'class initialization' stamp: 'IgorStasenko 12/19/2012 11:56'!
initialize
	"GdbARMAlien initialize"

	PostBuildStackDelta := 0.! !

!GdbARMAlien class methodsFor: 'primitives' stamp: 'lw 6/25/2012 15:35'!
primitiveNewCPU
	"Answer the address of a new ARMulator C type ARMul_State instance."
	<primitive: 'primitiveNewCPU' module: 'GdbARMPlugin'>
	^self primitiveFailed! !

!GdbARMAlien class methodsFor: 'accessing' stamp: 'lw 7/17/2012 22:12'!
setStackAlignmentDelta: 	stackAlignmentDelta
	"copy of BochsIA32Alien>>#setStackAlignmentDelta:, because I don't know yet what it's effect is."
	self assert: stackAlignmentDelta isPowerOfTwo.
	PostBuildStackDelta :=  stackAlignmentDelta > 8
								ifTrue: [stackAlignmentDelta - 8]
								ifFalse: [0]! !

!GdbARMAlien methodsFor: 'Cog API' stamp: 'lw 7/2/2012 11:50'!
abstractInstructionCompilerClass
	^CogARMCompiler! !

!GdbARMAlien methodsFor: 'Cog API' stamp: 'lw 7/31/2012 14:44'!
bitsInWord
	^32! !

!GdbARMAlien methodsFor: 'opcodes' stamp: 'tpr 5/5/2014 16:35'!
byteSwappedNopOpcode
	"For the Tsts class which keeps filling BitMaps with nop, provide one swapped so it turns out correct when disassembled
	mov r0, r0 swapped -> "
	^ 16r00000A0E1! !

!GdbARMAlien methodsFor: 'accessing-abstract' stamp: 'lw 11/17/2012 21:39'!
cResultRegister
	self r0! !

!GdbARMAlien methodsFor: 'accessing-abstract' stamp: 'lw 11/17/2012 21:39'!
cResultRegister: aValue
	self r0: aValue! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'tpr 4/25/2014 16:21'!
cflag
"The ARM cpsr flags are kept as individual fields in the Alien structure. The address here is the 1-based byte offset into the ARMul_State structure"
	^self unsignedLongAt: 573! !

!GdbARMAlien methodsFor: 'disassembly' stamp: 'tpr 5/13/2014 05:38'!
decorateDisassembly: anInstructionString for: aSymbolManager "<Cogit>" fromAddress: address
	(anInstructionString endsWith: 'mov	r0, r0')
		ifTrue: [^super decorateDisassembly: 'nop' for: aSymbolManager].
	^super decorateDisassembly: anInstructionString for: aSymbolManager! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/11/2012 11:09'!
eflags
	
	^ (((self nflag << 5 bitOr: self zflag << 4) 
			bitOr: self cflag << 3) 
				bitOr: self vflag << 2)
					bitOr: self ifflags! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'tpr 5/6/2014 13:45'!
endCondition
"why did the simulator stop?"
	^self unsignedLongAt: 5! !

!GdbARMAlien methodsFor: 'accessing-abstract' stamp: 'lw 7/12/2012 22:16'!
endianness
	^#little! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'tpr 5/6/2014 13:45'!
errorCode
"simulator error code"
	^self unsignedLongAt: 9! !

!GdbARMAlien methodsFor: 'testing' stamp: 'tpr 5/2/2014 15:47'!
extractOffsetFromBL: instr
"we are told this is a BL <offset> instruction, so work out the offset it encodes"
	| relativeJump |
	relativeJump := instr bitAnd: 16r00FFFFFF.
	relativeJump := (relativeJump bitAt: 24) = 1 
						ifTrue: [((relativeJump bitOr: 16r3F000000) << 2) signedIntFromLong]
						ifFalse: [relativeJump << 2].
	^relativeJump! !

!GdbARMAlien methodsFor: 'execution' stamp: 'lw 7/31/2012 11:52'!
flushICacheFrom: startAddress "<Integer>" to: endAddress "<Integer>"
	self primitiveFlushICacheFrom: startAddress To: endAddress! !

!GdbARMAlien methodsFor: 'accessing-abstract' stamp: 'lw 7/12/2012 22:57'!
fp
	"According to the use in SVr4"
	^self r11! !

!GdbARMAlien methodsFor: 'accessing-abstract' stamp: 'lw 7/16/2012 09:42'!
fp: aNumber
	"According to SVr4, the frame pointer is stored in r11"
	^self r11: aNumber! !

!GdbARMAlien methodsFor: 'error handling' stamp: 'tpr 5/6/2014 15:09'!
handleCallFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>"
	"Convert an execution primitive failure for a call into a ProcessorSimulationTrap signal."
	|  callAddress failedInstruction|
	"grab the instruction at issue"
	failedInstruction := memoryArray unsignedLongAt: pc + 1 bigEndian: false.
	(self instructionIsBL: failedInstruction)
		ifFalse:[self halt].
	"short jump via BL, therefore we have a 24bit signed integer offset"
	callAddress := (pc + 8 + (self extractOffsetFromBL: failedInstruction)).

	^(ProcessorSimulationTrap
			pc: pc
			nextpc: pc + 4
			address: callAddress signedIntToLong
			type: #call)
		signal! !

!GdbARMAlien methodsFor: 'error handling' stamp: 'tpr 5/6/2014 14:18'!
handleExecutionPrimitiveFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>"
	"Handle an execution primitive failure for an otherwise unhandled opcode."
	^self reportPrimitiveFailure! !

!GdbARMAlien methodsFor: 'error handling' stamp: 'tpr 5/25/2014 06:41'!
handleExecutionPrimitiveFailureIn: memoryArray "<Bitmap|ByteArray>" minimumAddress: minimumAddress "<Integer>"
	"Handle an execution primitive failure.  Convert out-of-range call and absolute
	 memory read into register instructions into ProcessorSimulationTrap signals."
	"self printRegistersOn: Transcript"
	| pc |
	self endCondition = 5 ifTrue:[self pc: self priorPc].
	((pc := self pc) between: minimumAddress and: memoryArray byteSize - 1) ifTrue:
		[(self instructionTypeAt: pc in: memoryArray)
			caseOf: {
				[#Call] 			-> [^self handleCallFailureAt: pc in: memoryArray].
				[#LongCall] 	-> [^self handleLongCallFailureAt: pc in: memoryArray].
				[#Jump] 		-> [^self handleJmpFailureAt: pc in: memoryArray].
				[#LongJump] 	-> [^self handleLongJmpFailureAt: pc in: memoryArray].
				[#MoveAwR]	-> [^self handleMoveAwRFailureAt: pc in: memoryArray].
				[#MoveMbrR]	-> [^self handleMoveMbrRFailureAt: pc in: memoryArray].
				[#MoveRAw]	-> [^self handleMoveRAwFailureAt: pc in: memoryArray].
				[#MoveRMbr]	-> [^self handleMoveRMbrFailureAt: pc in: memoryArray].
				[#Ret]			-> [^self handleRetFailureAt: pc in: memoryArray].} 
			otherwise: [^self handleExecutionPrimitiveFailureAt: pc in: memoryArray]].

	pc = 0 ifTrue:[self halt: 'pc should not be 0 at this point; simulator failure'].

	((pc := self lr - 4) between: minimumAddress and: memoryArray byteSize - 1) ifTrue:
		[(self instructionTypeAt: pc in: memoryArray)
			caseOf: {
				[#Call] 		-> [^self handleCallFailureAt: pc in: memoryArray].
				[#LongCall] -> [^self handleLongCallFailureAt: pc in: memoryArray].
				[#Jump] 	-> [^self handleJmpFailureAt: pc in: memoryArray].
				[#LongJump] 	-> [^self handleLongJmpFailureAt: pc in: memoryArray].
				[#Ret]		-> [^self handleRetFailureAt: pc in: memoryArray].} 
			otherwise: [^self handleExecutionPrimitiveFailureAt: pc in: memoryArray]].
	^self reportPrimitiveFailure! !

!GdbARMAlien methodsFor: 'error handling' stamp: 'tpr 5/6/2014 17:26'!
handleJmpFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>"
	"Convert an execution primitive failure for a jump into a ProcessorSimulationTrap signal."
	|  callAddress failedInstruction|
	"grab the instruction at issue"
	failedInstruction := memoryArray unsignedLongAt: pc + 1 bigEndian: false.
	(self instructionIsB: failedInstruction)
		ifFalse:[self halt].
	"short jump via B, therefore we have a 24bit signed integer offset"
	callAddress := (pc + 8 + (self extractOffsetFromBL: failedInstruction)).

	^(ProcessorSimulationTrap
			pc: pc
			nextpc: pc + 4
			address: callAddress signedIntToLong
			type: #jump)
		signal! !

!GdbARMAlien methodsFor: 'error handling' stamp: 'tpr 5/12/2014 17:27'!
handleLongCallFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>"
	"Convert an execution primitive failure for a long call into a ProcessorSimulationTrap signal."
	|  callAddress failedInstruction|
	"grab the instruction at issue"
	failedInstruction := memoryArray unsignedLongAt: pc + 1 bigEndian: false.
	"Hmm. Perhaps we ought to test for an actual BLX here rather than assuming?"
	(self instructionIsBLX: failedInstruction)
				ifFalse:[ self halt: 'failed call type test'].
	"The memoryArray starts indexing from 1, whereas the pc is based on 0-indexing, therefore all access-offsets are one greater than expected" 
	"address, combined from prior four MOV/ORR instructions. See CogARMCompiler>concretizeLongCall"
	callAddress := (memoryArray byteAt: pc -3) 
						+ ((memoryArray byteAt: pc - 7) << 8) 
						+ ((memoryArray byteAt: pc - 11) << 16) 
						+ ((memoryArray byteAt: pc - 15) << 24).
	^(ProcessorSimulationTrap
			pc: pc
			nextpc: pc + 4
			address: callAddress signedIntToLong
			type: #call)
		signal! !

!GdbARMAlien methodsFor: 'error handling' stamp: 'tpr 5/12/2014 17:29'!
handleLongJmpFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>"
	"Convert an execution primitive failure for a long jump into a ProcessorSimulationTrap signal."
	|  callAddress failedInstruction|
	"grab the instruction at issue"
	failedInstruction := memoryArray unsignedLongAt: pc + 1 bigEndian: false.
	"Hmm. Perhaps we ought to test for an actual BX here rather than assuming?"
	(self instructionIsBX: failedInstruction)
				ifFalse:[ self halt: 'failed call type test'].
	"The memoryArray starts indexing from 1, whereas the pc is based on 0-indexing, therefore all access-offsets are one greater than expected" 
	"address, combined from prior four MOV/ORR instructions. See CogARMCompiler>concretizeLongCall"
	callAddress := (memoryArray byteAt: pc -3) 
						+ ((memoryArray byteAt: pc - 7) << 8) 
						+ ((memoryArray byteAt: pc - 11) << 16) 
						+ ((memoryArray byteAt: pc - 15) << 248).
	^(ProcessorSimulationTrap
			pc: pc
			nextpc: pc + 4
			address: callAddress signedIntToLong
			type: #jump)
		signal! !

!GdbARMAlien methodsFor: 'error handling' stamp: 'tpr 5/2/2014 15:26'!
handleMoveAwRFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>"
	"Convert an execution primitive failure for a register load from an Address into a ProcessorSimulationTrap signal."
	((memoryArray byteAt: pc + 4) = 16rE5  "test for 0xE59X as the most significant two bytes - X being the index of the RISCTempReg (or 0xA in current code).
		LDR Rx, [RiscTempReg, #0]"
		and: [(memoryArray byteAt: pc + 3) = (16r90 + CogARMCompiler ARMTempReg)])
		ifTrue:
			[(ProcessorSimulationTrap
					pc: pc
					nextpc: pc + 4 
					address: (memoryArray byteAt: pc -3) "address, combined from prior four MOV/ORR instructions. See CogARMCompiler>concretizeMoveAwR"
								+ ((memoryArray byteAt: pc - 7) << 8) 
								+ ((memoryArray byteAt: pc - 11) << 16) 
								+ ((memoryArray byteAt: pc - 15) << 24)
					type: #read
					accessor: (self registerStateSetters at: ("destination register" (memoryArray byteAt: pc + 2) >> 4) + 1))
				signal]
		ifFalse:
			[self reportPrimitiveFailure]! !

!GdbARMAlien methodsFor: 'error handling' stamp: 'eem 11/21/2013 16:24'!
handleMoveMbrRFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>"
	"Convert an execution primitive failure for a byte register load into a ProcessorSimulationTrap signal."
	"MoveMbrR"
	| modrmByte |
	self halt.
	^(((modrmByte := memoryArray byteAt: pc + 2) bitAnd: 16rC0) = 16r80) "ModRegRegDisp32"
		ifTrue:
			[(ProcessorSimulationTrap
					pc: pc
					nextpc: pc + 6
					address: ((self perform: (#(eax ecx edx ebx esp ebp esi edi) at: (modrmByte bitAnd: 7) + 1))
							+ (memoryArray unsignedLongAt: pc + 3 bigEndian: false)
								bitAnd: 16rFFFFFFFF)
					type: #read
					accessor: (#(al: cl: dl: bl: ah: ch: dh: bh:) at: ((modrmByte >> 3 bitAnd: 7) + 1)))
				signal]
		ifFalse:
			[self reportPrimitiveFailure]! !

!GdbARMAlien methodsFor: 'error handling' stamp: 'tpr 5/2/2014 10:35'!
handleMoveRAwFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>"
	"Convert an execution primitive failure for a register write into Memory at a predefined address into a ProcessorSimulationTrap signal."
	^((memoryArray byteAt: pc + 4) = 16rE5 
		and: [(memoryArray byteAt: pc + 3) = (16r80 + CogARMCompiler ARMTempReg)])
		ifTrue:
			[(ProcessorSimulationTrap
					pc: pc
					nextpc: pc + 4
					address: (memoryArray byteAt: pc -3) 
								+ ((memoryArray byteAt: pc - 7) << 8) 
								+ ((memoryArray byteAt: pc - 11) << 16) 
								+ ((memoryArray byteAt: pc - 15) <<24)
					type: #write
					accessor: (self registerStateNames at: ((memoryArray byteAt: pc + 2) >> 4) + 1))
				signal]
		ifFalse:
			[self reportPrimitiveFailure]! !

!GdbARMAlien methodsFor: 'error handling' stamp: 'eem 11/21/2013 16:24'!
handleMoveRMbrFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>"
		"Convert an execution primitive failure for a byte register write into a ProcessorSimulationTrap signal."
	"MoveRMbr"
	| modrmByte |
	self halt.
	^(((modrmByte := memoryArray byteAt: pc + 2) bitAnd: 16rC0) = 16r80) "ModRegRegDisp32"
		ifTrue:
			[(ProcessorSimulationTrap
					pc: pc
					nextpc: pc + 6
					address: ((self perform: (#(eax ecx edx ebx esp ebp esi edi) at: (modrmByte bitAnd: 7) + 1))
							+ (memoryArray unsignedLongAt: pc + 3 bigEndian: false)
								bitAnd: 16rFFFFFFFF)
					type: #write
					accessor: (#(al cl dl bl ah ch dh bh) at: ((modrmByte >> 3 bitAnd: 7) + 1)))
				signal]
		ifFalse:
			[self reportPrimitiveFailure]! !

!GdbARMAlien methodsFor: 'error handling' stamp: 'tpr 5/25/2014 17:06'!
handleRetFailureAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>"
	"Convert an execution primitive failure for a ret into a ProcessorSimulationTrap signal."
	self halt.
	^(ProcessorSimulationTrap
			pc: pc
			nextpc: pc + 4
			address: (memoryArray unsignedLongAt: self sp -3) 
			type: #return
			accessor: #pc:)
		signal! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'tpr 4/25/2014 16:22'!
ifflags
"The ARM cpsr flags are kept as individual fields in the Alien structure. The address here is the 1-based byte offset into the ARMul_State structure"
	^self unsignedLongAt: 581! !

!GdbARMAlien methodsFor: 'testing' stamp: 'tpr 5/3/2014 15:16'!
instructionIsB: instr
"is this a B <offset> instruction?"
	^instr >> 28 < 16rF "test for allowed condcode - 0xF is extension" and: [(instr bitAnd: (16rF<<24)) = (16rA<<24)]! !

!GdbARMAlien methodsFor: 'testing' stamp: 'tpr 5/3/2014 15:16'!
instructionIsBL: instr
"is this a BL <offset> instruction?"
	^instr >> 28 < 16rF "test for allowed condcode - 0xF is extension" and: [(instr bitAnd: (16rF<<24)) = (16rB<<24)]! !

!GdbARMAlien methodsFor: 'testing' stamp: 'tpr 5/2/2014 16:03'!
instructionIsBLX: instr
"is this a BLX <targetReg> instruction?"
	^instr >> 28 < 16rF "test for allowed condcode - 0xF is extension" and: [(instr bitAnd: 16r0FFFFFF0) = 16r12FFF30]! !

!GdbARMAlien methodsFor: 'testing' stamp: 'tpr 5/2/2014 17:18'!
instructionIsBX: instr
"is this a BX <targetReg> instruction?"
	^instr >> 28 < 16rF "test for allowed condcode - 0xF is extension" and: [(instr bitAnd: 16r0FFFFFF0) = 16r12FFF10]! !

!GdbARMAlien methodsFor: 'testing' stamp: 'tpr 5/2/2014 17:52'!
instructionIsLDR: instr byReg: rn
"is this a LDR r1, [r2, rn] instruction? Special case to detect MoveAwR case"
	| foo |
	^instr >> 28 < 16rF "test for allowed condcode - 0xF is extension" and: [foo := (instr >> 20 bitAnd: 16rFF). foo = 16r59  and:[(instr >>16 bitAnd: 16rF) = rn]]! !

!GdbARMAlien methodsFor: 'testing' stamp: 'tpr 5/3/2014 15:17'!
instructionIsLDRB: instr
"is this a LDRB instruction?"
	| foo |
	^instr >> 28 < 16rF "test for allowed condcode - 0xF is extension" 
		and: [foo := (instr >> 20 bitAnd: 16rFF).
			foo = 16r55 "ldrb r1, [r2, #imm]"
				or:[foo = 16r5D "ldrb r1, [r2, #-imm]"
				or:[foo = 16r7D "ldrb r1, [r2, r3]"]]]! !

!GdbARMAlien methodsFor: 'testing' stamp: 'tpr 5/28/2014 03:45'!
instructionIsReturnViaLR: instr
"is this a MOV pc, lr instruction?"
	^instr =  16rE1A0F00E! !

!GdbARMAlien methodsFor: 'testing' stamp: 'tpr 5/2/2014 17:44'!
instructionIsSTR: instr
"is this a STR instruction?"
	| foo |
	^instr >> 28 < 16rF "test for allowed condcode - 0xF is extension" and: [foo := (instr >> 20 bitAnd: 16rFF). foo = 16r58 "str r1, [r2, #imm]" or:[foo = 16r50 "str r1, [r2, #-imm]" or:[foo = 16r78 "str r1, [r2, r3]"]]]! !

!GdbARMAlien methodsFor: 'testing' stamp: 'tpr 5/2/2014 17:49'!
instructionIsSTR: instr byReg: rn
"is this a STR r1, [r2, rn] instruction? Special case to detect MoveRAw case"
	| foo |
	^instr >> 28 < 16rF "test for allowed condcode - 0xF is extension" and: [foo := (instr >> 20 bitAnd: 16rFF). foo = 16r58  and:[(instr >>16 bitAnd: 16rF) = rn]]! !

!GdbARMAlien methodsFor: 'testing' stamp: 'tpr 5/2/2014 17:33'!
instructionIsSTRB: instr
"is this a STRB instruction?"
	| foo |
	^instr >> 28 < 16rF "test for allowed condcode - 0xF is extension" and: [foo := (instr >> 20 bitAnd: 16rFF). foo = 16r54 "strb r1, [r2, #imm]" or:[foo = 16r5c "strb r1, [r2, #-imm]" or:[foo = 16r7c "strb r1, [r2, r3]"]]]! !

!GdbARMAlien methodsFor: 'error handling' stamp: 'tpr 5/28/2014 03:43'!
instructionTypeAt: pc "<Integer>" in: memoryArray "<Bitmap|ByteArray>"
	"Identify which type of instruction is at pc in memoryArray. For the time being, only those instructions needed for PrimitiveFailure are identified."
	| RISCTempReg lastInstruction typeOperandStatus |
	RISCTempReg := CogARMCompiler ARMTempReg.
	lastInstruction := memoryArray unsignedLongAt:  pc + 1 bigEndian: false .
	"self disassembleFrom: pc - 16 to: pc + 11 in: memoryArray on: Transcript cr"
	
	"Ret"
	(self instructionIsReturnViaLR: lastInstruction ) ifTrue: [^#Ret].

	"Call"
	(self instructionIsBL: lastInstruction) ifTrue: [^#Call].
	"long call"
	(self instructionIsBLX: lastInstruction) ifTrue: [^#LongCall].
	
	
	"Jump"
	(self instructionIsB: lastInstruction) ifTrue: [^#Jump].
	"long Jump"
	(self instructionIsBX: lastInstruction) ifTrue: [^#LongJump].
		
	typeOperandStatus := lastInstruction >> 20 bitAnd: 16rFF.
	"MoveRMbr"
	(self instructionIsSTRB: lastInstruction) ifTrue: [^#MoveRMbr].
		
	"MoveRAw"
	(self instructionIsSTR: lastInstruction byReg: RISCTempReg) ifTrue: [^#MoveRAw].
		
	"MoveMbrR"
	(self instructionIsLDRB: lastInstruction) ifTrue: [^#MoveMbrR].
		
	"MoveAwR"
	(self instructionIsLDR: lastInstruction byReg: RISCTempReg) ifTrue: [^#MoveAwR].
	
	
	^#UnidentifiedInstruction! !

!GdbARMAlien methodsFor: 'accessing-abstract' stamp: 'lw 7/10/2012 14:20'!
integerRegisterState
	^{	self r0. self r1. self r2. self r3. self r4. self r5. self r6. self r7. self r8. 
		self r9. self r10. self r11. self r12. self sp. self lr. self pc}! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
lr
	^self unsignedLongAt: 69! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
lr: anUnsignedInteger

	^self unsignedLongAt: 69 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'tpr 4/25/2014 16:22'!
nflag
"The ARM cpsr flags are kept as individual fields in the Alien structure. The address here is the 1-based byte offset into the ARMul_State structure"
	^self unsignedLongAt: 565! !

!GdbARMAlien methodsFor: 'opcodes' stamp: 'lw 8/8/2012 13:55'!
nopOpcode
	"mov r0, r0"
	^ 16rE1A00000! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
pc
	^self unsignedLongAt: 73! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
pc: anUnsignedInteger

	^self unsignedLongAt: 73 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'opcodes' stamp: 'tpr 5/2/2014 16:29'!
popPcOpcode
"See also CogARMCompiler>concretizePopR"
	^16rE49DF004! !

!GdbARMAlien methodsFor: 'execution' stamp: 'lw 8/20/2012 12:45'!
postCallArgumentsNumArgs: numArgs "<Integer>" in: memory "<ByteArray|Bitmap>"
	"Answer an argument vector of the requested size after a vanilla
	 ABI call. For ARM the Procedure Calling Specification can be found in IHI0042D_aapcs.pdf.
	On ARM this typically means accessing r0 through r3 and fetching additional arguments from the stack, acording to pages 20f. aapcs.
	We assume that all arguments are single word arguments, which can not be supplied on co-processor-registers.
	 For compatibility with Cog/Slang we answer unsigned values."
	^(1 to: numArgs) collect: [:i |
		i < 5 
			ifTrue: [self perform: (self registerStateNames at: i)]
			"ARM uses a full descending stack. Directly after calling a procedure, nothing but the arguments are pushed."
			ifFalse: [memory unsignedLongAt: self sp + (i-5)*4 bigEndian: false]].! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'tpr 5/5/2014 09:24'!
postTrapCorrectedPC
	"return the pc - 8 for trap handling - remember the ARM alwayshas that funky +8 offset vs the actual instruction running/failig"
	^self pc -8! !

!GdbARMAlien methodsFor: 'primitives' stamp: 'lw 8/24/2012 19:10'!
primitiveDisassembleAt: address inMemory: memoryArray "<Bitmap|ByteArray>"
	"Answer an Array of the size and the disassembled code string for the instruction at the current instruction pointer in memory."
	<primitive: 'primitiveDisassembleAtInMemory' module: 'GdbARMPlugin'>
	^self primitiveFailed! !

!GdbARMAlien methodsFor: 'primitives' stamp: 'lw 7/9/2012 20:27'!
primitiveErrorAndLog
	"Answer an array of the current error code and log contents"
	<primitive: 'primitiveErrorAndLog' module: 'GdbARMPlugin'>
	^self primitiveFailed! !

!GdbARMAlien methodsFor: 'primitives' stamp: 'lw 7/31/2012 11:53'!
primitiveFlushICacheFrom: startAddress "<Integer>" To: endAddress "<Integer>"
	"Flush the icache in the requested range"
	<primitive: 'primitiveFlushICacheFromTo' module: 'GdbARMPlugin'>
	^self primitiveFailed! !

!GdbARMAlien methodsFor: 'primitives' stamp: 'lw 7/2/2012 11:16'!
primitiveResetCPU
	"Reset the receiver to registers all zero, and protected 32-bit mode."
	<primitive: 'primitiveResetCPU' module: 'GdbARMPlugin'>
	^self reportPrimitiveFailure! !

!GdbARMAlien methodsFor: 'primitives' stamp: 'eem 11/21/2013 16:22'!
primitiveRunInMemory: memoryArray "<Bitmap|ByteArray>" minimumAddress: minimumAddress "<Integer>" maximumAddress: maximimAddress "<Integer>" readOnlyBelow: minimumWritableAddress "<Integer>"
	"Run the receiver using the argument as the store.  Origin the argument at 0. i.e. the first byte of the
	 memoryArray is address 0.  Make addresses below minimumAddress illegal.  Convert out-of-range
	 calls, jumps and memory read/writes into ProcessorSimulationTrap signals."
	<primitive: 'primitiveRunInMemoryMinAddressMaxAddressReadWrite' module: 'GdbARMPlugin' error: ec>
	^ec == #'inappropriate operation'
		ifTrue: [self handleExecutionPrimitiveFailureIn: memoryArray
					minimumAddress: minimumAddress]
		ifFalse: [self reportPrimitiveFailure]

	"self printRegistersOn: Transcript"! !

!GdbARMAlien methodsFor: 'primitives' stamp: 'tpr 5/8/2014 08:23'!
primitiveRunInMemory: memoryArray "<Bitmap|ByteArray>" minimumAddress: minimumAddress "<Integer>" readOnlyBelow: minimumWritableAddress "<Integer>"
	"Run the receiver using the argument as the store.  Origin the argument at 0. i.e. the first byte of the
	 memoryArray is address 0.  Make addresses below minimumAddress illegal.  Convert out-of-range
	 calls, jumps and memory read/writes into ProcessorSimulationTrap signals.
	Note that minWriteMaxExecAddress is both the minimum writeable address AND the maximum executable address"
	<primitive: 'primitiveRunInMemoryMinimumAddressReadWrite' module: 'GdbARMPlugin' error: ec>
	^ec == #'inappropriate operation'
		ifTrue: [self handleExecutionPrimitiveFailureIn: memoryArray
					minimumAddress: minimumAddress]
		ifFalse: [self reportPrimitiveFailure]

	"self printRegistersOn: Transcript"! !

!GdbARMAlien methodsFor: 'primitives' stamp: 'eem 11/21/2013 16:23'!
primitiveSingleStepInMemory: memoryArray "<Bitmap|ByteArray>" minimumAddress: minimumAddress "<Integer>" maximumAddress: maximimAddress "<Integer>" readOnlyBelow: minimumWritableAddress "<Integer>"
	"Single-step the receiver using the argument as the store.  Origin the argument at 0. i.e. the first byte of the
	 memoryArray is address 0.  Make addresses below minimumAddress illegal.  Convert out-of-range
	 calls, jumps and memory read/writes into ProcessorSimulationTrap signals."
	<primitive: 'primitiveSingleStepInMemoryMinAddressMaxAddressReadWrite' module: 'GdbARMPlugin' error: ec>
	^ec == #'inappropriate operation'
		ifTrue: [self handleExecutionPrimitiveFailureIn: memoryArray
					minimumAddress: minimumAddress]
		ifFalse: [self reportPrimitiveFailure]! !

!GdbARMAlien methodsFor: 'primitives' stamp: 'eem 11/21/2013 16:23'!
primitiveSingleStepInMemory: memoryArray "<Bitmap|ByteArray>" minimumAddress: minimumAddress "<Integer>" readOnlyBelow: minimumWritableAddress "<Integer>"
	"Single-step the receiver using the argument as the store.  Origin the argument at 0. i.e. the first byte of the
	 memoryArray is address 0.  Make addresses below minimumAddress illegal.  Convert out-of-range
	 calls, jumps and memory read/writes into ProcessorSimulationTrap signals."
	<primitive: 'primitiveSingleStepInMemoryMinimumAddressReadWrite' module: 'GdbARMPlugin' error: ec>
	^ec == #'inappropriate operation'
		ifTrue: [self handleExecutionPrimitiveFailureIn: memoryArray
					minimumAddress: minimumAddress]
		ifFalse: [self reportPrimitiveFailure]! !

!GdbARMAlien methodsFor: 'printing' stamp: 'eem 12/9/2013 09:28'!
printFields: fields inRegisterState: registerStateVector on: aStream
	| rsvs |
	aStream ensureCr.
	rsvs := registerStateVector readStream.
	fields withIndexDo:
		[:sym :index| | val |
		sym = #cr
			ifTrue: [aStream cr]
			ifFalse:
				[(val := rsvs next) isNil ifTrue: [^self].
				aStream nextPutAll: sym; nextPut: $:; space.
				val printOn: aStream base: 16 length: 8 padded: true.
				#eflags == sym
					ifTrue:
						[aStream space.
						 "'FIVCZN'"'--VCZN' withIndexDo:
							[:flag :bitIndex|
							flag ~= $- ifTrue:
								[aStream nextPut: flag; nextPutAll: 'F='; print: (val bitAnd: 1 << (bitIndex - 1)) >> (bitIndex - 1); space]]]
					ifFalse:
						[val > 16 ifTrue:
							[aStream space; nextPut: $(.
							 val printOn: aStream base: 10 length: 1 padded: false.
							 aStream nextPut: $)]].
				(fields at: index + 1) ~~ #cr ifTrue:
					[aStream tab]]]! !

!GdbARMAlien methodsFor: 'printing' stamp: 'lw 8/8/2012 14:04'!
printOn: aStream
	aStream nextPutAll: 'an ARMAlien('.
	self registerState allButLast with: self registerStateNames allButLast do: [ :state :i |
		aStream 
			<< i << ': ' 
			<< (state abs > 15 ifTrue: [state hex] ifFalse: [state asString]) 
			<< ', '].
	aStream << 'NZCVIF: ' 
		<< (self registerState last printStringBase: 2 length: 6 padded: true) << ')'.! !

!GdbARMAlien methodsFor: 'printing' stamp: 'eem 12/9/2013 09:30'!
printRegisterState: registerStateVector on: aStream
	self printFields: #(	r0 r1 r2 r3 cr
						r4 r5 r6 r7 cr
						r8 r9 r10 r11 cr
						r12 sp lr pc eflags cr)
		inRegisterState: registerStateVector
		on: aStream! !

!GdbARMAlien methodsFor: 'printing' stamp: 'eem 12/9/2013 09:31'!
printRegisterStateExceptPC: registerStateVector on: aStream
	self printFields: #(	r0 r1 r2 r3 cr
						r4 r5 r6 r7 cr
						r8 r9 r10 r11 cr
						r12 sp lr eflags cr)
		inRegisterState: registerStateVector
		on: aStream! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'tpr 5/11/2014 02:53'!
priorPc
"where did the simulator stop just before a prefetch abort?"
	^self unsignedLongAt: 609! !

!GdbARMAlien methodsFor: 'execution' stamp: 'lw 2/1/2013 23:17'!
pushWord: aValue in: aMemory
	aMemory longAt: (self sp: self sp - 4) + 1 put: aValue bigEndian: false! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r0
	^self unsignedLongAt: 13! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r0: anUnsignedInteger

	^self unsignedLongAt: 13 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r1
	^self unsignedLongAt: 17! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r10
	^self unsignedLongAt: 53! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r10: anUnsignedInteger

	^self unsignedLongAt: 53 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r11
	^self unsignedLongAt: 57! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r11: anUnsignedInteger

	^self unsignedLongAt: 57 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r12
	^self unsignedLongAt: 61! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r12: anUnsignedInteger

	^self unsignedLongAt: 61 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r1: anUnsignedInteger

	^self unsignedLongAt: 17 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r2
	^self unsignedLongAt: 21! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r2: anUnsignedInteger

	^self unsignedLongAt: 21 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r3
	^self unsignedLongAt: 25! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r3: anUnsignedInteger

	^self unsignedLongAt: 25 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r4
	^self unsignedLongAt: 29! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r4: anUnsignedInteger

	^self unsignedLongAt: 29 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r5
	^self unsignedLongAt: 33! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r5: anUnsignedInteger

	^self unsignedLongAt: 33 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r6
	^self unsignedLongAt: 37! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r6: anUnsignedInteger

	^self unsignedLongAt: 37 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r7
	^self unsignedLongAt: 41! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r7: anUnsignedInteger

	^self unsignedLongAt: 41 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r8
	^self unsignedLongAt: 45! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r8: anUnsignedInteger

	^self unsignedLongAt: 45 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r9
	^self unsignedLongAt: 49! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
r9: anUnsignedInteger

	^self unsignedLongAt: 49 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'tpr 4/25/2014 16:22'!
rawCPSR
"The ARM cpsr flags are kept as individual fields in the Alien structure. The address here is the 1-based byte offset into the ARMul_State structure"
"read the raw value of the cpsr from the alien structure"
	^self unsignedLongAt: 533! !

!GdbARMAlien methodsFor: 'accessing-abstract' stamp: 'lw 7/31/2012 15:12'!
registerState
	^{	self r0. self r1. self r2. self r3. self r4. self r5. self r6. self r7.
		self r8. self r9. self r10. self r11. self r12. self sp. self lr. self pc. self eflags }! !

!GdbARMAlien methodsFor: 'accessing-abstract' stamp: 'eem 3/18/2014 10:37'!
registerStateGetters
	^#(	r0 r1 r2 r3 r4 r5 r6 r7
		r8 r9 r10 r11 r12 sp lr pc eflags )! !

!GdbARMAlien methodsFor: 'accessing-abstract' stamp: 'lw 8/9/2012 19:23'!
registerStateNames
	^#(	r0 r1 r2 r3 r4 r5 r6 r7 r8 r9 r10 fp r12 sp lr pc eflags)! !

!GdbARMAlien methodsFor: 'accessing-abstract' stamp: 'lw 11/17/2012 18:12'!
registerStatePCIndex
	^16! !

!GdbARMAlien methodsFor: 'accessing-abstract' stamp: 'tpr 5/2/2014 15:24'!
registerStateSetters
"a list of register setting messages used to initialise or reset registers"
	^#(	r0: r1: r2: r3: r4: r5: r6: r7: r8: r9: r10: fp: r12: sp: lr: pc:)! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/2/2012 11:15'!
reset
	self primitiveResetCPU! !

!GdbARMAlien methodsFor: 'accessing-abstract' stamp: 'lw 7/12/2012 22:38'!
setFramePointer: framePointer stackPointer: stackPointer
	"Initialize the processor's frame and stack pointers"
	self fp: framePointer.
	self sp: stackPointer! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'tpr 4/25/2014 16:22'!
sflag
"The ARM cpsr flags are kept as individual fields in the Alien structure. The address here is the 1-based byte offset into the ARMul_State structure"
	^self unsignedLongAt: 585! !

!GdbARMAlien methodsFor: 'execution simulation' stamp: 'lw 2/2/2013 00:03'!
simulateCallOf: address nextpc: nextpc memory: aMemory
	"Simulate a frame-building call of address.  Build a frame since
	a) this is used for calls into the run-time which are unlikely to be leaf-calls"
	"This method builds a stack frame as expected by the simulator, not as defined by ARM aapcs-abi.
	In ARM aapcs, every method can define for itself, wether it wants to push lr (nextpc), and wether it 
	uses a frame pointer. The standard never mentions a fp. It merely defines r4-r11 to be callee-saved."

	self assert: self sp \\ 8 = 0. "This check ensures, that we conform with ARM abi. Before doing anything to the stack, we ensure 2-word alignment."
	self pushWord: nextpc in: aMemory.
	self pushWord: self r11 in: aMemory.
	self r11: self sp.
	PostBuildStackDelta ~= 0 ifTrue:
		[self sp: self sp - PostBuildStackDelta]. "In order to satisfy the CStackAlignment check by cogit, which is only valid on IA32 platforms."
	self pc: address! !

!GdbARMAlien methodsFor: 'execution simulation' stamp: 'lw 8/8/2012 11:56'!
simulateLeafCallOf: address nextpc: nextpc memory: aMemory
	self lr: nextpc.
	self pc: address! !

!GdbARMAlien methodsFor: 'execution simulation' stamp: 'lw 2/1/2013 22:40'!
simulateLeafReturnIn: aMemory
	self pc: self lr! !

!GdbARMAlien methodsFor: 'execution simulation' stamp: 'lw 2/2/2013 00:04'!
simulateReturnIn: aMemory
	PostBuildStackDelta ~= 0 ifTrue:
		[self sp: self sp + PostBuildStackDelta].
	self r11: (self popWordIn: aMemory).
	self pc: (self popWordIn: aMemory)! !

!GdbARMAlien methodsFor: 'accessing-abstract' stamp: 'lw 11/17/2012 20:44'!
smashRegisterAccessors
	^#(r0: r1: r2: r3: r4: r5: r6: r7: r8: r9: r10:)! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
sp
	^self unsignedLongAt: 65! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'lw 7/10/2012 17:25'!
sp: anUnsignedInteger

	^self unsignedLongAt: 65 put: anUnsignedInteger! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'tpr 4/25/2014 16:23'!
tflag
"The ARM cpsr flags are kept as individual fields in the Alien structure. The address here is the 1-based byte offset into the ARMul_State structure"
"This would be the Thumb flag if we have it -which depends rather oddly on the compiletime flags used to build the ARMulator. Sigh"
	^self unsignedLongAt: 589! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'tpr 4/25/2014 16:22'!
vflag
"The ARM cpsr flags are kept as individual fields in the Alien structure. The address here is the 1-based byte offset into the ARMul_State structure"
	^self unsignedLongAt: 577! !

!GdbARMAlien methodsFor: 'accessing' stamp: 'tpr 4/25/2014 16:22'!
zflag
"The ARM cpsr flags are kept as individual fields in the Alien structure. The address here is the 1-based byte offset into the ARMul_State structure"
	^self unsignedLongAt: 569! !

OrderedCollection subclass: #DBPlan
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Benchmarks-DeltaBlue'!

!DBPlan commentStamp: '<historical>' prior: 0!
A Plan is an ordered list of constraints to be executed in sequence to resatisfy all currently satisfiable constraints in the face of one or more changing inputs.!

!DBPlan methodsFor: 'planning' stamp: 'ClementBera 9/23/2013 10:49'!
execute
	"Execute my constraints in order."

	self do: [: c | c execute].! !

Error subclass: #ProcessorSimulationTrap
	instanceVariableNames: 'pc nextpc address type registerAccessor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cog-Processors'!

!ProcessorSimulationTrap commentStamp: 'lw 8/23/2012 19:25' prior: 0!
A ProcessorSimulationTrap is an Error raised by CogProcessorAliens which allow the VMSimulator to fix the problem and resume execution.
I know where the problem occured (pc) and which instruction is next (nextpc), which field of the processor need be read/written and what type of memory access was the source of error.

I am created in #handleExecutionPrimitiveFailureIn:minimumAddress:readOnlyBelow: and associated methods. 
In the IA32 case, the type is managed by the OpcodeExecutionMap, using the first byte of the last instruction as index. 
In the ARM case, we need rely on a case statement, since no byte (sequence) is able to directly tell which type I am of.!

!ProcessorSimulationTrap class methodsFor: 'instance creation' stamp: 'eem 5/7/2010 11:08'!
pc: pc nextpc: nextpc address: address type: type
	^self new
		pc: pc;
		nextpc: nextpc;
		address: address;
		type: type! !

!ProcessorSimulationTrap class methodsFor: 'instance creation' stamp: 'eem 5/7/2010 11:08'!
pc: pc nextpc: nextpc address: address type: type accessor: regAccessorMessage
	^self new
		pc: pc;
		nextpc: nextpc;
		address: address;
		type: type;
		registerAccessor: regAccessorMessage! !

!ProcessorSimulationTrap methodsFor: 'accessing' stamp: 'eem 12/18/2008 15:26'!
address
	"Answer the value of address"

	^ address! !

!ProcessorSimulationTrap methodsFor: 'accessing' stamp: 'eem 12/18/2008 15:26'!
address: anObject
	"Set the value of address"

	address := anObject! !

!ProcessorSimulationTrap methodsFor: 'accessing' stamp: 'eem 12/28/2008 17:56'!
nextpc
	"Answer the value of nextpc"

	^ nextpc! !

!ProcessorSimulationTrap methodsFor: 'accessing' stamp: 'eem 12/28/2008 17:56'!
nextpc: anObject
	"Set the value of nextpc"

	nextpc := anObject! !

!ProcessorSimulationTrap methodsFor: 'accessing' stamp: 'eem 12/18/2008 15:58'!
pc
	"Answer the value of pc"

	^ pc! !

!ProcessorSimulationTrap methodsFor: 'accessing' stamp: 'eem 12/18/2008 15:58'!
pc: anObject
	"Set the value of pc"

	pc := anObject! !

!ProcessorSimulationTrap methodsFor: 'printing' stamp: 'eem 11/22/2013 12:25'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' (pc: '; print: pc; nextPut: $/. pc printOn: aStream base: 16.
	aStream nextPutAll: ' nextpc: '; print: nextpc; nextPut: $/. nextpc printOn: aStream base: 16.
	aStream nextPutAll: ' address: '; print: address; nextPut: $/. address printOn: aStream base: 16.
	aStream nextPutAll: ' type: '; print: type.
	aStream nextPutAll: ' accessor: '; print: registerAccessor; nextPut: $)! !

!ProcessorSimulationTrap methodsFor: 'accessing' stamp: 'eem 1/1/2009 22:33'!
registerAccessor
	"Answer the value of registerAccessor"

	^ registerAccessor! !

!ProcessorSimulationTrap methodsFor: 'accessing' stamp: 'eem 1/1/2009 22:33'!
registerAccessor: anObject
	"Set the value of registerAccessor"

	registerAccessor := anObject! !

!ProcessorSimulationTrap methodsFor: 'accessing' stamp: 'eem 12/18/2008 15:32'!
type
	"Answer the value of type"

	^ type! !

!ProcessorSimulationTrap methodsFor: 'accessing' stamp: 'eem 12/18/2008 15:32'!
type: anObject
	"Set the value of type"

	type := anObject! !
DBStrength initialize!
RichObject initialize!
ShootoutChameneosColour initialize!
ShootoutMall initialize!
CommandLineLauncher initialize!
BochsIA32Alien initialize!
CogProcessorAlien initialize!
GdbARMAlien initialize!
